
#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).begin(), (c).end()
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

template <class T>
istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator<< (ostream &out, const vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator<< (ostream &out, const pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e18;

struct line
{
    ld k, b;
    line() {}
    line(ld k, ld b) : k(k), b(b) {}
};
struct box
{
    vector <line> v;
    box() {}
    void add(line l)
    {
        v.pb(l);
    }
    ld get(int x)
    {
        ld mx = -INF;
        for (auto l : v)
            mx = max(mx, l.k * x + l.b);
        return mx;
    }
};

int lambdasget(int n, int m, vector <int> a)
{
    vector <int> p(n + 1);
    partial_sum(all(a), p.begin() + 1);
    ld left = 0.0, right = 1e8;
    ld ans = 0;
    for (int _ = 0; _ < 60; ++_)
    {
        ld lambda = (left + right) / 2.0;
        vector <ld> dp(n + 1, INF), k(n + 1);
        dp[0] = 0;
        dp[1] = lambda, k[1] = 1;
        box c;
        c.add(line(1, 0));
        for (int i = 2; i <= n; ++i)
        {
            // try new otr
            if (dp[i] > dp[i - 1] + lambda)
            {
                dp[i] = dp[i - 1] + lambda;
                k[i] = k[i - 1] + 1;
            }
            // try prod otr
            /*
            ld val = p[i - 1] + (i - 1) * a[i - 1] - c.get(a[i - 1]) + lambda;
            if (dp[i] > val)
            {
                dp[i] = val;
                k[i] = k[i - 1];
            }
            c.add(line(i, p[i - 1] - dp[i - 1]));
            */
            for (int j = 1; j <= i; ++j)
            {
                ld val = dp[j - 1] + (p[i] - p[j - 1]) * (i - j) + lambda;
                if (dp[i] > val)
                {
                    dp[i] = val;
                    k[i] = k[j - 1] + 1;
                }
            }
        }
        if (k[n] <= m)
        {
            ans = dp[n] - k[n] * lambda;
            right = lambda;
        }
        else
            left = lambda;
    }
    return round(ans);
}

signed main()
{
    Start();
    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    cin >> a;
    vector <int> p(n + 1);
    partial_sum(all(a), p.begin() + 1);
    ld left = 0.0, right = 1e9;
    ld ans = 0;
    for (int _ = 0; _ < 70; ++_)
    {
        ld lambda = (left + right) / 2.0;
        vector <ld> dp(n + 1, INF), k(n + 1);
        dp[0] = 0;
        dp[1] = lambda, k[1] = 1;
        box c;
        c.add(line(1, 0));

        int optj = 1;
        auto foo = [&] (int i, int j) -> ld {return dp[j - 1] + (p[i] - p[j - 1]) * (i - j) + lambda;};
        for (int i = 2; i <= n; ++i)
        {
            // try new otr
            if (dp[i] > dp[i - 1] + lambda)
            {
                dp[i] = dp[i - 1] + lambda;
                k[i] = k[i - 1] + 1;
            }
            // try prod otr
            /*
            int l = 1, r = i - 1;
            while (r - l > 5)
            {
                int m1 = l + (r - l + 1) / 3, m2 = l + 2 * (r - l + 1) / 3;
                 val1 = 
            }*/
            /*
            ld val = p[i - 1] + (i - 1) * a[i - 1] - c.get(a[i - 1]) + lambda;
            if (dp[i] > val)
            {
                dp[i] = val;
                k[i] = k[i - 1];
            }
            c.add(line(i, p[i - 1] - dp[i - 1]));
            */
            while (optj < i && foo(i, optj + 1) <= foo(i, optj)) ++optj;
                int j = optj;
                ld val = dp[j - 1] + (p[i] - p[j - 1]) * (i - j) + lambda;
                if (dp[i] > val)
                {
                    dp[i] = val;
                    optj = j;
                    k[i] = k[j - 1] + 1;
                }
        }
        if (k[n] <= m)
        {
            ans = dp[n] - m * lambda;
            right = lambda;
        }
        else
            left = lambda;
    }
    cout << int(round(ans));
    return 0;
}

