
#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).begin(), (c).end()
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

template <class T>
istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator<< (ostream &out, const vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator<< (ostream &out, const pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e18;

struct line
{
    ld k, b;
    line() {}
    line(ld k, ld b) : k(k), b(b) {}
};
struct box
{
    vector <line> v;
    box() {}
    void add(line l)
    {
        v.pb(l);
    }
    ld get(int x)
    {
        ld mx = -INF;
        for (auto l : v)
            mx = max(mx, l.k * x + l.b);
        return mx;
    }
};

int lambdasget(int n, int m, vector <int> a)
{
    vector <int> p(n + 1);
    partial_sum(all(a), p.begin() + 1);
    ld left = 0.0, right = 1e8;
    ld ans = 0;
    for (int _ = 0; _ < 60; ++_)
    {
        ld lambda = (left + right) / 2.0;
        vector <ld> dp(n + 1, INF), k(n + 1);
        dp[0] = 0;
        dp[1] = lambda, k[1] = 1;
        box c;
        c.add(line(1, 0));
        for (int i = 2; i <= n; ++i)
        {
            // try new otr
            if (dp[i] > dp[i - 1] + lambda)
            {
                dp[i] = dp[i - 1] + lambda;
                k[i] = k[i - 1] + 1;
            }
            // try prod otr
            /*
            ld val = p[i - 1] + (i - 1) * a[i - 1] - c.get(a[i - 1]) + lambda;
            if (dp[i] > val)
            {
                dp[i] = val;
                k[i] = k[i - 1];
            }
            c.add(line(i, p[i - 1] - dp[i - 1]));
            */
            for (int j = 1; j <= i; ++j)
            {
                ld val = dp[j - 1] + (p[i] - p[j - 1]) * (i - j) + lambda;
                if (dp[i] > val)
                {
                    dp[i] = val;
                    k[i] = k[j - 1] + 1;
                }
            }
        }
        if (k[n] <= m)
        {
            ans = dp[n] - k[n] * lambda;
            right = lambda;
        }
        else
            left = lambda;
    }
    return round(ans);
}

signed main()
{
    Start();
    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    cin >> a;
    vector <int> p(n + 1);
    partial_sum(all(a), p.begin() + 1);
    ld left = 0.0, right = 1e9;
    ld ans = 0;
    for (int _ = 0; _ < 120; ++_)
    {
        ld lambda = (left + right) / 2.0;
        vector <ld> dp(n + 1, INF), k(n + 1);
        dp[0] = 0;
        dp[1] = lambda, k[1] = 1;
        box c;
        c.add(line(1, 0));
        auto foo = [&] (int i, int j) -> ld {return dp[j - 1] + (p[i] - p[j - 1]) * (i - j) + lambda;};
        vector <int> opt(n + 1, 1);
        function <void(int, int, int, int)> rec = [&] (int l, int r, int L, int R) -> void
        {
            if (l > r)
                return;
            if (L == R)
            {
                for (int x = l; x <= r; ++x)
                {
                    opt[x] = L;
                ld bst = foo(x, opt[x]);
                if (bst < dp[x])
                {
                    dp[x] = bst;
                    k[x] = k[opt[x] - 1] + 1;
                }
                if (dp[x] > dp[x - 1] + lambda)
                {
                    dp[x] = dp[x - 1] + lambda;
                    k[x] = k[x - 1] + 1;
                }
                }
                return;
            }
            if (l == r)
            {
                ld &bst = dp[l];
                for (int j = L; j <= min(l, R); ++j)
                {
                    if (foo(l, j) < bst)
                    {
                        bst = foo(l, j);
                        opt[l] = j;
                        k[l] = k[opt[l] - 1] + 1;
                    }
                }
                if (bst < dp[l])
                {
                    dp[l] = bst;
                    k[l] = k[opt[l] - 1] + 1;
                }
                if (dp[l] > dp[l - 1] + lambda)
                {
                    dp[l] = dp[l - 1] + lambda;
                    k[l] = k[l - 1] + 1;
                }
                return;
            }
            int x = (l + r) / 2;
            rec(l, x - 1, L, R);
                ld &bst = dp[x];
                for (int j = opt[x - 1]; j <= min(x, R); ++j)
                {
                    if (foo(x, j) < bst)
                    {
                        bst = foo(x, j);
                        opt[x] = j;
                        k[x] = k[x - 1] + 1;
                    }
                }
                if (bst < dp[x])
                {
                    dp[x] = bst;
                    k[x] = k[opt[x] - 1] + 1;
                }
                if (dp[x] > dp[x - 1] + lambda)
                {
                    dp[x] = dp[x - 1] + lambda;
                    k[x] = k[x - 1] + 1;
                }
            rec(x + 1, r, opt[x], R);

        };
        rec(2, n, 2, n);
        if (k[n] <= m)
        {
            ans = dp[n] - m * lambda;
            right = lambda;
        }
        else
            left = lambda;
    }
    cout << int(round(ans));
    return 0;
}

