#include<bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define ll long long
typedef vector<int> vi;
typedef pair<int, int> ii;
#define FORi(i,a,b) for(int i=a;i<b;i++)
#define FOR(i,n) FORi(i,0,n)
#define FOA(v,a) for(auto v : a)

#define len(qq) ((int) qq.size())


int pre[4000][4000];

int n, w, h;
int box(int x,int y){
	int ans=0;
	ans = pre[y][x];
	if(y>h) ans-=pre[y-h-1][x];
	if(x>w) ans-=pre[y][x-w-1];
	if(y>h && x>w) ans+=pre[y-h-1][x-w-1];
	return ans;
}

#define MAXR 1000000
int seg[MAXR*5];
#define MID ((l+r)/2)

int query(int rl, int rr, int l=0, int r=MAXR, int ind=1){
	if(rl<=l && r<=rr) return seg[ind];
	else if(rl>r || rr<l) return 0;
	return query(rl, rr, l, MID, ind*2) + query(rl,rr,MID+1,r,ind*2+1);
}

void update(int pos, int x, int l=0, int r=MAXR, int ind=1){
	if(l==r && l==pos) seg[ind]+=x;
	else if(l>=r || l>pos || r<pos) return;
	else{
		update(pos,x,l,MID,ind*2);
		update(pos,x,MID+1,r,ind*2+1);
		seg[ind] = seg[ind*2] + seg[ind*2+1];
	}
}

int main(){
	int maxy=0, maxx=0;
	cin>>n>>w>>h;
	int x[n], y[n];
	FOR(i,n) cin>>x[i]>>y[i];
	FOR(i,n) x[i]++, y[i]++;
	FOR(i,n) maxy = max(maxy, y[i]);
	FOR(i,n) maxx = max(maxx, x[i]);
	int ans=0;
	/*
	FOR(i,100){
		FOR(j,100){
			// upper right at i,j
			int cur=0;
			FOR(k,n){
				if(x[k]<=i && x[k]>=i-w && y[k]<=j && y[k]>=j-h) cur++;
			}
			ans = max(ans, cur);
		}
	}
	cout<<ans<<endl;
	*/
	
	if(n>1000){
		/*
		map<int, multiset<int> > xy;
		FOR(i,n) xy[x[i]].insert(y[i]);
		FORi(i,1,maxy+2){
			auto xit = xy.begin();
			FORi(j,1,maxx+2){
				if((*xit).F==j){
					pre[i][j]+=(*xit).S.count(i);
					xit++;
				}
				pre[i][j]-=pre[i-1][j-1];
				pre[i][j]+=pre[i-1][j];
				pre[i][j]+=pre[i][j-1];
				//cout<<pre[i][j]<<" ";
			}
			//cout<<endl;
		}
		FOR(i,n){
			ans = max(ans, box(x[i], y[i]));
		}
		*/


		map<int, vi> impx;
		FOR(i,n) impx[x[i]].push_back(i);

		queue<int> added;
		FOA(v,impx){
			FOA(q,v.S) added.push(q), update(y[q],1); // also add to seg
			while(!added.empty() && x[added.front()]<v.F-w){
				update(y[added.front()], -1);
				added.pop();
			}
			FOA(q,v.S) ans = max(ans, query(y[q]-h, y[q]));
		}
		cout<<ans<<endl;
		return 0;
	}


	unordered_set<int> impy;
	map<int, vi> impx;
	FOR(i,n) impx[x[i]].push_back(i);
	FOR(i,n) impy.insert(y[i]);
	FOA(cy,impy){
		// Sweep box with y-val between cy-h and cy
		queue<int> added;
		FOA(v,impx){
			FOA(q,v.S) if(y[q]>=cy-h && y[q]<=cy) added.push(x[q]); // also add to seg
			while(!added.empty() && added.front()<v.F-w){
				added.pop();
				// also remove from seg
			}
			ans = max(ans, len(added)); // change for seg query
		}
	}

	cout<<ans<<endl;
}
