#include<bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define ll long long
typedef vector<int> vi;
typedef pair<int, int> ii;
#define FORi(i,a,b) for(int i=a;i<b;i++)
#define FOR(i,n) FORi(i,0,n)
#define FOA(v,a) for(auto v : a)

#define len(qq) ((int) qq.size())

int n, w, h;
struct nod{
	int laz=0;
	int val=0;
	int l=-1, r=-1;
};

#define MAXR 400000000
vector<nod> seg(1);
#define MID ((l+r)/2)

void down(int ind){
	seg[seg[ind].l].val += seg[ind].laz;
	seg[seg[ind].r].val += seg[ind].laz;
	seg[seg[ind].l].laz += seg[ind].laz;
	seg[seg[ind].r].laz += seg[ind].laz;
	seg[ind].laz = 0;
}

void create(int ind){
	if(seg[ind].l==-1) seg[ind].l=len(seg), seg.push_back(nod());
	if(seg[ind].r==-1) seg[ind].r=len(seg), seg.push_back(nod());
}

int query(int rl, int rr, int l=0, int r=MAXR, int ind=0){
	if(rl<=l && r<=rr) return seg[ind].val;
	else if(rl>r || rr<l) return 0;
	if(l!=r) create(ind);
	down(ind);
	return max(query(rl, rr, l, MID, seg[ind].l) , query(rl,rr,MID+1,r,seg[ind].r));
}

void update(int rl, int rr, int x, int l=0, int r=MAXR, int ind=0){
	if(rl<=l && r<=rr) seg[ind].val+=x, seg[ind].laz+=x;
	else if(rl>r || rr<l) return;
	else if(l!=r){
		create(ind);
		down(ind);
		update(rl, rr, x, l, MID,seg[ind].l);
		update(rl,rr, x, MID+1,r,seg[ind].r);
		seg[ind].val = max(seg[seg[ind].l].val, seg[seg[ind].r].val);
	}
}

int main(){
	int maxy=0, maxx=0;
	cin>>n>>w>>h;
	int x[n], y[n];
	FOR(i,n) cin>>x[i]>>y[i];
	FOR(i,n) x[i]++, y[i]++;
	FOR(i,n) maxy = max(maxy, y[i]);
	FOR(i,n) maxx = max(maxx, x[i]);
	int ans=0;
	/*
	FOR(i,100){
		FOR(j,100){
			// upper right at i,j
			int cur=0;
			FOR(k,n){
				if(x[k]<=i && x[k]>=i-w && y[k]<=j && y[k]>=j-h) cur++;
			}
			ans = max(ans, cur);
		}
	}
	cout<<ans<<endl;
	*/
	
	//if(n>1000){
		/*
		map<int, multiset<int> > xy;
		FOR(i,n) xy[x[i]].insert(y[i]);
		FORi(i,1,maxy+2){
			auto xit = xy.begin();
			FORi(j,1,maxx+2){
				if((*xit).F==j){
					pre[i][j]+=(*xit).S.count(i);
					xit++;
				}
				pre[i][j]-=pre[i-1][j-1];
				pre[i][j]+=pre[i-1][j];
				pre[i][j]+=pre[i][j-1];
				//cout<<pre[i][j]<<" ";
			}
			//cout<<endl;
		}
		FOR(i,n){
			ans = max(ans, box(x[i], y[i]));
		}
		*/


		map<int, vi> impx;
		FOR(i,n) impx[x[i]].push_back(i);

		queue<int> added;
		FOA(v,impx){
			FOA(q,v.S) added.push(q), update(y[q], y[q]+h,1); // also add to seg
			//FOR(i,4*MAXR) cout<<"("<<seg[i]<<" "<<laz[i]<<") ";
			//cout<<endl;
			while(!added.empty() && x[added.front()]<v.F-w){
				update(y[added.front()], y[added.front()]+h, -1);
				added.pop();
			}
			ans = max(ans, query(0, maxy+h));
		}
		cout<<ans<<endl;
		return 0;
	/*}


	unordered_set<int> impy;
	map<int, vi> impx;
	FOR(i,n) impx[x[i]].push_back(i);
	FOR(i,n) impy.insert(y[i]);
	FOA(cy,impy){
		// Sweep box with y-val between cy-h and cy
		queue<int> added;
		FOA(v,impx){
			FOA(q,v.S) if(y[q]>=cy-h && y[q]<=cy) added.push(x[q]); // also add to seg
			while(!added.empty() && added.front()<v.F-w){
				added.pop();
				// also remove from seg
			}
			ans = max(ans, len(added)); // change for seg query
		}
	}

	cout<<ans<<endl;
	*/
}
