#include<bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define ll long long
typedef vector<int> vi;
typedef pair<int, int> ii;
#define FORi(i,a,b) for(int i=a;i<b;i++)
#define FOR(i,n) FORi(i,0,n)
#define FOA(v,a) for(auto v : a)

#define len(qq) ((int) qq.size())

int n, w, h;
struct nod{
	int laz=0;
	int val=0;
	nod *l = nullptr;
	nod *r = nullptr;
};

#define MAXR 200000001
int lastused=0;
#define MID ((l+r)/2)

void down(nod* ind){
	(*(*ind).l).val += (*ind).laz;
	(*(*ind).r).val += (*ind).laz;
	(*(*ind).l).laz += (*ind).laz;
	(*(*ind).r).laz += (*ind).laz;
	(*ind).laz = 0;
}

void create(nod* ind){
	if((*ind).l==nullptr) (*ind).l=new nod();
	if((*ind).r==nullptr) (*ind).r=new nod();
}

nod* seg = new nod();
int query(int rl, int rr, int l=0, int r=MAXR, nod* ind=seg){
	if(rl<=l && r<=rr) return (*ind).val;
	else if(rl>r || rr<l) return 0;
	if(l!=r) create(ind);
	down(ind);
	return max(query(rl, rr, l, MID, (*ind).l) , query(rl,rr,MID+1,r,(*ind).r));
}

void update(int rl, int rr, int x, int l=0, int r=MAXR, nod* ind=seg){
	if(rl<=l && r<=rr) (*ind).val+=x, (*ind).laz+=x;
	else if(rl>r || rr<l) return;
	else if(l!=r){
		create(ind);
		down(ind);
		update(rl, rr, x, l, MID,(*ind).l);
		update(rl,rr, x, MID+1,r,(*ind).r);
		(*ind).val = max((*(*ind).l).val, (*(*ind).r).val);
	}
}

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);

	int maxy=0, maxx=0;
	cin>>n>>w>>h;
	int x[n], y[n];
	FOR(i,n) cin>>x[i]>>y[i];
	FOR(i,n) x[i]++, y[i]++;
	FOR(i,n) maxy = max(maxy, y[i]);
	FOR(i,n) maxx = max(maxx, x[i]);
	int ans=0;


	map<int, vi> impx;
	FOR(i,n) impx[x[i]].push_back(i);

	queue<int> added;
	FOA(v,impx){
		FOA(q,v.S) added.push(q), update(y[q], y[q]+h,1);
		while(!added.empty() && x[added.front()]<v.F-w){
			update(y[added.front()], y[added.front()]+h, -1);
			added.pop();
		}
		ans = max(ans, query(0, maxy+h));
	}
	cout<<ans<<endl;
}
