// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define P pair
typedef P<int, int> Pii;
typedef P<ll, ll> Pll;
typedef P<string, string> Pss;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


#define add_fill(a, c) setw(a) << setfill(c)
// #define endl '\n'

#define slimming(a) a.shrink_to_fit()
#define len(a) (ll)a.size()

#define f first
#define s second

const ll INF = (ll) (1e9);
#define MOD 1000000009

#define yes "YES"
#define no "NO"
#define imp "impossible"

#define pb push_back
#define eb emplace_back

#pragma GCC optimize "-O3"
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma comment(linker, "/stack:200000000")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

// mt19937 rnd(time(0));

ll get_rand() {
   return (rand() << 16) ^ rand();
}

bool get(ll mask, ll id){
   return ((mask>>id)&1);
}

struct node{
   node* son[26];
   bool term;
   node(){
      for(int i = 0; i < 26; ++i)
         this->son[i] = nullptr;
      this->term = false;
   }
};

void add(string &s, node* a){
   node* cur = a;
   for(auto i : s){
      if(cur->son[i-'A'] == nullptr){
         cur->son[i-'A'] = new node();
      }
      cur = cur->son[i-'A'];
   }
   cur->term = true;
}

bool find(string &s, node* a){
   node* cur = a;
   for(auto i : s){
      if(cur->son[i-'A'] == nullptr){
         return false;
         // cur->son[i-'A'] = node();
      }
      cur = cur->son[i-'A'];
   }
   return cur->term;
   // cur->term = true;
}
ll n = 26;
string a[26];
map < ll, ll > ans1, ans2;
vector < bool > alpha;

node* root1 = new node();
node* root2 = new node();


void dfs1(ll id, string s1){
   if(id == n/2){
      ll tmp = 0;
      for(auto i : s1)
         tmp |= (i-'A');
      if(!find(s1, root1)){
         ans1[tmp]++;
         add(s1, root1);
      }
      return;
   }

   for(int i = 0; i < len(a[id]); ++i){
      if(alpha[a[id][i]-'A'])continue;
      alpha[a[id][i]-'A'] = true;
      dfs1(id+1, s1+a[id][i]);
      alpha[a[id][i]-'A'] = false;
   }
}

vector < bool > alpha2;
void dfs2(ll id, string s2){
   if(id == n){
      ll tmp = 0;
      for(auto i : s2)
         tmp |= (i-'A');
      if(!find(s2, root2)){
         ans2[tmp]++;
         add(s2, root2);
      }
      return;
   }

   for(int i = 0; i < len(a[id]); ++i){
      if(alpha[a[id][i]-'A'])continue;
      alpha2[a[id][i]-'A'] = true;
      dfs2(id+1, s2+a[id][i]);
      alpha2[a[id][i]-'A'] = false;
   }
}

void solve() {
   for(int i = 0; i < n; ++i){
      string s;
      cin >> s;
      set < char > q;
      for(auto j : s)
         q.insert(j);
      s = "";
      for(auto j:q)
         s += j;
      a[i] = s;
      // cin >> a[i];
   }

   set < char > c;
   for(int i = 0; i < n; ++i){
      for(auto j : a[i])
         c.insert(j);
   }
   if(len(c) < 26){
      cout << 0;
      return;
   }

   dfs1(0, "");
   dfs2(13, "");
   
   

   ll ans = 0;
   for(auto i : ans1){
      ll cnt = i.s;
      ll inv = (~i.f);
      ans += cnt * ans2[inv];
   }
   cout << ans;
   return;
}

int main() {
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);

   // freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

   ll t = 1;
   // cin >> t;
   while (t--) {
      solve();
      cout << endl;
   }
   return 0;
}