#include <bits/stdc++.h>
using namespace std;

const int N = 6003;
const long long inf = 1e17;
int n, k, a[N];
long long p[N];
vector<long long> dp[N];

inline long long S(int l, int r) {
	return (p[r] - p[l - 1]) * (r - l);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k; k = min(k, n);
	for(int i = 1; i <= n; ++i) {
		cin >> a[i];
		p[i] = p[i - 1] + a[i];
		for(int j = 0; j <= i; ++j) {
			dp[i].push_back(0);
		}
	}
	for(int i = 1; i <= n; ++i) {
		dp[i][0] = inf;
		for(int j = 1; j <= k; ++j) {
			dp[i][j] = inf;
			for(int ii = 0; ii < i; ++ii) {
				dp[i][j] = min(dp[i][j], dp[ii][j - 1] + S(ii + 1, i));
			}
		}
	}
	cout << dp[n][k] << endl;
	return 0;
}
