///❤
#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define ll long long
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N =  1e3 + 10;

using namespace std;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, h, w;
	cin >> n >> w >> h;

///==================================================================================================

	if (n > 1000) {
		vector <vector <int> > a(N, vector <int>(N + 1, 0));

		for (int i = 0; i < n; i++) {
			int x, y;
			cin >> x >> y;
			a[x][y]++;
		}

		vector <vector <int> > pref(N, vector <int>(N + 1));

		for (int i = 1; i < N; i++)
			for (int j = 1; j < N; j++)
				pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];

		int ans = 0;

		for (int i = 1; i <= N; i++) {
			for (int j = 1; j <= N; j++) {
				int x = i + w;
				int y = j + h;
				if (x >= N || y >= N) break;
				int sum = pref[x][y];
				sum -= pref[x][j - 1];
				sum -= pref[i - 1][y];
				sum += pref[i - 1][j - 1];
				ans = max(ans, sum);
			}
		}

		cout << ans;
		return 0;
	}

///==================================================================================================

	vector <int> ax, ay;
	vector <pair <int, int> > v;

	for (int i = 0, x, y; i < n; i++) {
		cin >> x >> y;
		ax.push_back(x);
		ay.push_back(y);
		v.push_back({ x, y });
	}

	sort(all(ax));
	sort(all(ay));

	map <int, int> mpx, mpy, xmp, ymp;

	int q = 0, qx, qy;
	mpx[ax[0]] = ++q;
	xmp[q] = ax[0];
	ax[0] = q;

	for (int i = 1; i < n; i++) 
		if (ax[i] != ax[i - 1]) { mpx[ax[i]] = ++q; xmp[q] = ax[i]; ax[i] = q; }
	qx = q;
	q = 0;
	mpy[ay[0]] = ++q;
	ymp[q] = ay[0];
	ay[0] = q;

	for (int i = 1; i < n; i++)
		if (ay[i] != ay[i - 1]) { mpy[ay[i]] = ++q; ymp[q] = ay[i]; ay[i] = q; }

	qy = q;
	
///==================================================================================================

	vector <vector <int> > a(N, vector <int>(N));

	for (int i = 0; i < n; i++) {
		v[i] = { mpx[v[i].ff], mpy[v[i].ss] };
		a[v[i].ff][v[i].ss]++;
	}
	
	vector <vector <int> > pref(N, vector <int>(N + 1));

	for (int i = 1; i < N; i++)
		for (int j = 1; j < N; j++)
			pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];

	int ans = 0;

	for (int i = 1; i <= qx; i++) {
		for (int j = 1; j <= qy; j++) {
			int x = i;
			int x_border = xmp[i] + w;
			for (x = x; x <= qx; x++) 
				if (xmp[x] > x_border) { x--; break; }
			
			int y = j;
			int y_border = ymp[j] + h;
			for (y = y; y <= qy; y++)
				if (ymp[y] > y_border) { y--; break; }


			int sum = pref[x][y];
			sum -= pref[x][j - 1];
			sum -= pref[i - 1][y];
			sum += pref[i - 1][j - 1];
			ans = max(ans, sum);

		}
	}

	cout << ans;

	return 0;

}