///❤
#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define ll long long
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N =  1e3 + 10;

using namespace std;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, h, w;
	cin >> n >> w >> h;

///==================================================================================================

	if (n > 1000) {
		vector <vector <int> > a(N, vector <int>(N + 1, 0));

		for (int i = 0; i < n; i++) {
			int x, y;
			cin >> x >> y;
			a[x][y]++;
		}

		vector <vector <int> > pref(N, vector <int>(N + 1));

		for (int i = 1; i < N; i++)
			for (int j = 1; j < N; j++)
				pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];

		int ans = 0;

		for (int i = 1; i <= N; i++) {
			for (int j = 1; j <= N; j++) {
				int x = i + w;
				int y = j + h;
				if (x >= N || y >= N) break;
				int sum = pref[x][y];
				sum -= pref[x][j - 1];
				sum -= pref[i - 1][y];
				sum += pref[i - 1][j - 1];
				ans = max(ans, sum);
			}
		}

		cout << ans;
		return 0;
	}

///==================================================================================================

	
	vector <int> ax, ay;
	set <int> dx, dy;
	vector <pair <int, int> > v;

	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		dx.insert(x);
		dy.insert(y);
		v.push_back({ x, y });
	}

	ax.push_back(-1);
	ay.push_back(-1);

	for (auto x : dx) ax.push_back(x);
	for (auto y : dy) ay.push_back(y);

	map <int, int> mpx, mpy;
	vector <vector <int> > pref(n + 1, vector <int>(n + 1));

	int lx = ax.size();
	int ly = ay.size();
	lx--;
	ly--;

	for (int i = 1; i <= lx; i++) mpx[ax[i]] = i;
	for (int i = 1; i <= ly; i++) mpy[ay[i]] = i;

	for (int i = 0; i < n; i++) 
		pref[mpx[v[i].ff]][mpy[v[i].ss]]++;
	
	for (int i = 1; i <= lx; i++)
		for (int j = 1; j <= ly; j++)
			pref[i][j] += pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1];

	int ans = 0;

	for (int i = 1; i <= lx; i++) {
		for (int j = 1; j <= ly; j++) {
			int x = ax[i] + w;
			int y = ay[j] + h;

			int l = 1, r = lx;

			while (r - l > 1) {
				int mid = (r + l) / 2;
				if (ax[mid] > x) r = mid;
				else l = mid;
			}

			if (ax[r] > x) x = l;
			else x = r;

			l = 1, r = ly;

			while (r - l > 1) {
				int mid = (r + l) / 2;
				if (ay[mid] > y) r = mid;
				else l = mid;
			}

			if (ay[r] > x) y = l;
			else y = r;

			int sum = pref[x][y];
			sum -= pref[x][j - 1];
			sum -= pref[i - 1][y];
			sum += pref[i - 1][j - 1];
			ans = max(ans, sum);

		}
	}

	cout << ans;

	return 0;

}