#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <queue>
#include <deque>
using namespace std;
#define pbc push_back 
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define pob pop_back()
#define sp system("pause")
#define vin(v) for(auto &i:v) cin>>i;
typedef long long ll;
const int MAXN = 1e5 + 1;
int t[4 * MAXN];
int get(int v, int l, int r, int ql, int qr)
{
	if (l >= ql && r <= qr) return t[v];
	if (l >= qr || ql >= r) return 0;
	int g1 = get(2 * v + 1, l, (l + r) / 2, ql, qr);
	int g2 = get(2 * v + 2, (l + r) / 2, r, ql, qr);
	return g1 + g2;
}
void upd(int v, int l, int r, int pos, int x)
{
	if (l > pos || r <= pos) return;
	if (l == pos && r == l + 1)
	{
		t[v] += x;
		return;
	}
	int m = (l + r) / 2;
	if (m <= pos) upd(2 * v + 2,(l + r) / 2,r, pos, x);
	else upd(2 * v + 1, l,(l+r)/2, pos, x);
	t[v] = t[2 * v + 1] + t[2 * v + 2];
}
struct query
{
	int type;
	int id;
	int add;
	int x;
};
bool cmp(query a, query b)
{
	if (a.x == b.x)
	{
		return a.type < b.type;
	}
	return a.x < b.x;
}
signed main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, w, h;
	cin >> n >> w >> h;
	vector<pair<int, int>> points(n);
	vector<int> xs, ys;
	for (int i = 0; i < n; ++i)
	{
		cin >> points[i].first >> points[i].second;
		xs.pbc(points[i].first);
		ys.pbc(points[i].second);
	}
	sort(all(xs)), sort(all(ys));
	xs.resize(unique(all(xs)) - xs.begin());
	ys.resize(unique(all(ys)) - ys.begin());
	vector<pair<pair<int, int>,pair<int,int>>> querybounds;
	vector<query> realq;
	vector<int> ans;
	for (int i = 0; i < (int)xs.size(); ++i)
	{
		for (int j = 0; j < (int)ys.size(); ++j)
		{
			querybounds.pbc({ {xs[i], xs[i] + w}, {ys[j], ys[j] + h} });
			realq.pbc({ 1,(int)querybounds.size() - 1, -1, xs[i] - 1 });
			realq.pbc({ 1, (int)querybounds.size() - 1, 1, xs[i] + w });
		}
	}
	for (int i = 0; i < n; ++i)
	{
		realq.pbc({ 0,i,1,points[i].first });
	}
	sort(all(realq), cmp);
	ans.resize(querybounds.size());
	for (int i = 0; i < (int)realq.size(); ++i)
	{
		if (realq[i].type == 0)
		{
			int lol = lower_bound(all(ys), points[realq[i].id].second) - ys.begin();
			upd(0, 0, n, lol, 1);
		}
		else
		{
			int lel = lower_bound(all(ys), querybounds[realq[i].id].second.first) - ys.begin();
			int lol = upper_bound(all(ys), querybounds[realq[i].id].second.second) - ys.begin();
			ans[realq[i].id] += realq[i].add *  get(0, 0, n, lel, lol);
		}
	}
	int ansos = 0;
	for (int i : ans) ansos = max(ansos, i);
	cout << ansos;
	//sp;
}