#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <queue>
#include <deque>
using namespace std;
#define pbc push_back 
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define pob pop_back()
#define sp system("pause")
#define vin(v) for(auto &i:v) cin>>i;
typedef long long ll;
const int MAXN = 1e5 + 1;
int t[4 * MAXN];
int add[4 * MAXN];
inline void push(int v, int l, int r)
{
	if (l != r - 1) add[2 * v + 1] += add[v], add[2 * v + 2] += add[v];
	t[v] += add[v];
	add[v] = 0;
}

int get(int v, int l, int r, int ql, int qr)
{
	push(v, l, r);
	if (l >= ql && r <= qr) return t[v];
	if (l >= qr || ql >= r) return 0;
	int g1 = get(2 * v + 1, l, (l + r) / 2, ql, qr);
	int g2 = get(2 * v + 2, (l + r) / 2, r, ql, qr);
	return g1 + g2;
}
void upd(int v, int l, int r, int ql, int qr, int x)
{
	push(v, l, r);
	if (l >= qr || ql >= r) return;
	if(l>=ql &&r<=qr)
	{	
		add[v] += x;
		push(v, l, r);
		return;
	}
	upd(2 * v + 1, l, (l + r) / 2, ql, qr, x);
	upd(2 * v + 2, (l + r) / 2, r, ql, qr, x);
	t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}
struct query
{
	int type;
	int id;
	int add;
	int x;
};
bool cmp(query a, query b)
{
	if (a.x == b.x)
	{
		return a.type < b.type;
	}
	return a.x < b.x;
}
int n, w, h;
vector<int> ys;
void adddot(int y, int val)
{
	int j = upper_bound(all(ys), y + h) - ys.begin();
	int jj = lower_bound(all(ys), y) - ys.begin();
	upd(0, 0, ys.size(), jj, j, val);
}
int getmax()
{
	return t[0];
}
signed main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> n >> w >> h;
	vector<pair<int, int>> points(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> points[i].first >> points[i].second;
		ys.pbc(points[i].second);
	}
	sort(all(ys));
	ys.resize(unique(all(ys)) - ys.begin());
	sort(all(points));
	int  r = 0;
	int ans = 0;
	for (int i = 0; i < n; ++i)
	{
		while (r < n && points[r].first <= points[i].first + w)
		{
			adddot(points[r].second, 1);
			++r;
		}
		ans = max(ans, getmax());
		adddot(points[i].second, -1);
	}
	cout << ans;
	//sp;
}