#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int,int> pi;
typedef pair<ll,ll> pl;
#define F first
#define S second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);
#define endl '\n'
#ifdef dremix
    #define p(x) cerr<<#x<<" = "<<x<<endl;
    #define p2(x,y) cerr<<"("<<#x<<","<<#y<<") = "<<x<<","<<y<<endl;
    #define pv(x) cerr<<#x<<" = {";for(auto v : x)cerr<<v<<", ";cerr<<"}"<<endl;
#else
    #define p(x)
    #define p2(x,y)
    #define pv(x)
#endif
const ll INF = 2e18;
const int MOD = 1e9+7;
const int N = 1e5+1;


struct BIT{
    vector<int> bit;
    int N;

    void init(int n){
        bit.assign(n+1,0);
        N = n;
    }

    void add(int k, int x){
        while(k<=N){
            bit[k] += x;
            k += k&-k;
        }
    }

    int pref(int k){
        int sum = 0;
        while(k>0){
            sum += bit[k];
            k -= k&-k;
        }
        return sum;
    }

    int query(int l, int r){
        return pref(r) - pref(l-1);
    }

};


int main (){
fastio

/// lemma : optimal rectangle always has a corner on a point
/// => 4N possible positions for rectangle
/// find way to count points in rectangle efficiently
/// wrong ^^^
/// new lemma : optimal rectangle has a point on one of its sides
/// can prove that you can choose 2 sides of the rectangle that
/// are next to each other and always arrive at an optimal answer
/// with at least one point on each of those sides
/// choose top and right sides -> use 2 BITS to create a segment

int n,w,h;
cin>>n>>w>>h;

int i;
pi arr[n];

vector<vector<int> > pts(N);

for(i=0;i<n;i++){
    int x,y;
    cin>>x>>y;
    arr[i] = {x,y};
    pts[x].push_back(y);
}

BIT left,right;
left.init(N);
right.init(N);

sort(arr,arr+n);

int l = 0,r = 0;
int ans = 0;

for(i=0;i<n;i++){
    while(r < arr[i].F){
        r++;
        for(auto x : pts[r]){
            right.add(x,1);
            p(x)
        }
    }
    while(l < r - w - 1){
        l++;
        for(auto x : pts[l]){
            left.add(x,1);
            p2(1,x)
        }
    }
    p2(arr[i].F,arr[i].S)
    p2(l,r)

    int p1 = left.query(max(1,arr[i].S-h),arr[i].S);
    int p2 = right.query(max(1,arr[i].S-h),arr[i].S);

    p2(p1,p2)

    ans = max(ans,p2 - p1);
}

cout<<ans;




}
