#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int,int> pi;
typedef pair<ll,ll> pl;
#define F first
#define S second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);
#define endl '\n'
#ifdef dremix
    #define p(x) cerr<<#x<<" = "<<x<<endl;
    #define p2(x,y) cerr<<"("<<#x<<","<<#y<<") = "<<x<<","<<y<<endl;
    #define pv(x) cerr<<#x<<" = {";for(auto v : x)cerr<<v<<", ";cerr<<"}"<<endl;
#else
    #define p(x)
    #define p2(x,y)
    #define pv(x)
#endif
const ll INF = 2e18;
const int MOD = 1e9+7;
const int N = 1e8+1;

int val[N*4],prop[N*4];

void push(int l, int r, int par){
    int &x = prop[par];
    val[l] += x;
    prop[l] += x;
    val[r] += x;
    prop[r] += x;
    prop[par] = 0;
}

void update(int s, int e, int idx, int qs, int qe, int x){
    if(qs<=s && e<=qe){
        val[idx] += x;
        prop[idx] += x;
        return;
    }
    if(s>qe || e<qs)
        return;
    int mid = (s+e)/2;
    push(idx*2,idx*2+1,idx);
    update(s,mid,idx*2,qs,qe,x);
    update(mid+1,e,idx*2+1,qs,qe,x);
    val[idx] = max(val[idx*2],val[idx*2+1]);
}

int main (){
fastio

/// lemma : optimal rectangle always has a corner on a point
/// => 4N possible positions for rectangle
/// find way to count points in rectangle efficiently
/// wrong ^^^
/// new lemma : optimal rectangle has a point on one of its sides
/// can prove that you can choose 2 sides of the rectangle that
/// are next to each other and always arrive at an optimal answer
/// with at least one point on each of those sides
/// choose top and right sides -> use 2 BITS to create a segment

int n,w,h;
cin>>n>>w>>h;

int i;
pi arr[n];

vector<vector<int> > pts(N);

for(i=0;i<n;i++){
    int x,y;
    cin>>x>>y;
    arr[i] = {x,y};
    pts[x].push_back(y);
}

sort(arr,arr+n);

int l = 0,r = 0;
int ans = 0;

for(i=0;i<n;i++){
    p2(arr[i].F,arr[i].S)
    while(r < arr[i].F){
        r++;
        for(auto x : pts[r]){
            p2(1,x)
            p2(x,min(N,x+h))
            update(1,N,1,x,min(N,x+h),1);
        }
    }
    while(l < r - w - 1){
        l++;
        for(auto x : pts[l]){
            p2(-1,x)
            p2(x,min(N,x+h))
            update(1,N,1,x,min(N,x+h),-1);
        }
    }
    p(val[1])
    ans = max(ans,val[1]);
}

cout<<ans;




}
