#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using ll = long long;

int const lgmax = 26;
std::vector<int> var[1 + lgmax];

short dp[(1 << lgmax)];
  std::vector<std::pair<int,int>> sol;

int getmod(int modulo) {
  for(int i = 0; i < (1 << lgmax); i++)
    dp[i] = 0;
  dp[0] = 1;
  

  for(int mask = 0; mask < (1 << lgmax) - 1; mask++) {
    if(__builtin_popcount(mask) < lgmax / 2 && 0 < dp[mask]) {
      sol.push_back({dp[mask], mask});

      int id = __builtin_popcount(mask);
      for(int i = 0; i < var[id].size(); i++) {
        if((mask & (1 << var[id][i])) == 0) {
          dp[mask | (1 << var[id][i])] += dp[mask];
        }
      }
    }
  }
  return dp[(1 << lgmax) - 1];
}

int main() {
  std::string s;
  for(int i = 0; i < lgmax; i++) {
    std::cin >> s;
    for(int j = 0; j < s.size(); j++)
      var[i].push_back(s[j] - 'A');
    std::sort(var[i].begin(), var[i].end());
    var[i].erase(std::unique(var[i].begin(), var[i].end()), var[i].end());
  }
  
  std::cout << getmod((1<<14) - 1);
  return 0;
}
