#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using ll = long long;
using us = unsigned short;

int const lgmax = 26;
std::vector<int> var[1 + lgmax];

us dp[(1 << lgmax)];

int getmod(int modulo) {
  for(int i = 0; i < (1 << lgmax); i++)
    dp[i] = 0;
  dp[0] = 1;
  for(int mask = 0; mask < (1 << lgmax) - 1; mask++) {
    if(0 < dp[mask]) {
      int id = __builtin_popcount(mask);
      for(int i = 0; i < var[id].size(); i++) {
        if((mask & (1 << var[id][i])) == 0) {
          dp[mask | (1 << var[id][i])] += dp[mask];
          if(modulo <= dp[mask | (1 << var[id][i])])
            dp[mask | (1 << var[id][i])] -= modulo;
        }
      }
    }
  }
  return dp[(1 << lgmax) - 1];
}

int prime(int number) {
  for(int i = 2; i * i <= number; i++)
    if(number % i == 0)
      return 0;
  return 1;
}

int main() {
  std::string s;
  for(int i = 0; i < lgmax; i++) {
    std::cin >> s;
    for(int j = 0; j < s.size(); j++)
      var[i].push_back(s[j] - 'A');
    std::sort(var[i].begin(), var[i].end());
    var[i].erase(std::unique(var[i].begin(), var[i].end()), var[i].end());
  }
  
  std::cout << getmod((1<<14) - 1);
  return 0;
}

