#include <iostream>
#include <bits/stdc++.h>
#define ii pair<int,int>
#define x first
#define y second
#define INF 100000000
#define SUM(x,y,w,h) (sums[x+w][y+h]-sums[x-1][y+h]-sums[x+w][y-1]+sums[x-1][y-1])
using namespace std;

int main() {
    int n,w,h;
    cin>>n>>w>>h;

    vector<ii> pts(n);
    int maxy=0;
    set<int> xcoord;
    set<int> ycoord;
    for(int i=0; i<n; i++){
        cin>>pts[i].x>>pts[i].y;
        xcoord.insert(pts[i].x);
        ycoord.insert(pts[i].y);
    }
    map<int,int> xcmp;
    map<int,int> ycmp;
    int i=0;
    for(auto x:xcoord){
        xcmp[x]=i;
        i++;
    }
    i=0;
    for(auto y:ycoord){
        ycmp[y]=i;
        i++;
    }
    vector<vector<int>> sums(xcoord.size()+1,vector<int> (ycoord.size()+1,0));
    for(auto p:pts){
        sums[xcmp[p.x]+1][ycmp[p.y]+1]++;
    }
    for(int i=1; i<sums.size(); i++){
        for(int j=1; j<sums[i].size(); j++){
            sums[i][j]+=sums[i-1][j]+sums[i][j-1]-sums[i-1][j-1];
        }
    }
    int m=0;
    for(auto x1:xcoord){
        for(auto y1:ycoord){
            int x2=*prev(xcoord.upper_bound(x+w));
            int y2=*prev(ycoord.upper_bound(y+h));
            m=max(m,sums[xcmp[x2]+1][ycmp[y2]+1]-sums[xcmp[x2]+1][ycmp[y1]]-sums[xcmp[x1]][ycmp[y2]+1]+sums[xcmp[x1]][ycmp[y1]])
        }
    }
    cout<<m;
    return 0;
}
