#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100005;
const long long INF = 1000000000000000LL;

struct smn {
  long long c;
  int k;
};

smn dp[MAXN];

int a[MAXN];
long long sp[MAXN];

smn best(smn a, smn b) {
  if (a.c < b.c)
    return a;
  if (a.c > b.c)
    return b;
  if (a.k < b.k)
    return a;
  return b;
}

int baga(int n, long long cost) {
  for (int i = 1; i <= n; ++i) {
    dp[i] = {INF, 0};
    for (int j = 0; j < i; ++j) {
      smn aux = dp[j];
      aux.k++;
      aux.c += sp[j] * j + sp[j] - sp[i] * j - sp[j] * i + sp[i] * i - sp[i] + cost;
      dp[i] = best(dp[i], aux);
    }
  }
  return dp[n].k;
}

long long solve(int n, int k) {
  long long l = 0, r = 1000000000000000LL;
  long long last;
  while (l <= r) {
    long long mid = (l + r) / 2;
    if (baga(n, mid) >= k) {
      l = mid + 1;
      last = mid;
    } else {
      r = mid - 1;
    }
  }
  baga(n, last);
  return dp[n].c - 1LL * k * last;
}

int main() {
  //freopen("cancer.in", "r", stdin);
  //freopen("cancer.out", "w", stdout);

  int n, k;
  scanf("%d%d", &n, &k);
  for (int i = 1; i <= n; ++i) {
    scanf("%d", &a[i]);
    sp[i] = sp[i - 1] + a[i];
  }

  printf("%lld\n", solve(n, k));

  return 0;
}
