#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template < typename T > using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define ld long double
#define pb push_back
#define F first
#define S second
#define endl '\n'
#define Endl '\n'
#define pii pair < int, int >

const int N = 6000 + 10;
const int K = 6000 + 10;

ll dp[N][K];


int n, k;
vector < int > a;

vector < ll > pref;

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> k;
    a.resize(n + 1);
    pref.resize(n + 1);
    pref[0] = 0;
    for (int i = 1;i <= n; ++i){
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    for (int i = 0;i <= n; ++i){
        for (int j = 0;j <= k; ++j){
            dp[i][j] = 1e18;
            if (i == 0 || i == 1)dp[i][j] = 0;
        }
    }
    dp[1][1] = 0;
    for (int i = 2;i <= n; ++i){
        for (int j = 1;j <= k; ++j){
            if (j <= min(k, i)){
                if (j == 1){
                    dp[i][j] = pref[i] * (i - 1);
                    continue;
                }
                for (int z = i - 1;z > 0; --z){
                    if (dp[z][j - 1] == 1e18)break;
                    ll cost = pref[i] - pref[z];
                    //cerr << cost << " " << (i - (z + 1)) << Endl;
                    dp[i][j] = min(dp[i][j], dp[z][j - 1] + cost * (i - (z + 1)));
                }
            }else{
                //dp[i][j] = dp[i][j - 1];
            }
        }
    }

//    for (int i = 1;i <= n; ++i){
//        for (int j = 1;j <= k; ++j){
//            cout << dp[i][j] << " ";
//        }
//        cout << endl;
//    }
//    cout << endl;

    ll best = 1e18;
    for (int i = 1;i <= k; ++i)best = min(best, dp[n][i]);
    cout << best << endl;
    return 0;
}


