#include <bits/stdc++.h>

using namespace std;

const int alp = 26;

struct node
{
    int cnt = 0;
    vector<node*> to;
    node()
    {
        to.resize(alp, NULL);
    }
    node* get(char t)
    {
        int num = t - 'A';
        if (to[num] == NULL) to[num] = new node();
        return to[num];
    }
    node* cop(int c)
    {
        node* nw = new node();
        nw -> cnt = cnt * c;
        for (int i = 0; i < alp; ++i)
            if (to[i] != NULL)
                nw -> to[i] = to[i] -> cop(c);
        return nw;
    }
};

void add(string s, node* bor, int q)
{
    sort(s.begin(), s.end());
    for (int i = 0; i < s.size(); ++i)
    {
        bor = bor -> get(s[i]);
    }
    (bor -> cnt) += q;
}

int get(string s, node* bor)
{
    sort(s.begin(), s.end());
    for (int i = 0; i < s.size(); ++i)
    {
        bor = bor -> get(s[i]);
    }
    return bor -> cnt;
}

string opp(string s)
{
    vector<bool> used(alp);
    for (int i = 0; i < s.size(); ++i)
        used[s[i] - 'A'] = true;
    string res = "";
    for (int i = 0; i < alp; ++i)
        if (!used[i])
            res += (char)('A' + i);
    return res;
}

vector<string> s(alp);

bool in(string s, char t)
{
    for (int i = 0; i < s.size(); ++i)
        if (s[i] == t) return true;
    return false;
}

vector<pair<string, int> > get_all()
{
    vector<pair<string, int> > all;
    all.push_back({"", 1});
    for (int i = 0; i < (alp / 2); ++i)
    {
        vector<pair<string, int> > cop = all;
        all.clear();
        for (char j : s[i])
            for (int k = 0; k < cop.size(); ++k)
                if (!in(cop[k].first, j))
                {
                    all.push_back({cop[k].first + j, cop[k].second});
                }
    }
    for (int i = 0; i < all.size(); ++i)
    {
        sort(all[i].first.begin(), all[i].first.end());
    }
    sort(all.begin(), all.end());
    auto cop = all;
    all.clear();
    if (cop.size()) all.push_back(cop[0]);
    for (int i = 1; i < cop.size(); ++i)
        if (cop[i] != cop[i - 1]) all.push_back(cop[i]);
        else all.back().second += cop[i].second;
    cop.clear();
    return all;
}

int main()
{
    for (int i = 0; i < alp; ++i) cin >> s[i];
    for (int i = 0; i < alp; ++i)
    {
        sort(s[i].begin(), s[i].end());
        string nw = "";
        nw += s[i][0];
        for (int j = 1; j < s[i].size(); ++j)
            if (s[i][j] != s[i][j - 1]) nw += s[i][j];
        s[i] = nw;
    }

    auto all = get_all();
    node* bor = new node();
    for (int i = 0; i < all.size(); ++i)
    {
        add(all[i].first, bor, all[i].second);
    }
    reverse(s.begin(), s.end());
    all = get_all();
    int res = 0;
    for (int i = 0; i < all.size(); ++i)
    {
        res += get(opp(all[i].first), bor) * all[i].second;
    }
    cout << res << endl;
}
