#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> pref(n);
    for(int i = 0; i < n; i++) {
        pref[i] = (i == 0 ? 0 : pref[i - 1]) + a[i];
    }

    int l = 0;
    int r = 1000000000000LL;
    while(r - l > 1) {
        int lambda = (l + r) / 2;
        vector<int> dp(n, 1000000000000000LL);
        vector<int> p(n, -1);
        for(int i = 0; i < n; i++) {
            for(int i1 = i; i1 >= 0; i1--) {
                int sum = pref[i] - (i1 == 0 ? 0 : pref[i1 - 1]);
                int cost = sum * (i - i1) + lambda;
                int cur = (i1 == 0 ? 0 : dp[i1 - 1]) + cost;
                if(cur < dp[i]) {
                    dp[i] = cur;
                    p[i] = i1;
                }
            }
        }
        int i = n - 1;
        int cnt = 0;
        while(i != -1) {
            i = p[i] - 1;
            cnt++;
        }
        if(cnt > k) {
            l = lambda;
        } else {
            r = lambda;
        }
    }

    int lambda = r;
    vector<int> dp(n, 1000000000000000LL);
    vector<int> realcost(n, 1000000000000000LL);
    vector<int> p(n, -1);
    for(int i = 0; i < n; i++) {
        for(int i1 = i; i1 >= 0; i1--) {
            int sum = pref[i] - (i1 == 0 ? 0 : pref[i1 - 1]);
            int cost = sum * (i - i1) + lambda;
            int cur = (i1 == 0 ? 0 : dp[i1 - 1]) + cost;
            if(cur < dp[i]) {
                dp[i] = cur;
                realcost[i] = (i1 == 0 ? 0 : realcost[i1 - 1]) + sum * (i - i1);
                p[i] = i1;
            }
        }
    }
    int i = n - 1;
    int cnt = 0;
    while(i != -1) {
        i = p[i] - 1;
        cnt++;
    }
    assert(cnt == k);

    cout << realcost[n - 1] << endl;

    return 0;
}
