#pragma gcc optimize("O3")
#pragma gcc optimize("Ofast")
#pragma gcc target("avx2")
#include <iostream>
#include <cstring>
#include <fstream>
#include <algorithm>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

/*namespace hashtable
{
    const int M = 5400603;
    int key[M], val[M], ptr[M];

    int sz;

    void init()
    {
        memset(key, 255, sizeof key);
        memset(val, 255, sizeof val);
        memset(ptr, 255, sizeof ptr);
    }

    int Hash(int k)
    {
        return k % M;
    }

    void Set(int k, int v)
    {
        int h = Hash(k);
        while (key[h] != -1)
        {
            if (ptr[h] != -1)
                ptr[h] = sz++;
            h = ptr[h];
        }
        key[h] = k;
        val[h] = v;
    }

    int Get(int k)
    {
        int h = Hash(k);
        while (key[h] != k)
            h = ptr[h];
        return val[h];
    }
}
int s13;/**/

const int full_m  = ((1 << 26) - 1);
const int full_13 = ((1 << 13) - 1);

int cnk[27][27];

int popcnt[2 << 13];
int Left[2 << 13], Right[2 << 13];

inline int get_id_13(int mask)
{
    int cur = __builtin_popcount(mask);
    int idx = 0;
    for (int j = 0; j < 13; ++j)
    {
        if ((mask >> j) & 1)
        {
            idx += cnk[13 - j - 1][cur--];
        }
    }
    return idx;
}

inline int get_id(int mask)
{
    return Left[mask >> 13] + Right[mask & full_13];
}

int A[26][5], Asz[26];
int cnt[2][10400600]; // 1 << 26

int mask;
void dfs(int i, int en, int h)
{
    if (i == en)
    {
        ++cnt[h][get_id(mask)];
        return;
    }
    for (int j = 0; j < Asz[i]; ++j)
    {
        int c = A[i][j];
        if ((~mask >> c) & 1)
        {
            mask ^= (1 << c);
            dfs(i + 1, en, h);
            mask ^= (1 << c);
        }
    } 
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    for (int n = 0; n <= 26; ++n)
    {
        cnk[n][0] = 1;
        for (int k = 1; k <= n; ++k)
            cnk[n][k] = cnk[n - 1][k] + cnk[n - 1][k - 1];
    }

    for (int mask = 0; mask < (1 << 13); ++mask)
    {
        int x = __builtin_popcount(mask);
        popcnt[mask] = x;
        Right[mask] = get_id_13(mask);
        for (int k = 0; k < x; ++k)
            Left[mask] += cnk[13][k] * cnk[13][13 - k];
        Left[mask] += Right[mask] * cnk[13][13 - x];
    }

    for (int i = 0; i < 26; ++i)
    {
        string s;
        cin >> s;
        for (char c : s)
            A[i][Asz[i]++] = c - 'a';
        sort(A[i], A[i] + Asz[i]);
        Asz[i] = unique(A[i], A[i] + Asz[i]) - A[i];
    }
    for (int h = 0; h < 2; ++h)
    {
        dfs(h * 13, h * 13 + 13, h);
    }
    ll ans = 0;
    for (int mask = 0; mask < (1 << 26); ++mask)
    {
        if (popcnt[mask >> 13] + popcnt[mask & full_13] == 13)
        {
            ans += cnt[0][get_id(mask)] * (ll)cnt[1][get_id(mask ^ full_m)];
        }
    }
    cout << ans << '\n';

    return 0;
}