#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

const int maxN = 100005;
const int smallN = 6003;
int N, K;
int A[maxN];
ll S[maxN];

ll f(int l, int r)
{
    return (S[r] - S[l - 1]) * (r - l);
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> N >> K;
    for (int i = 1; i <= N; ++i)
    {
        cin >> A[i];
    }
    for (int i = 1; i <= N; ++i)
        S[i] = S[i - 1] + A[i];
    if (N <= 6000)
    {
        vector<int> bg(K + 1);
        iota(all(bg), 1);
        bg[K] = N + 1;
        while (true)
        {
            bool found = false;
            for (int i = K - 1; i >= 1; --i)
            {
                if (bg[i] + 1 < bg[i + 1] && f(bg[i - 1], bg[i] - 1) + f(bg[i], bg[i + 1] - 1) >= f(bg[i - 1], bg[i]) + f(bg[i] + 1, bg[i + 1] - 1))
                {
                    ++bg[i];
                    found = true;
                    break;
                }
            }
            if (!found) break;
        }
        ll ans = 0;
        for (int i = 0; i < K; ++i)
            ans += f(bg[i], bg[i + 1] - 1);
        cout << ans << '\n';
    }

    return 0;
}