#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

const int maxN = 100005;
const int smallN = 6003;
int N, K;
int A[maxN];
ll S[maxN];
ll dp[2][maxN];

ll sg(int l, int r)
{
    return (S[r] - S[l - 1]) * (r - l);
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> N >> K;
    for (int i = 1; i <= N; ++i)
    {
        cin >> A[i];
        S[i] = A[i] + S[i - 1];
    }
    memset(dp, 0x20, sizeof dp);
    for (int i = 1; i <= N; ++i)
        dp[1][i] = S[i] * (ll)(i - 1);
    for (int k = 2; k <= K; ++k)
    {
        memset(dp[k & 1], 0x20, sizeof dp[k & 1]);

        function< void(int, int, int, int) > solve = [&](int l, int r, int optL, int optR)
        {
            if (l > r) return;
            int m = (l + r) >> 1;
            int optM = -1;
            for (int j = optL; j < m && j <= optR; ++j)
                if (chkmin(dp[k & 1][m], dp[~k & 1][j] + (S[m] - S[j]) * (m - j - 1)))
                    optM = j;
            solve(l, m - 1, optL, optM);
            solve(m + 1, r, optM, optR);
        };
        solve(k, N, k - 1, N);

        for (int i = k; i <= N; ++i)
        {
//                debug(k, i, dp[k & 1][i], dp[k & 1][i + 1] - dp[k & 1][i]);
        }
    }
    cout << dp[K & 1][N] << '\n';
    return 0;
}