﻿#pragma GCC optimize("Ofast,unroll-loops")

/*
#ifdef LOCAL
#include "headers.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#endif
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>
#include <map>

using namespace std;
 
//#define int ll
 
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
#define sz(x) int((x).size())


/*
template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
*/
 
const int N = 1e5 + 10;
//const ll MOD = 998244353;
const ll MOD = 1e9 + 7;
const ld eps = 5e-8;
const pii dir[] = { { 0, 1 }, { 0, -1 }, { 1, 0 }, { -1, 0 } };

vector <char> a[26];
unsigned short s[1 << 26];
int cur;
ll ans;

void solve1(char i) {
    if (i == char(26)) {
        s[cur]++;
    }
    else {
        for (char x : a[i]) {
            if (!(cur >> x & 1)) {
                cur ^= (1 << x);
                solve1(i + 1);
                cur ^= (1 << x);
            }
        }
    }
}

void solve2(char i) {
    if (i == char(13)) {
        ans += s[((1 << 26) - 1) ^ cur];
    }
    else {
        for (char x : a[i]) {
            if (!(cur >> x & 1)) {
                cur ^= (1 << x);
                solve2(i + 1);
                cur ^= (1 << x);
            }
        }
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    for (char i = 0; i < 26; i++) {
        string s;
        cin >> s;

        sort(s.begin(), s.end());
        s.erase(unique(s.begin(), s.end()), s.end());

        for (char c : s) {
            a[i].push_back(c - 'A');
        }
    }

    solve1(13);
    solve2(0);

    cout << ans << endl;

    return 0;
}

