#include <algorithm>
#include <iostream>
#include <bitset>
#include <random>
#include <chrono>
#include <set>
using namespace std;
using llong = long long;
using uint = unsigned int;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) {cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';}
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
	return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(x)
#endif
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }
const int alSz = 26;
const int dpSz = 24;
const int szDiff = alSz - dpSz;
#define Bits(x) __builtin_popcount(x)

llong C[30][30];
llong dp[1 << dpSz];
vector<int> at[dpSz], at_[dpSz];

llong DP()
{
    sort(at, at + dpSz, [](const vector<int>& l, const vector<int>& r) {
         return l.size() > r.size();
    });
    vector<pair<int, int>> inds;
    for (int i = 0; i < dpSz; ++i)
        inds.push_back({C[dpSz][i + 1], i});
    sort(inds.begin(), inds.end());
    for (int i = 0; i < inds.size(); ++i)
        at_[inds[i].second] = at[i];
    for(int i=0;i<dpSz;++i)at[i]=at_[i];
    fill(dp, dp + (1 << dpSz), 0);
    dp[0] = 1;
    for (uint mask = 1; mask < (1 << dpSz); ++mask)
    {
        int bits = Bits(mask);
        for (int i: at[bits - 1])
            dp[mask] += dp[mask ^ (1 << i)];
    }
    return dp[(1 << dpSz) - 1];
}
int main()
{
    C[0][0] = 1;
    for (int i = 1; i < 30; ++i)
    {
        C[i][0] = C[i][i] = 1;
        for (int j = 1; j < i; ++j)
            C[i][j] = C[i - 1][j] + C[i - 1][j - 1];
    }
	ios::sync_with_stdio(0);
	cin.tie(0);
    string raw[alSz];
    for (int i = 0; i < alSz; ++i) {
        cin >> raw[i];
        sort(raw[i].begin(), raw[i].end());
        raw[i].erase(unique(raw[i].begin(), raw[i].end()), raw[i].end());
    }
    sort(raw, raw + alSz, [](const string& l, const string& r) {
         return l.size() < r.size();
    });
    {
        int i = szDiff - 1;
        while (i + 1 < alSz && raw[i + 1].size() == raw[i].size()) ++i;
        int j = i;
        while (j && raw[j - 1].size() == raw[j].size()) --j;
        swap(i, j);
        int bestval = 1000'000'000;
        vector<int> best, cur(szDiff);
        for (cur[0] = 0; cur[0] <= j; ++cur[0])
        for (cur[1] = cur[0] + 1; cur[1] <= j; ++cur[1])
        //for (cur[2] = cur[1] + 1; cur[2] <= j; ++cur[2])
        //for (cur[3] = cur[2] + 1; cur[3] <= j; ++cur[3])
        {
            int curval = 0;
            for (char a: raw[0])
            for (char b: raw[1])
            //for (char c: raw[2])
            //for (char d: raw[3])
                if (set<char>{a, b/*, c, d*/}.size() == szDiff) ++curval;
            if (best.empty() || curval < bestval)
                bestval = curval, best = cur;
        }
        raw[0].swap(raw[best[0]]);
        raw[1].swap(raw[best[1]]);
        //raw[2].swap(raw[best[2]]);
        //raw[3].swap(raw[best[3]]);
        BUGO(bestval)
    }
    //int ops =0;
    llong ans = 0;
    for (char a: raw[0])
    for (char b: raw[1])
    //for (char c: raw[2])
    //for (char d: raw[3])
    {
        if (set<char>{a, b/*, c, d*/}.size() != szDiff) continue;
        //++ops;
        for (int i = 0; i < dpSz; ++i)
            at[i].clear();
        for (int i = szDiff; i < alSz; ++i)
            for (char t: raw[i])
                if (!set<char>{a, b/*, c, d*/}.count(t))
                    at[t - 'A' - (t>a) - (t>b)/* - (t>c) - (t>d)*/].push_back(i - szDiff);
        ans += DP();
    }
    //BUGO(ops)
    cout << ans;
}
