#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>

using namespace std;

void rec(vector<long long>& pref, vector<long long>& suff, vector<int>& t, int k, int summ, long long& ans, long long all_summ) {
	if (t.size() == k - 1) {
		t.push_back(pref.size() - 1 - summ);
		rec(pref, suff, t, k, pref.size() - 1, ans, all_summ);
		t.pop_back();
		return;
	}
	if (t.size() < k) {
		for (int j = 1; j <= pref.size() - 1 + t.size() - k + 1 - summ; ++j) {
			t.push_back(j);
			rec(pref, suff, t, k, summ + j, ans, all_summ);
			t.pop_back();
		}
		return;
	}
	long long fr = 0;
	int now = 0;
	for (int i : t) {
		fr += (all_summ - pref[now] - suff[now + i]) * (i - 1);
		now += i;
	}
	ans = min(ans, fr);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	long long all_summ = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		all_summ += a[i];
	}
	vector<long long> pref(n + 1), suff(n + 1);
	pref[0] = suff[n] = 0;
	for (int i = 0; i < n; ++i)
		pref[i + 1] = pref[i] + a[i], suff[n - i - 1] = suff[n - i] + a[n - 1 - i];
	vector<int> t;
	t.reserve(k);
	long long ans = 2e18;
	rec(pref, suff, t, k, 0, ans, all_summ);
	cout << ans;
}