#include<bits/stdc++.h>

using namespace std;
#define int long long
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);
#define fileio freopen("avia.in", "r", stdin); freopen("avia.out", "w", stdout);


vector<int> tree;
vector<int> upd;
map<int, int> mpr;
vector<int> mp;
int K;

void build() {
    tree.resize((1 << (K + 1)));
    upd.resize((1 << (K + 1)));
}

void upd_v(int v) {
    if (2 * v >= tree.size()) {
        upd[v] = 0;
        return;
    }
    tree[2 * v] += upd[v];
    upd[2 * v] += upd[v];

    tree[2 * v + 1] += upd[v];
    upd[2 * v + 1] += upd[v];

    upd[v] = 0;
}

void add_lr(int l, int r, int hw, int vl = 0, int vr = (1 << K) - 1, int v = 1) {
    int yl = mp[vl];
    int yr = mp[vr];
    if (yl > r || yr < l) {
        return;
    }
    if (l <= yl && yr <= r) {
        tree[v] += hw;
        upd[v] += hw;
        return;
    }
    int vm = (vl + vr) / 2;
    upd_v(v);
    add_lr(l, r, hw, vl, vm, 2 * v);
    add_lr(l, r, hw, vm + 1, vr, 2 * v + 1);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

int mx_lr(int l, int r, int vl = 0, int vr = (1 << K) - 1, int v = 1) {
    int yl = mp[vl];
    int yr = mp[vr];
    if (yl > r || yr < l) {
        return 0;
    }
    if (l <= yl && yr <= r) {
        return tree[v];
    }
    int vm = (vl + vr) / 2;
    upd_v(v);
    int s1 = mx_lr(l, r, vl, vm, 2 * v);
    int s2 = mx_lr(l, r, vm + 1, vr, 2 * v + 1);
    return max(s1, s2);
}



signed main() {
    fastio
//    fileio
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> a (n);
    vector<int> b (n);
    vector<tuple<int, int, int>> ev;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        b[i] = a[i].second;
        ev.push_back({a[i].first, -1, a[i].second});
        ev.push_back({a[i].first + w, 1, a[i].second});
    }
    sort(b.begin(), b.end());
    mp.push_back(b[0]);
    mpr[b[0]] = 0;
    int mxv = b[0];
    for (int i = 1; i < n; ++i) {
        if (b[i] == b[i - 1]) continue;
        mpr[b[i]] = mp.size();
        mp.push_back(b[i]);
        mxv = b[i];
    }
    K = 0;
    while ((1 << K) < mp.size()) ++K;
    while (mp.size() < (1 << K)) mp.push_back(1e9);
    build();
    sort(ev.begin(), ev.end());
    int mx = 0;
    for (auto p : ev) {
        int x = get<0>(p);
        int bal = get<1>(p);
        int y = get<2>(p);
        if (bal == 1) {
            add_lr(y, y + h, -1);
            continue;
        }
        add_lr(y, y + h, 1);
        mx = max({mx, tree[1]});
    }
    cout << mx;
}