#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e5) + 5;
const ll inf = ll(1e17) + 123;

ll n = 26;
vector<string> a;

void solve() {
    a.resize(n);
    for(ll i = 0; i < n; i++) {
        cin >> a[i];
        set<char> tmp;
        for(auto c : a[i]) {
            tmp.insert(c);
        }
        a[i] = "";
        for(auto el : tmp) {
            a[i] += el;
        }
    }

    unordered_map<ll, ll> old, cur;
    cur[0] = 1;
    for(ll i = 0; i < n; i++) {
        old = cur;
        cur.clear();

        for(auto el : old) {
            for(ll j = 0; j < a[i].size(); j++) {
                ll pos = ll(1) << (a[i][j] - 'A');
                if(el.first & pos) continue;
                ll nwmsk = el.first + pos;
                cur[nwmsk] += el.second;
            }
        }
    }

    cout << cur[(ll(1) << 26) - 1] << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
