#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

typedef int ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e5) + 5;

ll n = 26;
vector<string> a;

void solve() {
    a.resize(n);
    for(ll i = 0; i < n; i++) {
        cin >> a[i];
        set<char> tmp;
        for(auto c : a[i]) {
            tmp.insert(c);
        }
        a[i] = "";
        for(auto el : tmp) {
            a[i] += el;
        }
    }

    unordered_map<ll, long long> old, cur;
    cur[0] = 1;
    for(ll i = 0; i < n / 2; i++) {
        old = cur;
        cur.clear();

        for(auto el : old) {
            for(ll j = 0; j < a[i].size(); j++) {
                ll pos = ll(1) << (a[i][j] - 'A');
                if(el.first & pos) continue;
                ll nwmsk = el.first + pos;
                cur[nwmsk] += el.second;
                if(cur[nwmsk] > ll(1e18)) {
                    cur[nwmsk] = 0;
                }
            }
        }
    }

    unordered_map<ll, long long> old2, cur2;
    cur2[0] = 1;
    for(ll i = n / 2; i < n; i++) {
        old2 = cur2;
        cur2.clear();

        for(auto el : old2) {
            for(ll j = 0; j < a[i].size(); j++) {
                ll pos = ll(1) << (a[i][j] - 'A');
                if(el.first & pos) continue;
                ll nwmsk = el.first + pos;
                cur2[nwmsk] += el.second;
                if(cur2[nwmsk] > ll(1e18)) {
                    cur2[nwmsk] = 0;
                }
            }
        }
    }

    ll all = (ll(1) << 26) - 1;

    ll ans = 0;
    for(auto el : cur) {
        ans += el.second * cur2[all - el.first];
    }
    cout << ans;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
