#include <bits/stdc++.h>

#define Tree int h,int l,int r
#define Left (h<<1),l,((l+r)>>1)
#define Right ((h<<1)|1),((l+r)>>1)+1,r
#define ll long long
#define pb push_back
#define F first
#define S second

using namespace std;

const int N=1e5+5;

int n,w,h,nx,ny,ans;
int Sx[8*N],Sy[8*N],x[N],y[N];
map < int , int > fx,fy;
vector < int > sx,sy,P[8*N];

void compress() {
	sort(sx.begin(),sx.end());
	sort(sy.begin(),sy.end());
	
	for (int i=0; i<sx.size(); i++) 
		if (!i || sx[i]!=sx[i-1]) fx[sx[i]]=++nx,Sx[nx]=sx[i];
		
	for (int i=0; i<sy.size(); i++) 
		if (!i || sy[i]!=sy[i-1]) fy[sy[i]]=++ny,Sy[ny]=sy[i];
}

int v[8*N],vadd[8*N];

void Shift(Tree) {
	if (!vadd[h]) return ;	
	v[(h<<1)]+=vadd[h];
	v[((h<<1)|1)]+=vadd[h];
	vadd[(h<<1)]+=vadd[h];
	vadd[((h<<1)|1)]+=vadd[h];
	vadd[h]=0;
}

int L,R,dl,idx;

void Upd(Tree) {
	if (r<L || R<l) return;
	if (L<=l && r<=R) {
		v[h]+=dl;
		vadd[h]+=dl;
		return ;
	}
	
	Shift(h,l,r);
	Upd(Left);
	Upd(Right);
	v[h]=max(v[(h<<1)],v[((h<<1)|1)]);
}


main () {
	ios::sync_with_stdio(false);
	cin.tie(NULL),cout.tie(NULL);
	
	cin>>n>>w>>h;
	
	for (int i=1; i<=n; i++) {
		cin>>x[i]>>y[i];
		
		sx.pb(x[i]);
		sy.pb(y[i]);
		sy.pb(max(0,y[i]-h));
	}
	
	compress();
	
	for (int i=1; i<=n; i++) 
		P[fx[x[i]]].pb(i);

	int id=0;
	for (int i=1; i<=nx; i++) {

		while (id<nx && Sx[id+1]<Sx[i]-w) {
			++id;
			for (int j=0; j<P[id].size(); j++) {
				idx=P[id][j];
				L=fy[max(0,y[idx]-h)];
				R=fy[y[idx]];
				dl=-1;
				Upd(1,1,ny);
			}
		}
		
		for (int j=0; j<P[i].size(); j++) {
			idx=P[i][j];
			L=fy[max(0,y[idx]-h)];
			R=fy[y[idx]];
			dl=1;
			Upd(1,1,ny);
		}

		ans=max(ans,v[1]);
	}
	
	cout<<ans<<"\n";
}