#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>

#define ll long long

using namespace std;

vector<string> names;
vector<ll> dp;

ll calc(ll k, int i)
{
    if(dp[k] != -1)
        return dp[k];
    if(k == 0)
        return 1;
    
    ll res = 0;
    set<char> let;
    for(char c:names[i])
        if(let.find(c) == let.end() && (1<<(c-'A'))&k)
        {
            let.insert(c);
            res += calc(k^(1<<c-'A'), i+1);
        }
    dp[k] = res;
    return res;
}

int main()
{
    dp = vector<ll>(1<<26,-1);
    names = vector<string>(26);
    for(int i=0; i<26; i++)
        cin>>names[i];
    cout<<calc((1<<26) - 1, 0)<<endl;
}