#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n,k;
    cin>>n>>k;
    vector<vector<int>> dp(k+1, vector<int>(n,0));
    vector<int> a(n);

    for(int i=0; i<n; i++)
        cin>>a[i];

    int sum = a[0];
    for(int j=1; j<n; j++)
    {
        dp[1][j] = dp[1][j-1] + a[j]*j + sum;
        sum += a[j];
    }

    for(int i=2; i<=k; i++)
    {
        for(int j=1; j<n; j++)
        {
            dp[i][j] = dp[i-1][j];
            int price = 0;
            sum = 0;
            for(int f=j; f>0; f--)
            {
                price += sum + (a[f] * (j-f));
                sum += a[f];
                dp[i][j] = min(dp[i][j], dp[i-1][f-1] + price);
            }
        }
    }
    
    cout<<dp[k][n-1]<<endl;
    return 0;
}