#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n, w, h;
    cin>>n>>w>>h;
    vector<pair<int,int>> pts;

    int maxpoint = 0;
    for(int i=0; i<n; i++)
    {
        int x,y;
        cin>>x>>y;
        maxpoint = max(maxpoint, max(x,y));
        pts.push_back(make_pair(x,y));
    }

    if(maxpoint <= 100 && n <= 100)
    {
        int best = 0;

        for(int x=0; x<100; x++)
            for(int y=0; y<100; y++)
            {
                int count = 0;
                for(auto p:pts)
                    if(p.first >= x && p.second >= y && p.first - x <= w && p.second-y <= h)
                        count++;
                best = max(best,count);
            }
        cout<<best<<endl;
    }
    else
    {
        vector<vector<int>> ptscount(1000, vector<int>(1000, 0));
        for(auto p:pts)
            ptscount[p.first][p.second]++;
        for(int i=0; i<1000; i++)
            for(int j=0; j<1000; j++)
                ptscount[i][j] += ((i==0)?0:ptscount[i-1][j]) + ((j==0)?0:ptscount[i][j-1]) - ((i==0||j==0)?0:ptscount[i-1][j-1]);
        
        int best = 0;
        for(auto p:pts)
            best = max(best, ptscount[p.first][p.second] - ((p.second<=h)?0:ptscount[p.first][p.second-h-1]) - ((p.first<=w)?0:ptscount[p.first-w-1][p.second]) - ((p.second<=h||p.first<=w)?0:ptscount[p.first-w-1][p.second-h-1]));
        cout<<best<<endl;    
    }
    
}