#include <algorithm>
#include <iostream>
#include <map>
#include <string>
#include <vector>
using namespace std;
#define all(x) begin(x), end(x)
#define allr(x) rbegin(x), rend(x)
typedef long long ll;

static constexpr ll mod = 1'000'000'007ll;
static constexpr int INF = 1'000'000'000ll;

int main() {
  ll k, n;
  cin >> n >> k;
  vector<ll> na(n);
  vector<vector<ll>> dp(n + 1, vector<ll>(k));
  for (ll ni = 0; ni < n; ni++) {
    cin >> na[ni];
  }

  k -= 1;
  for (ll ni = n - 1; ni >= 0; ni--) {
    for (ll ki = 0; ki <= k; ki++) {
      dp[ni][ki] = 10e18;
      ll sum = 0;
      for (ll nii = ni; nii < n; nii++) {
        sum += na[nii];

        if (ki > 0)
          dp[ni][ki] = min(dp[ni][ki], sum * (nii - ni) + dp[nii + 1][ki - 1]);
        else
          dp[ni][ki] = sum * (nii - ni);
      }
    }
  }

  cout << dp[0][k] << endl;

  return 0;
}
