#include <algorithm>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <vector>
using namespace std;
#define all(x) begin(x), end(x)
#define allr(x) rbegin(x), rend(x)
typedef long long ll;

static constexpr ll mod = 1'000'000'007ll;
static constexpr int INF = 1'000'000'000ll;

int main() {
  int n, w, h;
  cin >> n >> w >> h;
  map<int, vector<int>> mx;
  int minx = INF, maxx = 0, miny = INF, maxy = 0;
  for (int ni = 0; ni < n; ni++) {
    int x, y;
    cin >> x >> y;
    mx[x].push_back(y);
    minx = min(x, minx);
    miny = min(y, miny);
    maxx = max(maxx, x);
    maxy = max(y, maxy);
  }
  for (auto& p : mx) sort(all(p.second));

  int ans = 0;
  for (int x = minx; x <= maxx; x++) {
    auto it1 = mx.lower_bound(x);
    auto it2 = mx.lower_bound(x + w);
    for (int y = miny; y <= maxy; y++) {
      int lol = 0;
      for (auto it = it1; it != it2; ++it) {
        auto it3 = lower_bound(all(it->second), y);
        auto it4 = lower_bound(all(it->second), y + h);
        if (it3 == it->second.end()) continue;
        lol += distance(it3, it4);
        if (it3 != it4 && it4 != it->second.end()) lol++;
      }
      ans = max(ans, lol);
    }
  }
  cout << ans << endl;

  return 0;
}
