#include<bits/stdc++.h>
// #define int long long
#define ii std::pair <int, int>
#define app push_back
#define all(a) a.begin(), a.end()
#define bp __builtin_popcountll
#define ll long long
#define mp make_pair
#define f first
#define pb push_back
#define s second
#define Time (double)clock()/CLOCKS_PER_SEC
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
const int N = 2e5, mod = 1e9 + 7;
struct seg_tree
{
    int tree[4 * N];
    int push[4 * N];

    seg_tree() {
        memset(tree, 0, sizeof(tree));
        memset(push, 0, sizeof(push));
    }
    void doPush(int v) {
        tree[v] += push[v];
        if (2 * v < 4 * N) {
            push[2 * v] += push[v];
            push[2 * v + 1] += push[v];
        }
        push[v] = 0;
    }
    void upd(int v, int tl, int tr, int l, int r, int x) {
        doPush(v);
        if (l > r) return;
        if (tl == l && tr == r) {
            push[v] += x;
            doPush(v);
            return;
        }
        int tm = (tl + tr) / 2;
        upd(v * 2, tl, tm, l, std::min(r, tm), x);
        upd(v * 2 + 1, tm + 1, tr, std::max(tm + 1, l), r, x);
        tree[v] = std::max(tree[v * 2], tree[v * 2 + 1]);
    }
};
struct seg
{
    int l, r, x;
};
std::vector<int> X, Y;
std::vector<seg> byX[N];
int pointX[N], pointY[N];

int get(std::vector<int> &x, int y) {
    return std::lower_bound(x.begin(), x.end(), y) - x.begin();
}
int main() {
    #ifndef LOCAL
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    #endif
    int n, h, w;
    std::cin >> n >> w >> h;
    FOR(i, n) {
        std::cin >> pointX[i] >> pointY[i];
        int x = pointX[i], y = pointY[i];
        // auto seg1 = {y - h, y, + 1};
        // auto seg2 = {y - h, y, - 1};

        Y.pb({y - h});
        Y.pb({y});
        X.pb(x);
        X.pb(x + w + 1);
    }
    std::sort(X.begin(), X.end());
    X.resize(std::unique(X.begin(), X.end()) - X.begin());


    std::sort(Y.begin(), Y.end());
    Y.resize(std::unique(Y.begin(), Y.end()) - Y.begin());

    FOR(i, n) {
        int x = pointX[i], y = pointY[i];
        seg seg1 = {get(Y, y - h), get(Y, y), + 1};
        seg seg2 = {get(Y, y - h), get(Y, y), - 1};

        byX[get(X, x)].pb(seg1);
        byX[get(X, x + w + 1)].pb(seg2);
    }
    seg_tree tree;
    int answ = 0;
    FOR(i, X.size()) {
        for (auto e : byX[i]) {
            tree.upd(1, 0, Y.size() - 1, e.l, e.r, e.x);
        }
        answ = std::max(answ, tree.tree[1]);
    }
    std::cout << answ;
}