#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000000

using namespace std;

string zboroj[26];
bool vis[26];
unordered_map<int,int> dp[26];

ll rec (ll pos, ll curr) {
    if (pos >= 26) return 1;

    if (dp[pos].count(curr)) return dp[pos][curr];

    ll ret = 0;

    for (auto it:zboroj[pos]) {
        ll br = it-'A';

        if (vis[br]) continue;

        vis[br] = true;
        ret += rec(pos+1,curr|(1LL<<(br)));
        vis[br] = false;
    }

    return dp[pos][curr] = ret;
}

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (ll i = 0; i<26; i++) {
        string a;
        cin>>a;

        set<char> koi;

        for (auto it:a) koi.insert(it);

        for (auto it:koi) zboroj[i] += it;
    }

    MS(vis,0);

    cout<<rec(0,0)<<endl;
}
