#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000000

using namespace std;

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n,w,h;

    cin>>n>>w>>h;

    pair<int,int> tacki[n];
    for (int i = 0; i<n; i++) cin>>tacki[i].second>>tacki[i].first;

    vector<pair<pair<int,int>,int>> events;

    for (int i = 0; i<n; i++) {
        events.pb({{tacki[i].first, 1}, tacki[i].second});
        events.pb({{tacki[i].first+w+1, 0}, tacki[i].second});
    }

    sort(events.begin(), events.end());

    multiset<int> crnt;
    int res = 0;

    for (int i = 0; i<2*n; i++) {
        pair<int,int> currCoord = {events[i].first.first, events[i].second};
        bool finish = !events[i].first.second;

        if (finish) crnt.erase(currCoord.second);
        else {
            crnt.insert(currCoord.second);

            for (auto it = crnt.begin(); it != crnt.end(); it++) {
                auto it2 = it;
                it2++;

                int startVred = *it;
                int ctr = 1;

                for (; it2 != crnt.end(); it2++) {
                    if (*it2-startVred <= h) {
                        ctr++;
                    } else break;
                }

                res = max(res,ctr);
            }
        }
    }

    cout<<res<<endl;
}
