#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000000

using namespace std;

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n,w,h;

    cin>>n>>w>>h;

    pair<int,int> tacki[n];
    for (int i = 0; i<n; i++) cin>>tacki[i].second>>tacki[i].first;

    vector<pair<int,int>> events[1001];

    for (int i = 0; i<n; i++) {
        events[tacki[i].first].pb({1, tacki[i].second});
        events[tacki[i].first+w+1].pb({0, tacki[i].second});
    }

    for (int i = 0; i<1001; i++) sort(events[i].begin(), events[i].end());

    int vertEvents[1001];
    int res = 0;

    for (int i = 0; i<1001; i++) {
        for (auto it:events[i]) {
            pair<int,int> currCoord = {i, it.second};
            bool finish = !it.first;

            if (finish) vertEvents[currCoord.second]--;
            else vertEvents[currCoord.second]++;
        }

        int ctrMom = 0;

        for (int j = 0; j<1001; j++) {
            ctrMom += vertEvents[j];
            res = max(res,ctrMom);
        }
    }

    cout<<res<<endl;
}
