#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int dp[2][1 << 26];

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	vector<string> a(26);
	for (int i = 0; i < 26; ++i) {
		cin >> a[i];
		a[i].erase(unique(a[i].begin(), a[i].end()), a[i].end());
	}
	for (int i = 1; i <= 26; ++i) {
		for (int j = 0; j < (1 << 26); ++j)
			dp[i % 2][j] = 0;
		for (char c : a[i - 1]) {
			for (int mask = 0; mask < (1 << 26); ++mask) {
				if (mask & ((ll)1 << (c - 'A')))
					continue;
				int mask1 = (mask | ((ll)1 << (c - 'A')));
				dp[i % 2][mask1] += dp[(i - 1) % 2][mask];
			}
		}
	}
	cout << dp[0][(1 << 26) - 1];

	return 0;
}