#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <unordered_map>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

unordered_map<int, ll> dp;

ll rec(int k, vector<string>& a, int mask) {
	if (k == 26)
		return 1;
	if (dp.find(mask) != dp.end())
		return dp[mask];
	ll ans = 0;
	for (char c : a[k]) {
		if (mask & (1 << (c - 'A')))
			continue;
		ans += rec(k + 1, a, (mask | (1 << (c - 'A'))));
	}
	dp[mask] = ans;
	return ans;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	vector<string> a(26);
	for (int i = 0; i < 26; ++i) {
		cin >> a[i];
		sort(a[i].begin(), a[i].end());
		a[i].erase(unique(a[i].begin(), a[i].end()), a[i].end());
	}
	cout << rec(0, a, 0);

	return 0;
}