#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, w, h;
	cin >> n >> w >> h;
	vector<pii> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].first >> a[i].second;
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			int x = max(a[i].first, a[j].first);
			int y = max(a[i].second, a[j].second);
			int cnt = 0;
			for (int k = 0; k < n; ++k) {
				if (x - w <= a[k].first && a[k].first <= x && y - h <= a[k].second && a[k].second <= y)
					++cnt;
			}
			ans = max(ans, cnt);
		}
	}
	cout << ans;

	return 0;
}