#include <bits/stdc++.h>

#define int long long
using namespace std;
int n;
const int maxn = 1e3;
int a[maxn][maxn];
int pref[maxn + 1][maxn + 1];
vector<pair<int, int>> p;
int mxx = 0;
int mxy = 0;

void calc() {
    for (int i = 1; i < maxn + 1; ++i) {
        for (int j = 1; j < maxn + 1; ++j) {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i - 1][j - 1];
        }
    }
}

int get(int x1, int y1, int x2, int y2) {
    return pref[x2 + 1][y2 + 1] - pref[x1][y2 + 1] - pref[x2 + 1][y1] + pref[x1][y1];
}

int solve(int w, int h) {
    int ans = 0;
    if (mxx * mxy <= 1e5) {
        for (int i = 0; i <= mxx; ++i) {
            for (int j = 0; j <= mxy; ++j) {
                int x = i;
                int y = j;
                ans = max(ans, get(max(x - w, 0ll), max(y - h, 0ll), x, y));
            }
        }
        return ans;
    }
    for (int i = 0; i < p.size(); ++i) {
        int x = p[i].first;
        int y = p[i].second;
        ans = max(ans, get(max(x - w, 0ll), max(y - h, 0ll), x, y));
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cin >> n;
    int w, h;
    cin >> w >> h;

    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        mxx = max(mxx, x);
        mxy = max(mxy, y);
        p.push_back({x, y});
        a[x][y]++;
    }
    calc();
    cout << solve(w, h);
}