#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


class P {
public:
    int x, y;
    P(int x, int y)
    {
        this->x = x;
        this->y = y;
    }
};


int n, w, h;
P* points[100000];
int pc[1000][1000];


int main()
{
    cin >> n >> w >> h;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        points[i] =new P(a, b);
        pc[a][b] = 1;
    }
    for (int i = 0; i <= 1000; i++) {
        for (int j = 0; j <= 1000; j++) {
            if (i > 0)
                pc[i][j] += pc[i - 1][j];
            if (j > 0)
                pc[i][j] += pc[i][j-1];
            if (j > 0&&i>0)
                pc[i][j] -= pc[i - 1][j - 1];


        }
    }

    int ma = 0;
    for (int i = 0; i < n; i++) {
        int cmp = pc[points[i]->x][points[i]->y];
        if (points[i]->y - h - 1 > 0)
            cmp -= pc[points[i]->x][pc[points[i]->x][points[i]->y]];
        if (points[i]->x - w - 1 > 0)
            cmp -= pc[points[i]->x - w - 1][points[i]->y];
        if (points[i]->y - h - 1 > 0 && points[i]->x - w - 1 > 0)
            cmp -= pc[points[i]->x - w - 1][pc[points[i]->x][points[i]->y]];
        ma = max(ma, cmp);
    }
    cout << ma;
}
