/*
																							  
																							  
										..........             ...........  ..  ..          
	 ..--.............  ...................----......... ...........--......------.         
	  ..::----------------::---.-:*:::::*:*******:::***:-:::::----............-**..         
	  ..-:::-................:::****:--..-:--:::-..:**-::-..................:**:-.          
	   ...-::::..........-*:--.-::-:-.....-:.-..-::-..--.....--..........-::::--..          
	  ...-..-*::::-....:*--...----:--......-:.--..-::...--....-----...-:::::-..-..          
		.-...-*::--:**:.-...-:..-:--.......-:-..-...::-...-.....-:--:::::::-....            
		....-...-::::......--...-.*-........::-.--...-:-...-.-...----:::...-..-.            
		..---...-:*.......--...---*-........-:-..-....-::...---...--:-::-...-.-.            
		  .--..-::..-....--...-:.::-........-::..--....-*:..-.:-...--:-:::-.--..            
		  .--.:*-..-....-:....--.::-........-:*-..:--...:*-..--*-...--::**:-.-..            
		  ...:+-..-.....:....-:.-::-....-...-:*:..:-.-..-:*..-.*:....--:****:-..            
		  ..-+-..-...-..:...--:.:::-....--...::*..-:-.--.:::.--*::...---::-:*...            
		  ..*....-..-..--...-::.::*-.....-.-.*:*-.-:---:-::*--::.::...---:--::.             
		  .--.-.-..--..--..--::.*:*--....:.:-*:::.-::---*-::*-*..:::..----:--+..            
		  .-.:..-..--..--..-:::-*:::-....:.-*::.*.---:--:*::-*-..-:::..---:--*-.            
		..--:-.-...--..--..-::::*::*:-...:--*:-.:.--.-:--*:::*....::::.-------*.            
		..:-*..-..-::..:----:--:*-:*::...---*:-.:-::..-:::*::*-...-::::.------:.            
		.--:*.-..--::..:---::..::--:*:-..---**-.----...-:::::::...-::-::------:.            
		.--:*.-..--::..:--::-..-:-.-*:------:*-.--:.....::::--:-..-::--:*------.            
	   ..--:*.-..--:*..:--::-...::..-:------::..--:...--::-::-:...-::---:*:---:-.           
	   .--.:*--.---::-.:--::-..--:-..-:----:-:..-::-+%####%@@**-..-::---.*::----..          
	   .--.:::-.---:::.:--::+=%%%=*--.-:---:.-..-:**%#####@-::*+-.-::--:.::::----.          
	  ..--.::*-.:--:::--:*%##@@@#+**-...-:--....:--*@#@#@#%=:+::-.-::--:.::::::--..         
	  ..--.-::-.---::*:-*::#####@=+%:-...--.....-...=+++**=*+*--..-::--:--*:---*---...      
	   ..-.-::-.---::::::-:+=++=++*++...............-=:::::*+.:...-::--*:-*::-.---....      
		...--::.----::*::--.+****::+:.................-:--:---:.-.-::--**.**:-..--....      
		...---:-.:--:-:*:::-.-**:::--...................---------.-::..+*.**:-..--.         
		  .---::.---::::*::-------......................-----:-:..:::..++.::*:...--.        
		  .---::--:-::-::*::-----........................---:-:*..**:.-=+.::**-..--..       
		  .:-.::*.:--:-:::=+:--...........................-:--=*.-**-.-==-::***-..--..      
		  .:..--:*.:-*::::*=*::-.........................-.-*+=*.***--:=+-:::**:-...-.      
		  .-..-::*+-*:*:-::==*-.---..........:-..........:=***=*:**:.-*=*.*:::**:..--..     
		..-...-::++*:**:-::+=**++:....................:=++=***=***:-.:+=:.+*:::*:*----..    
		.-....-:***+:*:*:::+=+*+++*+=*-............:*:=**+=***=***:.::++:.++:-:-:::-.--...  
	   ..-....-*+**+*:**:::*=+*+++**+=+=:*::...-:*::::=***+=**:--::=*:-+++:::-:*-----..  
	  ..-....--+***+=:::**::++*+++**+%+==*::::::**+=%%%+**=+*+=*:-:::++*.*+*+*::---*..:---..
	 ..-....--+****==+-::*::*=+++=***=+=########@@%%%%@%+*++*++*::-:*=+:-=+**+*::---:..-:--.
	..-...--.*****+=++:------:+++=%@@@##%@####@@%%%%=+:%@%%@#@*:::::=++.*+***++:::----..-:--
   ..--..-:.**:*:..........-=@@%@@@%%@*:::---*:--:------*%%%@+:::-:=#+.***+***++::---:-..-:*
  ...-..-:-:+::-........-*@@@@=+*%##@%+:----**:---------*%%@=*::-:++:**:::::***++::---:...:-
  ..-..::--=::-.......-:@@%%=:*+%*:-%%=:..--**:**-:-....=@@=%@##@%%=::-......-*+++::---:..-:
...-..:::-*+::.......-=%%%%:+*%*:--..:%:.....-:*:-....--**%@+*+%%%%%@=::-.......-++::--:-..:
..-..::---=*:-......-=%%%%*+=%::-..-...=.............-....--:%***%%%@##**:........:*:---:..:
.-..-----*+::-.....--#@%%=+*@::--....:*@%=+***+*****:..-...---:%*++%%%%@+*........--*-----.:
-..----:-++*:-------*####%@@%:-..--..=#%@%%%%%@==%%%..-...--.---+=**%%%%@+..........::---:.:
..-.----:=***:::::::*####%%#+::-...:@@@%%@@%%%:%=-%%@-:..--..----+%*+@%%@+...........*---:-:
.-.-----*=*-*::::::::####%%#:--.-++*=%%@%%#@%%@**%%%@@#*-:..-:.---=%=@##@*---.......-:----::
-..---:-+=*.-=:::::::@##@@%##@+***::=@%%%%%#=+%:*%+=@@%=****-.*%####%%#%+*--------.---:---*-
...:--::*=*.-********:::::*+++:::*::+%==%%@%@@:-:+%@@%=+*:::**++*=%%+=+-..:*******---:*---*-
 .----:**=*..:*:---------:**:*:-:*::+@@%%%===%#@@@@=*+:+*::::+:-----*+:-...........--:::--*-
..----:**=*..::*---------:+*::*-:*::+::*=@@#@%%@##%@##@%*:-::+:-----:**--.........-:::.:-:::
..----:+*=*..::::--------:=:-**-:*:*+-----:+=@@@@@@%=*--*::::*:----:-:*-----...--:::....:*:-
*/

// #pragma GCC target ("avx,avx2,fma")
// #pragma GCC optimize("Ofast,unroll-loops")
  
#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>


// #pragma GCC optimize("Stack:\")
// using namespace __gnu_pbds;
 // #pragma GCC optimization("O2")
// #pragma GCC optimization
// #pragma GCC optimization("avx")
// #pragma GCC optimization("avx2")

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2")

// 8x = Ofast, avx, avx2, fma

// #pragma GCC optimize ("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;
mt19937 rnd(time(0));
typedef long long ll;
typedef long double ld;

// #define _GLIBCXX_DEBUG
// #define int ll
#define f first
#define s second
#define pb push_back
// #define int ll
#define pii pair<int, int> 
#define vi vector<int>

const int mod = 1e9 + 7;

void solve() {
	int n, k;
	cin >> n >> k;
	int a[n];
	for (auto &i : a)
		cin >> i;
	int pref[n];
	for (int i = 0; i < n; ++i) {
		pref[i] = a[i];
		if (i)
			pref[i] += pref[i - 1];
	}
	auto sum = [&] (int l, int r) {
		return pref[r] - (l > 0 ? pref[l - 1] : 0);
	};
	int dp[n + 1][k + 1];
	memset(dp, 127, sizeof(dp));
	dp[0][0] = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= k; ++j) {
			for (int from = i - 1; from >= 0; --from) {
				dp[i][j] = min(dp[i][j], dp[from][j - 1] + sum(from, i - 1) * (i - from - 1));
			}
		}
	}
	cout << dp[n][k] << endl;
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	while(t--){
		solve();
	}

	return 0;
}