/*
																							  
																							  
										..........             ...........  ..  ..          
	 ..--.............  ...................----......... ...........--......------.         
	  ..::----------------::---.-:*:::::*:*******:::***:-:::::----............-**..         
	  ..-:::-................:::****:--..-:--:::-..:**-::-..................:**:-.          
	   ...-::::..........-*:--.-::-:-.....-:.-..-::-..--.....--..........-::::--..          
	  ...-..-*::::-....:*--...----:--......-:.--..-::...--....-----...-:::::-..-..          
		.-...-*::--:**:.-...-:..-:--.......-:-..-...::-...-.....-:--:::::::-....            
		....-...-::::......--...-.*-........::-.--...-:-...-.-...----:::...-..-.            
		..---...-:*.......--...---*-........-:-..-....-::...---...--:-::-...-.-.            
		  .--..-::..-....--...-:.::-........-::..--....-*:..-.:-...--:-:::-.--..            
		  .--.:*-..-....-:....--.::-........-:*-..:--...:*-..--*-...--::**:-.-..            
		  ...:+-..-.....:....-:.-::-....-...-:*:..:-.-..-:*..-.*:....--:****:-..            
		  ..-+-..-...-..:...--:.:::-....--...::*..-:-.--.:::.--*::...---::-:*...            
		  ..*....-..-..--...-::.::*-.....-.-.*:*-.-:---:-::*--::.::...---:--::.             
		  .--.-.-..--..--..--::.*:*--....:.:-*:::.-::---*-::*-*..:::..----:--+..            
		  .-.:..-..--..--..-:::-*:::-....:.-*::.*.---:--:*::-*-..-:::..---:--*-.            
		..--:-.-...--..--..-::::*::*:-...:--*:-.:.--.-:--*:::*....::::.-------*.            
		..:-*..-..-::..:----:--:*-:*::...---*:-.:-::..-:::*::*-...-::::.------:.            
		.--:*.-..--::..:---::..::--:*:-..---**-.----...-:::::::...-::-::------:.            
		.--:*.-..--::..:--::-..-:-.-*:------:*-.--:.....::::--:-..-::--:*------.            
	   ..--:*.-..--:*..:--::-...::..-:------::..--:...--::-::-:...-::---:*:---:-.           
	   .--.:*--.---::-.:--::-..--:-..-:----:-:..-::-+%####%@@**-..-::---.*::----..          
	   .--.:::-.---:::.:--::+=%%%=*--.-:---:.-..-:**%#####@-::*+-.-::--:.::::----.          
	  ..--.::*-.:--:::--:*%##@@@#+**-...-:--....:--*@#@#@#%=:+::-.-::--:.::::::--..         
	  ..--.-::-.---::*:-*::#####@=+%:-...--.....-...=+++**=*+*--..-::--:--*:---*---...      
	   ..-.-::-.---::::::-:+=++=++*++...............-=:::::*+.:...-::--*:-*::-.---....      
		...--::.----::*::--.+****::+:.................-:--:---:.-.-::--**.**:-..--....      
		...---:-.:--:-:*:::-.-**:::--...................---------.-::..+*.**:-..--.         
		  .---::.---::::*::-------......................-----:-:..:::..++.::*:...--.        
		  .---::--:-::-::*::-----........................---:-:*..**:.-=+.::**-..--..       
		  .:-.::*.:--:-:::=+:--...........................-:--=*.-**-.-==-::***-..--..      
		  .:..--:*.:-*::::*=*::-.........................-.-*+=*.***--:=+-:::**:-...-.      
		  .-..-::*+-*:*:-::==*-.---..........:-..........:=***=*:**:.-*=*.*:::**:..--..     
		..-...-::++*:**:-::+=**++:....................:=++=***=***:-.:+=:.+*:::*:*----..    
		.-....-:***+:*:*:::+=+*+++*+=*-............:*:=**+=***=***:.::++:.++:-:-:::-.--...  
	   ..-....-*+**+*:**:::*=+*+++**+=+=:*::...-:*::::=***+=**:--::=*:-+++:::-:*-----..  
	  ..-....--+***+=:::**::++*+++**+%+==*::::::**+=%%%+**=+*+=*:-:::++*.*+*+*::---*..:---..
	 ..-....--+****==+-::*::*=+++=***=+=########@@%%%%@%+*++*++*::-:*=+:-=+**+*::---:..-:--.
	..-...--.*****+=++:------:+++=%@@@##%@####@@%%%%=+:%@%%@#@*:::::=++.*+***++:::----..-:--
   ..--..-:.**:*:..........-=@@%@@@%%@*:::---*:--:------*%%%@+:::-:=#+.***+***++::---:-..-:*
  ...-..-:-:+::-........-*@@@@=+*%##@%+:----**:---------*%%@=*::-:++:**:::::***++::---:...:-
  ..-..::--=::-.......-:@@%%=:*+%*:-%%=:..--**:**-:-....=@@=%@##@%%=::-......-*+++::---:..-:
...-..:::-*+::.......-=%%%%:+*%*:--..:%:.....-:*:-....--**%@+*+%%%%%@=::-.......-++::--:-..:
..-..::---=*:-......-=%%%%*+=%::-..-...=.............-....--:%***%%%@##**:........:*:---:..:
.-..-----*+::-.....--#@%%=+*@::--....:*@%=+***+*****:..-...---:%*++%%%%@+*........--*-----.:
-..----:-++*:-------*####%@@%:-..--..=#%@%%%%%@==%%%..-...--.---+=**%%%%@+..........::---:.:
..-.----:=***:::::::*####%%#+::-...:@@@%%@@%%%:%=-%%@-:..--..----+%*+@%%@+...........*---:-:
.-.-----*=*-*::::::::####%%#:--.-++*=%%@%%#@%%@**%%%@@#*-:..-:.---=%=@##@*---.......-:----::
-..---:-+=*.-=:::::::@##@@%##@+***::=@%%%%%#=+%:*%+=@@%=****-.*%####%%#%+*--------.---:---*-
...:--::*=*.-********:::::*+++:::*::+%==%%@%@@:-:+%@@%=+*:::**++*=%%+=+-..:*******---:*---*-
 .----:**=*..:*:---------:**:*:-:*::+@@%%%===%#@@@@=*+:+*::::+:-----*+:-...........--:::--*-
..----:**=*..::*---------:+*::*-:*::+::*=@@#@%%@##%@##@%*:-::+:-----:**--.........-:::.:-:::
..----:+*=*..::::--------:=:-**-:*:*+-----:+=@@@@@@%=*--*::::*:----:-:*-----...--:::....:*:-
*/

// #pragma GCC target ("avx,avx2,fma")
// #pragma GCC optimize("Ofast,unroll-loops")
  
#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>


// #pragma GCC optimize("Stack:\")
// using namespace __gnu_pbds;
 // #pragma GCC optimization("O2")
// #pragma GCC optimization
// #pragma GCC optimization("avx")
// #pragma GCC optimization("avx2")

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2")

// 8x = Ofast, avx, avx2, fma

// #pragma GCC optimize ("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;
mt19937 rnd(time(0));
typedef long long ll;
typedef long double ld;

// #define _GLIBCXX_DEBUG
// #define int ll
#define f first
#define s second
#define pb push_back
#define int ll
#define pii pair<int, int> 
#define vi vector<int>

const int mod = 1e9 + 7;

void solve() {
	int n, k;
	cin >> n >> k;
	int a[n];
	for (auto &i : a)
		cin >> i;
	int pref[n];
	for (int i = 0; i < n; ++i) {
		pref[i] = a[i];
		if (i)
			pref[i] += pref[i - 1];
	}
	auto sum = [&] (int l, int r) -> int{
		return pref[r] - (l > 0 ? pref[l - 1] : 0);
	};
	int dp[n + 1][k + 1];
	int mn[n + 1][k + 1];
	memset(dp, 127, sizeof(dp));
	dp[0][0] = 0;
	memset(mn, 127, sizeof(mn));
	for (int j = 0; j <= n; ++j)
		mn[j][0] = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= k; ++j) {
			int l = -1, r = i;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				// cout << i << ' ' << mid << ' ' << mn[mid][j - 1] << endl;
				if (mn[mid][j - 1] > 1e15) {
					l = mid;
				} else {
					r = mid;
				}
			}
			int L = r;
			l = r;
			r = i;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (dp[mid][j - 1] > 1e15) {
					r = mid;
				} else {
					l = mid;
				}
			}
			int R = l;
			l = L, r = R;
			while (r - l > 2) {
				int mid1 = l + (r - l) / 3;
				int mid2 = r - (r - l) / 3;
				int getl = dp[mid1][j - 1] + sum(mid1, i - 1) * (i - mid1 - 1);
				int getr = dp[mid2][j - 1] + sum(mid2, i - 1) * (i - mid2 - 1);

				if (getl < getr) {
					r = mid2;
				} else {
					l = mid1;
				}
			}
			for (int k = l; k <= r; ++k) {
				dp[i][j] = min(dp[i][j], dp[k][j - 1] + sum(k, i - 1) * (i - k - 1));
			}
			// for (int from = R; from >= L; --from) {
			// 	dp[i][j] = min(dp[i][j], dp[from][j - 1] + sum(from, i - 1) * (i - from - 1));
			// 	cout << i << ' ' << j << ' ' << from << ' ' << dp[from][j - 1] + sum(from, i - 1) * (i - from - 1) << endl;
			// }
			mn[i][j] = dp[i][j];
			mn[i][j] = min(mn[i][j], mn[i - 1][j]);
			// cout << endl;
		}
	}
	cout << dp[n][k] << endl;
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	while(t--){
		solve();
	}

	return 0;
}