/*
																							  
																							  
										..........             ...........  ..  ..          
	 ..--.............  ...................----......... ...........--......------.         
	  ..::----------------::---.-:*:::::*:*******:::***:-:::::----............-**..         
	  ..-:::-................:::****:--..-:--:::-..:**-::-..................:**:-.          
	   ...-::::..........-*:--.-::-:-.....-:.-..-::-..--.....--..........-::::--..          
	  ...-..-*::::-....:*--...----:--......-:.--..-::...--....-----...-:::::-..-..          
		.-...-*::--:**:.-...-:..-:--.......-:-..-...::-...-.....-:--:::::::-....            
		....-...-::::......--...-.*-........::-.--...-:-...-.-...----:::...-..-.            
		..---...-:*.......--...---*-........-:-..-....-::...---...--:-::-...-.-.            
		  .--..-::..-....--...-:.::-........-::..--....-*:..-.:-...--:-:::-.--..            
		  .--.:*-..-....-:....--.::-........-:*-..:--...:*-..--*-...--::**:-.-..            
		  ...:+-..-.....:....-:.-::-....-...-:*:..:-.-..-:*..-.*:....--:****:-..            
		  ..-+-..-...-..:...--:.:::-....--...::*..-:-.--.:::.--*::...---::-:*...            
		  ..*....-..-..--...-::.::*-.....-.-.*:*-.-:---:-::*--::.::...---:--::.             
		  .--.-.-..--..--..--::.*:*--....:.:-*:::.-::---*-::*-*..:::..----:--+..            
		  .-.:..-..--..--..-:::-*:::-....:.-*::.*.---:--:*::-*-..-:::..---:--*-.            
		..--:-.-...--..--..-::::*::*:-...:--*:-.:.--.-:--*:::*....::::.-------*.            
		..:-*..-..-::..:----:--:*-:*::...---*:-.:-::..-:::*::*-...-::::.------:.            
		.--:*.-..--::..:---::..::--:*:-..---**-.----...-:::::::...-::-::------:.            
		.--:*.-..--::..:--::-..-:-.-*:------:*-.--:.....::::--:-..-::--:*------.            
	   ..--:*.-..--:*..:--::-...::..-:------::..--:...--::-::-:...-::---:*:---:-.           
	   .--.:*--.---::-.:--::-..--:-..-:----:-:..-::-+%####%@@**-..-::---.*::----..          
	   .--.:::-.---:::.:--::+=%%%=*--.-:---:.-..-:**%#####@-::*+-.-::--:.::::----.          
	  ..--.::*-.:--:::--:*%##@@@#+**-...-:--....:--*@#@#@#%=:+::-.-::--:.::::::--..         
	  ..--.-::-.---::*:-*::#####@=+%:-...--.....-...=+++**=*+*--..-::--:--*:---*---...      
	   ..-.-::-.---::::::-:+=++=++*++...............-=:::::*+.:...-::--*:-*::-.---....      
		...--::.----::*::--.+****::+:.................-:--:---:.-.-::--**.**:-..--....      
		...---:-.:--:-:*:::-.-**:::--...................---------.-::..+*.**:-..--.         
		  .---::.---::::*::-------......................-----:-:..:::..++.::*:...--.        
		  .---::--:-::-::*::-----........................---:-:*..**:.-=+.::**-..--..       
		  .:-.::*.:--:-:::=+:--...........................-:--=*.-**-.-==-::***-..--..      
		  .:..--:*.:-*::::*=*::-.........................-.-*+=*.***--:=+-:::**:-...-.      
		  .-..-::*+-*:*:-::==*-.---..........:-..........:=***=*:**:.-*=*.*:::**:..--..     
		..-...-::++*:**:-::+=**++:....................:=++=***=***:-.:+=:.+*:::*:*----..    
		.-....-:***+:*:*:::+=+*+++*+=*-............:*:=**+=***=***:.::++:.++:-:-:::-.--...  
	   ..-....-*+**+*:**:::*=+*+++**+=+=:*::...-:*::::=***+=**:--::=*:-+++:::-:*-----..  
	  ..-....--+***+=:::**::++*+++**+%+==*::::::**+=%%%+**=+*+=*:-:::++*.*+*+*::---*..:---..
	 ..-....--+****==+-::*::*=+++=***=+=########@@%%%%@%+*++*++*::-:*=+:-=+**+*::---:..-:--.
	..-...--.*****+=++:------:+++=%@@@##%@####@@%%%%=+:%@%%@#@*:::::=++.*+***++:::----..-:--
   ..--..-:.**:*:..........-=@@%@@@%%@*:::---*:--:------*%%%@+:::-:=#+.***+***++::---:-..-:*
  ...-..-:-:+::-........-*@@@@=+*%##@%+:----**:---------*%%@=*::-:++:**:::::***++::---:...:-
  ..-..::--=::-.......-:@@%%=:*+%*:-%%=:..--**:**-:-....=@@=%@##@%%=::-......-*+++::---:..-:
...-..:::-*+::.......-=%%%%:+*%*:--..:%:.....-:*:-....--**%@+*+%%%%%@=::-.......-++::--:-..:
..-..::---=*:-......-=%%%%*+=%::-..-...=.............-....--:%***%%%@##**:........:*:---:..:
.-..-----*+::-.....--#@%%=+*@::--....:*@%=+***+*****:..-...---:%*++%%%%@+*........--*-----.:
-..----:-++*:-------*####%@@%:-..--..=#%@%%%%%@==%%%..-...--.---+=**%%%%@+..........::---:.:
..-.----:=***:::::::*####%%#+::-...:@@@%%@@%%%:%=-%%@-:..--..----+%*+@%%@+...........*---:-:
.-.-----*=*-*::::::::####%%#:--.-++*=%%@%%#@%%@**%%%@@#*-:..-:.---=%=@##@*---.......-:----::
-..---:-+=*.-=:::::::@##@@%##@+***::=@%%%%%#=+%:*%+=@@%=****-.*%####%%#%+*--------.---:---*-
...:--::*=*.-********:::::*+++:::*::+%==%%@%@@:-:+%@@%=+*:::**++*=%%+=+-..:*******---:*---*-
 .----:**=*..:*:---------:**:*:-:*::+@@%%%===%#@@@@=*+:+*::::+:-----*+:-...........--:::--*-
..----:**=*..::*---------:+*::*-:*::+::*=@@#@%%@##%@##@%*:-::+:-----:**--.........-:::.:-:::
..----:+*=*..::::--------:=:-**-:*:*+-----:+=@@@@@@%=*--*::::*:----:-:*-----...--:::....:*:-
*/

// #pragma GCC target ("avx,avx2,fma")
// #pragma GCC optimize("Ofast,unroll-loops")
  
#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>


// #pragma GCC optimize("Stack:\")
// using namespace __gnu_pbds;
 // #pragma GCC optimization("O2")
// #pragma GCC optimization
// #pragma GCC optimization("avx")
// #pragma GCC optimization("avx2")

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2")

// 8x = Ofast, avx, avx2, fma

// #pragma GCC optimize ("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;
mt19937 rnd(time(0));
typedef long long ll;
typedef long double ld;

// #define _GLIBCXX_DEBUG
// #define int ll
#define f first
#define s second
#define pb push_back
#define int ll
#define pii pair<int, int> 
#define vi vector<int>

const int mod = 1e9 + 7;
const int maxn = 1e5 + 50;
vector<vi> dp;
int pref[maxn];

int sum(int l, int r) {
	return pref[r] - (l > 0 ? pref[l - 1] : 0);
};

void rec(int l, int r, int optl, int optr, int k) {
	if (l > r)
		return;
	int mid = (l + r) / 2;
	int opt = 0;
	for (int j = optl; j <= min(mid - 1, optr); ++j) {
		// cout << k << ' ' << mid << ' ' << dp[mid][k] << endl;
		// cout << j << ' ' << dp[j][k - 1] + sum(j, mid - 1) * (mid - j - 1) << endl;
		// cout << (dp[j][k - 1] + sum(j, mid - 1) * (mid - j - 1) < dp[mid][k]) << endl;
		if (dp[j][k - 1] + sum(j, mid - 1) * (mid - j - 1) < dp[mid][k]) {
			dp[mid][k] = dp[j][k - 1] + sum(j, mid - 1) * (mid - j - 1);
			opt = j;
		}
	}
	// cout << opt << endl;
	rec(l, mid - 1, optl, opt, k);
	rec(mid + 1, r, opt, optr, k);
}

void solve() {
	int n, k;
	cin >> n >> k;
	int a[n];
	dp.resize(n + 1, vi(k + 1, int(1e18)));
	for (auto &i : a)
		cin >> i;
	for (int i = 0; i < n; ++i) {
		pref[i] = a[i];
		if (i)
			pref[i] += pref[i - 1];
	}
	dp[0][0] = 0;
	for (int j = 1; j <= k; ++j) {
		rec(1, n, 0, n, j);	
	}
	cout << dp[n][k] << endl;
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	while(t--){
		solve();
	}

	return 0;
}