/*
																							  
																							  
										..........             ...........  ..  ..          
	 ..--.............  ...................----......... ...........--......------.         
	  ..::----------------::---.-:*:::::*:*******:::***:-:::::----............-**..         
	  ..-:::-................:::****:--..-:--:::-..:**-::-..................:**:-.          
	   ...-::::..........-*:--.-::-:-.....-:.-..-::-..--.....--..........-::::--..          
	  ...-..-*::::-....:*--...----:--......-:.--..-::...--....-----...-:::::-..-..          
		.-...-*::--:**:.-...-:..-:--.......-:-..-...::-...-.....-:--:::::::-....            
		....-...-::::......--...-.*-........::-.--...-:-...-.-...----:::...-..-.            
		..---...-:*.......--...---*-........-:-..-....-::...---...--:-::-...-.-.            
		  .--..-::..-....--...-:.::-........-::..--....-*:..-.:-...--:-:::-.--..            
		  .--.:*-..-....-:....--.::-........-:*-..:--...:*-..--*-...--::**:-.-..            
		  ...:+-..-.....:....-:.-::-....-...-:*:..:-.-..-:*..-.*:....--:****:-..            
		  ..-+-..-...-..:...--:.:::-....--...::*..-:-.--.:::.--*::...---::-:*...            
		  ..*....-..-..--...-::.::*-.....-.-.*:*-.-:---:-::*--::.::...---:--::.             
		  .--.-.-..--..--..--::.*:*--....:.:-*:::.-::---*-::*-*..:::..----:--+..            
		  .-.:..-..--..--..-:::-*:::-....:.-*::.*.---:--:*::-*-..-:::..---:--*-.            
		..--:-.-...--..--..-::::*::*:-...:--*:-.:.--.-:--*:::*....::::.-------*.            
		..:-*..-..-::..:----:--:*-:*::...---*:-.:-::..-:::*::*-...-::::.------:.            
		.--:*.-..--::..:---::..::--:*:-..---**-.----...-:::::::...-::-::------:.            
		.--:*.-..--::..:--::-..-:-.-*:------:*-.--:.....::::--:-..-::--:*------.            
	   ..--:*.-..--:*..:--::-...::..-:------::..--:...--::-::-:...-::---:*:---:-.           
	   .--.:*--.---::-.:--::-..--:-..-:----:-:..-::-+%####%@@**-..-::---.*::----..          
	   .--.:::-.---:::.:--::+=%%%=*--.-:---:.-..-:**%#####@-::*+-.-::--:.::::----.          
	  ..--.::*-.:--:::--:*%##@@@#+**-...-:--....:--*@#@#@#%=:+::-.-::--:.::::::--..         
	  ..--.-::-.---::*:-*::#####@=+%:-...--.....-...=+++**=*+*--..-::--:--*:---*---...      
	   ..-.-::-.---::::::-:+=++=++*++...............-=:::::*+.:...-::--*:-*::-.---....      
		...--::.----::*::--.+****::+:.................-:--:---:.-.-::--**.**:-..--....      
		...---:-.:--:-:*:::-.-**:::--...................---------.-::..+*.**:-..--.         
		  .---::.---::::*::-------......................-----:-:..:::..++.::*:...--.        
		  .---::--:-::-::*::-----........................---:-:*..**:.-=+.::**-..--..       
		  .:-.::*.:--:-:::=+:--...........................-:--=*.-**-.-==-::***-..--..      
		  .:..--:*.:-*::::*=*::-.........................-.-*+=*.***--:=+-:::**:-...-.      
		  .-..-::*+-*:*:-::==*-.---..........:-..........:=***=*:**:.-*=*.*:::**:..--..     
		..-...-::++*:**:-::+=**++:....................:=++=***=***:-.:+=:.+*:::*:*----..    
		.-....-:***+:*:*:::+=+*+++*+=*-............:*:=**+=***=***:.::++:.++:-:-:::-.--...  
	   ..-....-*+**+*:**:::*=+*+++**+=+=:*::...-:*::::=***+=**:--::=*:-+++:::-:*-----..  
	  ..-....--+***+=:::**::++*+++**+%+==*::::::**+=%%%+**=+*+=*:-:::++*.*+*+*::---*..:---..
	 ..-....--+****==+-::*::*=+++=***=+=########@@%%%%@%+*++*++*::-:*=+:-=+**+*::---:..-:--.
	..-...--.*****+=++:------:+++=%@@@##%@####@@%%%%=+:%@%%@#@*:::::=++.*+***++:::----..-:--
   ..--..-:.**:*:..........-=@@%@@@%%@*:::---*:--:------*%%%@+:::-:=#+.***+***++::---:-..-:*
  ...-..-:-:+::-........-*@@@@=+*%##@%+:----**:---------*%%@=*::-:++:**:::::***++::---:...:-
  ..-..::--=::-.......-:@@%%=:*+%*:-%%=:..--**:**-:-....=@@=%@##@%%=::-......-*+++::---:..-:
...-..:::-*+::.......-=%%%%:+*%*:--..:%:.....-:*:-....--**%@+*+%%%%%@=::-.......-++::--:-..:
..-..::---=*:-......-=%%%%*+=%::-..-...=.............-....--:%***%%%@##**:........:*:---:..:
.-..-----*+::-.....--#@%%=+*@::--....:*@%=+***+*****:..-...---:%*++%%%%@+*........--*-----.:
-..----:-++*:-------*####%@@%:-..--..=#%@%%%%%@==%%%..-...--.---+=**%%%%@+..........::---:.:
..-.----:=***:::::::*####%%#+::-...:@@@%%@@%%%:%=-%%@-:..--..----+%*+@%%@+...........*---:-:
.-.-----*=*-*::::::::####%%#:--.-++*=%%@%%#@%%@**%%%@@#*-:..-:.---=%=@##@*---.......-:----::
-..---:-+=*.-=:::::::@##@@%##@+***::=@%%%%%#=+%:*%+=@@%=****-.*%####%%#%+*--------.---:---*-
...:--::*=*.-********:::::*+++:::*::+%==%%@%@@:-:+%@@%=+*:::**++*=%%+=+-..:*******---:*---*-
 .----:**=*..:*:---------:**:*:-:*::+@@%%%===%#@@@@=*+:+*::::+:-----*+:-...........--:::--*-
..----:**=*..::*---------:+*::*-:*::+::*=@@#@%%@##%@##@%*:-::+:-----:**--.........-:::.:-:::
..----:+*=*..::::--------:=:-**-:*:*+-----:+=@@@@@@%=*--*::::*:----:-:*-----...--:::....:*:-
*/

// #pragma GCC target ("avx,avx2,fma")
// #pragma GCC optimize("Ofast,unroll-loops")
  
#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>


// #pragma GCC optimize("Stack:\")
// using namespace __gnu_pbds;
 // #pragma GCC optimization("O2")
// #pragma GCC optimization
// #pragma GCC optimization("avx")
// #pragma GCC optimization("avx2")

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2")

// 8x = Ofast, avx, avx2, fma

// #pragma GCC optimize ("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;
mt19937 rnd(time(0));
typedef long long ll;
typedef long double ld;

// #define _GLIBCXX_DEBUG
// #define int ll
#define f first
#define s second
#define pb push_back
#define int ll
#define pii pair<int, int> 
#define vi vector<int>

const int mod = 1e9 + 7;

void solve() {
	int n, w, h;
	cin >> n >> w >> h;
	pii a[n];
	map<int, vi> x;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].f >> a[i].s;
		x[a[i].f].pb(a[i].s);
	}
	int ans = 0;
	auto l = x.begin();
	map<int, int> mp;
	for (auto i = x.begin(); i != x.end(); ++i) {
		// cout << 1 << endl;
		while (l != x.end() && l->f < i->f - w) {
			// cout << 2 << endl;
			for (auto &j : l->s)
				mp[j]--;
			l++;
		}
		for (auto &j : i->s)
			mp[j]++;
		int cnt = 0;
		int mx = 0;
		auto it = mp.begin();
		for (auto j = mp.begin(); j != mp.end(); ++j) {
			// cout << 3 << endl;
			while (it != mp.end() && it->f < j->f - h) {
				// cout << 4 << endl;
				cnt -= it->s;
				it++;
			}
			cnt += j->s;
			mx = max(mx, cnt);
		}
		ans = max(ans, mx);
	}
	cout << ans << endl;

}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	while(t--){
		solve();
	}

	return 0;
}