#include <random>

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cstring>
#include <string>

using namespace std;

#define MAXN 1000000
#define MAXN 1000000

vector<int> arr[26];

int ans = 0;
int cur[26];

void gen(int x) {
    if (x == 26) {
        ans++;
        return;
    }
    for (auto i:arr[x]) {
        if (cur[i] == 0) {
            cur[i] = 1;
            gen(x + 1);
            cur[i] = 0;
        }
    }

}

bool comp(vector<int>& a, vector<int>& b) {
    return a.size() < b.size();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    memset(cur, 0, sizeof(cur));
    for (int i = 0; i < 26; ++i) {
        string s;
        cin >> s;
        sort(s.begin(), s.end());
        s.erase(unique(s.begin(), s.end()), s.end());
        for(char c:s){
            int ind = c-'A';
            arr[ind].push_back(i);
        }
    }
    sort(arr, arr+26, comp);
    gen(0);
    cout << ans;
    return 0;
}