#include <random>

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cstring>
#include <string>
#include <unordered_map>

using namespace std;
#define int long long
vector<int> arr[26];
vector<int> last[26];

unordered_map<int, int> dp[30];

int calc_dp(int cnt, int mask) {
    if (dp[cnt].count({mask})) {
        return dp[cnt][mask];
    }
    if (cnt == 0) {
        if (__builtin_popcount(mask) == 26) {
            return 1;
        }
        return 0;
    }
    int ans = 0;
    bool flag = false;
    for (auto i:last[cnt - 1]) {
        if ((mask | (1LL << i)) != mask) {
            if (flag) {
                ans = 0;
                break;
            }
            mask ^= (1LL << i);
            ans += calc_dp(cnt - 1, mask);
            mask ^= (1LL << i);
            flag = 1;
        }
    }
    if (!flag) {
        for (auto i:arr[cnt - 1]) {
            if ((mask | (1LL << i)) != mask) {
                mask ^= (1LL << i);
                ans += calc_dp(cnt - 1, mask);
                mask ^= (1LL << i);
            }
        }
    }
    return dp[cnt][mask] = ans;

}

bool comp(vector<int> &a, vector<int> &b) {
    return a.size() > b.size();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    for (int i = 0; i < 26; ++i) {
        string s;
        cin >> s;
        sort(s.begin(), s.end());
        s.erase(unique(s.begin(), s.end()), s.end());
        for (char c:s) {
            int ind = c - 'A';
            arr[ind].push_back(i);
        }
    }
    sort(arr, arr + 26, comp);

    for (int let = 0; let < 26; ++let) {
        for (int hum = 0; hum < 26; ++hum) {
            if (find(arr[hum].begin(), arr[hum].end(), let) != arr[hum].end()) {
                last[hum].push_back(let);
                break;
            }
        }
    }
    cout << calc_dp(26, 0);
    return 0;
}