#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
typedef long long ll;
typedef long double ld;

const int N = 1 << 26;
const short MOD[] = {32749, 32719, 32717, 32713};
const short INV[] = {217, 25539, 639, 6323};

unsigned short current[N];
string s[26];
vector<int> bycnt[26][14];

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int max_mask1 = 1 << 13;
	for (int i = 0; i < max_mask1; ++i) {
		for (int j = 0; j <= 13; ++j) {
			if (i >> j & 1)
				continue;
			bycnt[__builtin_popcount(i)][j].push_back(i);
		}
	}
	for (int i = 0; i < 26; ++i) {
		cin >> s[i];
		sort(all(s[i]));
		s[i].resize(unique(all(s[i])) - begin(s[i]));
	}
	// mt19937 rnd(1);
	// shuffle(all(s), rnd);
	sort(all(s));
	reverse(all(s));
	int answ[4];
	for (int modcnt = 0; modcnt < 4; ++modcnt) {
		fill(all(current), 0);
		current[0] = 1;
		for (int i = 0; i < 26; ++i) {
			// cout << "modulo " << modcnt << " index" << i << endl;
			for (int cc = 0; cc < sz(s[i]); ++cc) {
				int curr = s[i][cc] - 'A';
				int currmod = MOD[modcnt];
				if (curr < 13) {
					for (int j = 0; j <= 13; ++j) {
						int h = i - j;
						if (h < 0 || h > 13)
							continue;
						for (int lomask : bycnt[j][13]) {
							for (int himask : bycnt[h][curr]) {
								int pmask = (lomask << 13) | himask;
								int nmask = pmask | (1 << curr);
								if (!current[pmask])
									continue;
								current[nmask] += current[pmask];
								if (current[nmask] >= currmod)
									current[nmask] -= currmod;
							}
						}
					}
				} else {
					int checkcurr = curr - 13;
					for (int j = 0; j <= 13; ++j) {
						int h = i - j;
						if (h < 0 || h > 13)
							continue;
						for (int himask : bycnt[j][checkcurr]) {
							for (int lomask : bycnt[h][13]) {
								int pmask = (himask << 13) | lomask;
								int nmask = pmask | (1 << curr);
								if (!current[pmask])
									continue;
								current[nmask] += current[pmask];
								if (current[nmask] >= MOD[modcnt])
									current[nmask] -= MOD[modcnt];
							}
						}
					}
				}
			}
		}
		answ[modcnt] = current[N - 1];
	}
	__int128 res = 0;
	for (int i = 0; i < 4; ++i) {
		__int128 lres = 1;
		for (int j = 0; j < 4; ++j) {
			if (i == j)
				lres *= INV[j];
			else
				lres *= MOD[j];
		}
		lres *= answ[i];
		res += lres;
	}
	__int128 modulo = 1;
	for (int i = 0; i < 4; ++i)
		modulo *= MOD[i];
	cout << ll(res % modulo);
	// cout << current[N - 1] << endl;
#ifdef DEBUG
	cout << endl << "time: " << clock() << endl;
#endif
	return 0;
}