#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
typedef long long ll;
typedef long double ld;

const int N = 1e3 + 10, K = 301;
const ll INF = 0x3f3f3f3f3f3f3f3f;

int n, k;
int a[N];
ll pref[N];
pair<ld, int> dp[N];

void countFor(ld cost) {
	fill(all(dp), make_pair(ld(+INF), -1));
	dp[0] = {0, 0};
	for (int j = 1; j <= n; ++j) {
		for (int h = 0; h < j; ++h) {
			ld curr = dp[h].x + ll(j - h - 1) * (pref[j] - pref[h]) + cost;
			if (dp[j].x > curr) {
				dp[j].x = curr;
				dp[j].y = dp[h].y + 1;
			}
		}
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 0; i < n; ++i)
		cin >> a[i], pref[i + 1] = pref[i] + a[i];
	
	ld lef = -1e12, rig = 1e12;
	for (int iter = 0; iter < 50; ++iter) {
		ld cost = (lef + rig) / 2;
		countFor(cost);
		if (dp[n].y == k) {
			rig = cost;
			break;
		}
		if (dp[n].y > k)
			lef = cost;
		else
			rig = cost;
	}
	countFor(rig);
	cout << setprecision(0) << fixed << round(dp[n].x - rig * k);
	return 0;
}	