#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
typedef long long ll;
typedef long double ld;

const int N = 1e5 + 10, C = 1 << 18, TREE = 1 << 19;

pair<int, int> a[N];

int tree[TREE], d[TREE];

void pull(int i) {
	i /= 2;
	while (i) {
		tree[i] = max(tree[2 * i], tree[2 * i + 1]) + d[i];
		i /= 2;
	}
}

template<int x>
void add(int l, int r) {
	l += C;
	r += C;
	int ole = l, ori = r;
	while (l <= r) {
		if (l & 1)	d[l] += x, tree[l] += x;
		if (!(r & 1))	d[r] += x, tree[r] += x;
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	pull(ole);
	pull(ori);
}

int get() {
	return tree[1];
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, w, h;
	cin >> n >> w >> h;
	map<int, int> remap;
	remap[0] = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
		remap[a[i].y] = 0;
		remap[a[i].y - h] = 0;
	}
	int ptr = 0;
	for (auto &e : remap)
		e.y = ptr++;
	sort(a, a + n);
	int ans = 0;

	int j = 0;
	for (int i = 0; i < n; ++i) {
		if (i) {
			// remove point a[i - 1]
			add<-1>(remap[max(a[i - 1].y - h, 0)], remap[a[i - 1].y]);
		}
		if (!i || a[i].x != a[i - 1].x) {
			while (j < n && a[j].x <= a[i].x + w) {
				// add point a[j].x
				add<1>(remap[max(a[j].y - h, 0)], remap[a[j].y]);
				++j;
			}
			ans = max(ans, get());
		}
	}
	cout << ans << "\n";
	return 0;
}