#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef pair<ll, ll> pl;
typedef vector<pl> vpl;
typedef vector<ll> vl;
typedef vector<vl> vvl;
typedef vector<vpl> vvpl;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vpi> vvpi;

#define fi first
#define se second
#define pb push_back
#define eb emplace_back
#define rep(i, n) for(int i = 0; i < n; ++i)
#define repl(i, n) for(ll i = 0; i < n; ++i)


//#define BRUH_WHY_TESTCASES
const int mod = 1e9 + 7;

ll bexp(ll b, ll p) {
    ll curr = b;
    ll res = 1;
    while(p) {
        if(p % 2)
        {
            res *= curr;
            res %= mod;
        }
        curr *= curr;
        curr %= mod;
        p /= 2;
    }
    return res;

}


const ll INFL = 2e18 + 5;

ll n, k;
const int maxn = 1005;
const int maxk = 1005;
ll dp[maxn][maxk] = { { 0 } };
ll pre[100005];
ll a[100005];

void subtask5()
{
    ll res = INFL;
    for(int left = 1; left <= n - 2; ++left)
    {
        if( pre[left] * (left-1) > res) break;
        for(int right = 1; left + right <= n - 1; ++right)
        {
            if(pre[left] * (left-1) + pre[right] * (right - 1) > res) break;
            res = min(res, pre[left] * (left-1) + (pre[n] - pre[n-right]) * (right - 1) + (pre[n-right] - pre[left]) * (n - right - left - 1));
        }
    }
    cout << res << '\n';
}



ll f(ll l, ll r)
{
    // l - last element of section 1
    // r - last element of section 2
    return pre[l] * (l - 1) + (pre[n] - pre[r]) * (n - r - 1) + (pre[r] - pre[l]) * (r - l - 1);
}
void subtask5_fast()
{
    ll res = INFL;
    int l = 1; int r = 2;
    res = f(1, 2);
    ++r;
    while(r < n)
    {
        int tl = 1; int tr = r - 1;
        while(tr - tl > 0)
        {
            int m1 = tl + (tr - tl) / 3;
            int m2 = tr - (tr - tl) / 3;
            ll f1 = f(m1, r);
            ll f2 = f(m2, r);
            res = min(res, f1);
            res = min(res, f2);
            if(f1 < f2)
            {
                tr = m2 - 1;
            }
            else
            {
                tl = m1 + 1;
            }
            

        }
        res = min(res, f(tl, r));
        ++r;
    }
    cout << res << '\n';

}
void solve()
{
    cin >> n >> k;
    rep(i, n)
    {
        cin >> a[i+1];
        pre[i+1] = pre[i] + a[i+1];
    }
    if(k == 3)
    {
        subtask5_fast(); return;
    }
    for(int i = 1; i <= n; ++i)
    {
        for(ll j = 1; j <= min((int)k, i); ++j)
        {
            dp[i][j] = INFL;
    
            if(i == j)
            {
                dp[i][j] = 0;
            }
            else if (j == 1)
            {
                dp[i][j] = pre[i] * (i - 1);
            }
            else
            {
                for(int off = 1; i - off >= j-1; ++off)
                {
                    dp[i][j] = min(dp[i][j], 
                     (pre[i] - pre[i-off]) * (off-1) + dp[i-off][j-1]);
                }
            }
        }
    }
    cout << dp[n][k] << '\n';
}

































int main()
{
    int t = 1;
    #ifdef BRUH_WHY_TESTCASES
        cin >> t;
    #endif
    rep(_t, t)
    {
        solve();
    }
}