#include <bits/stdc++.h>
using namespace std;
#define app push_back
#define ii pair <int, int>
#define x first
#define y second
#define all(x) x.begin(), x.end()

const int N = 1e5+7;
int mx[N << 2], prop[N << 2];

void gap(int v, int x) {
    prop[v] += x;
    mx[v] += x;
}

void push(int v) {
    if (prop[v]) {
        gap(v * 2 + 1, prop[v]);
        gap(v * 2 + 2, prop[v]);
        prop[v] = 0;
    }   
}   

void relax(int v) {
    mx[v] = max(mx[v * 2 + 1], mx[v * 2 + 2]);
}   

void add(int v, int tl, int tr, int l, int r, int x) {
    if (tr < l || r < tl)
        return;
    if (l <= tl && tr <= r) {
        gap(v, x);
        return;
    }   
    int tm = (tl + tr) >> 1;
    push(v);
    add(v * 2 + 1, tl, tm, l, r, x);
    add(v * 2 + 2, tm + 1, tr, l, r, x);
    relax(v);
}   

ii a[N];

int addl[N], addr[N];

signed main() {
    #ifdef HOME
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #endif
    int n, w, h; // w - x, h - y
    cin >> n >> w >> h;
    vector <int> c;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
        c.app(a[i].y);
    }   
    sort(c.begin(), c.end());

    for (int i = 0; i < n; ++i) {
        addl[i] = lower_bound(all(c), a[i].y - h) - c.begin();
        addr[i] = upper_bound(all(c), a[i].y) - c.begin() - 1;
    }   
    
    vector <ii> t;
    for (int i = 0; i < n; ++i)
        t.app({a[i].x, i});
    sort(all(t));

    int ptr = 0; // first bad
    int ans = 0;

    auto addi = [&] (int i) {
        if (addl[i] <= addr[i]) {
            add(0, 0, n - 1, addl[i], addr[i], 1);
        }   
    };  

    auto del = [&] (int i) {
        if (addl[i] <= addr[i]) {
            add(0, 0, n - 1, addl[i], addr[i], -1);
        }   
    };  

    for (int i = 0; i < n; ++i) {
        if (i) {
            del(t[i - 1].y);
        }   
        while (ptr < n && t[ptr].x - t[i].x <= w) {
            addi(t[ptr].y);
            ptr++;
        }   
        ans = max(ans, mx[0]);
    }   
    cout << ans << endl;
}