#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = unsigned;
#define int ll
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int n = 26;
vector<int> a[n];
map<int, int> dp;

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (char c : s) {
			a[i].push_back(c - 'A');
		}
		sort(all(a[i]));
		a[i].erase(unique(all(a[i])), a[i].end());
	}

	dp[0] = 1;
	int full = (1 << n) - 1;
	for (int i = 0; i < full; ++i) {
		if (dp.find(i) == dp.end()) {
			continue;
		}
		int v = dp[i];
		if (!v) {
			continue;
		}
		auto &vec = a[__builtin_popcountll(i)];
		for (int j : vec) {
			if ((i >> j) & 1) {
				continue;
			}
			dp[i | (1 << j)] += v;
		}
	}
	cout << dp[full] << "\n";
#ifdef LC
	cout << "Time: " << 1000 * clock() / CLOCKS_PER_SEC <<  "ms" << endl;
	cout << "States: " << dp.size() << " " << 100.0 * dp.size() / (1 << n) << "%" << endl;
#endif
	return 0;
}