#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
using namespace std;
using ll = unsigned;
#define int ll
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int INF = 1e9;

void time_assert(bool c) {
	if (c) {
		return;
	}
	while (clock() < 100 * CLOCKS_PER_SEC) {}
}

void wa_assert(bool c) {
	if (c) {
		return;
	}
	cout << "-1\n";
	exit(0);
}

const int n = 26;
const int full = (1 << n) - 1;
const int maxs = 10400700;

int cnk[n + 1][n + 1];

int getmask(int k, int i) {
	assert(0 <= i && i < cnk[n][k]);
	int res = 0;
	for (int b = n; b--; ) {
		if (i >= cnk[b][k]) {
			i -= cnk[b][k];
			res |= 1 << b;
			--k;
		}
	}
	return res;
}
int getind(int k, int res) {
	int i = 0;
	for (int b = n; b--; ) {
		if ((res >> b) & 1) {
			i += cnk[b][k--];
		}
	}
	return i;
}

vector<int> a[n];
int mem[2 * maxs];
int *cur = mem, *nxt = mem + maxs;

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	for (int i = 0; i <= n; ++i) {
		cnk[i][0] = cnk[i][i] = 1;
		for (int j = 1; j < i; ++j) {
			cnk[i][j] = min(INF, cnk[i - 1][j] + cnk[i - 1][j - 1]);
		}
	}
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (char c : s) {
			a[i].push_back(c - 'A');
		}
		sort(all(a[i]));
		a[i].erase(unique(all(a[i])), a[i].end());
	}
	cur[0] = 1;
	for (int cnt = 0; cnt < n; ++cnt) {
		if (cnt < n / 2) {
			assert(clock() < CLOCKS_PER_SEC);
		}
		fill_n(nxt, cnk[n][cnt + 1], 0);
		for (int ind = 0; ind < cnk[n][cnt]; ++ind) {
			if (!cur[ind]) {
				continue;
			}
			int i = getmask(cnt, ind);
			int v = cur[ind];
			for (int j : a[cnt]) {
				if ((i >> j) & 1) {
					continue;
				}
				nxt[getind(cnt + 1, i | (1 << j))] += v;
			}
		}
		copy_n(nxt, cnk[n][cnt + 1], cur);
	}
	cout << cur[0] << "\n";
#ifdef LC
	cout << "Time: " << 1000 * clock() / CLOCKS_PER_SEC <<  "ms" << endl;
	// cout << "States: " << len << " " << 100.0 * len / (1 << n) << "%" << endl;
#endif
	return 0;
}