#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = unsigned;
#define int ll
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int INF = 1e9;

void time_assert(bool c) {
	if (c) {
		return;
	}
	while (clock() < 100 * CLOCKS_PER_SEC) {}
}

void wa_assert(bool c) {
	if (c) {
		return;
	}
	cout << "-1\n";
	exit(0);
}

const int n = 26;
const int full = (1 << n) - 1;
const int l = 13;
const int maxs = 10400600;

vector<int> a[n];
int cnk[n + 1][n + 1];
int ans = 0;
int q[maxs];

int getind(int k, int res) {
	int i = 0;
	for (int b = n; b--; ) {
		if ((res >> b) & 1) {
			i += cnk[b][k--];
		}
	}
	return i;
}

void fi(int i, int m) {
	if (i == l) {
		int cur = getind(l, full ^ m);
		++q[cur];
		return;
	}
	for (int j : a[i]) {
		if ((m >> j) & 1) {
			continue;
		}
		fi(i + 1, m ^ (1 << j));
	}
}

void se(int i, int m) {
	if (i == n) {
		ans += q[getind(l, m)];
		return;
	}
	for (int j : a[i]) {
		if ((m >> j) & 1) {
			continue;
		}
		se(i + 1, m ^ (1 << j));
	}
}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	for (int i = 0; i <= n; ++i) {
		cnk[i][0] = cnk[i][i] = 1;
		for (int j = 1; j < i; ++j) {
			cnk[i][j] = min(INF, cnk[i - 1][j] + cnk[i - 1][j - 1]);
		}
	}
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (char c : s) {
			a[c - 'A'].push_back(i);
		}
	}
	for (int i = 0; i < n; ++i) {
		sort(all(a[i]));
		a[i].erase(unique(all(a[i])), a[i].end());
	}

	fi(0, 0);
	se(l, 0);
	cout << ans << "\n";

#ifdef LC
	cout << "Time: " << 1000 * clock() / CLOCKS_PER_SEC <<  "ms" << endl;
	// cout << "States: " << len << " " << 100.0 * len / (1 << n) << "%" << endl;
#endif
	return 0;
}