#include <bits/stdc++.h>
#define fr(i, n, m) for(int i = (n); i < (m); i ++)

using namespace std;
typedef long double ld;
const int mxn = 2e5;
int n, k;
int a[mxn];
int pre[mxn];


int dp[mxn];
int cn[mxn];

void f(int lambda){
	dp[0] = 0;
	cn[0] = 0;
	
	dp[1] = lambda;
	cn[1] = 1;
	int l = 1;
	fr(i, 2, n+1){
		int cost = dp[l-1]+(pre[i]-pre[l-1])*(i-l)+lambda;
		while(l < i && dp[l]+(pre[i]-pre[l])*(i-l-1) + lambda < cost){
			cost = dp[l]+(pre[i]-pre[l])*(i-l-1)+lambda;
			++l;
		}
		dp[i] = cost;
		cn[i] = cn[l-1]+1;
	}
}

int solve(){
	int l = 0, r = 1e9;
	int ans = 0;
	while(l < r){
		int mid = (l+r)/2;
		f(mid);
		if(cn[n] >= k){
			ans = mid;
			l = mid+1;
		}
		else{
			r = mid;
		}
	}
	f(ans);
	return dp[n]-k*ans;
}



int main(){
	cin >> n >> k;
	fr(i, 1, n+1){
		cin >> a[i];
		pre[i] = pre[i-1] + a[i];
	}
	
	cout<<solve();
	//simple dp : dp[i][k] divide first i into k 
	//cost for S [i,j] = sum from p = i : j Ap - |S|
	
	//key observation : dp[n][k] - dp[n][k-1] > dp[n][k+1] - dp[n][k]
	//allien trick.
	
	//let p[i][j] is start of the last optimal range in dp[i][j] => p[i][j] <= p[i+1][j] or p[i+1][j] = i+1
	
	
	
}
