#include <bits/stdc++.h>
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define all(x) begin(x), end(x)
#define OK cout << "OK" << endl
//#define int ll
//#define endl '\n'

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n, k, ans;
vector<int> A, range_sum;
priority_queue<pair<int, pii>> groups;

main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> k;
    A.resize(n), range_sum.resize(n);
    for(int i = 0; i < n; i++)
    {
        cin >> A[i];
        range_sum[i] = A[i];
        if (i) range_sum[i] += range_sum[i - 1];
    }
    groups.push({range_sum[n - 1] * (n - 1), {0, n - 1}});

    k--;
    while(k && !groups.empty())
    {
        //cout << k << endl;
        int l, r;
        l = groups.top().second.first;
        r = groups.top().second.second;
        groups.pop();

        int lst_sum, sum_l, sum_r, new_mid = l;
        lst_sum = (range_sum[r] - range_sum[l]) * (r - l - 1);
        sum_l = 0, sum_r = lst_sum;
        for(int i = l + 1; i <= r; i++)
        {
            //cout << l << " " << i << " " << r << " *** ";
            int tmp_sum_r = (range_sum[r] - range_sum[i]) * (r - i - 1);
            int tmp_sum_l = (range_sum[i] - ((l - 1) >= 0 ? range_sum[l - 1] : 0)) * (i - l);
            //cout << tmp_sum_r << " " << tmp_sum_l << endl;
            if (tmp_sum_l + tmp_sum_r > lst_sum)
            {
                new_mid = i - 1;
                break;
            }
            sum_l = tmp_sum_l;
            sum_r = tmp_sum_r;
            lst_sum = tmp_sum_l + tmp_sum_r;
        }

        groups.push({sum_l, {l, new_mid}});
        groups.push({sum_r, {new_mid + 1, r}});
        k--;
    }

    while(!groups.empty())
    {
        ans += groups.top().first;
        groups.pop();
    }

    cout << ans << endl;
}
