#include <bits/stdc++.h>
#define LL long long
using namespace std;

const int N = 26;
unordered_map < int, LL > dp;
string L[N];

string removeRepeatingLetters( string );
bool sizeSort( string, string );
LL F( int, int );

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    for(int i=0;i<N;i++) cin >> L[i];

    for(int i=0;i<N;i++) sort( L[i].begin(), L[i].end() );

    for(int i=0;i<N;i++) L[i] = removeRepeatingLetters( L[i] );

    sort( L, L+N, sizeSort );

    // for( string S : L ) cout << S << endl;

    cout << F( 0, 0 ) << endl;

}

LL F( int idx, int mask ){

    if( idx == N ) return 1;

    if( dp.find( mask ) != dp.end() ) return dp[mask];

    string S = L[idx];

    LL rv = 0;
    for( char c : S ){
        if( mask & ( 1 << ( c - 'A' ) ) ) continue;
        rv += F( idx+1, mask | ( 1 << ( c - 'A' ) ) );
    }

    return dp[mask] = rv;

}

bool sizeSort( string a, string b ){

    if( a.length() != b.length() ) return a.length() < b.length();
    return a < b;

}

string removeRepeatingLetters( string S ){

    string rv = ""; rv += S[0];
    for(int i=1;i<S.length();i++){
        if( S[i] != S[i-1] ) rv += S[i];
    }
    return rv;

}
