#include <bits/stdc++.h>
#define LL long long
using namespace std;

struct point{
    LL x, y;
    point(){}
    point( LL _x, LL _y ) : x(_x), y(_y) {}
};

const LL maxN = 1005;
LL N, W, H;
point PL[maxN];

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> N >> W >> H;

    for(LL i=0;i<N;i++) cin >> PL[i].x >> PL[i].y;

    LL maxRes = 1;
    for(LL i=0;i<N;i++){

        LL UL = 0, UR = 0, BL = 0, BR = 0;
        for(LL j=0;j<N;j++){

            bool reachRight = PL[j].x >= PL[i].x && PL[j].x - PL[i].x <= W;
            bool reachLeft  = PL[i].x >= PL[j].x && PL[i].x - PL[j].x <= W;
            bool reachUp    = PL[j].y >= PL[i].y && PL[j].y - PL[i].y <= H;
            bool reachDown  = PL[i].y >= PL[j].y && PL[i].y - PL[j].y <= H;

            UL += reachDown & reachRight;
            UR += reachDown & reachLeft;
            BL += reachUp & reachRight;
            BR += reachUp & reachLeft;

        }

        maxRes = max( maxRes, max( max( UL, UR ), max( BL, BR ) ) );

    }

    cout << maxRes << endl;

}
