#include <bits/stdc++.h>
#define LL long long
using namespace std;

struct point{
    LL x, y;
    point(){}
    point( LL _x, LL _y ) : x(_x), y(_y) {}
};

const LL maxN = 100005, maxD = 1005;
LL N, W, H;
point PL[maxN];
int rx = 0, ry = 0;
int maxRes = 0;
int currentPoints = 0;
int G[maxD][maxD] = {};

void goLeft(), goRight(), goUp();
void initRectangle();

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> N >> W >> H;

    for(int i=0;i<N;i++) cin >> PL[i].x >> PL[i].y;

    for(int i=0;i<N;i++) G[ PL[i].x ][ PL[i].y ]++;

    initRectangle();
    //cout << rx << ' ' << ry << ' ' << currentPoints << endl;

    while( ry + H < maxD-1 ){

        if( rx == 0 ){

            while( rx + W < maxD-1 ){
                goRight(); rx++;
                //cout << rx << ' ' << ry << ' ' << currentPoints << endl;
            }

        }else{

            while( rx > 0 ){
                goLeft(); rx--;
                //cout << rx << ' ' << ry << ' ' << currentPoints << endl;
            }

        }

        goUp(); ry++;
        //cout << rx << ' ' << ry << ' ' << currentPoints << endl;

    }

    cout << maxRes << endl;

}

void goRight(){

    for(int j=ry;j<=ry+H;j++) currentPoints -= G[rx][j];

    for(int j=ry;j<=ry+H;j++) currentPoints += G[rx+W+1][j];

    maxRes = max( maxRes, currentPoints );

}

void goLeft(){

    for(int j=ry;j<=ry+H;j++) currentPoints -= G[rx+W][j];

    for(int j=ry;j<=ry+H;j++) currentPoints += G[rx-1][j];

    maxRes = max( maxRes, currentPoints );

}

void goUp(){

    for(int i=rx;i<=rx+W;i++) currentPoints -= G[i][ry];

    for(int i=rx;i<=rx+W;i++) currentPoints += G[i][ry+H+1];

    maxRes = max( maxRes, currentPoints );

}

void initRectangle(){

    for(int i=0;i<=W;i++){
        for(int j=0;j<=H;j++){
            currentPoints += G[i][j];
        }
    }
    maxRes = currentPoints;

}
