#include<bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define se second
#define fi first
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ld long double
#define pb push_back

pii solve(vector<int>& a, int x) {
    int n = a.size();
    vector<int> pref(n + 1, 0);
    for (int i = 0; i < n; i++) pref[i + 1] = pref[i] + a[i];
    vector<pii> dp(n + 1, {1e18, 0});
    dp[0] = {0, 0};
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < i; j++) {
            pii res = {dp[j].fi + x + (i - j - 1) * (pref[i] - pref[j]), dp[j].se + 1};
            if (res.fi < dp[i].fi) {
                dp[i] = res;
            }
        }
    }
    return dp[n];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int l = -1, r = 1e9, ans = 0;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        pii res = solve(a, m);
        if (res.se <= k) {
            r = m;
            ans = res.fi - k * m;
        }
        else {
            l = m;
        }
    }
    cout << ans;
}
