#include<bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define se second
#define fi first
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ld long double
#define pb push_back

mt19937 gen(time(0));

pii solve(vector<int>& a, int x) {
    int n = a.size();
    vector<int> pref(n + 1, 0);
    for (int i = 0; i < n; i++) pref[i + 1] = pref[i] + a[i];
    vector<pii> dp(n + 1, {1e18, 0});
    dp[0] = {0, 0};
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < i; j++) {
            pii res = {dp[j].fi + x + (i - j - 1) * (pref[i] - pref[j]), dp[j].se + 1};
            if (res.fi < dp[i].fi) {
                dp[i] = res;
            }
        }
    }
    return dp[n];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    if (n > 6000) {
        vector<int> a(n), pref(n + 1);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            pref[i + 1] = pref[i] + a[i];
        }
        int test = 50, res = 1e18;
        while (test--) {
            vector<int> st;
            for (int i = 0; i + 1 < n; i++) st.pb(i);
            shuffle(all(st), gen);
            vector<int> r = {n - 1};
            for (int i = 0; i < k - 1; i++) r.pb(st[i]);
            sort(all(r));
            vector<int> l(k, 0);
            for (int i = 1; i < k; i++) l[i] = r[i - 1] + 1;
            vector<int> p;
            for (int i = 1; i < k; i++) p.pb(i);
            while (true) {
                shuffle(all(p), gen);
                bool f = false;
                for (auto j : p) {
                    int d = (r[j] - l[j]) * (pref[r[j] + 1] - pref[l[j]]);
                    d += (r[j - 1] - l[j - 1]) * (pref[r[j - 1] + 1] - pref[l[j - 1]]);
                    for (int i = l[j - 1]; i < r[j]; i++) {
                        int nd = (i - l[j - 1]) * (pref[i + 1] - pref[l[j - 1]]);
                        nd += (r[j] - (i + 1)) * (pref[r[j] + 1] - pref[(i + 1)]);
                        if (nd < d) {
                            f = true;
                            d = nd;
                            r[j - 1] = i, l[j] = i + 1;
                        }
                    }
                }
                if (!f) break;
            }
            int ans = 0;
            for (int i = 0; i < k; i++) {
                ans += (r[i] - l[i]) * (pref[r[i] + 1] - pref[l[i]]);
            }
            res = min(res, ans);
        }
        cout << res;
        return 0;
    }
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int l = -1, r = 1e12, ans = 0;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        pii res = solve(a, m);
        if (res.se <= k) {
            r = m;
            ans = res.fi - k * m;
        }
        else {
            l = m;
        }
    }
    cout << ans;
}
