#include<bits/stdc++.h>

using namespace std;

#define pii pair<int, int>
#define se second
#define fi first
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ld long double
#define pb push_back

struct node {
    int t = 0, d = 0;
    node* l;
    node* r;
    node() : t(0), d(0), l(nullptr), r(nullptr) {};
    node(int x, int y) : t(x), d(y), l(nullptr), r(nullptr) {};
};

typedef node* pnode;

void push(pnode v, int l, int r) {
    v->t += v->d;
    if (l + 1 != r) {
        if (!v->l) v->l = new node();
        v->l->d += v->d;
        if (!v->r) v->r = new node();
        v->r->d += v->d;
    }
    v->d = 0;
}

void update(pnode v, int l, int r, int l1, int r1, int x) {
    push(v, l, r);
    if (l >= r1 || l1 >= r) return;
    if (l1 <= l && r <= r1) {
        v->d += x;
        push(v, l, r);
        return;
    }
    int m = (l + r) / 2;
    update(v->l, l, m, l1, r1, x);
    update(v->r, m, r, l1, r1, x);
    v->t = max(v->l->t, v->r->t);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    w++, h++;
    pnode root = new node();
    int MX = 1e8 + 1;
    vector<pii> b;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        b.pb({x, y});
    }
    sort(all(b));
    int ans = 0, r = 0;
    for (int i = 0; i < n; i++) {
        int x = b[i].fi, y = b[i].se;
        update(root, 0, MX, y - h + 1, y + 1, 1);
        while (r < i && b[r].fi + w - 1 < x) {
            update(root, 0, MX, b[r].se - h + 1, b[r].se + 1, -1);
            r++;
        }
        ans = max(ans, root->t);
    }
    cout << ans;
}
