#include<bits/stdc++.h>

using namespace std;

#define pii pair<int, int>
#define se second
#define fi first
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ld long double
#define pb push_back

int I = 1;

int t[6000000], d[6000000], l[6000000], r[6000000];

void push(int v, int l2, int r2) {
    t[v] += d[v];
    if (l2 + 1 != r2) {
        if (l[v] == -1) d[I] = t[I] = 0, l[I] = r[I] = -1, l[v] = I++;
        d[l[v]] += d[v];
        if (r[v] == -1) d[I] = t[I] = 0, l[I] = r[I] = -1, r[v] = I++;
        d[r[v]] += d[v];
    }
    d[v] = 0;
}

void update(int v, int l2, int r2, int l1, int r1, int x) {
    push(v, l2, r2);
    if (l2 >= r1 || l1 >= r2) return;
    if (l1 <= l2 && r2 <= r1) {
        d[v] += x;
        push(v, l2, r2);
        return;
    }
    int m = (l2 + r2) / 2;
    update(l[v], l2, m, l1, r1, x);
    update(r[v], m, r2, l1, r1, x);
    t[v] = max(t[l[v]], t[r[v]]);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    w++, h++;
    t[0] = d[0] = 0;
    l[0] = r[0] = -1;
    int MX = 1e5 + 1;
    vector<pii> b;
    vector<int> z;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        b.pb({x, y});
        z.pb(y);
    }
    sort(all(z));
    sort(all(b));
    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        int x = b[i].fi, y = b[i].se;
        y = lower_bound(all(z), y) - z.begin();
        int lv = -1, rv = y;
        while (lv + 1 < rv) {
            int mid = (lv + rv) / 2;
            if (z[mid] >= b[i].se - h + 1) rv = mid;
            else lv = mid;
        }
        d[i] = rv;
        b[i].se = y;
    }
    int ans = 0, r = 0;
    for (int i = 0; i < n; i++) {
        int x = b[i].fi, y = b[i].se;
        update(0, 0, MX, d[i], y + 1, 1);
        while (r < i && b[r].fi + w - 1 < x) {
            update(0, 0, MX, d[r], b[r].se + 1, -1);
            r++;
        }
        ans = max(ans, t[0]);
    }
    cout << ans;
}
