#include "bits/stdc++.h"


//#define int long long

#define all(v) v.begin(), v.end()

using namespace std;


const int maxn = 1e5 + 10;


int t[maxn * 20 * 4];
int ln[maxn * 20 * 4];
int rn[maxn * 20 * 4];
int ver[maxn];

int sz = 1;

int copy(int v) {
    t[sz] = t[v];
    ln[sz] = ln[v];
    rn[sz] = rn[v];
    return sz++;
}


int get(int v, int l, int r, int tl = 0, int tr = maxn) {
    if (l <= tl && tr <= r) return t[v];
    if (tr <= l || r <= tl) return 0;
    int m = (tl + tr) / 2;
    return get(ln[v], l, r, tl, m) + get(rn[v], l, r, m, tr);
}


int update(int v, int i, int c, int tl = 0, int tr = maxn) {
    int new_v = copy(v);
    if (tl + 1 == tr) {
        t[new_v] += c;
        return new_v;
    }
    int m = (tl + tr) / 2;
    if (i < m) {
        ln[new_v] = update(ln[v], i, c, tl, m);
    } else {
        rn[new_v] = update(rn[v], i, c, m, tr);
    }
    t[new_v] = t[ln[new_v]] + t[rn[new_v]];
    return new_v;
}


int build(int v = 1, int tl = 0, int tr = maxn) {
    if (tr - tl == 1) {
        sz = v + 1;
        return v;
    }
    int m = (tl + tr) / 2;
    ln[v] = build(v * 2, tl, m);
    rn[v] = build(v * 2 + 1, m, tr);
    return v;
}


int x[maxn];
int y[maxn];

vector<int> groupedx[maxn];

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, w, h;
    cin >> n >> w >> h;
    vector<int> uncx, uncy;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        uncx.push_back(x[i]);
        uncy.push_back(y[i]);
    }
    sort(all(uncx));
    sort(all(uncy));
    uncx.resize(unique(all(uncx)) - uncx.begin());
    uncy.resize(unique(all(uncy)) - uncy.begin());
    map<int, int> cx;
    map<int, int> cy;
    for (int i = 0; i < uncx.size(); ++i) {
        cx[uncx[i]] = i;
    }
    for (int i = 0; i < uncy.size(); ++i) {
        cy[uncy[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        groupedx[cx[x[i]]].push_back(cy[y[i]]);
    }
    ver[0] = build();
    for (int i = 0; i < uncx.size(); ++i) {
        ver[i + 1] = ver[i];
        for (int ay: groupedx[i]) {
            ver[i + 1] = update(ver[i + 1], ay, 1);
        }
    }
    auto get_cnt = [&](int x1, int x2, int y1, int y2) -> int {
        return get(ver[x2], y1, y2) - get(ver[x1], y1, y2);
    };
    int ans = 0;
//    if (uncx.size() * uncy.size() <= 500 * 1000) {
//        for (int cx1 = 0; cx1 < uncx.size(); ++cx1) {
//            int x1 = uncx[cx1];
//            int x2 = x1 + w;
//            int cx2 = upper_bound(all(uncx), x2) - uncx.begin();
//            for (int cy1 = 0; cy1 < uncy.size(); ++cy1) {
//                int y1 = uncy[cy1];
//                int y2 = y1 + h;
//                int cy2 = upper_bound(all(uncy), y2) - uncy.begin();
//                ans = max(ans, get_cnt(cx1, cx2, cy1, cy2));
//            }
//        }
//    } else {
    for (int i = 0; i < n; ++i) {
        int cx2 = cx[x[i]] + 1, cy2 = cy[y[i]] + 1;
        int x1 = x[i] - w;
        int y1 = y[i] - h;
        int cx1 = lower_bound(all(uncx), x1) - uncx.begin();
        int cy1 = lower_bound(all(uncy), y1) - uncy.begin();
        ans = max(ans, get_cnt(cx1, cx2, cy1, cy2));
    }
//    }
    cout << ans;
}