#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

#define N 100005
#define M ll(1e9 + 7)
#define all(x) x.begin(), x.end()
#define F first
#define S second
#define PB push_back
#define sz(x) int(x.size())
#define endl '\n'
#define pri(x) cout << x << endl

#pragma GCC optimize("-O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef short int si;
//typedef tree <int, null_type, less_equal <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


vector <int> vx, vy;

int n, w, h;

vector <int> t[N], elems[N];

void updr(int vv, int v, int val)
{
    for (; v < sz(t[vv]); v = (v | (v + 1))) t[vv][v] += val;
}

void make(int v)
{
    vector <int> vt = elems[v];

    sort(all(elems[v]));

    elems[v].resize(unique(all(elems[v])) - elems[v].begin());

    elems[v].PB(1e9);

    t[v].resize(sz(elems[v]));

    int j = 0;

    while (j < sz(vt))
    {
        int kol = 1;

        while (j + 1 < sz(vt) && vt[j + 1] == vt[j]) {kol++; j++;}

        updr(v, lower_bound(all(elems[v]), vt[j]) - elems[v].begin(), kol);

        j++;
    }
}

void upd(int v, int tl, int tr, int X, int Y)
{
    for (; X < sz(vx); X = (X | (X + 1)))
    {
        elems[X].PB(Y);
    }
}

int get(int v, int x)
{
    int vr = upper_bound(all(elems[v]), x) - elems[v].begin() - 1;

    int ans = 0;

    for (; vr >= 0; vr = (vr & (vr + 1)) - 1) ans += t[v][vr];

    return ans;
}

int fnd_y(int v, int l, int r)
{
    return get(v, r) - get(v, l - 1);
}

int fnd_x(int v, int tl, int tr, int xl, int xr, int yl, int yr)
{
    int ans = 0;

    for (; xr >= 0; xr = (xr & (xr + 1)) - 1) ans += fnd_y(xr, yl, yr);

    xl--;

    for (; xl >= 0; xl = (xl & (xl + 1)) - 1) ans -=fnd_y(xl, yl, yr);

    return ans;
}

int calc(int X, int Y)
{
    int xl = X, xr = X + w;

    int yl = Y, yr = Y + h;

    xl = lower_bound(all(vx), xl) - vx.begin();

    xr = upper_bound(all(vx), xr) - vx.begin() - 1;

    int ans = fnd_x(1, 0, sz(vx) - 1, xl, xr, yl, yr);

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0); istream::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> w >> h;

    int x[n], y[n];

    for (int i = 0; i < n; i++) {cin >> x[i] >> y[i]; vx.PB(x[i]); vy.PB(y[i]);}

    sort(all(vx));
    sort(all(vy));

    vx.PB(1e9); vy.PB(1e9);

    vx.resize(unique(all(vx)) - vx.begin());
    vy.resize(unique(all(vy)) - vy.begin());

    for (int i = 0; i < n; i++) upd(1, 0, sz(vx) - 1, lower_bound(all(vx), x[i]) - vx.begin(), y[i]);

    for (int i = 0; i < N; i++) make(i);

    int ans = 0;

//    if (n <= 1000)
//    {
//        for (auto X : vx)
//        for (auto Y : vy)
//        {
//            if (X == 1e9 || Y == 1e9) continue;
//
//            ans = max(ans, calc(X, Y));
//        }
//    }
//    else
//    {
//        for (int i = 0; i < n; i++)
//            ans = max(ans, calc(x[i] - w, y[i] - h));
    }

    pri(ans);
}
