#include<iostream>
#include<vector>
#include<unordered_set>
#include<algorithm>

using namespace std;

const long long INF = 2e18;

int main() {
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	vector<long long> prefix_sum(n + 1, 0);
	for (int i = 1; i < n + 1; ++i) {
		cin >> a[i - 1];
		prefix_sum[i] = prefix_sum[i - 1] + a[i - 1];
	}
	long long ans = INF;
	for (int mask = 0; mask < (1 << (n - 1)); ++mask) {
		vector<int> coor;
		for (int i = 0; i < n - 1; ++i)
			if (mask & (1 << i))
				coor.push_back(i + 1);
		if (coor.size() == k - 1) {
			int left = 0;
			long long cur = 0;
			for (auto c : coor) {
				cur += (prefix_sum[c] - prefix_sum[left]) * (c - left - 1);
				left = c;
			}
			cur += (prefix_sum[n] - prefix_sum[left]) * (n - left - 1);
			ans = min(cur, ans);
			
		}
	}
	cout << ans;
}