#include<iostream>
#include<vector>
#include<unordered_set>
#include<algorithm>

using namespace std;

int main() {
	int n, w, h;
	cin >> n >> w >> h;
	vector<vector<int>> desk(1001, vector<int>(1001, 0));
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		desk[x][y] += 1;
	}
	vector<vector<int>> pref_sum_rows(1001 + 1, vector<int>(1001 + 1, 0));
	for (int x = 1; x < 1002; ++x)
		for (int y = 1; y < 1002; ++y)
			pref_sum_rows[x][y] = pref_sum_rows[x][y - 1] + desk[x - 1][y - 1];
	vector<vector<int>> pref_sum_cols(1001 + 1, vector<int>(1001 + 1, 0));
	for (int y = 1; y < 1002; ++y)
		for (int x = 1; x < 1002; ++x)
			pref_sum_cols[x][y] = pref_sum_cols[x - 1][y] + desk[x - 1][y - 1];
	int base = 0;
	for (int x = 0; x <= w; ++x) {
		for (int y = 0; y <= h; ++y) {
			base += desk[x][y];
		}
	}
	int cur = base;
	int ans = base;
	for (int x = 0; x <= 1000 - w; ++x) {
		for (int y = 1; y <= 1000 - h; ++y) {
			cur -= pref_sum_cols[x + w + 1][y] - pref_sum_cols[x][y];
			cur += pref_sum_cols[x + w + 1][y + h + 1] - pref_sum_cols[x][y + h + 1];
			ans = max(ans, cur);
		}
		base -= pref_sum_rows[x + 1][h + 1] - pref_sum_rows[x + 1][0];
		if (x < 1000 - w)
			base += pref_sum_rows[x + 1 + w + 1][h + 1] - pref_sum_rows[x + 1 + w + 1][0];
		cur = base;
		ans = max(ans, cur);
	}
	cout << ans;
}