#include <bits/stdc++.h>
using namespace std;

typedef long long li;
const li MAX = (li)2e5 + 3;
li inf = (li)1e18, mod = (li)1e9 + 7;
li n, w, h;
li ans = 0;
vector<li> pts[MAX];
struct node{
    li l, r, mid;
    vector<li> vals;
    node* son_l;
    node* son_r;
    node(li a, li b){
        l = a;
        r = b;
        mid = (a + b) / 2;
    }
};

void m_sort(node* root){
    vector<li> a = root->son_l->vals;
    vector<li> b = root->son_r->vals;
    li n = a.size(), m = b.size();
    li uk1 = 0, uk2 = 0;
    while(uk1 < n || uk2 < m){
        if (uk1 == n) {
            root->vals.push_back(b[uk2]);
            uk2++;
        }
        else if (uk2 == m){
            root->vals.push_back(a[uk1]);
            uk1++;
        }
        else if (a[uk1] < b[uk2]){
            root->vals.push_back(a[uk1]);
            uk1++;
        }
        else{
            root->vals.push_back(b[uk2]);
            uk2++;
        }
    }
}

void build(node* root){
    if (root->l == root->r){
        root->vals = pts[root->l];
    }
    else{
        root->son_l = new node(root->l, root->mid);
        root->son_r = new node(root->mid + 1, root->r);
        build(root->son_l);
        build(root->son_r);
        m_sort(root);
    }
}

li get_am(node* root, li num){
    li uk1 = -1, uk2 = root->vals.size();
    while(uk2 - uk1 > 1){
        li mid = (uk2 + uk1) / 2;
        if (root->vals[mid] <= num) uk1 = mid;
        else uk2 = mid;
    }
    return uk1 + 1;
}

li get_val(node* root, li bl, li br, li mini, li maxi){
    if (bl > br) return 0;
    else if (root->l == bl && root->r == br){
        return get_am(root, maxi) - get_am(root, mini - 1);
    }
    else{
        li a = get_val(root->son_l, bl, min(root->mid, br), mini, maxi);
        li b = get_val(root->son_r, max(root->mid + 1, bl), br, mini, maxi);
        return a + b;
    }
}

void solve(){
    cin >> n >> w >> h;
    vector<pair<li, li>> p;
    for (int i = 0; i < n; i++){
        li x, y;
        cin >> x >> y;
        pts[x].push_back(y);
        p.push_back({x, y});
    }
    for (int i = 1; i <= (li)1e5; i++) sort(pts[i].begin(), pts[i].end());
    node* root = new node(1, (li)1e5);
    build(root);
    sort(p.rbegin(), p.rend());
    li ans = 0;
    for (int i = 0; i < p.size(); i++){
        li r = p[i].first;
        li l = max(li(1), p[i].first - w);
        ans = max(ans, get_val(root, l, r, p[i].second - h, p[i].second));
    }

    cout << ans;
}

int main(){
    li q;
    q = 1;
    while(q--) solve();
}
