#include <bits/stdc++.h>
#define in(x) freopen(x, "r", stdin)
#define out(x) freopen(x, "w", stdout)
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#define FBO find_by_order
//#define OOK order_of_key
using namespace std;
//using namespace __gnu_pbds;

//typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = (int)(1e5 + 500);

int n, K;
long long a[N], pf[N];
vector <long long> f, fn;

long long _f(int x, int y) {
    return f[x] + pf[y] * y - pf[y] * x - pf[y] - pf[x] * y + pf[x] * x + pf[x];
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

//    in("input.txt");

    cin >> n >> K;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    f.resize(n + 1);
    fn.resize(n + 1);

    pf[0] = 0;
    for (int i = 0; i < n; ++i) {
        pf[i + 1] = pf[i] + a[i];
    }

    for (int i = 0; i <= n; ++i) {
        f[i] = pf[i] * (i - 1);
    }

    for (int k = 1; k < K; ++k) {
        for (int i = 0; i <= n; ++i) {
            fn[i] = -1;
        }
//        for (int j = 1; j <= n; ++j) {
//            for (int i = 1; i < j; ++i) {
//                if (fn[j] == -1) {
//                    fn[j] = f[i] + (pf[j] - pf[i]) * (j - i - 1);
//                }
//                fn[j] = min(fn[j], f[i] + (pf[j] - pf[i]) * (j - i - 1));
//                cerr << f[i] + pf[j] * j - pf[j] * i - pf[j] - pf[i] * j + pf[i] * i + pf[i] << " ";
//            }
//            cerr << "\n";
//        }

        for (int j = 2; j <= n; ++j) {
            int l = 1, r = j - 1;
            while (l < r) {
                int md1 = (l + r) >> 1;
                int md2 = md1 + 1;
                if (_f(md1, j) < _f(md2, j)) {
                    r = md1;
                } else {
                    l = md2;
                }
            }

            while ((l + 1 < j) && (_f(l, j) > _f(l + 1, j))) {
                ++l;
            }
            while ((l - 1 >= 1) && (_f(l - 1, j) < _f(l, j))) {
                --l;
            }

            fn[j] = _f(l, j);
        }

        f = fn;
    }

    cout << f[n] << "\n";
}

/*

    fn[j] = f[i] + (pf[j] - pf[i]) * (j - i - 1)
    fn[j] = f[i] + pf[j] * j - pf[j] * i - pf[j] - pf[i] * j + pf[i] * i + pf[i]


    FX = f[i] + pf[j] * i - pf[i] * j + pf[i] * (i + 1)

    fn[j] = pf[j] * (j - 1) + FX

*/
