#include <bits/stdc++.h>
#define in(x) freopen(x, "r", stdin)
#define out(x) freopen(x, "w", stdout)
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#define FBO find_by_order
//#define OOK order_of_key
using namespace std;
//using namespace __gnu_pbds;

//typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = (int)(1e5 + 500);

int n, w, h, W, H;
int x[N], y[N];
int pf[(int)(1e3 + 100)][(int)(1e3 + 100)];
vector <int> X, Y;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

//    in("input.txt");

    cin >> n >> w >> h;
    W = w;
    H = h;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        W = max(W, x[i]);
        H = max(H, y[i]);
    }

    if (max((int)(X.size()), (int)(Y.size())) <= (int)(1e3 + 500)) {
        X.clear();
        Y.clear();
        for (int i = 0; i < n; ++i) {
            X.push_back(x[i]);
            Y.push_back(y[i]);
        }

        sort(X.begin(), X.end());
        sort(Y.begin(), Y.end());
        X.resize(unique(X.begin(), X.end()) - X.begin());
        Y.resize(unique(Y.begin(), Y.end()) - Y.begin());

        for (int i = 0; i < n; ++i) {
            int _x = lower_bound(X.begin(), X.end(), x[i]) - X.begin();
            int _y = lower_bound(Y.begin(), Y.end(), y[i]) - Y.begin();
            ++pf[_x][_y];
        }

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i - 1 >= 0) {
                    pf[i][j] += pf[i - 1][j];
                }
                if (j - 1 >= 0) {
                    pf[i][j] += pf[i][j - 1];
                }
                if ((i - 1 >= 0) && (j - 1 >= 0)) {
                    pf[i][j] -= pf[i - 1][j - 1];
                }
            }
        }

        int ans = 0;
        for (int i = 0; i < (int)(X.size()); ++i) {
            for (int j = 0; j < (int)(Y.size()); ++j) {
                int cx = X[i], cy = Y[j];
                int nx = lower_bound(X.begin(), X.end(), cx - w) - X.begin();
                int ny = lower_bound(Y.begin(), Y.end(), cy - h) - Y.begin();

                int cur = pf[i][j];
                if (nx - 1 >= 0) {
                    cur -= pf[nx - 1][j];
                }
                if (ny - 1 >= 0) {
                    cur -= pf[i][ny - 1];
                }
                if ((nx - 1 >= 0) && (ny - 1 >= 0)) {
                    cur += pf[nx - 1][ny - 1];
                }

                ans = max(ans, cur);
            }
        }

        cout << ans << "\n";
    }
}
