#include <bits/stdc++.h>
#define in(x) freopen(x, "r", stdin)
#define out(x) freopen(x, "w", stdout)
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#define FBO find_by_order
//#define OOK order_of_key
using namespace std;
//using namespace __gnu_pbds;

//typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = (int)(1e5 + 500);

int n, w, h, W, H, ans = 0;
int x[N], y[N], fen[N];
int pf[(int)(1e3 + 100)][(int)(1e3 + 100)];
vector <int> X, Y;
vector <pair <int, int> > all;

void upd(int v, int val) {
    while (v <= H) {
        fen[v] += val;
        v += (v & -v);
    }
}

int get(int v) {
    int ret = 0;
    while (v > 0) {
        ret += fen[v];
        v -= (v & -v);
    }
    return ret;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

//    in("input.txt");

    cin >> n >> w >> h;
    H = h;
    W = w;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        W = max(W, x[i]);
        H = max(H, y[i]);
        all.push_back(make_pair(x[i], y[i]));
    }
    sort(all.begin(), all.end());

    if (H <= (int)(1e5)) {
        int l = 0;
        for (int i = 0; i < n; ++i) {
            int _x = all[i].first, _y = all[i].second;
            while (all[l].first < _x - w) {
                upd(all[l].second, -1);
                ++l;
            }
//            int y1 = all[i].second - h, y2 = all[i].second;
//            int cur = 0;
//            for (int j = l; j <= i; ++j) {
//                cur += (all[j].second >= y1) && (all[j].second <= y2);
//            }
//            ans = max(ans, cur);

            ans = max(ans, get(_y) - get(_y - h - 1) + 1);
            upd(_y, +1);
        }
    }

    assert(0);

    if (max(W, H) <= 1e4) {
        for (int i = 0; i < n; ++i) {
            ++pf[x[i]][y[i]];
        }

        for (int i = 0; i <= W; ++i) {
            for (int j = 0; j <= H; ++j) {
                if (i - 1 >= 0) {
                    pf[i][j] += pf[i - 1][j];
                }
                if (j - 1 >= 0) {
                    pf[i][j] += pf[i][j - 1];
                }
                if (i - 1 >= 0 && j - 1 >= 0) {
                    pf[i][j] -= pf[i - 1][j - 1];
                }
            }
        }

        for (int i = 0; i <= W; ++i) {
            for (int j = 0; j <= H; ++j) {
                int cur = pf[i][j];
                if (i - w - 1 >= 0) {
                    cur -= pf[i - w - 1][j];
                }
                if (j - h - 1 >= 0) {
                    cur -= pf[i][j - h - 1];
                }
                if (i - w - 1 >= 0 && j - h - 1 >= 0) {
                    cur += pf[i - w - 1][j - h - 1];
                }
                ans = max(ans, cur);
            }
        }
    } else {
        vector <int> X, Y;
        X.clear();
        Y.clear();
        for (int i = 0; i < n; ++i) {
            X.push_back(x[i]);
            Y.push_back(y[i]);
        }

        if ((int)(X.size()) <= 1e3 && (int)(Y.size()) <= 1e3) {
            for (int i = 0; i < (int)(X.size()); ++i) {
                for (int j = 0; j < (int)(Y.size()); ++j) {
                    pf[i][j] = 0;
                }
            }

            sort(X.begin(), X.end());
            sort(Y.begin(), Y.end());
            X.resize(unique(X.begin(), X.end()) - X.begin());
            Y.resize(unique(Y.begin(), Y.end()) - Y.begin());

            for (int i = 0; i < n; ++i) {
                int _x = lower_bound(X.begin(), X.end(), x[i]) - X.begin();
                int _y = lower_bound(Y.begin(), Y.end(), y[i]) - Y.begin();
                ++pf[_x][_y];
            }

            for (int i = 0; i < (int)(X.size()); ++i) {
                for (int j = 0; j < (int)(Y.size()); ++j) {
                    if (i - 1 >= 0) {
                        pf[i][j] += pf[i - 1][j];
                    }
                    if (j - 1 >= 0) {
                        pf[i][j] += pf[i][j - 1];
                    }
                    if ((i - 1 >= 0) && (j - 1 >= 0)) {
                        pf[i][j] -= pf[i - 1][j - 1];
                    }
                }
            }

            for (int i = 0; i < (int)(X.size()); ++i) {
                for (int j = 0; j < (int)(Y.size()); ++j) {
                    int cx = X[i], cy = Y[j];
                    int nx = lower_bound(X.begin(), X.end(), cx - w) - X.begin();
                    int ny = lower_bound(Y.begin(), Y.end(), cy - h) - Y.begin();

                    int cur = pf[i][j];
                    if (nx - 1 >= 0) {
                        cur -= pf[nx - 1][j];
                    }
                    if (ny - 1 >= 0) {
                        cur -= pf[i][ny - 1];
                    }
                    if ((nx - 1 >= 0) && (ny - 1 >= 0)) {
                        cur += pf[nx - 1][ny - 1];
                    }

                    ans = max(ans, cur);
                }
            }
        }
    }


    cout << ans << "\n";
}
