#include <bits/stdc++.h>

using namespace std;

string str[26];

string remdup(string a)
{
    string b = "";
    for(int i = 0; i < a.size(); i++) {
        bool ok = 1;
        for(int j = 0; j < i; j++)
        {
            if(a[i] == a[j])
                ok = 0;
        }
        if(ok) b += a[i];
    }
    return b;
}

unordered_map<int, long long> middle_map;

int mask = 0;

long long sum = 0;

void bkt_left(int index)
{
    if(index == 13) { middle_map[mask] = middle_map[mask] + 1; return; }

    for(auto ch : str[index])
    {
        int n = ch - 'A';
        if((mask>>n) & 1)
        {
            continue;
        }
        mask ^= (1<<n);
        bkt_left(index + 1);
        mask ^= (1<<n);
    }
}

void bkt_right(int index)
{
    if(index == 26) { sum += middle_map[mask ^ ((1<<26) - 1)]; return; }

    for(auto ch : str[index])
    {
        int n = ch - 'A';
        if((mask>>n) & 1)
        {
            continue;
        }
        mask ^= (1<<n);
        bkt_right(index + 1);
        mask ^= (1<<n);
    }
}

int freq[26];

bool cmp(string a, string b)
{
    if(a.size() == b.size())
    {
        int freq_a = 0, freq_b = 0;
        for(auto ch : a) freq_a += freq[ch - 'A'];
        for(auto ch : b) freq_b += freq[ch - 'A'];
        return freq_a < freq_b;
    }
    return a.size() < b.size();
}

int main()
{
    for(int i = 0; i < 26; i++)
    {
        cin >> str[i];
        str[i] = remdup(str[i]);
        for(auto ch : str[i]) freq[ch - 'A']++;
    }

    bool loopflag = 1;
    while(loopflag == 1) {
        loopflag = 0;

        /*long long prod = 1;
        for(int i = 0; i < 26; i++) {
            cout << freq[i] << " ";
            if(freq[i] != 0) prod *= freq[i];
        }
        cout << prod << endl;*/

        for(int i = 0; i < 26; i++) {
            if(freq[i] == 1)
            {
                loopflag = 1;
                int nr_string = 0;
                for(int j = 0; j < 26; j++)
                for(auto ch : str[j]) if(ch - 'A' == i) nr_string = j;

                for(auto ch : str[nr_string]) freq[ch - 'A']--;

                str[nr_string] = (string)"" + (char)(i + 'A');

                break;
            }
        }
    }

    sort(str, str + 26, cmp);
    for(int i = 1; i < 13; i+=2)
    {
        swap(str[i], str[25 - (i/2)]);
    }

    bkt_left(0);
    bkt_right(13);

    cout << sum;
}
