#include <bits/stdc++.h>

const int MAX_N = 100000;
// 2 * 10^12 = 10^7 * 10^5 * 2
const long long INF = 2000000000000;

int a[1+MAX_N];
int cnt[1+MAX_N];
long long dp[1+MAX_N];

int counted(int N, long long extra) {
	cnt[0] = 0;
	dp[0] = 0;

	for(int i = 1; i <= N; ++i) {
		long long sum = 0LL;
		dp[i] = INF * 2;
		cnt[i] = 0;
		// Bad dp - O(N^2)
		for(int j = i; j > 0; --j) {
			sum += a[j];
			if(dp[j - 1] + sum * (i - j) + extra < dp[i]) {
				dp[i] = dp[j - 1] + sum * (i - j) + extra;
				cnt[i] = cnt[j - 1] + 1;
			} else if(dp[j - 1] + sum * (i - j) + extra == dp[i] && cnt[j - 1] + 1 < cnt[i])
				cnt[i] = cnt[j - 1] + 1;
		}
	}

	return cnt[N];
}

int main() {
	int N, K;
	scanf("%d%d", &N, &K);

	for(int i = 1; i <= N; ++i)
		scanf("%d", &a[i]);

	long long l = -1, r = INF + 1;

	while(r - l > 1) {
		long long mid = (l + r) / 2;
		if(counted(N, mid) > K)
			l = mid;
		else
			r = mid;
	}

	counted(N, r);
	printf("%lld\n", dp[N] - r * K);
	return 0;
}
