#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
//#pragma GCC optimize("-fpeephole2")
//#pragma GCC optimize("-fsched-spec")
//#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
//#pragma GCC optimize("-falign-labels")
//#pragma GCC optimize("-fdevirtualize")
//#pragma GCC optimize("-fcaller-saves")
//#pragma GCC optimize("-fcrossjumping")
//#pragma GCC optimize("-fthread-jumps")
//#pragma GCC optimize("-freorder-blocks")
//#pragma GCC optimize("-fschedule-insns")
//#pragma GCC optimize("inline-functions")
//#pragma GCC optimize("-ftree-tail-merge")
//#pragma GCC optimize("-fschedule-insns2")
//#pragma GCC optimize("-fstrict-aliasing")
//#pragma GCC optimize("-falign-functions")
//#pragma GCC optimize("-fcse-follow-jumps")
//#pragma GCC optimize("-fsched-interblock")
//#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("-freorder-functions")
//#pragma GCC optimize("-findirect-inlining")
//#pragma GCC optimize("-fhoist-adjacent-loads")
//#pragma GCC optimize("-frerun-cse-after-loop")
//#pragma GCC optimize("inline-small-functions")
//#pragma GCC optimize("-finline-small-functions")
//#pragma GCC optimize("-ftree-switch-conversion")
//#pragma GCC optimize("-foptimize-sibling-calls")
//#pragma GCC optimize("-fexpensive-optimizations")
//#pragma GCC optimize("inline-functions-called-once")
//#pragma GCC optimize("-fdelete-null-pointer-checks")

#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

const int N = 1e4 + 10, MOD = 1e9 + 7, base = 131, INF = 1e9;

bool bit(int a, int n) {
    return (a >> n) & 1;
}

string s[26];
long long ans;
map < int, int > ma;
short cnt[(1 << 26)];
bitset < (1 << 26) > bb;

void gen1(int mask, int i) {
    if (i == 13) {
        ++cnt[mask];
        if (cnt[mask] == 32000) {
            bb[mask] = true;
            ma[mask] += 32000;
            cnt[mask] = 0;
        }
        return;
    }
    for (int j = 0; j < s[i].size(); ++j) {
        if (!bit(mask, s[i][j] - 'A')) {
            gen1((mask ^ (1 << (s[i][j] - 'A'))), i + 1);
        }
    }
}

void gen2(int mask, int i) {
    if (i == 26) {
        ans += cnt[(((1 << 26) - 1) ^ mask)];
        if (bb[(((1 << 26) - 1) ^ mask)]) ans += ma[(((1 << 26) - 1) ^ mask)];
        return;
    }
    for (int j = 0; j < s[i].size(); ++j) {
        if (!bit(mask, s[i][j] - 'A')) {
            gen2((mask ^ (1 << (s[i][j] - 'A'))), i + 1);
        }
    }
}

void solve() {
    for (int i = 0; i < 26; ++i) {
        string pr;
        cin >> pr;
        set < char > se;
        for (int j = 0; j < pr.size(); ++j) {
            if (!se.count(pr[j])) {
                s[i].push_back(pr[j]);
                se.insert(pr[j]);
            }
        }
    }
    gen1(0, 0);
    gen2(0, 13);
    cout << ans;
}