//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
//#pragma GCC optimize(3)
//#pragma GCC optimize("O3")
//#pragma GCC optimize("inline")
//#pragma GCC optimize("-fgcse")
//#pragma GCC optimize("-fgcse-lm")
//#pragma GCC optimize("-fipa-sra")
//#pragma GCC optimize("-ftree-pre")
//#pragma GCC optimize("-ftree-vrp")
//#pragma GCC optimize("-fpeephole2")
//#pragma GCC optimize("-fsched-spec")
//#pragma GCC optimize("-falign-jumps")
//#pragma GCC optimize("-falign-loops")
//#pragma GCC optimize("-falign-labels")
//#pragma GCC optimize("-fdevirtualize")
//#pragma GCC optimize("-fcaller-saves")
//#pragma GCC optimize("-fcrossjumping")
//#pragma GCC optimize("-fthread-jumps")
//#pragma GCC optimize("-freorder-blocks")
//#pragma GCC optimize("-fschedule-insns")
//#pragma GCC optimize("inline-functions")
//#pragma GCC optimize("-ftree-tail-merge")
//#pragma GCC optimize("-fschedule-insns2")
//#pragma GCC optimize("-fstrict-aliasing")
//#pragma GCC optimize("-falign-functions")
//#pragma GCC optimize("-fcse-follow-jumps")
//#pragma GCC optimize("-fsched-interblock")
//#pragma GCC optimize("-fpartial-inlining")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("-freorder-functions")
//#pragma GCC optimize("-findirect-inlining")
//#pragma GCC optimize("-fhoist-adjacent-loads")
//#pragma GCC optimize("-frerun-cse-after-loop")
//#pragma GCC optimize("inline-small-functions")
//#pragma GCC optimize("-finline-small-functions")
//#pragma GCC optimize("-ftree-switch-conversion")
//#pragma GCC optimize("-foptimize-sibling-calls")
//#pragma GCC optimize("-fexpensive-optimizations")
//#pragma GCC optimize("inline-functions-called-once")
//#pragma GCC optimize("-fdelete-null-pointer-checks")

#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

#define int long long

#ifdef DEBUG
const int N = 1e3 + 10, MOD = 1e9 + 7, base = 131, INF = 1e18;
#else
const int N = 6e3 + 10, MOD = 1e9 + 7, base = 131, INF = 1e18;
#endif

int n, k, a[N], dp[N][N], cnt[N], pref[N];

int get(int l, int r) {
    if (l > r) return 0;
    return (pref[r + 1] - pref[l]) * (r - l);
}

pair < int, int > ff(int pos, int tl, int tr, int h) {
    int res = INF, ind = -1;
    for (int i = tl; i <= tr; i++) {
        if (res > dp[i][h - 1] + get(i + 1, pos)) {
            res = dp[i][h - 1] + get(i + 1, pos);
            ind = i;
        }
    }
    return {res, ind};
}

void f(int l, int r, int tl, int tr, int h) {
    if (l == r) {
        dp[l][h] = ff(l, tl, tr, h).first;
        return;
    }
    int m = (r + l) / 2;
    pair < int, int > res = ff(m, tl, tr, h);
    f(l, m, tl, res.second, h);
    f(m + 1, r, res.second, tr, h);
}

void solve() {
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    for (int i = 0; i < n; i++) {
        dp[i][0] = get(0, i);
    }
    for (int i = 1; i < k; i++) {
        f(0, n - 1, 0, n - 1, i);
    }
    cout << dp[n - 1][k - 1];
}