#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long

using namespace std;

using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;

const int N = 6e3 + 5;
const int M = 1e9 + 7;

lll calc[N];

short opt[3][N];

int n, m;

void solve() {
    vector < lll > a(n), pref(n), dp(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i] = a[i];
        if (i) {
            pref[i] += pref[i - 1];
        }
    }
    int m1, m2, l, r;
    pair < lll, lll > res;
    lll cur;
    for (int i = 1; i < n; ++i) {
        l = 0;
        r = i - 1;
        while (r - l >= 5) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            res.F = m1 * pref[m1] + (i - m1 - 1) * (pref[i] - pref[m1]);
            res.S = m2 * pref[m2] + (i - m2 - 1) * (pref[i] - pref[m2]);
            if (res.F < res.S) {
                m2 = r;
            } else {
                m1 = l;
            }
        }
        cur = 1e18;
        while (l <= r) {
            cur = min(cur, l * pref[l] + (i - l - 1) * (pref[i] - pref[l]));
            ++l;
        }
        dp[i] = cur;
    }
    lll ans = 1e18;
    if (n <= 3) {
        ans = 0;
    }
    for (int i = 1; i < n; ++i) {
        cur = dp[i - 1];
        cur += (pref[n - 1] - pref[i - 1]) * (n - i - 1);
        ans = min(ans, cur);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> m;
    if (m == 3) {
        solve();
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        cin >> calc[i];
        if (i) {
            calc[i] += calc[i - 1];
        }
    }
    vector < vector < lll > > dp(n, vector < lll > (m + 1));
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j <= m; ++j) {
            dp[i][j] = 1e18;
        }
    }
    for (int i = 0; i < 3; ++i) {
        opt[(i % 3)][m] = n - 1;
        opt[(i % 3)][m + 1] = n - 1;
    }
    pair < lll, int > now, cur;
    for (int i = 1; i < n; ++i) {
        for (int j = m; j; --j) {
            now = {1e18, 0};
            for (int c = opt[(i - 1) % 3][j]; c <= opt[i % 3][j + 1] && c < i; ++c) {
                cur.F = dp[c][j - 1] + (calc[i] - calc[c]) * (i - c - 1);
                cur.S = c;
                now = min(now, cur);
            }
            dp[i][j] = now.F;
            opt[(i % 3)][j] = now.S;
        }
        dp[i][1] = calc[i] * i;
        opt[(i % 3)][1] = 0;
    }
    cout << dp[n - 1][m];
    return 0;
}
