#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define rsz resize
#define mp make_pair

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;

template<class T> bool ckmin(T& a, T b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, T b) { return a < b ? a = b, true : false; }

const int INF = 1e9;
const ll LINF = 1e18;

mt19937 rng(1337228);

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    bool okay = true;

    int n, k; cin >> n >> k;
    ll sum = 0;
    vi a(n); for(int& x : a) cin >> x, sum += x;
    vector<ll> dp(n+1, LINF); dp[0] = 0;
    while(k--) {
        vector<ll> nxt(n+1, LINF);
        vi opt(n+1, -1);

        for (int i = 1; i <= n; ++i) {
            ll sum = 0;
            for (int j = i; j--; ) {
                if (j < opt[i-1]) break;
                sum += a[j];
                if (ckmin(nxt[i], dp[j] + sum * (i-j)))
                    opt[i] = j;
            }
        }

        for (int i = 0; i < n; ++i) 
            if (opt[i] > opt[i+1]) okay = false;

        dp.swap(nxt);
    }

    //cout << (okay ? "YES" : "NO") << endl;
    cout << dp[n] - sum << endl;
}

/*
8 4
8 1 2 3 9 1 9 1

6 3
10 3 8 5 4 7
*/