#include <bits/stdc++.h>
#define vi vector<int>
#define vvi vector<vvi>
#define vb vector<bool>
#define vvb vector<vb>
#define ii pair<int, int>
#define x first
#define y second
#define vii vector<ii>
#define vvii vector<vii>
#define pb push_back
#define loop(i,s,e) for(int i=(s); i<(e);i++)
#define loopr(i,s,e) for(int i=(e)-1; i>=(s);i--)
#define chkmax(a,b) a = max(a,b)
#define chkmin(a,b) a = min(a,b)
#define all(a) a.begin(), a.end()
using namespace std;
const int INF = 1e9, MOD = 1e9+7;
void add(int &a, int b){ a = (a+b)%MOD;}
ii operator+(const ii& a, const ii& b){ return {a.x+b.x, a.y+b.y};}
ii operator-(const ii& a, const ii& b){ return {a.x-b.x, a.y-b.y};}
ii operator-(const ii& a){ return {-a.x, -a.y};}

struct Node{
    int l, r,mid;
    int maxi=0, prop=0;
    Node *lp=0, *rp=0;
    Node(int l, int r): l(l), r(r), mid((l+r)/2){}
    void add(int p){
        prop+=p, maxi+=p;
    }
    void fix(){
        if (!lp) lp = new Node(l, mid);
        if (!rp) rp = new Node(mid, r);
        if (prop){
            lp->add(prop);
            rp->add(prop);
            prop = 0;
        }
        maxi = max(lp->maxi, rp->maxi);
    }
    void update(int a, int b, int dx){
        if (a>=r || b<=l) return ;
        if (a<=l && r<=b){
            add(dx);
            return ;
        }
        fix();
        lp->update(a,b,dx);
        rp->update(a,b,dx);
        fix();
    }
    int query(){
        return maxi;
    }
};
int32_t main(){
    ios_base::sync_with_stdio(0);
    int n,w,h; cin>>n>>w>>h;
    vii a(n); 
    vector<pair<ii,int>> eve;
    loop(i,0,n) {
        cin>>a[i].x>>a[i].y;
        eve.pb({{a[i].x, 0},i}); // in
        eve.pb({{a[i].x+w, 1},i}); // out
    }
    sort(all(eve));
    Node seg(0, INF);
    int ans = 0;
    for(auto e:eve){
        int i = e.y, op = e.x.y;
        int ly = a[i].y - h, ry = a[i].y +1; // not include - [l,r)
        seg.update(ly, ry, (op?-1:1));
        //cout<<"HI: "<<i<<" "<<seg.query()<<endl;
        chkmax(ans, seg.query());
    }
    cout<<ans<<endl;
    return 0;
}
/*
color a
cls
g++ b.cpp -o a & a
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
*/