#include <bits/stdc++.h>
#define vi vector<int>
#define vvi vector<vvi>
#define vb vector<bool>
#define vvb vector<vb>
#define ii pair<int, int>
#define x first
#define y second
#define vii vector<ii>
#define vvii vector<vii>
#define pb push_back
#define loop(i,s,e) for(int i=(s); i<(e);i++)
#define loopr(i,s,e) for(int i=(e)-1; i>=(s);i--)
#define chkmax(a,b) a = max(a,b)
#define chkmin(a,b) a = min(a,b)
#define all(a) a.begin(), a.end()
using namespace std;
const int INF = 1e8, MOD = 1e9+7;
/*void add(int &a, int b){ a = (a+b)%MOD;}
ii operator+(const ii& a, const ii& b){ return {a.x+b.x, a.y+b.y};}
ii operator-(const ii& a, const ii& b){ return {a.x-b.x, a.y-b.y};}
ii operator-(const ii& a){ return {-a.x, -a.y};}*/

struct Node{
    int maxi=0, prop=0,lp=0,rp=0;
};
const int MAX = 1e6;
Node nodes[MAX]; int cnt = 0;
void add(int cur, int p){
    nodes[cur].prop+=p, nodes[cur].maxi+=p;
}
void fix(int cur){
    if (!nodes[cur].lp) nodes[cur].lp = cnt++;
    if (!nodes[cur].rp) nodes[cur].rp = cnt++;
    if (nodes[cur].prop){
        add(nodes[cur].lp, nodes[cur].prop);
        add(nodes[cur].rp, nodes[cur].prop);
        nodes[cur].prop = 0;
    }
    nodes[cur].maxi = max(nodes[nodes[cur].lp].maxi, nodes[nodes[cur].rp].maxi);
}
void update(int a, int b, int dx, int cur = 0, int l=0, int r=INF){
    if (a>=r || b<=l) return ;
    if (a<=l && r<=b){
        add(cur, dx);
        return ;
    }
    fix(cur);
    int mid = (l+r)/2;
    update(a,b,dx, nodes[cur].lp, l, mid);
    update(a,b,dx, nodes[cur].rp, mid, r);
    fix(cur);
}
int query(){
    return nodes[0].maxi;
}

int32_t main(){
    ios_base::sync_with_stdio(0);
    int n,w,h; cin>>n>>w>>h;
    vii a(n); 
    vector<pair<ii,int>> eve;
    loop(i,0,n) {
        cin>>a[i].x>>a[i].y;
        eve.pb({{a[i].x, 0},i}); // in
        eve.pb({{a[i].x+w, 1},i}); // out
    }
    sort(all(eve));
    int ans = 0;
    for(auto e:eve){
        int i = e.y, op = e.x.y;
        int ly = a[i].y - h, ry = a[i].y +1; // not include - [l,r)
        update(ly, ry, (op?-1:1));
        //cout<<"HI: "<<i<<" "<<seg.query()<<endl;
        chkmax(ans, query());
    }
    cout<<ans<<endl;
    return 0;
}
/*
color a
cls
g++ b.cpp -o a & a
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
*/