#include <iostream>
#include <cstring>

using namespace std;

const int NMAX = 27, SIGMAX = (int)('Z' - 'A' + 1);
const int MMAX = 6;

bool fr[NMAX][SIGMAX];
int List[NMAX][SIGMAX + 1];

int M;
char S[MMAX];

bool Sel[SIGMAX];

int p[NMAX];

int ans = 0;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    for(int Id = 1; Id <= 26; ++Id)
    {
        cin >> (S + 1);

        M = (int)strlen(S + 1);

        for(int i = 1; i <= M; ++i)
            fr[Id][(int)(S[i] - 'A')] = 1;

        for(int let = 0; let <= (int)('Z' - 'A'); ++let)
            if(fr[Id][let])
                List[Id][(++List[Id][0])] = let;
    }

    return;
}

static inline void Heuristics ()
{
    for(int i = 1; i <= 26; ++i)
        p[i] = i;

    return;
}

static inline void Go (int Level)
{
    if(Level == 27)
    {
        ++ans;

        return;
    }

    int Id = p[Level];

    for(int i = 1; i <= List[Id][0]; ++i)
        if(!Sel[List[Id][i]])
            Sel[List[Id][i]] = 1, Go(Level + 1), Sel[List[Id][i]] = 0;

    return;
}

int main()
{
    Read();

    Heuristics();

    Go(1);

    cout << ans << '\n';

    return 0;
}
