#include <iostream>
#include <cstring>
#include <algorithm>

using namespace std;

const int NMAX = 27, SIGMAX = (int)('Z' - 'A' + 1);
const int MMAX = 6;

bool fr[NMAX][SIGMAX];

int M;
char S[MMAX];

int Where_can_this_go[SIGMAX][NMAX];

int ans = 0;
bool Sel[NMAX];

int p[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    for(int Id = 1; Id <= 26; ++Id)
    {
        cin >> (S + 1);

        M = (int)strlen(S + 1);

        for(int i = 1; i <= M; ++i)
            fr[Id][(int)(S[i] - 'A')] = 1;

        for(int let = 0; let <= (int)('Z' - 'A'); ++let)
            if(fr[Id][let])
                Where_can_this_go[let][(++Where_can_this_go[let][0])] = Id;
    }

    return;
}

auto cmp = [] (int i, int j)
{
    if(Where_can_this_go[i][0] < Where_can_this_go[j][0])
        return 1;

    return 0;
};

static inline void Heuristics ()
{
    for(int i = 0; i <= (int)('Z' - 'A'); ++i)
        p[i] = i;

    sort(p + 0, p + ((int)('Z' - 'A') + 1), cmp);

    return;
}

static inline void Go (int Level)
{
    if(Level == 26)
    {
        ++ans;

        return;
    }

    int Id = p[Level];

    for(int i = 1; i <= Where_can_this_go[Id][0]; ++i)
        if(!Sel[Where_can_this_go[Id][i]])
            Sel[Where_can_this_go[Id][i]] = 1, Go(Level + 1), Sel[Where_can_this_go[Id][i]] = 0;

    return;
}

int main()
{
    Read();

    Heuristics();

    Go(0);

    cout << ans << '\n';

    return 0;
}
