#include <iostream>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 1e2 + 5;

int N, W, H;

PII A[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> W >> H;

    for(int i = 1; i <= N; ++i)
        cin >> A[i].first >> A[i].second;

    return;
}

static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

static inline void Solve ()
{
    int ans = 0;

    for(int X1 = 0; X1 <= 200; ++X1)
        for(int Y1 = 0; Y1 <= 200; ++Y1)
        {
            int X2 = X1 + W, Y2 = Y1 + H;

            int cnt = 0;

            for(int i = 1; i <= N; ++i)
                if(A[i].first >= X1 && A[i].first <= X2)
                    if(A[i].second >= Y1 && A[i].second <= Y2)
                        ++cnt;

            ans = my_max(ans, cnt);
        }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
