#include <iostream>
#include <unordered_map>
#include <algorithm>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 1e3 + 5;

int N, W, H;

PII A[NMAX];

unordered_map < int, bool > fr_X;

int List[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> W >> H;

    for(int i = 1; i <= N; ++i)
        cin >> A[i].first >> A[i].second, fr_X[A[i].first] = 1;

    return;
}

static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

static inline void Task_1 ()
{
    int ans = 0;

    for(auto it : fr_X)
    {
        int X1  = it.first, X2 = X1 + W;

        List[0] = 0;

        for(int i = 1; i <= N; ++i)
            if(A[i].first >= X1 && A[i].first <= X2)
                List[++List[0]] = A[i].second;

        sort(List + 1, List + List[0] + 1);

        for(int j = 1; j <= List[0]; ++j)
        {
            int Left = j + 1, Right = List[0], pos = j;

            while(Left <= Right)
            {
                int Mid = ((Left + Right) >> 1);

                if(List[Mid] - List[j] <= H)
                    pos = Mid, Left = Mid + 1;
                else Right = Mid - 1;
            }

            ans = my_max(ans, pos - j + 1);
        }
    }

    cout << ans << '\n';

    return;
}

static inline void Solve ()
{
    if(N <= 1e3)
        Task_1();

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
