#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
 
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")


mt19937 gen(time(0));

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const int n = 26;

unordered_map<int, ll> calc(vector<int> a, int d) {
	unordered_map<int, ll> ret;
	for(int i = 0; i < 26; i++) {
		if (a[0] >> i & 1) {
			ret[1 << i] = 1;
		}
	}
	for(int i = 1; i < size(a); i++) {
		unordered_map<int, ll> nxt;
		for(int j = 0; j < 26; j++) {
			if (a[i] >> j & 1) {
				int mask = (1 << n) - 1;
				mask ^= (1 << j);
				for(int z = mask; z; z = (z - 1) & mask) {
					if (__builtin_popcount(z) == i && ret.find(z) != ret.end())
						nxt[z ^ (1 << j)] += ret[z];
				}
			}
		}
		swap(nxt, ret);
	}
	return ret;
}

bool cmp(int a, int b) {
	return __builtin_popcount(a) > __builtin_popcount(b);
}

void run() {
	vector<int> a(n);
	for(int i = 0; i < n; i++) {
		string s;
		cin >> s;
	//	a[i] = (1 << i);
		for(char c : s) a[i] |= (1 << (c - 'A'));
	}
	vector<int> l, r;
	for(int i = 0; i < n; i++) {
		if (i < n / 2) l.push_back(a[i]);
		else r.push_back(a[i]);
	}
	sort(all(a), cmp);
	auto a1 = calc(l, 0);
	auto a2 = calc(r, 1);
	ll ans = 0;
	int mask = ((1 << n) - 1);
	if (size(a1) > size(a2)) swap(a1, a2);
	for(auto v : a1) {
		if (a2.find(mask ^ v.first) != a2.end()) {
			ans += v.second * a2[mask ^ v.first];
		}
	}
	cout << ans;
}

signed main() {
#ifdef LOCAL
	freopen("input", "r", stdin);
	freopen("output", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	run();
	
}	