#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
 
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")
*/

mt19937 gen;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const ll INF = 1e18;

vector<ll> a;

ll get(int l, int r) {
	l = max(l, 1);
	return (r - l) * (a[r] - a[l - 1]);
}	

void run() {
	int n, k;
	cin >> n >> k;
	a.resize(n + 1);
	for(int i = 1; i <= n; i++) {
		cin >> a[i];
	}	
	partial_sum(all(a), a.begin());
	vector<vector<ll>> dp(n + 2, vector<ll>(k + 2, INF));
	vector<vector<int>> p(n + 2, vector<int>(k + 2, 1));
	dp[0][0] = 0;
	for(int j = 1; j <= k; j++) {
		p[n + 1][j] = n;
		for(int i = n; i >= 1; i--) {
			for(int v = p[i][j - 1]; v <= p[i + 1][j]; v++) {
				if (dp[i][j] > dp[v - 1][j - 1] + get(v, i)) {
					dp[i][j] = dp[v - 1][j - 1] + get(v, i);
					p[i][j] = v;
				}
			}
		} 
	}
	cout << dp[n][k];
}

signed main() {
#ifdef LOCAL
	freopen("input", "r", stdin);
	freopen("output", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	run();
	
}	