#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;


#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
 
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")


mt19937 gen;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const ll INF = 1e18;		

const int N = 1e5 + 1;
ll a[N];
ll dp[2][N];
int p[2][N];

ll get(int l, int r) {
	return (r - l) * (a[r] - a[l - 1]);
}

int n, k;

void kek() {
	ll ans = INF;
	ll pt = 2;
	for(ll i = 1; i + 2 <= n; i++) {
		chkmax(pt, i + 1);
		while (pt + 1 < n && get(i + 1, pt) + get(pt + 1, n) >= get(i + 1, pt + 1) + get(pt + 2, n)) {
			pt++;
		}
		chkmin(ans, get(1, i) + get(i + 1, pt) + get(pt + 1, n));
	}
	cout << ans;
}

void run() {
	cin >> n >> k;
	for(int i = 1; i <= n; i++) {
		cin >> a[i];
		a[i] += a[i - 1];
	}
	if (k == 3 && n >= 1e4) {
		kek();
		exit(0);
	}
	dp[0][0] = INF;
	fill(p[0], p[0] + N, 0);
	for(int i = 1; i <= n; i++) {
		dp[0][i] = (i - 1) * a[i];
	}
	for(int j = 2; j <= k; j++) {
		fill(dp[1], dp[1] + N, INF);
		p[1][n + 1] = n;
		for(int i = n; i >= 1; i--) {
			for(int v = p[0][i]; v <= p[1][i + 1]; v++) {
				if (dp[1][i] > dp[0][v - 1] + (i - v) * (a[i] - a[v - 1])) {	
					dp[1][i] = dp[0][v - 1] + (i - v) * (a[i] - a[v - 1]);
					p[1][i] = v;
				}
			}
		} 
		swap(p[0], p[1]);
		swap(dp[0], dp[1]);

	}
	cout << dp[0][n];
}

signed main() {
#ifdef LOCAL
	freopen("input", "r", stdin);
	freopen("output", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	run();
	
}		