#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
 
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")
*/

mt19937 gen;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const int INF = 1e9;
const int N = 1e5 + 50;
int x[N], y[N];

int t[4 * N], d[4 * N];

void upd(int v, int tl, int tr, int l, int r, int val) {
	if (l >= r) return;
	if (tl == l && tr == r) {
		d[v] += val;
		return;
	}
	d[v * 2 + 1] += d[v];
	d[v * 2 + 2] += d[v];
	d[v] = 0;
	int tm = (tl + tr) / 2;
	upd(v * 2 + 1, tl, tm, l, min(r, tm), val);
	upd(v * 2 + 2, tm, tr, max(l, tm), r, val);
	t[v] = max(t[v * 2 + 1] + d[v * 2 + 1], t[v * 2 + 2] + d[v * 2 + 2]);
}

vector<int> ids[N];

void run() {
	int n, w, h;
	cin >> n >> w >> h;
	vector<int> xs, ys;
	for(int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
		xs.push_back(x[i]);
		ys.push_back(y[i]);
	}
	xs.push_back(0);
	ys.push_back(0);
	xs.push_back(INF);
	ys.push_back(INF);
	sort(all(xs));
	sort(all(ys));
	xs.resize(unique(all(xs)) - xs.begin());
	ys.resize(unique(all(ys)) - ys.begin());
	for(int i = 0; i < n; i++) {
		ids[lower_bound(all(xs), x[i]) - xs.begin()].push_back(i);
	}
	int r = -1;
	int ans = 0;
	for(int i = 0; i < size(xs); i++) {
		while (r + 1 < size(xs) && xs[r + 1] - xs[i] <= w) {
			++r;
			for(int d : ids[r]) {
				upd(0, 0, size(xs), lower_bound(all(ys), y[d] - h) - ys.begin(),
				 upper_bound(all(ys), y[d]) - ys.begin(), 1);
			}
		}
		chkmax(ans, t[0] + d[0]);
		for(int d : ids[i]) {
				upd(0, 0, size(xs), lower_bound(all(ys), y[d] - h) - ys.begin(),
				 upper_bound(all(ys), y[d]) - ys.begin(), -1);
			
		}
	}
	cout << ans;
}

signed main() {
#ifdef LOCAL
	freopen("input", "r", stdin);
	freopen("output", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	run();
	
}	