#include <bits/stdc++.h>

#define ll long long
#define ld double
#define pb push_back
#define eb emplace_back
#define ft first
#define sd second

using namespace std;
const ll inf = (ll)1e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef FREOPEN
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif

    ll k , n;

    cin >> n >> k;
    vector <ll> a(n+1);
    vector <ll> p(n+1);
    ll sum = 0;

    for (ll i = 1; i <= n; ++i) {
        cin >> a[i];
        sum += a[i];
        p[i] = p[i-1] + a[i];
    }
    vector <ll> dplst(n+1,inf),dpcur(n+1,inf);
    dplst[0] = 0;
    ll ans = inf;
    for (ll step = 1; step <= k; ++step) {
        for (ll i = 1; i <= n; ++i) {
            ll l = 0;
            ll r = i-1;
            ll m1,m2,z1,z2;
            while (l + 2 < r) {
                m1 = l + (r-l)/3;
                m2 = r - (r-l)/3;
                z1 = dplst[m1] + (i-m1)*(p[i]-p[m1]);
                z2 = dplst[m2] + (i-m2)*(p[i]-p[m2]);
                if (z1 >= z2)
                    l = m1;
                if (z1 <= z2)
                    r = m2;
            }
            dpcur[i] = min(min(dplst[l]+(i-l)*(p[i]-p[l]),dplst[l+1]+(i-l-1)*(p[i]-p[l+1])),dplst[r]+(i-r)*(p[i]-p[r]));
            if (step == k-1) {
                ans = min(ans,dpcur[i]+(n-i)*(sum-p[i]));
            }
        }
        ans = min(ans,dpcur[n]);
        dplst = dpcur;
        fill(dpcur.begin(),dpcur.end(),inf);
    }
    ans -= sum;
    cout << ans;
    return 0;
}