#include <bits/stdc++.h>

using namespace std;
#define fin(i, s, n) for(auto i = s; i < n; ++i)
#define fine(i, s, n) for(auto i = s; i <= n; ++i)
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define x first
#define y second
#define int int64_t
using ii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;
const int SZ = 1005;



struct yt {
    int l,r,mid,v=0;
    yt *lp = nullptr, *rp = nullptr;
    yt(int l, int r) : l(l), r(r), mid((l+r)>>1) {}
    void add(int i) {
        ++v;
        if(l!=r) {
            if(i <= mid) {
                if(!lp) lp = new yt(l,mid);
                lp->add(i);
            } else {
                if(!rp) rp = new yt(mid+1,r);
                rp->add(i);
            }
        }
    }
    int query(int f, int t) {
        if(f <= l && r <= t) return v;
        return ((f<=mid&&(lp!=nullptr))?lp->query(f,t):0) + ((t>mid&&(rp!=nullptr))?rp->query(f,t):0);
    }
};
struct tr {
    int l,r,mid,v=0;
    tr *lp = nullptr,*rp = nullptr;
    yt* ytr;
    tr(int lx, int rx, int ly, int ry) : l(lx),r(rx),mid((l+r)>>1),ytr(new yt(ly,ry)) {}
    void add(int x, int y) {
        ytr->add(y);
        ++v;
        if(l!=r) {
            if(x <= mid) {
                if(!lp) lp = new tr(l,mid,ytr->l,ytr->r);
                lp->add(x,y);
            } else {
                if(!rp) rp = new tr(mid+1,r,ytr->l,ytr->r);
                rp->add(x,y);
            }
        }
    }
    int query(int fx, int tx, int fy, int ty) {
        if(fx <= l && r <= tx) {
            return ytr->query(fy,ty);
        }
        return ((fx<=mid&&(lp!=nullptr))?lp->query(fx,tx,fy,ty):0) + ((tx>mid&&(rp!=nullptr))?rp->query(fx,tx,fy,ty):0);
    }
};



int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, w, h;
    cin >> n >> w >> h;
    tr* t = new tr(0,SZ+1,0,SZ+1);
    vector<ii> ps(n);
    vvi count(SZ, vi(SZ, 0));
    for (auto &p : ps) {
        cin >> p.x >> p.y;
        ++p.x;  ++p.y;
        ++count[p.x][p.y];
        t->add(p.x,p.y);
    }
    vvi dp(SZ, vi(SZ, 0));
    dp[0][0] = count[0][0];
    /*fin(i, 0, SZ) {
        fin(j, 0, SZ) {
            dp[i][j] = count[i][j];
            if (i) dp[i][j] += dp[i - 1][j];
            if (j) dp[i][j] += dp[i][j - 1];
            if (i && j) dp[i][j] -= dp[i - 1][j - 1];
            if(dp[i][j] != t->query(0,i,0,j)) cout << "dp[" << i << "][" << j << "] = " << dp[i][j] << ",tree says " << t->query(0,i,0,j) << '\n';
        }
    }*/
    int best = 0;
    for(int x = w+1; x < SZ; ++x) {
        for(int y = h+1; y < SZ; ++y) {
//            int cur = dp[x][y] - dp[x-w-1][y] - dp[x][y-h-1] + dp[x-w-1][y-h-1];
            best = max(best,t->query(x-w,x,y-h,y));
        }
    }
    cout << best << '\n';
    return 0;
}