#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

const ll Inf = 1e18;
 
int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  int n, k;
  cin >> n >> k;
  vector <int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  vector <ll> pref(n + 1);
  for (int i = 0; i < n; ++i) {
    pref[i + 1] = pref[i] + a[i];
  }
  auto get = [&] (ll x) {
    vector <ll> dp(n + 1, Inf);
    vector <int> go(n + 1, -1);
    dp[0] = 0;
    for (int i = 1; i <= n; ++i) {
      for (int j = 0; j < i; ++j) {
        ll cur = dp[j] + (pref[i] - pref[j]) * (i - j - 1) + x;
        if (cur < dp[i]) {
          dp[i] = cur;
          go[i] = j;
        }
      }
    }
    ll cost = dp[n]; 
    int cnt = 0;
    int id = n;
    while (id != 0) {
      ++cnt;
      id = go[id];
    }
    return make_pair(cost, cnt);
  };  
  ll l = -1, r = 1e13;
  while (r - l > 1) {
    ll m = (l + r) / 2;
    if (get(m).second > k) l = m;
    else r = m;
  }
  cout << get(r).first - r * k << '\n';
}
