#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int MAXN = 1e5 + 5;

int x[MAXN];
int y[MAXN];

int t[8 * MAXN];
int add[8 * MAXN];

void push(int v)
{
    t[v] += add[v];
    add[2 * v + 1] += add[v];
    add[2 * v + 2] += add[v];
    add[v] = 0;
    return;
}

void pull(int v)
{
    t[v] = max(t[2 * v + 1] + add[2 * v + 1], t[2 * v + 2] + add[2 * v + 2]);
    return;
}

void update(int v, int tl, int tr, int l, int r, int val)
{
    push(v);
    if (tl >= r || l >= tr)
    {
        return;
    }
    if (l <= tl && tr <= r)
    {
        add[v] += val;
        return;
    }
    update(2 * v + 1, tl, (tl + tr) / 2, l, r, val);
    update(2 * v + 2, (tl + tr) / 2, tr, l, r, val);
    pull(v);
}

int h, w;

void func(int y, int val)
{
    int l = max(0, y - w);
    update(0, 0, MAXN, l, y + 1, val);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n >> h >> w;
    if (n <= 1000)
    {
        vector<pair<int, int>> a(n);
        for (int i = 0; i < n; ++i)
        {
            cin >> x[i] >> y[i];
            a[i] = {x[i], y[i]};
        }
        sort(a.begin(), a.end());
        int ans = 0;
        int r = 0;
        set<pair<int, int>> b;
        for (int i = 0; i < n; ++i)
        {
            while (r < n && a[r].first <= a[i].first + h)
            {
                b.insert({a[r].second, r});
                ++r;
            }
            vector<int> c;
            for (auto el : b)
            {
                c.push_back(el.first);
            }
            int rr = 0;
            for (int j = 0; j < c.size(); ++j)
            {
                while (rr < c.size() && c[rr] <= c[j] + w)
                {
                    ++rr;
                }
                ans = max(ans, rr - j);
            }
            b.erase({a[i].second, i});
        }
        cout << ans << endl;
        return 0;
    }
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> x[i] >> y[i];
        a[i] = {x[i], y[i]};
    }
    sort(a.begin(), a.end());
    int ans = 0;
    int r = 0;
    for (int i = 0; i < n; ++i)
    {
        while (r < n && a[r].first <= a[i].first + h)
        {
            func(a[r].second, 1);
            ++r;
        }
        ans = max(ans, t[0] + add[0]);
        func(a[i].second, -1);
    }
    cout << ans << endl;
    return 0;
}
