#include <bits/stdc++.h>
#define DIM 200010
using namespace std;

struct segment_tree{
    int maxi,lazy;
} aint[DIM*4];

pair <int,int> v[DIM];

set <int> s;
int n,i,pos_dr,pos_st,maxi,w,h;

void update_lazy (int nod, int st, int dr){

    if (!aint[nod].lazy)
        return;

    if (st != dr){
        int fiu_st = nod<<1, fiu_dr = (nod<<1)|1;
        aint[fiu_st].maxi += aint[nod].lazy;
        aint[fiu_st].lazy += aint[nod].lazy;

        aint[fiu_dr].maxi += aint[nod].lazy;
        aint[fiu_dr].lazy += aint[nod].lazy;
    }

    aint[nod].lazy = 0;

}

void update (int nod, int st, int dr, int x, int y, int val){
    update_lazy (nod,st,dr);
    if (x <= st && dr <= y){

        aint[nod].maxi += val;
        aint[nod].lazy += val;

        update_lazy (nod,st,dr);

        return;
    }

    int mid = (st+dr)>>1;
    if (x <= mid)
        update (nod<<1,st,mid,x,y,val);
    if (y > mid)
        update ((nod<<1)|1,mid+1,dr,x,y,val);

    update_lazy (nod<<1,st,mid);
    update_lazy ((nod<<1)|1,mid+1,dr);

    aint[nod].maxi = max (aint[nod<<1].maxi,aint[(nod<<1)|1].maxi);

}

int main (){

    //ifstream cin ("date.in");
    //ofstream cout ("date.out");

    cin>>n>>w>>h;
    for (i=1;i<=n;i++){
        cin>>v[i].first>>v[i].second;
        s.insert(v[i].first);
        //events[v[i].first].push_back(v[i].second);
        maxi = max (maxi,v[i].second);
    }

    maxi += h;

    sort (v+1,v+n+1);

    /// in fiecare pozitie din aint reprezita suma unui dreptunghi care se termina acolo
    pos_st = 1, pos_dr = 1;
    int sol = 0;
    for (auto it : s){

        while (pos_dr <= n && v[pos_dr].first == it){

            /// adaug punctul asta

            update (1,1,maxi,v[pos_dr].second,v[pos_dr].second + h - 1,1);

            pos_dr++;
        }

        while (pos_st <= pos_dr && it - v[pos_st].first + 1 > w){

            /// trb sa sterg punctul asta
            update (1,1,maxi,v[pos_st].second,v[pos_dr].second + h - 1,-1);

            pos_st++;
        }

        sol = max (sol,aint[1].maxi);

    }

    cout<<sol;



    return 0;
}
