#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define sz(x) (long long)((x).size())
#define f first
#define s second

const ll mod197 = 1e9 + 7;

void initial(){
#ifdef PC
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}
signed main(){
    initial();
    ll n, k;
    cin >> n >> k;
    ll dp[n][k + 1];
    vector <ll> a(n);
    vector <ll> pref(n + 1, 0);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j <= k; j++)
            dp[i][j] = 1e15;

    for (int i = n - 1; i >= 0; i--)
    {
        dp[i][1] = (pref[n] - pref[i]) * (n - i - 1);
        for (int j = 2; j <= k; j++)
        {
            ll l = 0, r = n - 1;
            while (r - l > 2)
            {
                int m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
                ll f1 = dp[m1][j - 1] + (pref[m1] - pref[i]) * (m1 - i - 1);
                ll f2 = dp[m2][j - 1] + (pref[m2] - pref[i]) * (m2 - i - 1);
                if (f1 > f2)
                    l = m1;
                else
                    r = m2;
            }
            ll f1 = dp[l][j - 1] + (pref[l] - pref[i]) * (l - i - 1);
            ll f2 = dp[l + 1][j - 1] + (pref[l + 1] - pref[i]) * (l + 1 - i - 1);
            ll f3 = dp[l + 2][j - 1] + (pref[l + 2] - pref[i]) * (l + 2 - i - 1);
            dp[i][j] = min({f1, f2, f3});
        }
    }
    cout << dp[0][k];
}