﻿#include <iostream>
//#include <algorithm>
#include <set>
//#include <map>
#include <vector>
//#include <iomanip>
//#include <cmath>
//#include <regex>
#include <string>

using namespace std;

vector <set <char>> names(26);

vector <vector <long long>> dp(2, vector <long long>(1 << 26, 0));

bool get(int mask, int index) {
	return (mask >> index) > 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	string str;
	for (int i = 0; i < 26; ++i) {
		cin >> str;
		for (auto ch : str)
			names[i].insert(ch);
	}
	for (auto el : names[0]) {
		dp[0][1 << (el - 'A')] = 1;
	}
	for (int i = 1; i < 26; ++i) {
		for (int mask = 0; mask < (1 << 26); ++mask) {
			for (auto el : names[i]) {
				if (!get(mask, (int)(el - 'A'))) {
					dp[i % 2][mask + (1 << (el - 'A'))] += dp[(i + 1) % 2][mask];
				}
			}
		}
	}
	cout << dp[1][(1 << 26) - 1];
}