﻿#include <iostream>
#include <set>
#include <vector>
#include <string>

using namespace std;

vector <set <int>> names(26);

vector <long long> dp1(67108864, 0);
vector <long long> dp2(67108864, 0);

vector <vector <int>> must_to_see(30);

bool get(int mask, int index) {
	return (mask >> index) % 2 == 1;
}

int sum_of_cifr(int mask) {
	int count = 0;
	while (mask > 0) {
		count += mask % 2;
		mask /= 2;
	}
	return count;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	string str;
	for (int i = 0; i < 26; ++i) {
		cin >> str;
		for (auto ch : str)
			names[i].insert(int(ch - 'A'));
	}
	for (auto el : names[0]) {
		dp1[1 << el] = 1;
	}
	for (int mask = 0; mask < (1 << 26); ++mask) {
		must_to_see[sum_of_cifr(mask)].push_back(mask);
	}
	for (int i = 1; i < 26; ++i) {
		for (auto el : names[i]) {
			for (int mask : must_to_see[i]) {
				if (!get(mask, el)) {
					if (i % 2 == 0)
						dp1[mask + (1 << el)] += dp2[mask];
					else
						dp2[mask + (1 << el)] += dp1[mask];
				}
			}
		}
		for (int mask : must_to_see[i]) {
			if (i % 2 == 0)
				dp2[mask] = 0;
			else
				dp1[mask] = 0;
		}
	}
	cout << dp2[67108863];
}