﻿#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <iomanip>
#include <cmath>
#include <regex>
#include <string>

using namespace std;

long long a[100000];
long long pref[100000];

int n, k;

long long dp[6001][6001];

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n >> k;
	cin >> a[0];
	pref[0] = a[0];
	for (int i = 1; i < n; ++i) {
		cin >> a[i];
		pref[i] = pref[i - 1] + a[i];
	}
	for (int i = 1; i <= n; ++i) {
		dp[i][1] = pref[i - 1] * i;
		for (int j = 2; j <= min(i, k); ++j) {
			dp[i][j] = dp[i - 1][j - 1] + a[i - 1];
			for (int r = j - 1; r < i; ++r) {
				dp[i][j] = min(dp[i][j], dp[r][j - 1] + (pref[i - 1] - pref[r - 1]) * (i - r));
			}
		}
	}
	cout << dp[n][k] - pref[n - 1];
}