﻿#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <iomanip>
#include <cmath>
#include <regex>
#include <string>

using namespace std;

int n;
long long w, h;

struct point {
	long long x, y;
};

vector <point> points;

vector <long long> px;
vector <long long> py;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n;
	cin >> w >> h;
	point point1;
	for (int i = 0; i < n; ++i) {
		cin >> point1.x >> point1.y;
		points.push_back(point1);
		px.push_back(point1.x);
		py.push_back(point1.y);
	}
	int maximum = 0;
	long long lx, rx, ly, ry;
	if (n > 1000) {
		for (int k = 0; k < n; ++k) {
			lx = px[k] - w;
			rx = px[k];
			ly = py[k] - h;
			ry = py[k];
			int count = 0;
			for (int j = 0; j < n; ++j) {
				if (lx <= points[j].x && rx >= points[j].x) {
					if (ly <= points[j].y && ry >= points[j].y) {
						++count;
					}
				}
			}
			maximum = max(count, maximum);
		}
		cout << maximum;
		return 0;
	}
	for (int i = 0; i < n; ++i) {
		for (int k = 0; k < n; ++k) {
			lx = px[i];
			rx = lx + w;
			ly = py[k];
			ry = ly + h;
			int count = 0;
			for (int j = 0; j < n; ++j) {
				if (lx <= points[j].x && rx >= points[j].x) {
					if (ly <= points[j].y && ry >= points[j].y) {
						++count;
					}
				}
			}
			maximum = max(count, maximum);
		}
	}
	cout << maximum;
}