#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iostream>

using namespace std;

long long dp[2][1u << 26u];
set<int> have[2];
vector<int> arr[26];
bool was[26];
string s;

void solve() {
    for (int i = 0; i < (1u << 26u); i++) {
        dp[0][i] = dp[1][i] = 0;
    }
    for (auto &i : arr) {
        for (bool &wa : was) {
            wa = false;
        }
        cin >> s;
        for (char c : s) {
            if (was[c - 'A']) continue;
            was[c - 'A'] = true;
            i.push_back(c - 'A');
        }
    }
    have[1].insert(0);
    dp[1][0] = 1;
    for (int i = 0; i < 26; i++) {
        have[i % 2].clear();
        for (unsigned int k : arr[i]) {
            for (unsigned int mask : have[(i + 1) % 2]) {
                if (mask & (1u << k)) continue;
                have[i % 2].insert(mask | (1u << k));
                dp[i % 2][mask | (1u << k)] += dp[(i + 1) % 2][mask];
            }
        }
    }
    cout << dp[1][(1u << 26u) - 1];
}

int main() {
    solve();
    return 0;
}
