//#include <bits/stdc++.h>
#include "cstdio"
#include "math.h"
#include "vector"
#include "algorithm"
#include "set"
#include "map"
#include "stack"
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <random>
#include <cstring>
#include <unordered_map>

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

using ll = long long;

#define pll pair<ll, ll>
#define pii pair<int, int>
#define pli pair<ll, int>
#define pb push_back
#define ld long double
#define pdd pair<double, double>
#define mp make_pair
//#define f first
//#define s second

mt19937 gen(time(0));

void setIO(string name = "") {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
//    freopen((name+".in").c_str(), "r", stdin);
//    freopen((name+".out").c_str(), "w", stdout);
}

const int MAXN = 6005;
const ll INF = 1e12;

vector<ll> p(MAXN);

void build(vector<ll> &a) {
    p[0] = a[0];
    for (int i = 1; i < a.size(); i++) {
        p[i] = p[i - 1] + a[i];
    }
}

ll get_sum(int l, int r) {
    if (l) return p[r] - p[l - 1];
    return p[r];
}

int main() {
//    ifstream in;
//    ofstream out;
//    in.open(".in");
//    out.open(".out");
    setIO();
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    build(a);
//    vector<vector<ll>> dp1(n, vector<ll> (n, INF)); //dp[pref][begin_last_segment]
//    vector<vector<ll>> dp2(n, vector<ll> (n, INF)); //dp[pref][begin_pre_last_segment]
//    dp1[k - 1][k - 1] = 0;
//    for (int i = 0; i < k - 1; i++) {
//        if (i == k - 2) {
//            dp2[k - 1][k - 2] = min(dp2[k - 1][k - 2], a[i] + a[i + 1]);
//        } else {
//            dp2[k - 1][k - 1] = min(dp2[k - 1][k - 1], a[i] + a[i + 1]);
//        }
//    }
//
//    for (int i = k; i < n; i++) {
//        for (int j = 0; j < i; j++) {
//            dp1[i][i] = min(dp2[i - 1][j], dp1[i][i]);
//        }
//        for (int j = max(k - 2, 0); j < i; j++) {
//            dp2[i][j] = dp2[i - 1][j] + a[i] * (i - j) + get_sum(j, i - 1);
//        }
//        for (int j = max(k - 2, 0); j < i - 1; j++) {
//
//        }
//
//        for (int j = k - 1; j < i; j++) {
//            dp1[i][j] = dp1[i - 1][j] + a[i] * (i - j) + get_sum(j, i - 1);
//        }
//    }
    vector<vector<vector<ll>>> dp(k, vector<vector<ll>> (n, vector<ll> (n, INF))); //dp[k][pref][begin_last_segment]
    for (int i = 0; i < k; i++) {
        dp[i][i][i] = 0;
        for (int j = i + 1; j < n; j++) {
            for (int l = 0; l < j; l++) {
                dp[i][j][l] = dp[i][j - 1][l] + (j - l) * a[j] + get_sum(l, j - 1);
            }
            if (i) {
                for (int l = i - 1; l < j - 1; l++) {
                    dp[i][j][j] = min(dp[i - 1][j - 1][l], dp[i][j][j]);
                }
            }
        }
    }
    ll ans = INF;
    for (int i = k - 1; i < n; i++) {
        ans = min(ans, dp[k - 1][n - 1][i]);
    }
    cout << ans;
    return 0;
}
