#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;


string s[26];
int cnt[26];


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.in", "r", stdin);
	for (int i = 0; i < 26; i++) {
		cin >> s[i];
	}
	for (int i = 0; i < 26; i++) {
		sort(all(s[i]));
		s[i].resize(distance(s[i].begin(), unique(all(s[i]))));
	}
	for (int i = 0; i < 26; i++) {
		for (auto x: s[i]) {
			cnt[x - 'A']++;
		}
	}
	int opt = 0;
	for (int t = 0; t < 26; t++) {
		if (cnt[t] < cnt[opt]) {
			opt = t;
		}
	}
	if (cnt[opt] == 0) {
		cout << 0 << '\n';
		return 0;
	}
	gp_hash_table<int, ll> curdp, ndp;
	curdp[0] = 1;
	for (int i = 0; i < 26; i++) {
		for (auto x: curdp) {
			for (int j = 0; j < sz(s[i]); j++) {
				int val = s[i][j] - 'A';
				if (x.first & (1 << val)) {
					continue;
				}
				ndp[x.first | (1 << val)] += x.second;
			}
		}
		swap(curdp, ndp);
		ndp.clear();
	}
	ll ans = 0;
	for (auto x: curdp) {
		ans += x.second;
	}
	cout << ans << '\n';
}