#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;


string s[26];
int cnt[26];
vector<int> where[26];
bool used[26];
bool used1[26];
ll ans = 0;
vector<pair<int, int> > st;


void gen(int ii) {
	if (ii == 4) {
		cc_hash_table<int, ll> curdp, ndp;
		//map<int, ll> curdp, ndp;
		curdp[0] = 1;
		for (int i = 0; i < 26; i++) {
			if (used[i]) {
				continue;
			}
			for (auto x: curdp) {
				for (int j = 0; j < sz(s[i]); j++) {
					int val = s[i][j] - 'A';
					if (used1[val]) {
						continue;
					}
					if ((x.first >> val) & 1) {
						continue;
					}
					ndp[x.first | (1 << val)] += x.second;
				}
			}
			swap(curdp, ndp);
			ndp.clear();
		}
		for (auto x: curdp) {
			ans += x.second;
		}
		return;
	}
	for (int j = 0; j < sz(where[st[ii].second]); j++) {
		int pos = where[st[ii].second][j];
		if (!used[pos]) {
			used[pos] = true;
			used1[st[ii].second] = true;
			gen(ii + 1);
			used1[st[ii].second] = false;
			used[pos] = false;
		}
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	freopen("input.in", "r", stdin);
	for (int i = 0; i < 26; i++) {
		cin >> s[i];
	}
	for (int i = 0; i < 26; i++) {
		sort(all(s[i]));
		s[i].resize(distance(s[i].begin(), unique(all(s[i]))));
	}
	for (int i = 0; i < 26; i++) {
		for (auto x: s[i]) {
			where[x - 'A'].pb(i);
			cnt[x - 'A']++;
		}
	}
	for (int t = 0; t < 26; t++) {
		st.pb(mp(cnt[t], t));
	}
	sort(all(st));
	if (st[0].first == 0) {
		cout << 0 << '\n';
		return 0;
	}
	gen(0);
	cout << ans << '\n';
}