#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
//#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;
const int MAXN = 100228;


int n, K;
ll a[MAXN];
ll pref[MAXN];
ll dp[MAXN];
ll ndp[MAXN];


ll get(int j, int i) {
	return (pref[i] - pref[j]) * (i - j - 1) + dp[j];
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.in", "r", stdin);
	cin >> n >> K;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		pref[i] = a[i] + pref[i - 1];
	}
	dp[0] = 1e18;
	for (int i = 1; i <= n; i++) {
		dp[i] = pref[i] * (i - 1);
	}
	for (int k = 2; k <= K; k++) {
		int uk = k - 1;
		vector<int> ids;
		for (int i = 1; i <= n; i++) {
			ndp[i] = 1e18;
			if (uk < i) {
				int l = 0;
				int r = sz(ids) - 1;
				if (n > 1000) {
					while (l + 40 < r) {
						ll mid1 = l + (r - l) / 3;
						ll mid2 = l + (r - l) / 3 * 2;
						if (get(ids[mid1], i) > get(ids[mid2], i)) {
							l = mid1;
						} else {
							r = mid2;
						}
					}
				}
				for (int j = l; j <= r; j++) {
					chkmin(ndp[i], get(ids[j], i));
				}
			}
			if (dp[i] < 1e17) {
				while (!ids.empty() && dp[ids.back()] >= dp[i]) {
					ids.pop_back();
				}
				ids.pb(i);
			}
		}
		for (int i = 1; i <= n; i++) {
			dp[i] = ndp[i];
		}
	}
	cout << dp[n] << '\n';
}