#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
//#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
const int MAXN = 100228;


int n, K;
ll a[MAXN];
ll pref[MAXN];
ll dpk[MAXN], ndpk[MAXN];
pair<double, int> dp[MAXN];
pair<int, ll> opt[MAXN];

ll get(int j, int i) {
	return (pref[i] - pref[j]) * (i - j - 1) + dpk[j];
}


void relax(int i, int j, double lyamda) {
	if (chkmin(dp[i], mp(lyamda + pref[i] * i   + dp[j].first + pref[j] * j  - pref[i] * j - pref[j] * i, dp[j].second - 1))) {
		opt[i] = mp(i - j, pref[i] - pref[j]);
	}
}

pair<double, int> getres(double lyamda, bool need = false) {
	for (int i = 1; i <= n; i++) {
		dp[i] = mp(pref[i] * i + lyamda, -1);
		opt[i] = mp(i, pref[i]);
	}
	for (int i = 1; i < n; i++) {
		int len = opt[i].first;
		ll sum = opt[i].second;
		for (int j = max(i + 1, i + len - 2); j <= min(n, i + len + 2); j++) {
			relax(j, i, lyamda);
		}
		relax(n, i, lyamda);
		for (int j = i + len + 3; j <= n; j++) {
			if (pref[j] - pref[i] >= sum) {
				break;
			}
			relax(j, i, lyamda);
		}
		relax(i + 1, i, lyamda);
		for (int j = i + len - 3; j > i + 1; j--) {
			if (pref[j] - pref[i] <= sum) {
				break;
			}
			relax(j, i, lyamda);
		}
		// i, -pref[i]
		// ll A = -pref[i];
		// ll B = i;
		// ll C = dp[i].first + pref[i] * i;
	}
	dp[n].second *= -1;
	return dp[n];
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.in", "r", stdin);
	cin >> n >> K;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		pref[i] = a[i] + pref[i - 1];
	}
	double l = 0;
	double r = 1e13;
	for (int it = 0; it < 75; it++) {
		double mid = (l + r) / 2.0;
		pair<double, int> f = getres(mid, true);
		if (f.second == K) {
			getres(mid, true);
			cout << (ll)round(f.first - K * mid - pref[n]) << '\n';
			return 0;
		}
		if (f.second > K) {
			l = mid;
		} else {
			r = mid;
		}
	}
	pair<double, int> f = getres(l, true);
	cout << (ll)round(f.first - K * l - pref[n]) << '\n';
}