#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
//#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;
const int MAXN = 100228;


int n, w, h;
int x[MAXN], y[MAXN];
int ls[MAXN], rs[MAXN];
int d[MAXN * 4], mod[MAXN * 4];
int ss = 1;



void push(int v) {
	if (mod[v] != 0) {
		d[v] += mod[v];
		if (v < ss) {
			mod[v * 2] += mod[v];
			mod[v * 2 + 1] += mod[v];
		}
		mod[v] = 0;
	}
}


void add(int v, int vl, int vr, int l, int r, int x) {
	if (l > vr || vl > r) {
		return;
	}
	if (l <= vl && vr <= r) {
		mod[v] += x;
		return;
	}
	push(v);
	add(v * 2, vl, (vl + vr) / 2, l, r, x);
	add(v * 2 + 1, (vl + vr) / 2 + 1, vr, l, r, x);
	d[v] = max(d[v * 2] + mod[v * 2], d[v * 2 + 1] + mod[v * 2 + 1]);
}


void add(int i, int val) {
	add(1, 1, ss, ls[i] + 1, rs[i] + 1, val);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.in", "r", stdin);
	cin >> n >> w >> h;
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
	}
	vector<pair<int, int> > order;
	for (int i = 0; i < n; i++) {
		order.pb(mp(x[i], i));
	}
	sort(all(order));
	vector<int> vy;
	for (int i = 0; i < n; i++) {
		vy.pb(y[i]);
	}
	sort(all(vy));
	vy.resize(distance(vy.begin(), unique(all(vy))));
	for (int i = 0; i < n; i++) {
		ls[i] = lower_bound(all(vy), y[i] - h) - vy.begin();
		rs[i] =	lower_bound(all(vy), y[i]) - vy.begin();
	}
	while (ss < n) {
		ss <<= 1;
	}
	int uk = 0;
	int ans = 0;
	for (int i = 0; i < n; i++) {
		while (uk < n && order[uk].first <= order[i].first + w) {
			add(order[uk].second, 1);
			uk++;
		}
		chkmax(ans, d[1] + mod[1]);
		add(order[i].second, -1);
	}
	cout << ans << '\n';
}