#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define mp make_pair
#define fi first
#define se second
#define pii pair<int, int>
#define pip pair<int, pii>
#define all(a) a.begin(), a.end()
#define sz(a) (int) a.size()
#define chkmax(a, b) a = max(a, b)
#define chkmin(a, b) a = min(a, b)
#define ld long double

const int inf = 1e15 + 7;
const int max_n = 6001;

int n, k;
int a[max_n];
int dp[max_n][max_n];
int id[max_n][max_n];

void solve() {
	cin >> n >> k;
	for(int i = 0;i < n;i++)
		cin >> a[i];
	for(int i = 1;i < n;i++)
		a[i] += a[i - 1];

	for(int i = 0;i < n;i++) {
		for(int j = 0;j <= k;j++)
			dp[j][i] = inf;
	}

	for(int i = 1;i <= k;i++)
		dp[i][0] = a[0];

	for(int i = 1;i < n;i++) {
		for(int j = k;j >= 1;j--) {
			int lft, rght;
			if (i == 1) lft = 0;
			else lft = id[i - 1][j];

			if (j == k) rght = i - 1;
			else rght = id[i][j + 1];

			for(int r = lft;r <= rght;r++) {
				int q = a[i] * (i + 1);
				if (r != -1) {
					q = (i - r) * (a[i] - a[r]) + dp[j - 1][r];
				}

				if (dp[j][i] > q) {
					dp[j][i] = q;
					id[i][j] = r;
				}
			}


			chkmin(dp[j][i], a[i] * (i + 1));
		}
	}

	cout << dp[k][n - 1] - a[n - 1];
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);

	solve();
}