#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define mp make_pair
#define fi first
#define se second
#define pii pair<int, int>
#define pip pair<int, pii>
#define all(a) a.begin(), a.end()
#define sz(a) (int) a.size()
#define chkmax(a, b) a = max(a, b)
#define chkmin(a, b) a = min(a, b)
#define ld long double

const int inf = 1e15 + 7;
const int max_n = (1 << 17);


int sum[2 * max_n];

void add_seg(int id, int x, int v = 1, int l = 0, int r = max_n - 1) {
	if (l > id || r < id) return;
	if (l == id && r == id) {
		sum[v] += x;
		return;
	}
	int m = ((l + r) >> 1);
	add_seg(id, x, v * 2, l, m);
	add_seg(id, x, v * 2 + 1, m + 1, r);
	sum[v] = sum[v * 2] + sum[v * 2 + 1];
}

int get_sum(int tl, int tr, int v = 1, int l = 0, int r = max_n - 1) {
	if (l > tr || r < tl) return 0;
	if (l >= tl && r <= tr) return sum[v];
	int m = ((l + r) >> 1);
	return get_sum(tl, tr, v * 2, l, m) + get_sum(tl, tr, v * 2 + 1, m + 1, r);
}

void solve() {
	int n, w, h;
	cin >> n >> w >> h;
	vector<pii> po(n);
	for(int i = 0;i < n;i++)
		cin >> po[i].fi >> po[i].se;

	sort(all(po));

	int id = 0;

	int res = 0;

	for(pii st : po) {
		add_seg(st.se, 1);
		while(po[id].fi < st.fi - w) {
			add_seg(po[id].se, -1);
			id++;
		}
		
		int new_res = get_sum(st.se - h, st.se);

		chkmax(res, new_res);

	}

	cout << res;
}



signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);

	solve();
}