#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ll long long
#define mp make_pair
#define fi first
#define se second
#define pii pair<int, int>
#define pip pair<int, pii>
#define all(a) a.begin(), a.end()
#define sz(a) (int) a.size()
#define chkmax(a, b) a = max(a, b)
#define chkmin(a, b) a = min(a, b)
#define ld long double

const int inf = 1e15 + 7;
const int max_n = (1 << 23);


int mx[2 * max_n];
int push[2 * max_n];
int lc[2 * max_n], rc[2 * max_n];
int siz = 2;

void push_num(int v, int x) {
	push[v] += x;
	mx[v] += x;
}

void push_down(int v) {
	push_num(lc[v], push[v]);
	push_num(rc[v], push[v]);
	push[v] = 0;
}

void push_up(int v) {
	mx[v] = max(mx[lc[v]], mx[rc[v]]);
}


void add_seg(int tl, int tr, int x, int v = 1, int l = 0, int r = max_n - 1) {
	if (l > tr || r < tl) return;
	if (l >= tl && r <= tr) {
		push[v] += x;
		mx[v] += x;
		return;
	}

	if (lc[v] == 0) lc[v] = siz++;
	if (rc[v] == 0) rc[v] = siz++;

	push_down(v);
	int mid = ((l + r) >> 1);
	add_seg(tl, tr, x, lc[v], l, mid);
	add_seg(tl, tr, x, rc[v], mid + 1, r);
	push_up(v);

	//cout << v << " " << mx[v] << endl;
}

int get_mx() {
	return mx[1];
}

void solve() {
	int n, w, h;
	cin >> n >> w >> h;
	vector<pii> po(n);
	for(int i = 0;i < n;i++)
		cin >> po[i].fi >> po[i].se;

	sort(all(po));

	int id = 0;

	int res = 0;

	int last = -1;

	for(pii st : po) {
			
		if (last == st.fi) {
			add_seg(st.se, st.se + h, 1);
			continue;
		}
		last = st.fi;

		int new_res = get_mx();

		chkmax(res, new_res);

		add_seg(st.se, st.se + h, 1);
		while(po[id].fi < st.fi - w) {
			add_seg(po[id].se, po[id].se + h, -1);
			//cout << "-1 " << po[id].se << " " << po[id].se + h << endl;
			id++;
		}
	}

	chkmax(res, get_mx());

	cout << res;
}



signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);

	solve();
}