#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
mt19937 rng((long long) (new char));
vector<int> bits[26];
int mask[26];
bool act[26];
int f[26];
ll sol;

const int C = (int) 3e6;

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  for (int i = 0; i < 26; i++) {
    act[i] = 1;
    string s;
    cin >> s;
    int mask_s = 0;
    for (auto &ch : s) {
      int x = ch - 'A';
      mask[i] |= (1 << x);
    }
  }
  shuffle(mask, mask + 26, rng);
  for (int i = 0; i < 26; i++) {
    for (int j = 0; j < 26; j++) {
      if (mask[i] & (1 << j)) {
        f[j]++;
        bits[i].push_back(j);
      }
    }
  }
  for (int i = 0; i < 26; i++) {
    if (f[i] == 0) {
      cout << "0\n";
      return 0;
    }
  }
  unordered_map<int, int> dp; dp.rehash(C);
  dp[0] = 1;
  for (int step = 0; step < 13; step++) {
    if (!act[step]) {
      continue;
    }
    unordered_map<int, int> dp2; dp2.rehash(C);
    for (auto &it : dp) {
      for (auto &b : bits[step]) {
        if (!(it.first & (1 << b))) {
          dp2[it.first ^ (1 << b)] += it.second;
        }
      }
    }
    dp = dp2;
  }
  unordered_map<int, int> DP; DP.rehash(C);
  DP[0] = 1;
  for (int step = 13; step < 26; step++) {
    if (!act[step]) {
      continue;
    }
    unordered_map<int, int> dp2; dp2.rehash(C);
    for (auto &it : DP) {
      for (auto &b : bits[step]) {
        if (!(it.first & (1 << b))) {
          dp2[it.first ^ (1 << b)] += it.second;
        }
      }
    }
    DP = dp2;
  }
  int tot = (1 << 26) - 1;
  ll sol = 0;
  if ((int) dp.size() < (int) DP.size()) {
    for (auto &it : dp) {
      sol += (ll) it.second * DP[tot ^ it.first];
    }
  } else {
    for (auto &it : DP) {
      sol += (ll) it.second * dp[tot ^ it.first];
    }
  }
  cout << sol << "\n";

}
