#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
mt19937 rng(777);
vector<int> bits[26];
int mask[26];
bool act[26];
int f[26];
ll sol;
vector<pair<int, int>> dp;
vector<pair<int, int>> DP;

int value_dp(int x) {
  int l = 0, r = (int) dp.size() - 1;
  while (l <= r) {
    int m = (l + r) / 2;
    if (dp[m].first == x) {
      return dp[m].second;
    }
    if (dp[m].first < x) {
      l = m + 1;
    } else {
      r = m - 1;
    }
  }
  return 0;
}

int value_DP(int x) {
  int l = 0, r = (int) DP.size() - 1;
  while (l <= r) {
    int m = (l + r) / 2;
    if (DP[m].first == x) {
      return DP[m].second;
    }
    if (DP[m].first < x) {
      l = m + 1;
    } else {
      r = m - 1;
    }
  }
  return 0;
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  for (int i = 0; i < 26; i++) {
    act[i] = 1;
    string s;
    cin >> s;
    int mask_s = 0;
    for (auto &ch : s) {
      int x = ch - 'A';
      mask[i] |= (1 << x);
    }
  }
  ///shuffle(mask, mask + 26, rng);
  sort(mask, mask + 26);
  for (int i = 0; i < 26; i++) {
    for (int j = 0; j < 26; j++) {
      if (mask[i] & (1 << j)) {
        f[j]++;
        bits[i].push_back(j);
      }
    }
  }
  for (int i = 0; i < 26; i++) {
    if (f[i] == 0) {
      cout << "0\n";
      return 0;
    }
  }
  dp.push_back({0, 1});
  for (int step = 0; step < 13; step++) {
    if (!act[step]) {
      continue;
    }
    vector<pair<int, int>> dp2;
    for (auto &it : dp) {
      for (auto &b : bits[step]) {
        if (!(it.first & (1 << b))) {
          dp2.push_back({it.first ^ (1 << b), it.second});
        }
      }
    }
    sort(dp2.begin(), dp2.end());
    dp.clear();
    int l = 0;
    while (l < (int) dp2.size()) {
      int r = l, sum = dp2[r].second;
      while (r + 1 < (int) dp2.size() && dp2[r].first == dp2[r + 1].first) {
        r++;
        sum += dp2[r].second;
      }
      dp.push_back({dp2[l].first, sum});
      l = r + 1;
    }
  }
  DP.push_back({0, 1});
  for (int step = 13; step < 26; step++) {
    if (!act[step]) {
      continue;
    }
    vector<pair<int, int>> dp2;
    for (auto &it : DP) {
      for (auto &b : bits[step]) {
        if (!(it.first & (1 << b))) {
          dp2.push_back({it.first ^ (1 << b), it.second});
        }
      }
    }
    sort(dp2.begin(), dp2.end());
    DP.clear();
    int l = 0;
    while (l < (int) dp2.size()) {
      int r = l, sum = dp2[r].second;
      while (r + 1 < (int) dp2.size() && dp2[r].first == dp2[r + 1].first) {
        r++;
        sum += dp2[r].second;
      }
      DP.push_back({dp2[l].first, sum});
      l = r + 1;
    }
  }
  int tot = (1 << 26) - 1;
  ll sol = 0;
  if ((int) dp.size() < (int) DP.size()) {
    for (auto &it : dp) {
      sol += (ll) it.second * value_DP(tot ^ it.first);
    }
  } else {
    for (auto &it : DP) {
      sol += (ll) it.second * value_dp(tot ^ it.first);
    }
  }
  cout << sol << "\n";

}
