#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = (int) 1e5 + 7;
const ll INF = (ll) 1e18;
int n;
int k;
int a[N];
ll s[N];
ll dp[N];
ll dp2[N];

void dv(int l, int r, int lo, int hi) {
  if (l > r) {
    return;
  }
  int i = (l + r) / 2, opt;
  for (int j = lo; j <= min(hi, i); j++) {
    if (dp[j - 1] + (s[i] - s[j - 1]) * (i - j + 1) < dp2[i]) {
      dp2[i] = dp[j - 1] + (s[i] - s[j - 1]) * (i - j + 1);
      opt = j;
    }
  }
  dv(l, i - 1, lo, opt);
  dv(i + 1, r, opt, hi);
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);


  cin >> n >> k;
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
    s[i] = s[i - 1] + a[i];
  }
  for (int i = 0; i < N; i++) {
    dp[i] = dp2[i] = INF;
  }
  dp[0] = 0;
  for (int step = 1; step <= k; step++) {
    dv(1, n, 1, n);
    for (int i = 1; i <= n; i++) {
      dp[i] = dp2[i];
      dp2[i] = INF;
    }
  }
  cout << dp[n] - s[n] << "\n";
}
