#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = (int) 1e5 + 7;
const ll INF = (ll) 1e18;
int n;
int k;
int a[N];
ll s[N];
ll dp[N];
ll dp2[N];

ll eval(int i, int j) {
  return dp[j - 1] + (s[i] - s[j - 1]) * (i - j + 1);
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  ///freopen ("input", "r", stdin);

  cin >> n >> k;
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
    s[i] = s[i - 1] + a[i];
  }
  for (int i = 0; i < N; i++) {
    dp[i] = dp2[i] = INF;
  }
  dp[0] = 0;
  for (int step = 1; step <= k; step++) {
    int j = 1;
    for (int i = 1; i <= n; i++) {
      while (j + 1 <= i && eval(i, j + 1) <= eval(i, j)) {
        j++;
      }
      dp2[i] = eval(i, j);
    }
    for (int i = 1; i <= n; i++) {
      dp[i] = dp2[i];
      dp2[i] = INF;
    }
  }
  cout << dp[n] - s[n] << "\n";
}
