#define fast ios::sync_with_stdio(false); cin.tie(0);
#define foru(i, k, n) for (int i = k; i < n; i++)
#define ford(i, k, n) for (int i = k; i >= n; i--)
#define pb push_back

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int sz = 1e5;
int n, k;
int a[sz];
ll p[sz];
inline ll query(int i, int j) { return (j >= i ? p[j] - (i ? p[i - 1] : 0) : 0); }
ll prv[sz], dp[sz];

int main() {
	fast;
	cin >> n >> k;
	foru(i, 0, n) {
		cin >> a[i]; p[i] = (i ? p[i - 1] : 0) + a[i];
	}
	if (k > 3) {
		for (int i = 0; i < n; i++) {
			prv[i] = query(0, i)*i; dp[i] = 1e17;
		}
		for (int pk = 2; pk <= k; pk++) {
			ll crmn = 1e17;
			for (int i = 0; i < n; i++) {
				for (int j = pk - 2; j < i; j++) {
					dp[i] = min(dp[i], query(j + 1, i)*(i - j - 1) + prv[j]);
				}
			}
			for (int j = 0; j < n; j++)prv[j] = dp[j];
		}
		cout << prv[n - 1];
	}
	else {
		ll bstret = 1e17;
		for (int i = 0; i < n - 2; i++) {
			ll cur = query(0, i)*i;
			int l = i + 1, r = n - 1, mid, bst = -1;
			while (l <= r) {
				mid = (l + r + 1) / 2;
				if (query(i + 1, mid) <= query(mid + 1, n - 1)) {
					bst = mid;
					l = mid + 1;
				}
				else r = mid - 1;
			}
			for (int j = -5; j <= 5; j++) {
				int nm = bst + j;
				if (nm > i&&nm < n-1) {
					ll x = (ll)(nm - i - 1)*query(i + 1, nm), y = (ll)(n - nm - 2)*query(nm + 1, n - 1);
					bstret = min(bstret, cur + x + y);
				}
			}
		}
		cout << bstret << '\n';
	}
	return 0;
}