#include <bits/stdc++.h>
#define i2 array<int,2>
#define PB push_back
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
using namespace std;
typedef long long ll;
//typedef long long __int128;
typedef long double ld;
const int oo = 2e9;
const ll OO = 1e18;
const int N = 100100;
const int K = 6010;
const ld E = 1e-9;
ll f[N][2], pref[N];
vector<ll> pts;
int n, a[N], k;

//__int128 now;

struct line{
    ll a, b, c;

    line(): a(0), b(0), c(0) {}
    line(ll A, ll B, ll C): a(A), b(B), c(C) {}
};

line empt = {0, 0, OO}, st[4 * N];

void build_Li(int v, int l, int r){
    st[v] = empt;
    if (l == r) return;

    int md = (l + r) >> 1;

    build_Li(v + v, l, md);
    build_Li(v + v + 1, md + 1, r);
}

ll get_val(line fi, ll loc){
    return fi.a * pref[loc] + fi.b * loc + fi.c;
}

void update(int v, int l, int r, line nw){
    int md = (l + r) >> 1;

    bool lf = bool(get_val(nw, l) < get_val(st[v], l));
    bool mid = bool(get_val(nw, md) < get_val(st[v], md));

    if (mid) swap(nw, st[v]);

    if (l == r) return;

    if (mid != lf)
        update(v + v, l, md, nw);
    else update(v + v + 1, md + 1, r, nw);
}

ll get_best(int v, int l, int r, int loc){
    ll cur = get_val(st[v], loc);

    if (l == r) return cur;

    int md = (l + r) >> 1;

    if (loc <= md)
        return min(cur, get_best(v + v, l, md, loc));
    else return min(cur, get_best(v + v + 1, md + 1, r, loc));
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef _LOCAL
    freopen("in.txt","r",stdin);
#endif // _LOCAL

    cin >> n >> k;

//    assert(n <= 6010);

    pref[0] = 0;

    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }

    for (int i = 0; i <= n; i++)
    for (int j = 0; j <= k; j++)
        f[i][j] = OO;

    f[0][0] = 0;
    int tp = 0;

    for (int cn = 0; cn < k; cn++){
        build_Li(1, 1, n);
        tp ^= 1;

        f[0][tp] = OO;
        bool was = 0;

        for (int i = 1; i <= n; i++){
            if (f[i - 1][tp ^ 1] != OO){
                ll l = i;
                line cur = {-l, -pref[l - 1], pref[l - 1] * l + f[i - 1][tp ^ 1]};
                was = 1;

                update(1, 1, n, cur);
            }

            if (was){
                f[i][tp] = ll(i) * pref[i] + get_best(1, 1, n, i);
            } else f[i][tp] = OO;
        }
    }

    cout << f[n][tp];

    return 0;
}
