#include <bits/stdc++.h>
#define i2 array<int,2>
#define PB push_back
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#define pli pair<line,int>
#define MP make_pair
#define ft first
#define sd second
using namespace std;
typedef long long ll;
typedef long double ld;
const int oo = 2e9;
const ll OO = 1e18;
const int N = 100100;
const int K = 6010;
const ld E = 1e-9;
ll f[N], pref[N], cnt[N];
vector<ll> pts;
int n, a[N], k;

struct line{
    ll a, b, c;

    line(): a(0), b(0), c(0) {}
    line(ll A, ll B, ll C): a(A), b(B), c(C) {}
};

line empt = {0, 0, OO};
pli st[4 * N];

void build_Li(int v, int l, int r){
    st[v] = MP(empt, 0);
    if (l == r) return;

    int md = (l + r) >> 1;

    build_Li(v + v, l, md);
    build_Li(v + v + 1, md + 1, r);
}

ll get_val(line fi, ll loc){
    return fi.a * pref[loc] + fi.b * loc + fi.c;
}

void update(int v, int l, int r, pli nw){
    int md = (l + r) >> 1;

    bool lf = bool(get_val(nw.ft, l) < get_val(st[v].ft, l));
    bool mid = bool(get_val(nw.ft, md) < get_val(st[v].ft, md));

    if (mid) swap(nw, st[v]);

    if (l == r) return;

    if (mid != lf)
        update(v + v, l, md, nw);
    else update(v + v + 1, md + 1, r, nw);
}

pli get_best(int v, int l, int r, int loc){
    pli cur = st[v];

    if (l == r) return cur;

    int md = (l + r) >> 1;

    pli nw;

    if (loc <= md)
        nw = get_best(v + v, l, md, loc);
    else nw = get_best(v + v + 1, md + 1, r, loc);

    if (get_val(cur.ft, loc) > get_val(nw.ft, loc))
        swap(cur, nw);

    return cur;
}

int calc_ans(ll ad){
    f[0] = 0;

    build_Li(1, 1, n);

    f[0] = 0;
    cnt[0] = 0;

    for (int i = 1; i <= n; i++){
        if (f[i - 1] != OO){
            ll l = i;
            line cur = {-l, -pref[l - 1], pref[l - 1] * l + f[i - 1] + ad};

            update(1, 1, n, MP(cur, cnt[i - 1] + 1));
        }

        pli NOW = get_best(1, 1, n, i);

        f[i] = ll(i) * pref[i] + get_val(NOW.ft, i);
        cnt[i] = NOW.sd;
    }

    return cnt[n];
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef _LOCAL
    freopen("in.txt","r",stdin);
#endif // _LOCAL

    cin >> n >> k;

//    assert(n <= 6010);

    pref[0] = 0;

    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }

        // smaller(?)
    ll LF = 0, RT = (ll(1e17) + k - 1) / k;

    while (LF < RT){
        ll md = (LF + RT) >> 1;

        int now = calc_ans(md);

        if (now == k){
            LF = md;
            break;
        }

        if (now < k)
            RT = md;
        else LF = md + 1;
    }

    calc_ans(LF);

    cout << f[n] - LF * ll(k);

    return 0;
}
