#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define i2 array<int,2>
#define PB push_back
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
using namespace std;
using namespace __gnu_pbds;
template <class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
typedef long long ll;
typedef long double ld;
const int oo = 2e9;
const ll OO = 1e18;
const int N = 100100;
const int MX = 100100;
const int BIG = (MX + MX) * 4;
//const int K = 6010;
vector<i2> events;
int n, w, h, ans = 0, x[N], y[N];
ordered_set<i2> st;

void solve(){
    events.clear();

    for (int i = 1; i <= n; i++){
        events.PB({x[i] - w, +i});
        events.PB({x[i] + 1, -i});
    }

    sort(all(events));

    st.clear();

    // if not empty st

    for (int it = 0; it < sz(events); ){
        int jt = it;

        while (jt < sz(events) && events[jt][0] == events[it][0]){
            i2 now = events[jt++];
            int id = abs(now[1]);

            if (now[1] < 0) {
                st.erase({y[id], id});
            } else {
                st.insert({y[id], id});
            }
        }

        if (sz(st) > 0){
            int now = 0;

            for (auto cr : st){
                ans = max(ans, int(st.order_of_key({cr[0] + h + 1, -oo})) - now);
                now++;
            }
        }

        it = jt;
    }
}

int vl[BIG], psh[BIG];

//struct seg_tree{
//    seg_tree *l, *r;
//    int vl, psh;
//
//    seg_tree(): l(0), r(0), vl(0), psh(0) {}
//
    void build(int v, int tl, int tr){
        vl[v] = psh[v] = 0;

        if (tl == tr) return;

        int md = (tl + tr) >> 1;

        build(v, tl, md);
        build(v, md + 1, tr);
    }

    void push(int v){
        if (psh[v] != 0){
            vl[v] += psh[v];

//            if (l) l -> psh += psh;
//            if (r) r -> psh += psh;

            if (v + v + 1 < BIG){
                psh[v + v] += psh[v];
                psh[1 + v + v] += psh[v];
            }

            psh[v] = 0;
        }
    }

    void update(int v, int tl, int tr, int ql, int qr, int ad){
        push(v);

        if (ql > qr) return;

        if (tl == ql && tr == qr) {
            psh[v] += ad;
            push(v);
            return;
        }

        int md = (tl + tr) >> 1;

        update(v + v, tl, md, ql, min(qr, md), ad);
        update(v + v + 1, md + 1, tr, max(md + 1, ql), qr, ad);

        vl[v] = max(vl[v + v], vl[v + v + 1]);
    }
//};
//
//seg_tree *root;

void se_solve(){
    events.clear();

    for (int i = 1; i <= n; i++){
        events.PB({x[i] - w, +i});
        events.PB({x[i] + 1, -i});
    }

    sort(all(events));

//    root = new seg_tree();

    build(1, 1, MX + MX);

//    for (int it = 0; it < sz(events); it++)
//        cerr << it << " " << events[it][0] << " " << events[it][1] << '\n';

    for (int it = 0; it < sz(events); ){
        int jt = it;

        while (jt < sz(events) && events[jt][0] == events[it][0]){
            i2 now = events[jt++];
            int id = abs(now[1]);

            if (now[1] < 0) {
//                root -> update(1, MX + MX, y[id], y[id] + h, -1);
                update(1, 1, MX + MX, y[id], y[id] + h, -1);
            } else {
                update(1, 1, MX + MX, y[id], y[id] + h, +1);
            }
        }

        ans = max(ans, vl[1]);

        it = jt;
    }
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef _LOCAL
    freopen("in.txt","r",stdin);
#endif // _LOCAL

    cin >> n >> w >> h;

    if (n <= 1000){
        for (int i = 1; i <= n; i++)
            cin >> x[i] >> y[i];

        solve();

        swap(w, h);

        for (int i = 1; i <= n; i++)
            swap(x[i], y[i]);

        solve();

        cout << ans;
        return 0;
    }

    for (int i = 1; i <= n; i++)
        cin >> x[i] >> y[i];

    se_solve();

    swap(w, h);

    for (int i = 1; i <= n; i++)
        swap(x[i], y[i]);

    se_solve();

    cout << ans;

    return 0;
}
