#include <bits/stdc++.h>

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/detail/standard_policies.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template < typename T > using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back
#define TIME clock() * 1.0 / CLOCKS_PER_SEC
#define sz(a) a.size()
#define endl '\n'
//#define int long long

const int N = 1e5;

vector < int > g[N + 100];

struct DO
{
    vector < int > t, add;
    int pr = 2;
    
    void build(int n)
    {
        while (pr < n) pr *= 2;
        t.resize(2 * pr, 0);
        add.resize(2 * pr, 0);
    }
    
    void push(int v)
    {
        t[v * 2] += add[v]; t[v * 2 + 1] += add[v];
        add[v * 2] += add[v]; add[v * 2 + 1] += add[v];
        add[v] = 0;
    }
    
    void upd(int l, int r, int v, int cl, int cr, int zn)
    {
//        if (v == 1)
//        {
//            if (zn == 1) cerr << "ADD " << l << " " << r << endl;
//            else cerr << "DEL " << l << " " << r << endl;
//        }
        if (cr < l || r < cl) return;
        if (cl != cr) push(v);
        if (l <= cl && cr <= r)
        {
            t[v] += zn;
            add[v] += zn;
            return;
        }
        int mid = (cl + cr) / 2;
        upd(l, r, v * 2, cl, mid, zn);
        upd(l, r, v * 2 + 1, mid + 1, cr, zn);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
    
    int get(int l, int r, int v, int cl, int cr)
    {
        if (r < cl || cr < l) return 0;
        if (cl != cr) push(v);
        if (l <= cl && cr <= r) return t[v];
        int mid = (cl + cr) / 2;
        return max(get(l, r, v * 2, cl, mid), get(l, r, v * 2 + 1, mid + 1, cr));
    }
};

DO t;

int32_t main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    int n, w, h;
    cin >> n >> w >> h;
    t.build(N + 1);
    for(int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        g[y].pb(x);
    }
    int ans = 0;
//    cerr << "0" << endl;
    for(int j = 0; j < h; j++)
    {
        for(auto x: g[j])
        {
            t.upd(x, x + w, 1, 0, t.pr - 1, 1);
        }
    }
    for(int i = 0; i <= N; i++)
    {
//        cerr << i << ":" << endl;
        if (i + h <= N)
        {
            for(auto x: g[i + h])
            {
                t.upd(x, x + w, 1, 0, t.pr - 1, 1);
            }
        }
        if (i)
        {
            for(auto x: g[i - 1])
            {
                t.upd(x, x + w, 1, 0, t.pr - 1, -1);
            }
        }
        for(auto x: g[i])
        {
            ans = max(ans, t.get(x, x + w, 1, 0, t.pr - 1));
//            cerr << x << " " << i << " " << t.get(x, x + w, 1, 0, t.pr - 1) << endl;
        }
    }
    cout << ans;
}
