#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back

const int N = 1e5 + 10;
const int INF = 1e9;
const int MOD = 1e9 + 7;
const int rx[4] = {-1, 0, 1, 0};
const int ry[4] = {0, 1, 0, -1};

mt19937 gen(time(0));

ll ans = 0;
bool used[N];
vector <int> str[26];

void dfs(int kol) {
    if (kol == 26) {
        ans ++;
        return;
    }
    for (auto to : str[kol]) {
        if (!used[to]) {
            used[to] = true;
            dfs(kol + 1);
            used[to] = false;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    for (int i = 0; i < 26; i++) {
        string name;
        cin >> name;
        set <char> st;
        for (auto it : name) st.insert(it);
        for (auto it : st) {
            str[int(it - 'A')].pb(i);
        }
    }
    dfs(0);
    cout << ans << endl;
    return 0;
}
