#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back

const int N = 1e5 + 10;
const ll INF = 1e16;
const int MOD = 1e9 + 7;
const int rx[4] = {-1, 0, 1, 0};
const int ry[4] = {0, 1, 0, -1};


mt19937 gen(time(0));

ll dp2[3][N], pref[N];

void dfs(int lev, int l, int r, int ol, int oR) {
    if (l > r) return;
    int mid = (l + r) / 2;
    dp2[lev][mid] = INF;
    int opt = -1;
    for (int i = ol; i <= min(mid - 1, oR); i++) {
        if (dp2[lev - 1][i] + (pref[mid] - pref[i]) * (mid - i - 1) <= dp2[lev][mid]) {
            opt = i;
            dp2[lev][mid] = dp2[lev - 1][i] + (pref[mid] - pref[i]) * (mid - i - 1);
        }
    }
    dfs(lev, l, mid - 1, ol, opt);
    dfs(lev, mid + 1, r, opt, oR);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    int a[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i] = a[i];
        if (i) pref[i] += pref[i - 1];
    }
    if (k == 3) {
        for (int i = 0; i < n; i++) {
            dp2[0][i] = pref[i] * i;
        }
        for (int i = 1; i < 3; i++) {
            dfs(i, 0, n - 1, 0, n - 1);
        }
        cout << dp2[2][n - 1] << endl;
        return 0;
    }
    ll dp[n][2];
    int nom[n][2];
    for (int i = 0; i < n; i++) {
        dp[i][1] = pref[i] * i;
        nom[i][1] = 0;
    }
    for (int j = 2; j <= k; j++) {
        for (int i = 0; i < n; i++) {
            dp[i][j % 2] = dp[i][(j - 1) % 2];
            nom[i][j % 2] = i;
            for (int g = max(nom[i][(j - 1) % 2], (i == 0 ? -1 : nom[i - 1][j % 2])); g < i; g++) {
                ll nw = dp[g][(j - 1) % 2] + (pref[i] - pref[g]) * (i - g - 1);
//                cerr << nw << " ";
                if (nw < dp[i][j % 2]) {
                    dp[i][j % 2] = nw;
                    nom[i][j % 2] = g;
                } else if (nw == dp[i][j % 2]) {
                    nom[i][j % 2] = max(nom[i][j % 2], g);
                }
            }
//            cerr << endl;
        }
    }
//    for (int j = 1; j <= k; j++) {
//        for (int i = 0; i < n; i++) cout << nom[i][j] << " ";
//        cout << endl;
//    }
    cout << dp[n - 1][k % 2] << endl;
    return 0;
}
