#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 1000 + 3;
int n, k, a[N];
const ll big = 1000000000000000000;
ll dp[N][N], sum[N];

ll get_sum(int l, int r){
    if (!l) return sum[r];
    return sum[r] - sum[l - 1];
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        sum[i] = a[i];
        if (i) sum[i] += sum[i - 1];
    }
    for (int j = 0; j < n; j++)
        dp[0][j] = get_sum(0, j) * 1LL * j;
    for (int i = 1; i < k; i++){
        for (int j = 0; j < n; j++){
            dp[i][j] = big;
            for (int g = j - 1; g >= 1; g--){
                dp[i][j] = min(dp[i][j], dp[i - 1][g - 1] + get_sum(g, j) * (j - g));
            }
        }
    }
    cout << dp[k - 1][n - 1];
    return 0;
}
