#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 100000 + 3;
int t[N * 4], mod[N * 8];

void push(int v, int tl, int tr){
    if (mod[v]){
        mod[v * 2] += mod[v];
        mod[v * 2 + 1] += mod[v];
        t[v * 2] += mod[v];
        t[v * 2 + 1] += mod[v];
        mod[v] = 0;
    }
}

void up(int v, int tl, int tr, int l, int r, int val){
    if (l > r) return;
    if (tl == l && tr == r){
        mod[v] += val;
        t[v] += val;
        return;
    }
    int tm = (tl + tr) / 2;
    push(v, tl, tr);
    up(v * 2, tl, tm, l, min(r, tm), val);
    up(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int get_max(int v, int tl, int tr, int l, int r){
    if (l > r) return 0;
    if (tl == l && tr == r) return t[v];
    int tm = (tl + tr) / 2;
    return max(get_max(v * 2, tl, tm, l, min(tm, r)),
               get_max(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

int n, w, h;
vector <int> events[N];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> w >> h;
    ++w; ++h;
    for (int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        events[y].pb(x);
    }
    int ans = 0;
    for (int i = 1; i <= h; i++){
        for (auto u: events[i]){
            int lotr = max(1, u - w + 1), rotr = min(N - 1, u);
            up(1, 0, N - 1, lotr, rotr, 1);
        }
    }
    ans = t[1];
    for (int i = h + 1; i < N; i++){
        for (auto u: events[i]){
            int lotr = max(1, u - w + 1), rotr = min(N - 1, u);
            up(1, 0, N - 1, lotr, rotr, 1);
        }
        for (auto u: events[i - h]){
            int lotr = max(1, u - w + 1), rotr = min(N - 1, u);
            up(1, 0, N - 1, lotr, rotr, -1);
        }
        ans = max(ans, t[1]);
    }
    cout << ans;
    return 0;
}
