
/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

#define int ll

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

void solve() {
    int n, k;
    cin >> n >> k;
    int a[n];
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int dp[n + 1][k + 1];
    const int inf = 1e18 + 7;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= k; j++)
            dp[i][j] = inf;
    }
    dp[0][0] = 0;
    int sum[n][n], sum1[n][n];
    for (int i = 0; i < n; i++) {
        sum[i][i] = 0;
        sum1[i][i] = a[i];
    }
    for (int l = 0; l < n; l++) {
        for (int r = l + 1; r < n; r++) {
            sum1[l][r] = sum1[l][r - 1] + a[r];
            sum[l][r] = sum[l][r - 1] + sum1[l][r - 1] + a[r] * (r - l);
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= k; j++) {
            for (int i1 = i; i1 >= 1; i1--) {
                dp[i][j] = min(dp[i][j], dp[i1 - 1][j - 1] + sum[i1 - 1][i - 1]);
//                cout << dp[i1 - 1][j - 1] + sum[i1 - 1][i - 1] << ' ';
            }
//            cout << endl;
        }
    }
    cout << dp[n][k] << endl;
}

signed main() {
    ios;
//    open("anime.in", "anime.out");
    int attempts = 1;
//    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}