#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

#define int long long

unordered_map<int, int> cnt; // mask -> cnt

string names[26];

int cur_mask = 0;


void rec1(int l, int r) {
    if (l == r) {
        cnt[cur_mask]++;
    } else  {
        for (char c : names[l]) {
            int x = c - 'A';
            if ((cur_mask & (1 << x)) == 0) {
                cur_mask ^= 1 << x;  
                rec1(l + 1, r);
                cur_mask ^= 1 << x;  
            }
        }
    }
}

int ans = 0;
const int all_mask = (1 << 26) - 1;

void rec2(int l, int r) {
    if (l == r) {
        int mask = all_mask ^ cur_mask;
        if (cnt.count(mask))
            ans += cnt[mask];
    } else  {
        for (char c : names[l]) {
            int x = c - 'A';
            if ((cur_mask & (1 << x)) == 0) {
                cur_mask ^= 1 << x;  
                rec2(l + 1, r);
                cur_mask ^= 1 << x;  
            }
        }
    }
}

int get_mask(string s) {
    int mask = 0;
    for (char c : s) {
        c -= 'A';
        mask ^= 1 << c;
    }
    return mask;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    for (int i = 0; i < 26; i++)
        cin >> names[i];
    for (int i = 0; i < 26; i++) {
        sort(names[i].begin(), names[i].end());
        names[i].resize(unique(names[i].begin(), names[i].end()) - names[i].begin());
    }
    rec1(0, 13);
    rec2(13, 26);
    cout << ans << endl;
}
