#pragma GCC optimize("Ofast,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse3,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

vector<unsigned short int> primes = {32749, 32719, 32717, 32713};
//vector<int> primes = {31627, 31643, 31649, 31657};

string names[26];

unsigned short int dp[1 << 26];

signed main() {
    primes.pop_back();
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    for (int i = 0; i < 26; i++) {
        string arr;
        cin >> arr;
        for (char &c : arr)
            c -= 'A';
        sort(arr.begin(), arr.end());
        arr.resize(unique(arr.begin(), arr.end()) - arr.begin());
        names[i] = arr;
    }
    vector<int> rems;
    for (int k = 0; k < (int) primes.size(); k++) {
        unsigned short int MOD = primes[k];
        dp[0] = 1;
        for (int mask = 1; mask < (1 << 26); mask++) {
            dp[mask] = 0;
            int i = __builtin_popcount(mask) - 1;
            for (int c : names[i]) {
                if (mask & (1 << c)) {
                    dp[mask] += dp[mask ^ (1 << c)];
                    if (dp[mask] >= MOD)
                        dp[mask] -= MOD;
                }
            }
        }
        rems.push_back(dp[(1 << 26) - 1]);
    }
    ll cur_mod = primes[0];
    ll cur_rem = rems[0];
    for (int i = 1; i < (int) primes.size(); i++) {
        for (int j = 0; j < primes[i]; j++) {
            ll k = cur_mod * j + cur_rem;
            if (k % primes[i] == rems[i]) {
                cur_mod = primes[i] * cur_mod;
                cur_rem = k;
                break;
            }
        }
    }
    cout << cur_rem << endl;
}
