#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

#define int long long

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    vector<int> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + arr[i];
    }
    set<int> borders;
    int cnt = n / k;
    set<int> q;
    for (int i = 0; i < k; i++) {
        borders.insert(i * cnt);
        if (i)
            q.insert(i * cnt);
    }
    borders.insert(n);
    int cur_ans = 0;

    auto calc = [&](int l, int r) {
        return (pref[r] - pref[l]) * (r - l - 1);
    };
    for (int i = 0; i < k; i++) {
        int l = cnt * i;
        int r = min(n, cnt * (i + 1));
        cur_ans += calc(l, r);
    }
    
    while (!q.empty()) {
        int pos = *q.begin();
        q.erase(q.begin());

        auto it = borders.lower_bound(pos);
        ++it;
        int r = *it;
        it--;
        it--;
        int l = *it;
        it++;
        if (calc(l, pos) + calc(pos, r) > calc(l, pos - 1) + calc(pos - 1, r)) {
            borders.erase(it);
            cur_ans -= calc(l, pos) + calc(pos, r);
            pos--;
            cur_ans += calc(l, pos) + calc(pos, r);
            borders.insert(pos);
            if (l != 0)
                q.insert(l);
            if (r != n)
                q.insert(r);
        }
        if (calc(l, pos) + calc(pos, r) > calc(l, pos + 1) + calc(pos + 1, r)) {
            borders.erase(it);
            cur_ans -= calc(l, pos) + calc(pos, r);
            pos++;
            cur_ans += calc(l, pos) + calc(pos, r);
            borders.insert(pos);
            if (l != 0)
                q.insert(l);
            if (r != n)
                q.insert(r);
        }
    }
    cout << cur_ans << endl;
}

