#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3e3;;

int arr[MAXN];

void add(int l, int r, int x) {
    for (int i = l; i < r; i++) {
        arr[i] += x;
    }
}

int get_max() {
    int ans = 0;
    for (int i = 0; i < MAXN; i++) {
        ans = max(ans, arr[i]);
    }
    return ans;
}

vector<vector<int>> evs;


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, w, h;
    cin >> n >> w >> h;

    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        evs.push_back({x + 1, -1, y, y + h + 1});
        evs.push_back({x - w, 1, y, y + h + 1});
    }
    sort(evs.begin(), evs.end());
    int ans = 0;
    for (auto &ev : evs) {
        add(ev[2], ev[3], ev[1]);
        ans = max(ans, get_max());
    }
    cout << ans << endl;
}
