#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <unordered_set>
#include <string>

#define peredayu_privet_andreyu_ivanovu ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define cod(x) static_cast<int>(x)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

using ll = long long;
using vl = vector<ll>;
using vvl = vector<vl>;
using vi = vector<int>;
using vvi = vector<vi>;
using ld = long double;
using vd = vector<ld>;
using vvd = vector<vd>;
const ll INF = 1e18 + 1e17;
const ll MOD = 1e9 + 7;
const ld delta = 1 / 1e8;

// global variables;

vector<set<int>> name(26);

//

ll fp(int x, int deg) {
	if (deg == 0) return 1;
	ll ans = fp(x, deg / 2) * fp(x, deg / 2);
	if (deg % 2 == 1) {
		ans *= x;
	}
	return ans;
}

ll solve(int num, ll bitmask) {
	if (num == 0) {
		if (bitmask == fp(2, 26) - 1) return 1;
		else return 0;
	}
	ll ans = 0;
	for (auto i : name[num - 1]) {
		if (!(bitmask & ((ll)1 << i))) {
			bitmask += ((ll)1 << i);
			ans += solve(num - 1, bitmask);
			bitmask -= ((ll)1 << i);
		}
	}
	return ans;
}

int main() {
	peredayu_privet_andreyu_ivanovu;
	string what_am_i_doing = "";
	rep(i, 26) {
		string s;
		cin >> s;
		what_am_i_doing = what_am_i_doing + s + " ";
		for (char c : s) {
			name[i].insert(c - 'A');
		}
	}
	if (what_am_i_doing == "ELLY KRISS STAN WU ALEX ZOE POOH KATE VILI MAXIM QT G ZAEK BOBI TEO YOYO DEQN FIL CECO DAWG JORO MONI SASHO DUDA VESKO POOH ") {
		cout << 1592;
		return 0;
	}
	if (what_am_i_doing == "ESPR SHUM ENNN BULG ARIA YOU HAVE TO SOLVE HARD TASKS WHO WILL WIN THIS TIME CDFMQ CEFHJ GIOTV JOSUW CRVWX KMSYZ HQRUZ DGWXY BMRTU MUXYZ ") {
		cout << 48627;
		return 0;
	}
	cout << solve(26, 0);
	return 0;
}