#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include <queue>
#include <deque>

#define peredayu_privet_andreyu_ivanovu ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define cod(x) static_cast<int>(x)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

using ll = long long;
using vl = vector<ll>;
using vvl = vector<vl>;
using vi = vector<int>;
using vvi = vector<vi>;
using ld = long double;
using vd = vector<ld>;
using vvd = vector<vd>;
const ll INF = 1e18 + 1e17;
const ll MOD = 1e9 + 7;
const ld delta = 1 / 1e8;

// global variables;

int n, h, w;
vector<pair<int, int> > a;

//

int main() {
	peredayu_privet_andreyu_ivanovu;
	cin >> n >> h >> w;
	a.resize(n);
	rep(i, n) {
		cin >> a[i].first >> a[i].second;
	}
	if (n > 1e3) {
		// sudtask 4;
		vvi desk(1e3 + 1, vi(1e3 + 1, 0));
		rep(i, a.size()) {
			++desk[a[i].first][a[i].second];
		}
		vvi pref(1e3 + 1, vi(1e3 + 1));
		rep(i, pref.size()) {
			pref[i][0] = 0;
			for (int j = 1; j < 1e3 + 1; ++j) {
				pref[i][j] = pref[i][j - 1] + desk[i][j];
			}
		}
		//rep(i, 10) {
		//	rep(j, 10) {
		//		cout << pref[i][j] << " ";
		//	}
		//	cout << "\n";
		//}
		int MAX = 0;
		for (pair<int, int> dot : a) {
			int cur_sum = 0;
			for (int i = dot.first; i >= max(1, dot.first - h); --i) {
				cur_sum += (pref[i][dot.second] - pref[i][max(0, dot.second - w - 1)]);
			}
			MAX = max(MAX, cur_sum);
		}
		cout << MAX;
		return 0;
	}
	sort(all(a)); // n*logn;
	int MAX = 0;
	for (int i = 0; i < n; ++i) {
		int left = i, right = n;
		while (left + 1 < right) {
			int mid = (left + right) / 2;
			if (a[mid].first - a[i].first <= h) {
				left = mid;
			}
			else {
				right = mid;
			}
		}
		int last = left;
		vector<pair<int, int> > segs(last - i + 1), rsegs(last - i + 1);
		for (int j = i; j <= last; ++j) {
			segs[j - i] = { a[j].second - w / 2, a[j].second + (w - w / 2) };
			rsegs[j - i] = { a[j].second + (w - w / 2), a[j].second - w / 2 };
		}
		sort(all(segs));
		sort(all(rsegs));
		vector<int> all_ends(0);
		rep(j, segs.size()) {
			all_ends.push_back(segs[j].first);
			all_ends.push_back(segs[j].second);
		}
		sort(all(all_ends));
		int pos_segs = 0, pos_rsegs = 0;
		int cur_ans = 0, cur_max = 0;
		rep(j, all_ends.size()) {
			while (pos_segs < segs.size()) {
				if (segs[pos_segs].first <= all_ends[j]) {
					++pos_segs;
					++cur_ans;
				}
				else {
					break;
				}
			}
			while (pos_rsegs < rsegs.size()) {
				if (rsegs[pos_rsegs].first < all_ends[j]) {
					++pos_rsegs;
					--cur_ans;
				}
				else {
					break;
				}
			}
			if (cur_ans > cur_max) {
				cur_max = cur_ans;
			}
		}
		MAX = max(MAX, cur_max);
	}
	cout << MAX;
	return 0;
}