#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 2e5, INF = 1e18;
int arr[MAXN], pref[MAXN];
int n, k;

array<__int128, 2> get(__int128 x) {
    vector<__int128> dp(n + 1, 0);
    vector<int> pr(n + 1, -1);
    for (int i = 1; i <= n; ++i) {
        dp[i] = INF;
        for (int j = 0; j < i; ++j) {
            __int128 nw = (__int128)(pref[i] - pref[j]) * (__int128)(i - j) + dp[j] + x;
            if (nw <= dp[i]) {
                dp[i] = nw;
                pr[i] = j;
            }
        }
    }
    int cnt = 0;
    int cur = n;
    while (cur != 0) {
        cnt++;
        cur = pr[cur];
    }
    return {dp[n], cnt};
}

main() {
    cin >> n >> k;
    int sm = 0;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        sm += arr[i];
    }
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + arr[i];
    }
    __int128 l = 0, r = INF;
    auto res = get(l);
    assert(res[1] >= k);
    assert(get(r)[1] < k || k == 1);
    while (r - l > 1) {
        __int128 m = (l + r) / 2;
        auto res = get(m);
        if (res[1] < k) {
            r = m;
        } else {
            l = m;
        }
    }
    res = get(l);
    cout << (int64_t)(res[0] - res[1] * l - sm);
    return 0;
}
