#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 2e5, INF = 1e18;
int arr[MAXN], pref[MAXN];
int n, k;
vector<vector<int>> dp;

void solve(int k, int l1, int r1, int l2, int r2) {
    if (r1 < l1) {
        return;
    }
    int m = (l1 + r1) / 2;
    int p = -1;
    for (int i = max((int64_t)0, l2); i <= min(m - 1, r2); ++i) {
        if (dp[i][0] == INF) {
            continue;
        }
        int nw = dp[i][0] + (pref[m] - pref[i]) * (m - i);
        if (nw < dp[m][1]) {
            p = i;
            dp[m][1] = nw;
        }
    }
    solve(k, l1, m - 1, l2, p);
    solve(k, m + 1, r1, p, r2);
}

main() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + arr[i];
    }
    dp.resize(n + 1, vector<int>(2, INF));
    dp[0][0] = 0;
    for (int i = 1; i <= k; ++i) {
        solve(i, 1, n, 0, n);
        for (int j = 0; j <= n; ++j) {
            dp[j][0] = dp[j][1];
            dp[j][1] = INF;
        }
    }
    cout << dp[n][0] - pref[n];
    return 0;
}
/**
5 4
49 51 93 45 55
*/
