#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <utility>
#include <random>
#include <chrono>
//#define int long long
#define pii pair<int, int>
#define x first
#define y second
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC target("avx,avx2")
#define endl "\n"
#define all(a) (a.begin()), (a.end())

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 30;
const int N2 = 1e6 + 10;
const int B = 1e2 + 10;
const int MXCORD = 1e5 + 10;
const int inf = 1e18 + 10;

int n = 26;
string a[N];
map<int, int> cnt;

void rec(int pos, int end, int msk)
{
	if (pos == end + 1)
	{
		++cnt[msk];
		return;
	}

	for (auto c : a[pos])
		rec(pos + 1, end, msk ^ (1ll << (c - 'A')));
}

void solve()
{
	int mid = (n - 1) / 2;

	rec(0, mid, 0);
	map<int, int> mp = move(cnt);
	rec(mid + 1, n - 1, 0);

	int ans = 0;
	int fullmsk = (1 << n) - 1;

	for (auto p : mp)
		ans += p.y * cnt[fullmsk ^ p.x];

	cout << ans << endl;
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
		sort(all(a[i]));
		a[i].resize(unique(all(a[i])) - a[i].begin());
	}

	solve();
}
