#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <utility>
#include <random>
#include <chrono>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC target("avx,avx2")
#define endl "\n"
#define all(a) (a.begin()), (a.end())

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 30;
const int N2 = 1e6 + 10;
const int B = 1e2 + 10;
const int MXCORD = 1e5 + 10;
const int inf = 1e18 + 10;

int n = 26;
string a[N];
vector<int> has[N];
bool used[N];
map<int, int> cnt;
vector<int> vmsks;
bool mode = false;
int ans = 0;
int fullmsk = (1 << n) - 1;

void rec2(int pos, int end, int msk)
{
	if (pos == end + 1)
	{
		if (!mode)
		{
			++cnt[msk];
			return;
		}
		else
		{
			ans += cnt[fullmsk ^ msk];
			return;
		}
	}

	for (auto c : a[pos])
		if (!((msk >> (c - 'A')) & 1))
			rec2(pos + 1, end, msk | (1ll << (c - 'A')));
}

void rec1(char curlet)
{
	if (curlet == 'Z' + 1)
	{
		++ans;
		return;
	}

	for(auto i : has[curlet - 'A'])
		if (!used[i])
		{
			used[i] = true;
			rec1(curlet + 1);
			used[i] = false;
		}
}

void solve()
{
	for (int i = 0; i < n; ++i)
		for (auto c : a[i])
			has[c - 'A'].push_back(i);

	rec1('A');
	cout << ans << endl;
}

void solve2()
{
	int mid = (n - 1) / 2;

	rec2(0, mid, 0);
	mode = true;
	vmsks.reserve(N2);
	rec2(mid + 1, n - 1, 0);

	cout << ans << endl;
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int mxsz = 0;

	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
		sort(all(a[i]));
		a[i].resize(unique(all(a[i])) - a[i].begin());
		mxsz = max(mxsz, (int)a[i].size());
	}


	if (mxsz > 3)
		solve();
	else
		solve2();
}