#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <utility>
#include <random>
#include <chrono>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC target("avx,avx2")

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 6e3 + 10;
const int inf = 1e18 + 10;

int n, k;
int a[N];
int dp[N][N];
int pref[N];

int getsum(int l, int r)
{
	return pref[r + 1] - pref[l];
}

int f(int l, int r)
{
	return getsum(l, r) * (r - l);
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> k;

	for (int i = 0; i < n; ++i)
		cin >> a[i];

	pref[0] = 0;

	for (int i = 1; i <= n; ++i)
		pref[i] = pref[i - 1] + a[i - 1];

	for (int i = 0; i < N; ++i)
		for (int j = 0; j < N; ++j)
			dp[i][j] = inf;

	dp[0][0] = 0;

	for(int i = 1; i <= n; ++i)
		for (int j = 1; j <= k; ++j)
		{
			for (int z = 0; z < i; ++z)
				dp[i][j] = min(dp[i][j], dp[z][j - 1] + f(z, i - 1));
		}

	cout << dp[n][k] << endl;
}

