#include <bits/stdc++.h>
//#define int long long
#define fr(i,x,y) for(int i=x;i<y;i++)
#define rfr(i,x,y) for(int i=x;i>=y;i--)
using namespace std;
const int N=1e6+1,M=1e6,INF=1e9;
int t[4*M];
int prom[4*M];
void push(int v,int l,int r)
{
    t[v]+=prom[v];
    prom[v*2]+=prom[v];
    prom[v*2+1]+=prom[v];
    prom[v]=0;
}
int get(int l,int r,int ll,int rr,int v=1)
{
    push(v,l,r);
    if(l>rr || r<ll)return -INF;
    if(l>=ll && r<=rr)return t[v];
    return max(get(l,(l+r)/2,ll,rr,v*2),get((l+r)/2+1,r,ll,rr,v*2+1));
}
int update(int l,int r,int ll,int rr,int d,int v=1)
{
    push(v,l,r);
    if(l>rr || r<ll)return t[v];
    if(l>=ll && r<=rr)
    {
        prom[v]=d;
        push(v,l,r);
        return t[v];
    }
    return t[v]=max(update(l,(l+r)/2,ll,rr,d,v*2),update((l+r)/2+1,r,ll,rr,d,v*2+1));
}
pair<int,int> mas[N];
vector<int> y;
void update(int ll,int rr,int d)
{
    //cout<<ll<<' '<<rr<<' ';
    int posl,posr;
    int l=-1,r=y.size()-1;
    while(r-l>1)
    {
        int mid=(r+l)/2;
        if(y[mid]<ll)l=mid;
        else r=mid;
    }
    posl=r;
    l=0,r=y.size();
    while(r-l>1)
    {
        int mid=(r+l)/2;
        if(y[mid]<=rr)l=mid;
        else r=mid;
    }
    posr=l;
    //cout<<posl<<' '<<posr<<'\n';
    update(0,M,posl,posr,d);
}
int get(int ll,int rr)
{
    int posl,posr;
    int l=-1,r=y.size();
    while(r-l>1)
    {
        int mid=(r+l)/2;
        if(y[mid]<ll)l=mid;
        else r=mid;
    }
    posl=r;
    l=-1,r=y.size();
    while(r-l>1)
    {
        int mid=(r+l)/2;
        if(y[mid]<=ll)l=mid;
        else r=mid;
    }
    posr=l;
    return get(0,M,posl,posr);
}
void solve()
{
    int n,w,h;
    cin>>n>>w>>h;
    fr(i,0,n)
    {
        cin>>mas[i].first>>mas[i].second;
        y.push_back(mas[i].second);
    }
    y.push_back(0);
    sort(y.begin(),y.end());
    sort(mas,mas+n);
    int i=0,j=0;
    int ans=0;
    update(mas[j].second,mas[j].second+h,1);
    while(j<n)
    {
        if(mas[j].first-mas[i].first<=w)
        {
            ans=max(ans,t[1]);
            j++;
            if(j<n)update(mas[j].second,mas[j].second+h,1);
        }
        else
        {
            update(mas[i].second,mas[i].second+h,-1);
            i++;
        }
        //cout<<i<<' '<<j<<' '<<t[1]<<'\n';
    }
    cout<<ans<<'\n';
}
signed main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    solve();
}
