#include<iostream>
#include<cmath>
#include<vector>
#include<algorithm>
#include<set>
#include<map>

#define vec vector
#define f first
#define s second
#define FOR(i, n) for(int (i) = 0; (i) < (n); (i)++)
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define pb push_back

using namespace std;

int main()
{
    int n, w, h;
    cin >> n >> w >> h;

    vec<pii> a (n);

    FOR(i, n)
    {
        cin >> a[i].f >> a[i].s;
    }

    sort(all(a));

    const int maxn = 1e3 + 2;

    vec<vec<int>> pref(maxn, vec<int> (maxn));
    vec<vec<int>> A(maxn, vec<int> (maxn));

    FOR(i, maxn)
    {
        FOR(j, maxn)
        {
            A[i][j] = 0;
            pref[i][j] = 0;
        }
    }

    for(auto i : a)
    {
        A[i.f][i.s]++;
    }

    for(int i = 1; i < maxn; i++)
    {
        for(int j = 1; j < maxn; j++)
        {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] + A[i][j] - pref[i - 1][j - 1];
        }
    }

    int mx = pref[w][h];

    // pref[x1][y1] - pref[x2][y1] - pref[x1][y2] + pref[x2][y2];

    for(auto i : a)
    {
        int x1 = i.f, y1 = i.s;
        int x2 = max(0, i.f - w), y2 = max(0, i.s - h);

        mx = max(mx, pref[x1][y1] - pref[x2][y1] - pref[x1][y2] + pref[x2][y2]);
    }

    cout << mx;

}

