#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define lsb(x) ((x) & (-(x)))
#define x first
#define y second

using namespace std;

const int N = (int)1e5;

int n, w, h;

pair <int, int> v[100005];
int aib[N + 5];

void update(int ind, int val) {
  for(; ind <= N; ind += lsb(ind))
    aib[ind] += val;
}

int query(int ind) {
  if(ind <= 0)
    return 0;
  int ans = 0;
  for(; ind; ind -= lsb(ind))
    ans += aib[ind];
  return ans;
}

int main() {
  cin >> n >> w >> h;
  for(int i = 1; i <= n; i++) {
    cin >> v[i].x >> v[i].y;
  }
  sort(v + 1, v + n + 1);
  int l = 1, r = 1, ans = 0;
  for(int i = 1; i <= n; i++) {
    while(v[r].x == v[i].x && r <= n)
      update(v[r].y, 1), r++;
    while(v[l].x < v[i].x - w && l <= r)
      update(v[l].y, -1), l++;
    ans = max(ans, query(v[i].y) - query(v[i].y - h - 1));
  }
  cout << ans;
  return 0;
}
