#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define lsb(x) ((x) & (-(x)))
#define x first
#define y second

using namespace std;

const int N = (int)1e5;

int n, w, h;

pair <int, int> v[100005];
set <int> s;
map <int, int> cod;
int lim[N + 5];
int lazy[4 * N + 5];
int aint[4 * N + 5];

void prop(int nod, int st, int dr) {
    int a = (nod << 1), b = (a | 1);
    aint[nod] += lazy[nod];
    if(st != dr) {
      lazy[a] += lazy[nod];
      lazy[b] += lazy[nod];
    }
    lazy[nod] = 0;
}

void update(int nod, int st, int dr, int l, int r, int val) {
  if(st > dr || dr < l || r < st)
    return;
  prop(nod, st, dr);
  if(l <= st && dr <= r) {
    aint[nod] += val;
    if(st != dr) {
      lazy[2 * nod] += val;
      lazy[2 * nod + 1] += val;
    }
    lazy[nod] = 0;
    return;
  }
  int mid = (st + dr) >> 1, a = (nod << 1), b = (a | 1);
  update(a, st, mid, l, r, val);
  update(b, mid + 1, dr, l, r, val);
  aint[nod] = max(aint[a], aint[b]);
}

int query() {
  prop(1, 1, N);
  return aint[1];
}

void upd(int ind, int val) {
  update(1, 1, N, lim[ind], ind, val);
}

bool comp(pair <int, int> a, pair <int, int> b) {
  return a.x > b.x;
}

void f() {
  for(int i = 1; i <= n; i++)
    swap(v[i].x, v[i].y);
  sort(v + 1, v + n + 1);
  int m = 0;
  for(int i = 1; i <= n; i++) {
    if(v[i].x != v[i - 1].x)
      cod[v[i].x] = ++m;
  }
  for(int i = 1; i <= n; i++) {
    int st = 1, dr = i, mid;
    while(st <= dr) {
      mid = (st + dr) >> 1;
      if(v[i].x - h <= v[mid].x)
        dr = mid - 1;
      else
        st = mid + 1;
    }
    lim[cod[v[i].x]] = cod[v[st].x];
  }
  for(int i = 1; i <= n; i++)
    v[i].x = cod[v[i].x], swap(v[i].x, v[i].y);
}

int main() {
  cin >> n >> w >> h;
  for(int i = 1; i <= n; i++) {
    cin >> v[i].x >> v[i].y;
  }
  f();
  sort(v + 1, v + n + 1);
  int l = 1, r = 1, ans = 0;
  for(int i = 1; i <= n; i++) {
    while(v[r].x == v[i].x && r <= n)
      upd(v[r].y, 1), r++;
    while(v[l].x < v[i].x - w && l <= r)
      upd(v[l].y, -1), l++;
    ans = max(ans, query());  }
  sort(v + 1, v + n + 1, comp);
  l = r = 1;
  for(int i = 1; i <= 4 * N; i++)
    aint[i] = lazy[i] = 0;
  for(int i = 1; i <= n; i++) {
    while(v[r].x == v[i].x && r <= n)
      upd(v[r].y, 1), r++;
    while(v[l].x > v[i].x + w && l <= r)
      upd(v[l].y, -1), l++;
    ans = max(ans, query());
  }
  cout << ans;
  return 0;
}
