#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <map>
#include <deque>

using namespace std;

const int MAX_N = 26;
string s[MAX_N];

map<int, long long> cnt;
int e[MAX_N];

int cnt_bits(int x) {

    int a = 0;
    while (x) {
        x &= x - 1;
        a++;
    }
    return a;
}

int main() {
//    freopen("input.txt", "r", stdin);

    int n = 0;
    while (n < 26)
        cin >> s[n++];

    for (int i = 0; i < n; i++) {
//        cout << s[i] << endl;
        for (char ch : s[i])
            e[i] |= (1 << (ch - 'A'));
//            e[i] |= (1 << (rand() % 26));
    }

    long long non_zero = 0;
    cnt[0] = 1;
    deque<int> q(1, 0);
    while (q.size()) {
        int mask = q.front();
        q.pop_front();

        long long c = cnt[mask];
        int i = cnt_bits(mask);
        for (int x = (mask ^ ((1 << n) - 1)) & e[i]; x; x &= x - 1) {
            int b = (x & -x);
//            if (cnt_bits(mask) + 1 != cnt_bits(mask ^ b)) {
//                cout << mask << endl;
//                return 0;
//            }

            if (!cnt[mask ^ b])
                q.push_back(mask ^ b);
            cnt[mask ^ b] += c;
        }
//        cerr << mask << ' ' << c << '\n';
//        if (mask == (1 << n) - 1)
//            return 0;
    }

    cout << cnt[(1 << n) - 1] << endl;

    return 0;
}
