#include<bits/stdc++.h>
using namespace std;

int const maxn = 1e5+5;
int const inf = (1<<31)-1;

int n,k,aq;
int a[maxn];
long long ps[maxn];

void init_()
{
    int i;

    ps[0] = 0;

    for(i=1; i<=n; i++)
        ps[i] = ps[i-1] + a[i];
}

inline long long sum(int l,int r)
{
    return (ps[r] - ps[l-1]) * (r-l);
}

vector<pair<int,int> > v;
queue<pair<int,int> >q;
int lamp;
void solve(int l,int r)
{
    aq++;

    int mid;
    pair<int,int>left,right;
    left.first = l;
    right.second = r;

    long long suml,sumr,psum,tsum;

    mid = (l+r)/2;

    psum = tsum = sum(l,mid) + sum(mid+1,r);

    do
    {
        psum = tsum;
        suml = sum(left.first,mid+1) + sum(mid+2,right.second);
        sumr = sum(left.first,mid-1) + sum(mid,right.second);

        tsum = min(suml,sumr);

        if(psum > tsum)
        {
            if(suml == sumr)
                mid += lamp;
            else if(suml < sumr)
                mid++;
            else mid--;
        }

    }while(psum > tsum);

    left.second = mid;
    right.first = mid+1;

    suml = sum(l,mid);
    sumr = sum(mid+1,r);

    if(suml > sumr)
    {
        q.push(left);
        q.push(right);
    }
    else
    {
        q.push(right);
        q.push(left);
    }
}

long long answer = inf;
vector<pair<int,int> >v1;
long long adjust_left()
{
    int i;
    long long tans = 0;

    for(i = 1;i<k;i++)
    {
        solve(v1[i-1].first,v1[i].second);

        pair<int,int> p1,p2;
        p1 = q.front(); q.pop();
        p2 = q.front(); q.pop();

        v1[i-1] = p1;
        v1[i] = p2;

        if(p1.first > p2.first)
            swap(v1[i-1],v1[i]);

        tans += sum(v1[i-1].first,v1[i-1].second);
    }

    tans+=sum(v1[k-1].first,v1[k-1].second);

    return tans;
}

long long adjust_right()
{
    int i;
    long long tans = 0;

    for(i = k-2; i>=0; i--)
    {
        solve(v1[i].first,v1[i+1].second);

        pair<int,int> p1,p2;
        p1 = q.front(); q.pop();
        p2 = q.front(); q.pop();

        v1[i] = p1;
        v1[i+1] = p2;

        if(p1.first > p2.first)
            swap(v1[i],v1[i+1]);

        tans += sum(v1[i+1].first,v1[i+1].second);
    }

    tans+=sum(v1[0].first,v1[0].second);

    return tans;
}

int main()
{
    int i;

    cin>>n>>k;

    for(i=1; i<=n; i++)
        cin>>a[i];

    init_();

    if(k >= n)
    {
        cout<<"0\n";
        return 0;
    }

    if(k == 1)
    {
        cout<<ps[n-1]*(n-1)<<"\n";
        return 0;
    }

    aq = 1;
    q.push(make_pair(1,n));

    while(!q.empty() && aq<k)
    {
        pair<int,int>p = q.front();
        q.pop();

        solve(p.first,p.second);
    }

    while(!q.empty())
    {
        pair<int,int>p = q.front();
        q.pop();

        v.push_back(p);
    }

    sort(v.begin(),v.end());

    long long tans = inf;
    v1 = v; lamp = -1;
    do
    {
        answer = min(answer,tans);
        tans = adjust_left();
    }while(tans < answer);

    tans = inf;
    v1 = v; lamp = 1;
    do
    {
        answer = min(answer,tans);
        tans = adjust_right();
    }while(tans < answer);

    cout<<answer<<endl;
	return 0;
}
