#include<bits/stdc++.h>
using namespace std;

struct point
{
    int x,y;

    point(){}
    point(int _x,int _y)
    {
        x = _x; y = _y;
    }

    bool operator<(const point &p)const
    {
        return y<p.y;
    }
};

bool cmp(point a, point b)
{
    if(a.x == b.x)
        return a.y<b.y;
    return a.x<b.x;
}

int n,w,h;
vector<point>v;
map<int,int>mp;
int answer;

void solve()
{
    vector<int>y;
    int br = 0;

    int l=-1,r,i,j;

    for(i=0;i<n;i++)
    {
        if(l==v[i].x)
             continue;
        l = v[i].x;
        r = l + w;

        mp.clear(); br = 0; y.clear();
        for(j=i;j<n;j++)
        {
            point p = v[j];
            if(p.x > r)
                break;

            if(!mp[p.y])
                y.push_back(p.y);
            mp[p.y] ++;
        }

        sort(y.begin(),y.end());

        int sz = y.size(),k=0;
        int down = y[0];
        int up = y[0];
        for(j=0; j<sz; j++)
        {
            up = y[j];
            down = up - h;

            while(y[k] < down)
            {
                br-=mp[y[k]];
                k++;
            }
            br+=mp[up];

            answer = max(answer,br);
        }
    }
}

int main()
{
    int i,x,y;

    cin>>n>>w>>h;

    for(i=0;i<n;i++)
    {
        cin>>x>>y;
        v.push_back(point(x,y));
    }

    sort(v.begin(),v.end(),cmp);

    solve();

    cout<<answer<<" \n";
	return 0;
}
