#include <iostream>
using namespace std;

const int MAXN = 6003;
const int MAXK = 6003;
const long long INF = 1ll << 60;

int n, k, a[MAXN];
long long p[MAXN];
long long dp[MAXN][MAXK];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        p[i] = p[i - 1] + a[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        dp[i][0] = INF;
        for (int j = 1; j <= min(i, k); ++ j)
        {
            dp[i][j] = INF;
            for (int l = 0; l < i; ++ l)
            {
                dp[i][j] = min(dp[i][j], dp[l][j - 1] + (p[i] - p[l]) * (i - l - 1));
                //cout << "trans : " << l << ' ' << i << " costs " << p[i] - p[l] << '*' << (i - l) << '=' <<  (p[i] - p[l]) * (i - l) << endl;
            }
            //cout << i << ' ' << j << ' ' << dp[i][j] << endl;
        }
    }

    cout << dp[n][k] << endl;
    return 0;
}
