#include <iostream>
using namespace std;

const int MAXN = 6003;
const int MAXK = 6003;
const long long INF = 1ll << 60;

int n, k, a[MAXN];
long long p[MAXN];
long long dp1[MAXN], dp2[MAXN], opt[MAXN];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        p[i] = p[i - 1] + a[i];
    }

    dp1[0] = 0;
    for (int i = 1; i <= n; ++ i)
    {
        dp1[i] = INF;
    }

    for (int j = 1; j <= k; ++ j)
    {
        for (int i = j; i <= n; ++ i)
        {
            dp2[i] = INF;
            for (int l = opt[i]; l < i; ++ l)
            {
                if (dp2[i] > dp1[l] + (p[i] - p[l]) * (i - l - 1))
                {
                    dp2[i] = dp1[l] + (p[i] - p[l]) * (i - l - 1);
                    opt[i] = l;
                }
            }
        }

        for (int i = j; i <= n; ++ i)
        {
            dp1[i] = dp2[i];
        }
    }

    cout << dp1[n] << endl;
    return 0;
}
