#include <bits/stdc++.h>

using namespace std;
 
using ll = long long;
using ld = long double;
using db = double; 
using str = string; 

using pi = pair<int, int>;
using pl = pair<ll, ll>;
using pd = pair<double, double>;

using vpi = vector <pi>;
using vpl = vector <pl>;

#define f first
#define s second
#define mp(x, y) make_pair(x, y)

#define sz(X) x.size()
#define pb(x) push_back(x)
#define ins(x) insert(x)

const int MOD = 1e9+7;
const int mxN = 1e3+5;
const ll INF = 1e18; 
const ld PI = acos((ld)-1);
 
int n, m;
int a[mxN];
ll T[mxN][mxN], cost[mxN][mxN];

ll solve()
{
	ll ans = 0;

	for(int i = 1; i <= n; i++)
	{
		ll sm = 0;
		for(int j = i; j >= 1; j--)
		{
			sm += a[j];
			cost[j][i] = (i - j) * sm;
			//cout << j << " " << i << " " << cost[j][i] << "\n";
		}

	}
	for(int i = 0; i <= n; i++)
	{
		for(int j = 0; j <= m; j++)
		{
			T[i][j] = INF;
		}
	}
	T[0][0] = 0;
	
	for(int i = 1; i <= n; i++)
	{
		for(int h = 1; h <= m; h++)
		{
			ll tmp = INF;
			for(int j = i; j >= 1; j--)
			{
				tmp = min(tmp, T[j - 1][h - 1] + cost[j][i]);
			}
			T[i][h] = tmp;
			//cout << tmp << "\n";
		}
	}	
	return T[n][m];
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	for(int i = 1; i <= n; i++)
	{
		cin >> a[i];
	}

	cout << solve() << "\n";

	return 0;
}
 
 /* stuff you should look for
	* int overflow, array bounds
	* special cases (n=1?)
	* do smth instead of nothing and stay organized
	* WRITE STUFF DOWN
	* DON'T GET STUCK ON ONE APPROACH
*/

