#include <bits/stdc++.h>

using namespace std;
 
using ll = long long;
using ld = long double;
using db = double; 
using str = string; 

using pi = pair<int, int>;
using pl = pair<ll, ll>;
using pd = pair<double, double>;

using vpi = vector <pi>;
using vpl = vector <pl>;

#define f first
#define s second
#define mp(x, y) make_pair(x, y)

#define sz(X) x.size()
#define pb(x) push_back(x)
#define ins(x) insert(x)

const int MOD = 1e9+7;
const int mxN = 1e5+5;
const ll INF = 1e18; 
const ld PI = acos((ld)-1);
 
int n, m;
int a[mxN];
//ll T[mxN][mxN];
ll pref[mxN];

ll ccost(int l, int r)
{
	return (pref[r] - pref[l - 1]) * (r - l);
}

struct sol
{
	ll val;
	int prev;

	sol(ll _val, int _prev)
	{
		val = _val; prev = _prev;
	}
	sol(){};

	ll get_cost(int ind)
	{
		//cout << val + cost[prev + 1][ind] << "\n";
		return val + ccost(prev + 1, ind);
	}

	int to(sol other)
	{
		int l = max(prev, other.prev), r = n;
		int ans = n + 1;
		while(l <= r)
		{
			int middle = (l + r) >> 1;

			//other stava po-dobro
			if(get_cost(middle) > other.get_cost(middle))
			{
				ans = middle;
				r = middle - 1;
			}
			else
			{
				l = middle + 1;
			}
		}
		return ans;
	}
};

sol T[mxN], T2[2][mxN];
int fptr, bptr;

ll solve()
{
	//ll ans = 0;
	for(int i = 1; i <= n; i++)
	{
		pref[i] = pref[i - 1] + a[i];
	}
	//ll ans = 0;
	//T[bptr++] = sol(0, 0, 0);
	int hp = 0;
	for(int I = 1; I <= m; I++)
	{
		fptr = bptr = 0;
		if(I == 1)
		{
			T[bptr++] = sol(0, 0);
		}
		for(int i = 0; i <= n; i++)
		{
			while(fptr + 1 < bptr && T[fptr + 1].get_cost(i) < T[fptr].get_cost(i)) fptr++;
	
			sol tmp = sol(T[fptr].get_cost(i), i);
			//ans = tmp.val;
			T2[hp][i] = tmp;
			//cout << I << " " << i << " " << tmp.val << "\n";
	
			tmp = T2[hp ^ 1][i];
			while(bptr - fptr >= 2 && T[bptr - 2].to(T[bptr - 1]) >= T[bptr - 1].to(tmp)) bptr--;
			T[bptr++] = tmp;
		}
		hp ^= 1;
	}
	/*for(int i = 1; i <= n; i++)
	{
		for(int h = 1; h <= m; h++)
		{
			ll tmp = INF;
			for(int j = i; j >= 1; j--)
			{
				tmp = min(tmp, T[j - 1][h - 1] + cost[j][i]);
			}
			T[i][h] = tmp;
			//cout << tmp << "\n";
		}
	}*/	
	return T2[hp ^ 1][n].val;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	for(int i = 1; i <= n; i++)
	{
		cin >> a[i];
	}

	cout << solve() << "\n";

	return 0;
}
 
 /* stuff you should look for
	* int overflow, array bounds
	* special cases (n=1?)
	* do smth instead of nothing and stay organized
	* WRITE STUFF DOWN
	* DON'T GET STUCK ON ONE APPROACH
*/

