#include <iostream>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <iterator>
#include <vector>
#include <limits.h>

using namespace std;

vector<int> has[30];
vector<int> powers;
map<int,long long> dp;
bool used[30];
string s[30];

long long rec(int index,int u)
{
	if(index==26)return 1;
	long long total=0;
	if(dp[u]!=0)return dp[u];
	for(int i=0;i<has[index].size();i++)
	{
		if(!used[has[index][i]])
		{
			used[has[index][i]]=true;
			u+=powers[has[index][i]];
			total+=rec(index+1,u);
			u-=powers[has[index][i]];
			used[has[index][i]]=false;
		}
	}
	return dp[u]=total;
}

void solve()
{
	for(int i=0;i<26;i++)
	{
		for(int j=0;j<s[i].length();j++)
		{
			bool u=false;
			for(int k=0;k<has[i].size();k++)
				if(has[i][k]==s[i][j]-'A')
					u=true;
			if(!u)has[i].push_back(s[i][j]-'A');
		}
	}
	powers.push_back(1);
	for(int i=1;i<26;i++)
		powers.push_back(powers[i-1]*2);
}

void init()
{
 	for(int i=0;i<26;i++)
 		cin>>s[i];
}

int main()
{
 	init();
 	solve();
 	cout<<rec(0,0)<<endl;
}
