#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <queue>
#include <limits.h>

using namespace std;

int n,w,h;


struct Point
{
	int x;
	int y;
};

Point points[100005];
deque<Point> MainQue;
int result=-1;

bool cmpX(Point a,Point b)
{
	return a.x<b.x;
}

bool cmpY(Point a,Point b)
{
	return a.y<b.y;
}

void solveY(deque<Point> temp)
{
	sort(temp.begin(),temp.end(),cmpY);
	
	vector<Point>points1;
	while(!temp.empty())
	{
		points1.push_back(temp.front());
		temp.pop_front();
	}
//	for(int i=0;i<points1.size();i++)
//		cout<<points1[i].x<<" "<<points1[i].y<<endl;
	int end=0,start=0;
	for(int i=0;i<points1.size();i++)
	{
		while(points1[end].y<=points1[i].y+h&&end<points1.size())
		{
			temp.push_back(points1[end]);
			end++;
		}
		while(points1[start].y<points1[i].y&&start<points1.size())
		{
			temp.pop_front();
			start++;
		}
		int x=temp.size();
		result=max(x,result);
	}

}

void solveX()
{
	sort(points,points+n,cmpX);
	int end=0,start=0;
	for(int i=0;i<n;i++)
	{
		while(points[end].x<=points[i].x+w&&end<n)
		{
			MainQue.push_back(points[end]);
			end++;
		}
		while(points[start].x<points[i].x&&start<n)
		{
			MainQue.pop_front();
			start++;
		}		
		solveY(MainQue);
	}
	cout<<result<<endl;
}

void init()
{
	scanf("%d%d%d",&n,&w,&h);
	for(int i=0;i<n;i++)
		scanf("%d%d",&points[i].x,&points[i].y);
}

int main()
{
 	init();
 	solveX();
}
