#include <bits/stdc++.h>
#define endl '\n'

///sama li shte si legnesh, tova e veche sporno
///sledvashtata stupka e domashno porno
///na koi li shte posegnesh, sama li shte si legnesh
///tova e veche sporno, shte pravime li porno
using namespace std;

const int maxval = 1e8 + 3;

struct event
{
    int moment, x, add;
    bool operator < (const event &t) const
    {
        if (moment != t.moment)
        return moment < t.moment;

        else
            return add < t.add;
    }
};

int n, w, h;
vector <event> events;
void read()
{
    cin >> n >> w >> h;
    for (int i = 1; i <= n; i++)
    {
        int x, y;
        cin >> x >> y;

        events.push_back({max(0, y - h), x, 1});
        events.push_back({y + 1, x, -1});
    }
}

struct node
{
    int add, max_val;
    node *left, *right;
    node() {add = max_val = 0, left = right = nullptr;}
};

int max_val(node *x)
{
    if (!x)
    return 0;

    return x->max_val;
}

void merge(node *&x)
{
    x->max_val = max(max_val(x->left), max_val(x->right));
    x->max_val += x->add;
}

void update(node *x, int l, int r, int ll, int rr, int add)
{
    if (r < ll || l > rr)
    return;

    if (l >= ll && r <= rr)
    {
        x->add += add;
        merge(x);
        return;
    }

    int mid = (l + r) / 2;
    if (!x->left)
        x->left = new node();

    if (!x->right)
        x->right = new node();

    update(x->left, l, mid, ll, rr, add);
    update(x->right, mid + 1, r, ll, rr, add);

    merge(x);
}

void solve()
{
    sort (events.begin(), events.end());
    node *root = new node();

    int ans = 0;
    for (auto i: events)
    {
        update(root, 0, maxval, max(0, i.x - w), i.x, i.add);
        ans = max(ans, root->max_val);
    }

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
