#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 100002;
const int INF = 2000000000;

int n, k;
int a[MAXN], sums[MAXN];

vector <int> p;

void Init ()
{
    cin>>n>>k;
    a[0]=0;
    sums[0]=0;
    for (int i=1; i<=n; i++)
    {
        cin>>a[i];
        sums[i]=sums[i-1]+a[i];
    }
    p.push_back (0);
}

/*int Rec (int st, int t) //t-tanks left
{
    //if (n-st+1<t)
    if (t==1)
        return (n-st)*(sums[n]-sums[st-1]);
    for (int i=1; i<=n-t+2; i++)
        return (i-1)*(sums[st+i-1]-sums[st-1])+Rec (st+i, t-1);
}*/

int main ()
{
    Init ();
    if (k==1)
    {
        cout<<sums[n]*(n-1)<<endl;
        return 0;
    }
    int min_val=INF;
    for (int i=2; i<=n-k+2; i++)//start of second tank
    {
        int val=0;
        val+=sums[i-1]*(i-2);
        for (int j=i+1; j<=n-k+3; j++) //start of 3rd tank
        {
            int new_val=val+(sums[j-1]-sums[i-1])*(j-i-1)+(sums[n]-sums[j-1])*(n-j);
           // cout<<"i="<<i<<" j="<<j<<" new_val="<<new_val<<endl;
            min_val=min (min_val, new_val);


        }
    }
    cout<<min_val<<endl;
    return 0;
}
