#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42;

int n,k,inp[nmax];
long long pref[nmax];

pair<long long,int> dp[nmax];

long long mem_penalty;

pair<long long,int> score(int prv,int pos)
{
    pair<long long,int> cur={dp[prv-1].first+1LL*(pref[pos]-pref[prv-1])*(pos-prv)+mem_penalty,dp[prv-1].second+1};

    return cur;
}

void dc_merge(int l_prv,int r_prv,int l_pos,int r_pos)
{
    if(l_pos>r_pos)return;

    int pos=(l_pos+r_pos)/2;

    int opt=-1;

    pair<long long,int> cur_mini={1LL<<62,0};

    for(int prv=l_prv;prv<=r_prv;prv++)
    {
        pair<long long,int> cur=score(prv,pos);

        dp[pos]=min(dp[pos],cur);

        if(cur_mini>cur)
        {
            cur_mini=cur;
            opt=prv;
        }
    }

    dc_merge(l_prv,opt,l_pos,pos-1);
    dc_merge(opt,r_prv,pos+1,r_pos);
}
void dc(int l,int r)
{
    if(l==r)
    {
        dp[l]=min(dp[l],score(l,l));
        return;
    }

    int av=(l+r)/2;

    dc(l,av);

    /*
    for(int pos=av+1;pos<=r;pos++)
        for(int prv=av;prv>=l;prv--)
            dp[pos]=min(dp[pos],score(prv,pos));
    */

    dc_merge(l,av,av+1,r);

    dc(av+1,r);
}
void eval(long long penalty)
{
    mem_penalty=penalty;

    dp[0]={0,0};

    for(int pos=1;pos<=n;pos++)
        dp[pos]={1LL<<62,0};

    dc(1,n);

    /*
    cout<<"penalty: "<<penalty<<endl;
    for(int i=1;i<=n;i++)cout<<dp[i].first<<" "<<dp[i].second<<endl;
    cout<<"---"<<endl;
    */
}
int main()
{
    scanf("%i%i",&n,&k);
    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    for(int i=1;i<=n;i++)pref[i]=pref[i-1]+inp[i];

    long long ok=1LL<<62,not_ok=0;//f(ok)=1 group, f(not_ok)=n groups

    while(ok-not_ok>1)
    {
        long long av=(ok+not_ok)/2;

        eval(av);

        if(dp[n].second<=k)ok=av;
        else not_ok=av;
    }

    eval(ok);

    long long outp=dp[n].first-1LL*ok*k;

    //outp=outp-1LL*not_ok*(k-dp[n].second);

    printf("%lld\n",outp);
    return 0;
}
/*
4 3
1 1 1 1
*/
