#include<bits/stdc++.h>
using namespace std;

const int nmax=4e5+42;
int n;

struct upd
{
    int x,y1,y2,coeff;
};

vector<upd> given;
bool cmp(upd a,upd b)
{
    return a.x<b.x;
}
void note(int x,int y1,int y2,int coeff)
{
    x=max(x,1);
    y1=max(1,y1);
    y2=min(nmax-1,y2);

    upd mem;
    mem.x=x;
    mem.y1=y1;
    mem.y2=y2;
    mem.coeff=coeff;

    given.push_back(mem);
}


struct info
{
    int maxi,lazy;
};
info tree[4*nmax];

info actual(info cur)
{
    cur.maxi+=cur.lazy;
    cur.lazy=0;
    return cur;
}
info my_merge(info a,info b)
{
    a=actual(a);
    b=actual(b);

    if(a.maxi>b.maxi)return a;
    return b;
}

void push(int node)
{
    tree[node*2].lazy+=tree[node].lazy;
    tree[node*2+1].lazy+=tree[node].lazy;
    tree[node].lazy=0;
}
void update(int node,int l,int r,int lq,int rq,int coeff)
{
    if(l==lq&&r==rq)
    {
        tree[node].lazy+=coeff;
        return;
    }

    push(node);

    int av=(l+r)/2;
    if(lq<=av)update(node*2,l,av,lq,min(av,rq),coeff);
    if(av<rq)update(node*2+1,av+1,r,max(av+1,lq),rq,coeff);

    tree[node]=my_merge(tree[node*2],tree[node*2+1]);
}

pair<int,int> inp[nmax];

vector<int> there_y;

int main()
{
    int w,h;

    scanf("%i%i%i",&n,&w,&h);

    for(int i=1;i<=n;i++)
    {
        int x,y;

        scanf("%i%i",&inp[i].first,&inp[i].second);

        x=inp[i].first;
        y=inp[i].second;

        there_y.push_back(y-h-1);
        there_y.push_back(y-h);
        there_y.push_back(y);
        there_y.push_back(y+1);
    }

    sort(there_y.begin(),there_y.end());

    for(int i=1;i<=n;i++)
    {
        int x=inp[i].first,y=inp[i].second;

        int where_1=lower_bound(there_y.begin(),there_y.end(),y-h)-there_y.begin();
        int where_2=lower_bound(there_y.begin(),there_y.end(),y)-there_y.begin();

        note(x-w,where_1,where_2,1);
        note(x+1,where_1,where_2,-1);
    }

    sort(given.begin(),given.end(),cmp);

    int outp=0;

    for(int i=0;i<given.size();i++)
    {
        int j=i;

        while(j<given.size()&&given[i].x==given[j].x)
        {
            update(1,1,nmax,given[j].y1,given[j].y2,given[j].coeff);
            j++;
        }

        i=j-1;
        outp=max(outp,actual(tree[1]).maxi);
    }

    printf("%i\n",outp);
    return 0;
}
