#include<bits/stdc++.h>
#define pb push_back
#define pii pair<int,int>
#define ll long long
#define ull unsigned long long
#define INF 1000000007
#define mod 1000000007
using namespace std;

struct Point
{
    int x,y,br;
};

bool cmp(pii a, pii b){return a.first<b.first;}

int n,w,h;
vector<Point> pts;
vector<pii > v;

void naive()
{
    sort(v.begin(),v.end(),cmp);
    pts.pb({v[0].first,v[0].second,1}); int sz=1;
    for(int i=1;i<n;i++)
    {
        if(v[i].first==v[i-1].first&&v[i].second==v[i-1].second)
        {
            pts[sz-1].br++;
        }
        else{pts.pb({v[i].first,v[i].second,1}); sz++;}
    }
    n=sz;
    int ans=0;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            int x=pts[i].x, y=pts[j].y, br=0;
            for(int k=0;k<n;k++)
            {
                if((pts[k].x>=x&&pts[k].x<=x+w)&&(pts[k].y>=y&&pts[k].y<=y+h)) br+=pts[k].br;
            }
            ans=max(ans,br);
        }
    }
    cout<<ans<<endl;
}

const int TRSZ1 = 2048;
const int TRSZ2 = 2048;
int tree[TRSZ1][TRSZ2];

int getleaf1(int x){return x+(TRSZ1>>1);}
int getleaf2(int x){return x+(TRSZ2>>1);}

void upd2(int x,int ind,int d)
{
    int pos=getleaf2(x);
    while(pos!=0)
    {
        tree[ind][pos]+=d;
        pos>>=1;
    }
}

void upd1(int x,int y,int d)
{
    int pos=getleaf1(x);
    while(pos!=0)
    {
        upd2(y,pos,d);
        pos>>=1;
    }
}

int query2(int l,int r,int ind)
{
    l=getleaf2(l);
    r=getleaf2(r);
    if(l==r) return tree[ind][l];
    int ans=tree[ind][l]+tree[ind][r];
    while((l>>1)!=(r>>1))
    {
        if((l&1)==0) ans+=tree[ind][l+1];
        if((r&1)==1) ans+=tree[ind][r-1];
        l>>=1; r>>=1;
    }
    return ans;
}

int query1(int l1,int r1,int l2,int r2)
{
    l1=getleaf1(l1);
    r1=getleaf1(r1);
    if(l1==r1) return query2(l2,r2,l1);
    int ans=query2(l2,r2,l1)+query2(l2,r2,r1);
    while((l1>>1)!=(r1>>1))
    {
        if((l1&1)==0) ans+=query2(l2,r2,l1+1);
        if((r1&1)==1) ans+=query2(l2,r2,r1-1);
        l1>>=1; r1>>=1;
    }
    return ans;
}

void solve()
{
    for(int i=0;i<n;i++)
    {
        upd1(v[i].first,v[i].second,1);
    }
    int ans=0;
    for(int i=0;i<n;i++)
    {
        int x1,x2=v[i].first,y1,y2=v[i].second;
        x1=x2-w; y1=y2-h;
        if(x1>=0&&y1>=0) ans=max(ans,query1(x1,x2,y1,y2));
    }
    cout<<ans<<endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin>>n>>w>>h;
    for(int i=0;i<n;i++)
    {
        int x,y;
        cin>>x>>y;
        v.pb({x,y});
    }
    if(n<=100) naive();
    else solve();
    return 0;
}
/**

6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2

*/
