#include<bits/stdc++.h>
#define eb push_back
#define pb push_back
#define f first
#define s second

using namespace std;

const unsigned long long MAXN = 1e5;
const unsigned long long MAXNB = 1000;
unsigned long long n, k;
unsigned long long a[MAXN];
unsigned long long dp[MAXNB][MAXNB];
unsigned long long pref[MAXNB];
unsigned long long  ans;

void input() {
    cin>>n>>k;
    for (unsigned long long i=0; i<n; i++) {
        cin>>a[i];
    }
}

void output() {
    cout<<ans<<endl;
}

void precalc() {
    pref[0] = 0;
    for (unsigned long long i=0; i<n; i++) {
        pref[i+1] = pref[i] + a[i];
    }
}

unsigned long long sum(unsigned long long r, unsigned long long l) {
    return (pref[r] - pref[l])*(r - l - 1);
}

void solve() {
    k--;
    precalc();
    if (k == 0) {
        ans = sum(n, 0);
        return;
    }

    for (unsigned long long i=0; i<n; i++) {
        dp[0][i] = sum(i+1, 0);
    }

    for (unsigned long long i=1; i<k; i++) {
        for (unsigned long long j=0; j<=i; j++) {
            dp[i][j] = 0;
        }
        for (unsigned long long j=i+1; j<n-1; j++) {
            dp[i][j] = dp[i-1][0] + sum(j+1, 1);
            for (unsigned long long z=1; z<j; z++) {
                dp[i][j] = min(dp[i][j], dp[i-1][z] + sum(j+1, z+1));
            }
        }
    }

    ans = dp[k-1][0] + sum(n, 1);
    for (unsigned long long i=1; i<n-1; i++) {
        ans = min(ans, dp[k-1][i] + sum(n, i+1));
    }
}

struct group {
    unsigned long long sum, cnt;
};


unsigned long long sum2(group &t) {
    return (t.cnt-1) * t.sum;
}

void solveK3() {
    unsigned long long p1 = 0, p2 = n - 2;
    group g1, g2 = {0, 0}, g3;
    g1.sum = a[0];
    g1.cnt = 1;
    for (unsigned long long i=1; i<n-1; i++) {
        g2.sum += a[i];
        g2.cnt++;
    }
    g3.sum = a[n-1];
    g3.cnt = 1;

    bool moved = 1;
    while (moved) {
        moved = 0;

        /*cerr<<sum2(g1) + sum2(g2) + sum2(g3)<<endl;
        cerr<<g1.sum<<' '<<g1.cnt<<endl;
        cerr<<g2.sum<<' '<<g2.cnt<<endl;
        cerr<<g3.sum<<' '<<g3.cnt<<endl;*/
        group temp1 = g1, temp2 = g2, temp3 = g3;
        if (p2 - p1 > 2) {
            //cerr<<1<<endl;
            temp1.sum += a[p1+1];
            temp1.cnt++;
            temp2.sum -= a[p1+1] + a[p2];
            temp2.cnt -= 2;
            temp3.sum += a[p2];
            temp3.cnt++;
            if (sum2(temp1) + sum2(temp2) + sum2(temp3) < sum2(g1) + sum2(g2) + sum2(g3)) {
                swap(temp3, g3);
                swap(temp2, g2);
                swap(temp1, g1);
                moved = 1;
                p1++, p2--;
                continue;
            }
        }

        if (p1 > 1) {
            //cerr<<2<<endl;
            temp1 = g1, temp2 = g2, temp3 = g3;
            temp1.sum -= a[p1];
            temp1.cnt--;
            temp2.sum -= -a[p1] + a[p2];
            temp3.sum += a[p2];
            temp3.cnt++;
            if (sum2(temp1) + sum2(temp2) + sum2(temp3) < sum2(g1) + sum2(g2) + sum2(g3)) {
                swap(temp3, g3);
                swap(temp2, g2);
                swap(temp1, g1);
                moved = 1;
                p1--, p2--;
                continue;
            }
        }

        if (p2 < n-2) {
            //cerr<<3<<endl;
            temp1 = g1, temp2 = g2, temp3 = g3;
            temp1.sum += a[p1+1];
            temp1.cnt++;
            temp2.sum -= a[p1+1] - a[p2+1];
            temp3.sum -= a[p2+1];
            temp3.cnt--;
            if (sum2(temp1) + sum2(temp2) + sum2(temp3) < sum2(g1) + sum2(g2) + sum2(g3)) {
                swap(temp3, g3);
                swap(temp2, g2);
                swap(temp1, g1);
                moved = 1;
                p1++, p2++;
                continue;
            }
        }

        if (p1+1 < p2){
            temp1 = g1, temp2 = g2;
            temp1.sum += a[p1+1];
            temp1.cnt++;
            temp2.sum -= a[p1+1];
            temp2.cnt--;
            //cerr<<sum2(temp1)<<' '<<sum2(temp2)<<" <> "<<sum2(g1)<<' '<<sum2(g2)<<endl;
            if (sum2(temp1) + sum2(temp2) < sum2(g1) + sum2(g2)) {
                swap(temp1, g1);
                swap(temp2, g2);
                moved = 1;
                p1++;
                continue;
            }
        }

        if (p1 > 0){
            temp1 = g1, temp2 = g2;
            temp1.sum -= a[p1];
            temp1.cnt--;
            temp2.sum += a[p1];
            temp2.cnt++;
            //cerr<<sum2(temp1)<<' '<<sum2(temp2)<<" <> "<<sum2(g1)<<' '<<sum2(g2)<<endl;
            if (sum2(temp1) + sum2(temp2) < sum2(g1) + sum2(g2)) {
                swap(temp1, g1);
                swap(temp2, g2);
                moved = 1;
                p1--;
                continue;
            }
        }

        if (p2-1 > p1) {
            temp3 = g3, temp2 = g2;
            temp3.sum += a[p2];
            temp3.cnt++;
            temp2.sum -= a[p2];
            temp2.cnt--;
            if (sum2(temp3) + sum2(temp2) < sum2(g3) + sum2(g2)) {
                swap(temp3, g3);
                swap(temp2, g2);
                moved = 1;
                p2--;
                continue;
            }
        }

        if (p2 < n-2) {
            temp3 = g3, temp2 = g2;
            temp3.sum -= a[p2+1];
            temp3.cnt--;
            temp2.sum += a[p2+1];
            temp2.cnt++;
            if (sum2(temp3) + sum2(temp2) < sum2(g3) + sum2(g2)) {
                swap(temp3, g3);
                swap(temp2, g2);
                moved = 1;
                p2++;
                continue;
            }
        }
    }

    ans = sum2(g1) + sum2(g2) + sum2(g3);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    if (k == 3){
        solveK3();
    } else {
        solve();
    }
    output();
    return 0;
}
/*
10 3
9 8 5 2 7 3 2 2 8 3
15
*/
