#include<bits/stdc++.h>
#define eb push_back
#define pb push_back
#define f first
#define s second

using namespace std;

const int MAXN = 1e5;
const int MAXX = 1e5;
int n, w, h;
pair<int, int> r[MAXN];
int st[4*MAXX], lp[4*MAXX];
int ans;

void input() {
    cin>>n>>w>>h;
    for (int i=0; i<n; i++) {
        cin>>r[i].f>>r[i].s;
    }
}

void output() {
    cout<<ans<<endl;
}

void updateLazy(int curr, bool leaf) {
    int temp = lp[curr];
    lp[curr] = 0;
    st[curr] += temp;
    if (!leaf) {
        lp[curr*2] += temp;
        lp[curr*2+1] += temp;
    }
}

void update(int curr, int cl, int cr, int l, int r, int val) {
    updateLazy(curr, cl==cr);
    if (cl > r || cr < l) {
        return;
    }
    //<<l<<' '<<r<<" th "<<cl<<' '<<cr<<' ';
    if (cl >= l && cr <= r) {
            //<<"end "<<endl;
        lp[curr] += val;
        updateLazy(curr, cl==cr);
        return;
    }//<<endl;

    int mid = (cl + cr) / 2;
    update(curr*2, cl, mid, l, r, val);
    update(curr*2+1, mid+1, cr, l, r, val);
    st[curr] = max(st[curr*2], st[curr*2+1]);
}

void update(int l, int r, int val) {
    update(1, 1, MAXX, max(l, 1), r, val);
}

void solve() {
    sort(r, r+n);


    int p = 0;
    ans = 1;
    update(r[0].f - h, r[0].f, 1);
    for (int i=1; i<n; i++) {
        //<<"start "<<i<<' '<<st[1]<<endl;
        while (r[p].f + w < r[i].f) {
            update(r[p].s - h, r[p].s, -1);
            p++;
        }
        //<<"point "<<p<<' '<<st[1]<<endl;
        while (i < n && r[p].f + w >= r[i].f) {
            update(r[i].s - h, r[i].s, 1);
            i++;
        } i--;
        //<<"2nd "<<i<<' '<<st[1]<<endl;
        ans = max(ans, st[1]);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}

/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

*/
