#include<bits/stdc++.h>
#define eb push_back
#define pb push_back
#define f first
#define s second

using namespace std;

const int MAXN = 1e5;
const int MAXX = 1e5;
int n, w, h;
pair<int, int> r[MAXN];
int st[4*MAXX], lp[4*MAXX];
int ans;

void input() {
    cin>>n>>w>>h;
    for (int i=0; i<n; i++) {
        cin>>r[i].f>>r[i].s;
    }
}

void output() {
    cout<<ans<<endl;
}

void updateLazy(int curr, bool leaf) {
    int temp = lp[curr];
    lp[curr] = 0;
    st[curr] += temp;
    if (!leaf) {
        lp[curr*2] += temp;
        lp[curr*2+1] += temp;
    }
}

void update(int curr, int cl, int cr, int l, int r, int val) {
    updateLazy(curr, cl==cr);
    if (cl > r || cr < l) {
        return;
    }
    //<<l<<' '<<r<<" th "<<cl<<' '<<cr<<' ';
    if (cl >= l && cr <= r) {
            //<<"end "<<endl;
        lp[curr] += val;
        updateLazy(curr, cl==cr);
        return;
    }//<<endl;

    int mid = (cl + cr) / 2;
    update(curr*2, cl, mid, l, r, val);
    update(curr*2+1, mid+1, cr, l, r, val);
    st[curr] = max(st[curr*2], st[curr*2+1]);
}

void update(int l, int r, int val) {
    update(1, 1, MAXX, max(l, 1), r, val);
}

int findLeft(int curr, vector<int> &y) {
    int l = 0, r = y.size();

    while (l != r) {
        int mid = (l+r) / 2;
        if (y[mid] < curr) {
            l = mid + 1;
        } else {
            r = mid;
        }
    }
    return y[l];
}

void solve() {
    sort(r, r+n);

    //compress
    set<int> used;
    vector<int> ys(n);
    for (int i=0; i<n; i++) {
        if (used.find(r[i].s) != used.end()) {
            continue;
        }
        ys[i] = r[i].s;
        used.insert(r[i].s);
    }
    sort(ys.begin(), ys.end());
    map<int, int> coor;
    for (int i=0; i<n; i++) {
        coor[ys[i]] = i;
    }


    int p = 0;
    ans = 1;
    update(coor[findLeft(r[0].s - h, ys)], coor[r[0].s], 1);
    for (int i=1; i<n; i++) {
        //<<"start "<<i<<' '<<st[1]<<endl;
        while (r[p].f + w < r[i].f) {
            update(findLeft(r[p].s - h, ys), coor[r[p].s], -1);
            p++;
        }
        //<<"point "<<p<<' '<<st[1]<<endl;
        while (i < n && r[p].f + w >= r[i].f) {
            update(findLeft(r[i].s - h, ys), coor[r[i].s], 1);
            i++;
        } i--;
        //<<"2nd "<<i<<' '<<st[1]<<endl;
        ans = max(ans, st[1]);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}

/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

2 2 2
4 1
2 4
*/
