#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define endl "\n";
#define out(x) << "{" << (#x) << ": " << x << "} "
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {out << x.first << " " << x.second; return out;}
template<class T, class T2> inline istream &operator >>(istream &in, pair<T, T2> &x) {in >> x.first >> x.second; return in;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}
const ll mod = 1e15 + 7;

#pragma GCC target("sse4")

/*
Ochilata - 1.5 pone
Vyv krakata - 1.5
S moite bratq i plateni 5 pone
Brat me
*/

const ll MAX_N = 6010;
ll n, k, arr[MAX_N];
ll pref[MAX_N];
long double dp[MAX_N];
ll howm[MAX_N];

ll doDp(long double delta) {
    dp[0] = 0;
    howm[0] = 0;
    for(ll i = 1; i <= n; i ++) {
        dp[i] = dp[0] + (pref[i] - pref[0]) * (i - 1) + delta;
        howm[i] = 1;
        for(ll q = 1; q < i; q ++) {
            if(chkmin(dp[i], dp[q] + (long double)(pref[i] - pref[q]) * (long double)(i - q - 1ll) + delta)) {
                howm[i] = howm[q] + 1;
            }
        }
    }
    return howm[n];
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> k;
    for(ll i = 1; i <= n; i ++) {
        cin >> arr[i];
        pref[i] = pref[i - 1] + arr[i];
    }
    long double l = -1e12, r = 1e12;
    for(int iter = 0; iter < 200; iter ++) {
        long double m = (l + r) / 2.f;
        if(doDp(m) >= k) {
            l = m;
        } else {
            r = m;
        }
    }
    doDp(l);
    cout << (ll)((long double)dp[n] - (long double)howm[n] * l + 0.5) << endl;

}
