#include<iostream>
#include<cstdio>
#include<algorithm>
using namespace std;

//o(n^3)

struct point
{
	int x,y;
};

point p[1002];
int n,w,h;

bool cmp(point a, point b)
{
	if(a.x == b.x) return a.y < b.y;
	return a.x < b.x;
}

int rect_up(int xe,int ye,int ind)
{
	int br = 1;
	int j = ind+1;
	while(p[j].x <= xe)
	{
		if(p[ind].y <= p[j].y && p[j].y <= ye) br++;
		j++;
	}
	return  br;
}

int rect_down(int xe,int ye, int ind)
{
	int br = 1;
	int j = ind+1;
	while(p[j].x <= xe && j < n)
	{
		if(p[ind].y >= p[j].y && p[j].y >= ye) br++;
		j++;
	}
	return  br;
}

void check()
{
	int ans = 0;
	for(int i = 0; i < n; i++)
	{
		ans = max(rect_up(p[i].x+w, p[i].y+h ,i), ans);
		if(p[i].y -h > 0)ans = max(rect_down(p[i].x+w,p[i].y-h,i), ans);
	}
	printf("%d\n",ans);
}

int main()
{
	scanf("%d%d%d",&n,&w,&h);
	for(int i = 0; i < n; i++)
	{
		scanf("%d%d",&p[i].x,&p[i].y);
	}
	sort(p,p+n,cmp);
	check();
}
/*
6 2 3
1 1 
3 1 
2 2 
3 3 
5 3 
3 5

10 8 8
8 9
20 14
3 9
7 8 
3 4 
7 8 
10 19
6 11 
5 10 
8 2 
*/
