#include<bits/stdc++.h>

#define ll long long int
#define fr first
#define sc second
#define pb push_back
#define row vector<ll>
#define row_matrix vector<ll>
#define bit(x) x&(-x)
#define all(A) A.begin(), A.end()
#define matrix vector<row_matrix>
using namespace std;

const int MAXN = 4096;

int A[MAXN][MAXN], prefix[MAXN][MAXN];
int n, w, h, mx, mxx, mxy, ans;
vector<pair<int, int>> points;

int main(){
    cin >> n >> w >> h; mx = max(w, h);
    points = vector<pair<int, int>>(n);
    for(int i = 0; i < n; i ++){
        cin >> points[i].fr >> points[i].sc;
        mx = max(points[i].fr, points[i].sc);
        ++ points[i].fr;
        ++ points[i].sc;
    }
    if(n <= 100 && mx <= 100){ /// subtask 1, brute force
         for(auto [x, y] : points){
            ++ A[x][y];
        }
        for(int urx = w; urx <= 100; urx ++){
            for(int ury = h; ury <= 100; ury ++){
                int curr = 0;
                for(int cx = urx - w; cx <= urx; cx ++){
                    for(int cy = ury - h; cy <= ury; cy ++){
                        curr += A[cx][cy];
                    }
                }
                ans = max(curr, ans);
            }
        }
        cout << ans << endl;
    }
    else if(n <= 100000 && mx <= 1000){
        for(auto [x, y] : points){
            ++ A[x][y];
        }
        for(int i = 0; i < MAXN; i ++){
            int acc = 0;
            for(int j = 0; j < MAXN; j ++){
                acc += A[i][j];
                prefix[i][j] = (i == 0 ? 0 : prefix[i - 1][j]) + acc;
            }
        }
        for(int x = w + 1; x < MAXN; x ++){
            for(int y = h + 1; y < MAXN; y ++){
                ans = max(ans, prefix[x][y] - prefix[x - w - 1][y] - prefix[x][y - h - 1] + prefix[x - w - 1][y - h - 1]);
            }
        }
        cout << ans << endl;
    }
    else if(n <= 1000 && mx <= 100000000){
        vector<pair<int, int>> addon;
        for(int i = 0; i < n; i ++){
            int x = points[i].fr, y = points[i].sc;
            if(x - w - 1 >= 0 && y - h - 1 >= 0) addon.pb({x - w - 1, y - h - 1});
        }
        vector<int> comp;
        for(auto [x, y] : points) comp.pb(x);
        for(auto [x, y] : addon) comp.pb(x);
        sort(all(comp));
        auto cut = unique(all(comp));
        comp.resize(distance(comp.begin(), cut));
        for(int i = 0; i < points.size(); i ++) points[i].fr = lower_bound(all(comp), points[i].fr) - comp.begin();
        for(int i = 0; i < addon.size(); i ++) addon[i].fr = lower_bound(all(comp), addon[i].fr) - comp.begin();

        comp.clear();
        for(auto [x, y] : points) comp.pb(y);
        for(auto [x, y] : addon) comp.pb(y);
        sort(all(comp));
        cut = unique(all(comp));
        comp.resize(distance(comp.begin(), cut));
        for(int i = 0; i < points.size(); i ++) points[i].sc = lower_bound(all(comp), points[i].fr) - comp.begin();
        for(int i = 0; i < addon.size(); i ++) addon[i].sc = lower_bound(all(comp), addon[i].sc) - comp.begin();

        for(auto [x, y] : points){
            ++ A[x][y];
        }

        for(int i = 0; i < MAXN; i ++){
            int acc = 0;
            for(int j = 0; j < MAXN; j ++){
                acc += A[i][j];
                prefix[i][j] = (i == 0 ? 0 : prefix[i - 1][j]) + acc;
            }
        }
        for(int i = 0, j ; i < points.size(); i ++){
            int x = points[i].fr, y = points[i].sc;
            int x1 = addon[i].fr, y1 = addon[i].sc;
            ans = max(ans, prefix[x][y] + prefix[x1][y1] - prefix[x1][y] - prefix[x][y1]);
        }
        cout << ans << endl;
    }
}
/**
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
*/
