#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = 1e5 + 3;
const ll INF = 2e18;
const ll MAX = 1e13;

int n, k;
ll a[N], prefix[N];
ll dp[N], cnt[N];

void divide_and_conquer(int l, int r, int sl, int sr, ll cost){
    if(l > r) return;

    int mid = (l + r) >> 1;
    divide_and_conquer(mid + 1, r, sl, sr, cost);

    array<ll, 3> ans{INF, INF, -1};
    for(int i = max(mid, sl); i <= sr; ++i)
        ans = min(ans, {dp[i + 1] + (prefix[i] - prefix[mid - 1]) * (i - mid) + cost, cnt[i + 1] + 1, i});
    dp[mid] = ans[0];
    cnt[mid] = ans[1];

    divide_and_conquer(l, mid - 1, sl, ans[2], cost);

}

void solve(ll cost){
    dp[n + 1] = 0;
    cnt[n + 1] = 0;

    divide_and_conquer(1, n, 1, n, cost);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 1; i <= n; ++i)
        cin >> a[i];

    for(int i = 1; i <= n; ++i)
        prefix[i] = prefix[i - 1] + a[i];

    ll l = -MAX, r = MAX;
    while(l != r){
        ll mid = (l + r) >> 1;
        solve(mid);

        if(cnt[1] <= k)
            r = mid;
        else
            l = mid + 1;
    }

    solve(l);
    cout << dp[1] - k * l << "\n";
}
/*
5 3
25 93 21 13 42
*/
