#include <bits/stdc++.h>
using namespace std;

int n, k, a [100005];
long long sum [100005];
vector <vector <long long> > dp;

struct intersect{
    int idx, pos;
    bool operator < (intersect oth) const{
        return pos > oth.pos;
    }
};
priority_queue <intersect> pq;
int nxt [100005], smallest;
bool crossed [100005];

void add (int i, int j1, int j2){
    int l = j1, r = n;
    while (l < r){
        int mid = l + r >> 1;
        long long diff = dp [i][j2] + (sum [mid] - sum [j2]) * (mid - j2 - 1) - dp [i][j1] - (sum [mid] - sum [j1]) * (mid - j1 - 1);
        if (diff >= 0) r = mid;
        else l = mid + 1;
    }
    pq.push ({j1, l});
    nxt [j1] = j2;
}

int main (){

    //ios::sync_with_stdio (false);
    //cin.tie (0);

    cin >> n >> k >> a [0];
    sum [0] = a [0];
    for (int i = 1; i < n; i ++){
        cin >> a [i];
        sum [i] = sum [i - 1] + a [i];
    }
    dp.resize (k);
    for (long long i = 0; i < n; i ++) dp [0].push_back (sum [i] * i);
    for (int i = 1; i < k; i ++){
        while (!pq.empty ()) pq.pop ();
        for (int j = 1; j < n; j ++){
            crossed [j - 1] = 0;
            add (i - 1, j, j - 1);
        }
        smallest = 0;
        for (int j = 0; j < n; j ++){
            while (!pq.empty () && pq.top ().pos <= j){
                if (crossed [pq.top ().idx]){
                    pq.pop ();
                    continue;
                }
                crossed [nxt [pq.top ().idx]] = 1;
                if (smallest == nxt [pq.top ().idx]){
                    smallest = pq.top ().idx;
                    nxt [smallest] = -1;
                    pq.pop ();
                }
                else{
                    int x = nxt [nxt [pq.top ().idx]];
                    add (i - 1, pq.top ().idx, x);
                    pq.pop ();
                }
            }
            dp [i].push_back (dp [i - 1][smallest] + (sum [j] - sum [smallest]) * (j - smallest - 1));
        }
    }

    cout << dp [k - 1][n - 1] << '\n';

}
