#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;

int n, w, h;
pair <int, int> points [100005];

int tree [400005], lazy [400005];
void updlazy (int l, int r, int pos){
    tree [pos] += lazy [pos];
    if (l < r){
        lazy [pos << 1] += lazy [pos];
        lazy [pos << 1 | 1] += lazy [pos];
    }
    lazy [pos] = 0;
}
void upd (int l, int r, int pos, int ql, int qr, int val){
    updlazy (l, r, pos);
    if (l >= ql && r <= qr){
        lazy [pos] += val;
        updlazy (l, r, pos);
        return;
    }
    if (l > qr || r < ql) return;
    int mid = l + r >> 1;
    upd (l, mid, pos << 1, ql, qr, val);
    upd (mid + 1, r, pos << 1 | 1, ql, qr, val);
    tree [pos] = max (tree [pos << 1], tree [pos << 1 | 1]);
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> w >> h;
    for (int i = 0; i < n; i ++) cin >> points [i].x >> points [i].y;
    sort (points, points + n);
    int l = 0, ans = 0;
    for (int i = 0; i < n; i ++){
        upd (0, 100000, 1, points [i].y, points [i].y + w, 1);
        while (points [l].x + h < points [i].x){
            upd (0, 100000, 1, points [l].y, points [l].y + w, -1);
            l ++;
        }
        ans = max (ans, tree [1]);
    }
    cout << ans << '\n';

}
