#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<string> names;

void read() {
    names.resize(26);
    for (int i = 0; i < 26; i++) {
        cin >> names[i];
    }
}

vector<vector<long long>> dp;

long long tryAll(int pos, int usedLetters) {
    if (pos == 26) {
        return 1;
    }

    if (usedLetters < 1000000 && dp[pos][usedLetters] != -1) {
        return dp[pos][usedLetters];
    }

    long long answer = 0;

    for (char letter : names[pos]) {
        int id = letter - 'A';

        if (!((usedLetters >> id) & 1)) {
            answer += tryAll(pos + 1, usedLetters | (1 << id));
        }
    }

    if (usedLetters < 1000000) {
        dp[pos][usedLetters] = answer;
    }

    return answer;
}

void solve() {
    for (int i = 0; i < 26; i++) {
        sort(names[i].begin(), names[i].end());
        names[i].resize(unique(names[i].begin(), names[i].end()) - names[i].begin());
    }

    dp.resize(26, vector<long long>(1000000, -1));
    cout << tryAll(0, 0) << endl;
}

int main() {
    setIO();

    read();

    solve();
}
