#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, k;
vector<int> a;

void read() {
    cin >> n >> k;

    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
}

void solve() {
    vector<vector<int>> dp(n, vector<int>(k, 1e9));

    dp[0][0] = 0;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < k; j++) {
            int sum = 0, num = 0;

            for (int k = i; k >= 0; k--) {
                num++;
                sum += a[k];

                if (j == 0) {
                    if (k == 0) {
                        dp[i][j] = sum * (num - 1);
                    }
                } else if (k > 0) {
                    dp[i][j] = min(dp[i][j], sum * (num - 1) + dp[k - 1][j - 1]);
                }
            }
        }
    }

    int answer = 1e9;

    for (int j = 0; j < k; j++) {
        answer = min(answer, dp[n - 1][j]);
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
