#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, k;
vector<int> a;

void read() {
    cin >> n >> k;

    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
}

vector<vector<long long>> cost;
vector<long long> dpBefore, dp;

void compute(int low, int high, int optL, int optR) {
    if (low > high) {
        return;
    }

    int middle = low + (high - low) / 2;

    pair<long long, int> best = {1e9, -1};
    for (int i = optL; i <= min(middle, optR); i++) {
        if (i == 0) {
            continue;
        }

        if (cost[i][middle] + dpBefore[i - 1] < best.first) {
            best.first = cost[i][middle] + dpBefore[i - 1];
            best.second = i;
        }
    }

    dp[middle] = best.first;

    compute(low, middle - 1, optL, best.second);
    compute(middle + 1, high, best.second, optR);
}

void solve() {
    cost.resize(n, vector<long long>(n));
    for (int i = 0; i < n; i++) {
        long long sum = 0;

        for (int j = i; j < n; j++) {
            sum += a[j];

            cost[i][j] = sum * (j - i);
        }
    }

    dpBefore.resize(n, 1e18);
    dp.resize(n, 1e18);

    for (int i = 0; i < n; i++) {
        dpBefore[i] = cost[0][i];
    }

    for (int i = 1; i < k; i++) {
        compute(i, n - 1, 0, n - 1);
        //dpBefore = dp;
    }

    //cout << dpBefore.back() << endl;
}

int main() {
    setIO();

    read();

    solve();
}
