#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;

const int Max_N=100100;
const int Max_K=100100;
const long long Inf=900000000000000000;

int n,k;
int or_arr[Max_N];

long long or_a_pr_s [Max_N];

void calc_pr_s(){
    or_a_pr_s[0]=or_arr[0];
    for(int i=1;i<n;i++){
        or_a_pr_s[i]=or_a_pr_s[i-1]+or_arr[i];
    }
//    for(int i=0;i<n;i++){
//        cout<<or_a_pr_s[i]<<endl;
//    }
    return;
}

long long get_sum(int l,int r){
    if(r<l){
        swap(l,r);
    }
    if(l==0){
        return or_a_pr_s[r];
    }
    return (or_a_pr_s[r]-or_a_pr_s[l-1]);
}

vector< vector<long long> > dp;
vector< vector<int> > dp_i;

long long acc_dp(int j,int i){
    if(i==0){
        return 0;
    }
    return dp[j][i];
}

void calc_dp(){
    dp.resize(n);
    dp_i.resize(n);
    for(int i=0;i<n;i++){
        dp[i].resize(k+1);
        dp_i[i].resize(k+1);
        dp[i][0]=0;
    }
    for(int j=0;j<n;j++){
        dp[j][1]=get_sum(0,j)*j;
    }
    for(int i=0;(i+1)<=k;i++){
        dp_i[i][i+1]=i-1;
    }
    for(int i=2;i<=k;i++){
        for(int j=i;j<n;j++){
            long long var_f=dp[dp_i[j-1][i]][i-1]+(get_sum(dp_i[j-1][i]+1,j)*(j-dp_i[j-1][i]-1));
            long long var_s=dp[dp_i[j-1][i]+1][i-1]+(get_sum(dp_i[j-1][i]+2,j)*(j-dp_i[j-1][i]-2));
            if(var_f<var_s){
                dp_i[j][i]=dp_i[j-1][i];
                dp[j][i]=var_f;
            }else{
                dp_i[j][i]=dp_i[j-1][i]+1;
                dp[j][i]=var_s;
            }
        }
    }
//    for(int i=0;i<=k;i++){
//        for(int j=0;j<n;j++){
//            cout<<dp[j][i]<<" ";
//        }
//        cout<<endl;
//    }
//    cout<<endl;
//    for(int i=0;i<=k;i++){
//        for(int j=0;j<n;j++){
//            cout<<dp_i[j][i]<<" ";
//        }
//        cout<<endl;
//    }
    return;
}

void print_res(){
    cout<<dp[n-1][k];
}

int main(){
ios_base::sync_with_stdio(false);
cin>>n>>k;
for(int i=0;i<n;i++){
    cin>>or_arr[i];
}
calc_pr_s();
calc_dp();
print_res();
return 0;
}

