
#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).begin(), (c).end()
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

template <class T>
istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator<< (ostream &out, const vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator<< (ostream &out, const pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e18;

signed main()
{
    Start();
    int n, k;
    cin >> n >> k;
    vector <int> a(n);
    cin >> a;
    vector <vector <int>> dp(n + 1, vector <int> (k + 1, INF));
    dp[0][0] = 0;
    vector <int> p(n + 1);
    partial_sum(all(a), p.begin() + 1);
    for (int i = 1; i <= n; ++i)
    {
        for (int x = 1; x <= k; ++x)
        {
            for (int j = 1; j <= i; ++j)
            {
                dp[i][x] = min(dp[i][x], dp[j - 1][x - 1] + (i - j) * (p[i] - p[j - 1]));
            }
        }
    }
    cout << dp[n][k];
    return 0;
}

