#include<bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define ll long long
typedef vector<int> vi;
typedef pair<int, int> ii;
#define FORi(i,a,b) for(int i=a;i<b;i++)
#define FOR(i,n) FORi(i,0,n)
#define FOA(v,a) for(auto v : a)

#define len(qq) ((int) qq.size())

int n, w, h;
struct nod{
	int laz=0;
	int val=0;
	int l=-1, r=-1;
};

#define MAXR 200000001
vector<nod> seg(10000000);
int lastused=0;
#define MID ((l+r)/2)

void down(int ind){
	seg[seg[ind].l].val += seg[ind].laz;
	seg[seg[ind].r].val += seg[ind].laz;
	seg[seg[ind].l].laz += seg[ind].laz;
	seg[seg[ind].r].laz += seg[ind].laz;
	seg[ind].laz = 0;
}

void create(int ind){
	if(seg[ind].l==-1) seg[ind].l=++lastused;
	if(seg[ind].r==-1) seg[ind].r=++lastused;
}

int query(int rl, int rr, int l=0, int r=MAXR, int ind=0){
	if(rl<=l && r<=rr) return seg[ind].val;
	else if(rl>r || rr<l) return 0;
	if(l!=r) create(ind);
	down(ind);
	return max(query(rl, rr, l, MID, seg[ind].l) , query(rl,rr,MID+1,r,seg[ind].r));
}

void update(int rl, int rr, int x, int l=0, int r=MAXR, int ind=0){
	if(rl<=l && r<=rr) seg[ind].val+=x, seg[ind].laz+=x;
	else if(rl>r || rr<l) return;
	else if(l!=r){
		create(ind);
		down(ind);
		update(rl, rr, x, l, MID,seg[ind].l);
		update(rl,rr, x, MID+1,r,seg[ind].r);
		seg[ind].val = max(seg[seg[ind].l].val, seg[seg[ind].r].val);
	}
}

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);

	int maxy=0, maxx=0;
	cin>>n>>w>>h;
	int x[n], y[n];
	FOR(i,n) cin>>x[i]>>y[i];
	FOR(i,n) x[i]++, y[i]++;
	FOR(i,n) maxy = max(maxy, y[i]);
	FOR(i,n) maxx = max(maxx, x[i]);
	int ans=0;


	map<int, vi> impx;
	FOR(i,n) impx[x[i]].push_back(i);

	queue<int> added;
	FOA(v,impx){
		FOA(q,v.S) added.push(q), update(y[q], y[q]+h,1);
		while(!added.empty() && x[added.front()]<v.F-w){
			update(y[added.front()], y[added.front()]+h, -1);
			added.pop();
		}
		ans = max(ans, query(0, maxy+h));
	}
	cout<<ans<<endl;
}
