// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef unsigned long long ull;
typedef long double ld;

#define P pair
typedef P<int, int> Pii;
typedef P<ll, ll> Pll;
typedef P<string, string> Pss;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


#define add_fill(a, c) setw(a) << setfill(c)
// #define endl '\n'

#define slimming(a) a.shrink_to_fit()
#define len(a) (ll)a.size()

#define f first
#define s second

const ll INF = (ll) (1e9);
#define MOD 1000000009

#define yes "YES"
#define no "NO"
#define imp "impossible"

#define pb push_back
#define eb emplace_back

#pragma GCC optimize "-O3"
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma comment(linker, "/stack:200000000")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

// mt19937 rnd(time(0));

ll get_rand() {
   return (rand() << 16) ^ rand();
}

bool get(ll mask, ll id){
   return ((mask>>id)&1);
}



void solve() {
   ll n, k;
   cin >> n >> k;

   vector < ll > a(n);
   for(int i = 0 ; i < n; ++i)
      cin >> a[i];
   
   ll ans = INF;
   for(ll mask = 0; mask < (1<<n); ++mask){
      vector < Pll > pod;
      vector < vector < ll > > b;
      pod.pb({1, get(mask, 0)});
      b.pb({a[0]});
      for(int i = 1; i < n; ++i){
         if(get(mask, i) == pod.back().s){
            pod.back().f += 1;
            b.back().pb(a[i]);
         }else{
            pod.pb({1, get(mask, i)});
            b.pb({a[i]});
         }
      }
      if(len(pod) != k){
         continue;
      }
      
      ll tmp = 0;
      for(int i = 0; i < k; ++i){
         ll tmp2 = 0;
         for(int j = 0; j < len(b[i]); ++j)
            tmp2 += b[i][j];
         for(int j = 0; j < len(b[i]); ++j)
            tmp += tmp2 - b[i][j];
      }
      ans = min(ans, tmp);
   }
   cout << ans;
   return;
}

int main() {
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);

   // freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

   ll t = 1;
   // cin >> t;
   while (t--) {
      solve();
      cout << endl;
   }
   return 0;
}