// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef unsigned long long ull;
typedef long double ld;

#define P pair
typedef P<int, int> Pii;
typedef P<ll, ll> Pll;
typedef P<string, string> Pss;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


#define add_fill(a, c) setw(a) << setfill(c)
// #define endl '\n'

#define slimming(a) a.shrink_to_fit()
#define len(a) (ll)a.size()

#define f first
#define s second

const ll INF = (ll) (1e9);
#define MOD 1000000009

#define yes "YES"
#define no "NO"
#define imp "impossible"

#define pb push_back
#define eb emplace_back

#pragma GCC optimize "-O3"
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma comment(linker, "/stack:200000000")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

// mt19937 rnd(time(0));

ll get_rand() {
   return (rand() << 16) ^ rand();
}

bool get(ll mask, ll id){
   return ((mask>>id)&1);
}


struct SegmentTree{
   vector < ll > a;
   vector < ll > tree;
   SegmentTree(vector < ll > _a){
      ll n = len(_a);
      tree.assign(n*4, 0);
      a = _a;

      build(1, 0, n-1);
   }
   void build(ll node, ll l, ll r){
      if(l == r){
         tree[node] = a[l];
         return;
      }

      ll m = (l + r) / 2;
      build(node*2, l, m);
      build(node*2+1, m +1, r);
      tree[node] = tree[node*2]+tree[node*2+1];
   }

   ll get(ll node, ll _l, ll _r, ll l, ll r){
      if(_l > r or _r < l)
         return 0;
      if(l <= _l and _r <= r)
         return tree[node];

      ll m = (_l + _r) / 2;
      return get(node*2, _l, m, l, r) + get(node*2+1, m+1, _r, l, r);
   }  
};

void solve() {
   ll n;
   cin >> n;
   ll w, h;
   cin >> w >> h;

   if(n <= 100){
      ll a[201][201];
      for(int i = 0; i < 201; ++i){
         for(int j = 0; j < 201; ++j)
            a[i][j] = 0;
      }
      
      ll mxx = 0, mxy = 0;
      vector < Pll > b(n);
      for(int i = 0; i < n; ++i){
         ll x, y;
         cin >> x >> y;
         mxx = max(mxx, x+1), mxy = max(y, mxy+1);
         // --x, --y;
         b[i] = {x, y};
         a[x][y] += 1;
      }

      // for(int i = 0; i < mxx; ++i){
      //    for(int j = 0; j < mxy; ++j)
      //       cout << a[i][j];
      //    cout << endl;
      // }

      for(int i = 1; i < 201; ++i)
         a[0][i] += a[0][i-1];
      for(int i = 1; i < 201; ++i)
         a[i][0] += a[i-1][0];
      for(int i = 1; i < 201; ++i){
         for(int j = 1; j < 201; ++j){
            a[i][j] += a[i-1][j] + a[i][j-1] - a[i-1][j-1];
         }
      }
      // for(int i = 0; i < mxx; ++i){
      //    for(int j = 0; j < mxy; ++j)
      //       cout << a[i][j];
      //    cout << endl;
      // }

      ll ans = 0;
      for(int i = 1; i <= mxx; ++i){
         for(int j = 1; j <= mxy; ++j){
            ans = max(ans, a[i-1][j-1] + a[i+w][j+h] - a[i-1][j+h] - a[i+w][j-1]);
         }
      }
      cout << ans;
   }else if(n <= 100000 and w <= 1000 and h <= 1000){
      ll a[201][201];
      for(int i = 0; i < 201; ++i){
         for(int j = 0; j < 201; ++j)
            a[i][j] = 0;
      }
      ll mxx = 0, mxy = 0;
      vector < Pll > b(n);
      for(int i = 0; i < n; ++i){
         ll x, y;
         cin >> x >> y;
         mxx = max(mxx, x+1), mxy = max(y, mxy+1);
         // --x, --y;
         b[i] = {x, y};
         a[x][y] += 1;
      }

      // for(int i = 0; i < mxx; ++i){
      //    for(int j = 0; j < mxy; ++j)
      //       cout << a[i][j];
      //    cout << endl;
      // }

      for(int i = 1; i < 201; ++i)
         a[0][i] += a[0][i-1];
      for(int i = 1; i < 201; ++i)
         a[i][0] += a[i-1][0];
      for(int i = 1; i < 201; ++i){
         for(int j = 1; j < 201; ++j){
            a[i][j] += a[i-1][j] + a[i][j-1] - a[i-1][j-1];
         }
      }

      ll ans = 0;
      // for(int i = 1; i <= mxx; ++i){
      //    for(int j = 1; j <= mxy; ++j){
      //       ans = max(ans, a[i-1][j-1] + a[i+w][j+h] - a[i-1][j+h] - a[i+w][j-1]);
      //    }
      // }
      for(int q = 0; q < n; ++q){
         // int i = b[q].f, j = b[q].s;
         ll s = a[b[q].f][b[q].s] 
               + a[max(0LL, b[q].f - w-1)][max(0LL, b[q].s-h-1)] 
               - a[max(0LL, b[q].f - w-1)][b[q].s]
               - a[b[q].f][max(0LL, b[q].s-h-1)];

         ans = max(ans, s);
      }
      cout << ans;
   }
   return;
}

int main() {
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);

   // freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

   ll t = 1;
   // cin >> t;
   while (t--) {
      solve();
      cout << endl;
   }
   return 0;
}