// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef unsigned long long ull;
typedef long double ld;

#define P pair
typedef P<int, int> Pii;
typedef P<ll, ll> Pll;
typedef P<string, string> Pss;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


#define add_fill(a, c) setw(a) << setfill(c)
// #define endl '\n'

#define slimming(a) a.shrink_to_fit()
#define len(a) (ll)a.size()

#define f first
#define s second

const ll INF = (ll) (1e9);
#define MOD 1000000009

#define yes "YES"
#define no "NO"
#define imp "impossible"

#define pb push_back
#define eb emplace_back

#pragma GCC optimize "-O3"
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma comment(linker, "/stack:200000000")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

// mt19937 rnd(time(0));

ll get_rand() {
   return (rand() << 16) ^ rand();
}

bool get(ll mask, ll id){
   return ((mask>>id)&1);
}


struct SegmentTree{
   vector < ll > a;
   // vector < ll > tree;
   unordered_map < ll, ll > tree;
   // SegmentTree(vector < ll > _a){
      // ll n = len(_a);
      // tree.assign(n*4, 0);
      // a = _a;

      // build(1, 0, n-1);
   // }
   void build(ll node, ll l, ll r){
      if(l == r){
         tree[node] = a[l];
         return;
      }

      ll m = (l + r) / 2;
      build(node*2, l, m);
      build(node*2+1, m +1, r);
      tree[node] = tree[node*2]+tree[node*2+1];
   }

   void update(ll node, ll l, ll r, ll id, ll add){
      if(l == r and id == l){
         tree[node] += add;
         return;
      }

      if(r < id or l > id)
         return;
      
      ll m = (l + r) / 2;
      update(node*2, l, m, id, add);
      update(node*2+1, m+1, r, id, add);
      tree[node] = tree[node*2]+tree[node*2+1];
   }

   ll get(ll node, ll _l, ll _r, ll l, ll r){
      if(_l > r or _r < l)
         return 0;

      if(l <= _l and _r <= r)
         return tree[node];

      ll m = (_l + _r) / 2;
      return get(node*2, _l, m, l, r) + get(node*2+1, m+1, _r, l, r);
   }  
};


void solve() {
   ll n;
   cin >> n;
   ll w, h;
   cin >> w >> h;

   
   SegmentTree sgt;

   vector < Pll > point(n);
   for(int i = 0; i < n; ++i){
      cin >> point[i].f >> point[i].s;
   }
   
   sort(all(point));

   ll l = 0, r = 0;
   map < ll, ll > y;
   while(r < n and point[r].f - point[l].f <= w){
      sgt.update(1, 1, 1e8, point[r].s, 1);
      y[point[r].s]++;
      ++r;
   }
   ll ans = 0;
   while(r < n){
      ll tmp = 0;
      for(auto to : y){
         if(to.s == 0)continue;
         tmp = max(tmp, sgt.get(1, 1, 1e8, to.f, to.f + h));
         // cout << to.f << ' ' << to.f+h << ' ' << sgt.get(1, 1, 1e8, to.f, to.f + h) << endl;
      }
      ans = max(ans, tmp);

      sgt.update(1, 1, 1e8, point[l].s, -1);
      // y.erase(y.find(point[l].s));
      // ++l;
      y[point[l].s] -= 1;
      ++l;
      while(r < n and point[r].f - point[l].f <= w){
         sgt.update(1, 1, 1e8, point[r].s, 1);
         y[point[r].s]++;
         ++r;
      }
   }
   cout << ans;
   
   return;
}

int main() {
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);

   // freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

   ll t = 1;
   // cin >> t;
   while (t--) {
      solve();
      cout << endl;
   }
   return 0;
}