#ifndef LOCAL
#pragma GCC optimize("Ofast")
#endif

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

typedef long long ll;

const int N = 26;
const int L = 1e7 + 1;

int pnt = 0;
ll ans = 0;
vector<int> A[N];

int v[L];

int cnt(int x) {
    return upper_bound(v, v + pnt, x) - lower_bound(v, v + pnt, x);
}

void gen(int alr, int mask, int lim, int ps) {
    if (alr == lim) {
        if (ps) {
            v[pnt++] = mask;
        } else {
            ans += cnt(((1 << N) - 1) ^ mask);
        }
    } else {
        for (auto j : A[alr]) {
            if (!((mask >> j) & 1)) {
                gen(alr + 1, mask | (1 << j), lim, ps);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    for (int i = 0; i < N; i++) {
        string s;
        cin >> s;
        int mask = 0;
        for (auto x : s) {
            mask |= (1 << (x - 'A'));
        }
        for (int j = 0; j < N; j++) {
            if ((mask >> j) & 1) {
                A[i].push_back(j);
            }
        }
    }
    gen(0, 0, 12, 1);
    reverse(A, A + N);
    {
        sort(v, v + pnt);
    }
    gen(0, 0, 14, 0);
    cout << ans << '\n';
}
