#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

#define int long long

const int N = 6001;
const int INF = 1e18 + 239;

int a[N];
int ps[N];
pair<int, int> dp[N];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        ps[i + 1] = ps[i] + a[i];
    }
    auto solve = [&](int B) {
        for (int i = 0; i <= n; i++) {
            dp[i] = {INF, -INF};
        }
        dp[0] = {0, 0};
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < i; j++) {
                pair<int, int> cand = dp[j];
                cand.first += (ps[i] - ps[j]) * (i - j) + B;
                cand.second--;
                dp[i] = min(dp[i], cand);
            }
        }
        return -dp[n].second;
    };
    int l = 0;
    int r = 1e9 + 239;
    while (r - l > 1) {
        int m = (r + l) >> 1;
        if (solve(m) >= k) {
            l = m;
        } else {
            r = m;
        }
    }
    solve(l);
    int ans = dp[n].first - k * l;
    cout << ans - ps[n] << '\n';
}
