#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define ll long long
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	ll n, k;
	cin >> n >> k;

	vector <ll> a(n+1);
	for (ll i = 1; i <= n; i++) 
		cin >> a[i];


	if (k >= n) {
		cout << 0;
		return 0;
	}

	vector <vector <ll> > dp(k + 1, vector <ll>(n + 1));

	ll sum = a[1];

	for (ll j = 2; j <= n; j++) {
		sum += a[j];
		dp[1][j] = sum * (j - 1);
	}

	for (ll i = 2; i <= k; i++) {
		for (ll j = i; j <= n; j++) {
			dp[i][j] = dp[i - 1][j - 1];
			ll sum = a[j];
			ll kol = 1;
			for (ll q = j - 1; q >= i; q--) {
				sum += a[q];
				kol++;
				dp[i][j] = min(dp[i][j], sum * (kol - 1) + dp[i - 1][q - 1]);
			}
		}
	}

	cout << dp[k][n];

	return 0;

}