///❤
#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define ll long long
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N =  1e3 + 10;

using namespace std;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, h, w;
	cin >> n >> w >> h;

	vector <vector <int> > a(N, vector <int>(N + 1, 0));

	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		a[x][y]++;
	}

	vector <vector <int> > pref(N, vector <int>(N + 1));

	for (int i = 1; i < N; i++) 
		for (int j = 1; j < N; j++) 
			pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];
		
	int ans = 0;

	for (int i = 1; i <= N; i++) {
		for (int j = 1; j <= N; j++) {
			int x = i + w;
			int y = j + h;
			if (x >= N || y >= N) break;
			int sum = pref[x][y];
			sum -= pref[x][j - 1];
			sum -= pref[i - 1][y];
			sum += pref[i - 1][j - 1];
			ans = max(ans, sum);
		}
	}

	cout << ans;
	
	return 0;

}