#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <queue>
#include <random>
#include <deque>
using namespace std;
#define pbc push_back 
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define pob pop_back()
#define sp system("pause")
#define vin(v) for(auto &i:v) cin>>i;
typedef long long ll;
const int MAXN = 1e5 +1;

ll pref[MAXN];

ll get(int l, int r)
{
	return pref[r] - (l == 0 ? 0 : pref[l - 1]);
}
int a[MAXN];
ll dp[MAXN];
ll newdp[MAXN];
const ll INF = 1e18;

ll getval(int pos, int i, int j)
{
	if (pos < 0) return INF;
	return dp[pos] + get(pos, i - 1) * (i - pos - 1);
}

ll stupid(int n, int k, vector<int> a)
{
	vector<vector<ll>> tdp(n + 1, vector<ll>(k + 1, 1e18));
	for (int i = 0; i < n; ++i)
	{
		pref[i] = (i == 0 ? 0 : pref[i - 1]) + a[i];
	}
	tdp[0][0] = 0;
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= k; ++j)
		{
			for (int ti = i - 1; ti >= 0; --ti)
			{
				ll x = get(ti, i - 1) * (i - ti - 1);
				tdp[i][j] = min(tdp[i][j], tdp[ti][j - 1] + x);
			}
		}
	}
	return tdp[n][k];
}
ll smart(int n, int k, vector<int> a)
{
	for (int i = 0; i < MAXN; ++i) dp[i] = newdp[i] = 1e18;
	for (int i = 0; i < n; ++i) pref[i] = (i == 0 ? 0 : pref[i - 1]) + a[i];
	dp[0] = 0;

	for (int j = 1; j <= k; ++j)
	{
		int ti = j - 1;
		for (int i = j; i <= n; ++i)
		{
			while (ti + 1 < i && getval(ti, i, j)  > getval(ti + 1, i, j)) ti++;
			newdp[i] = getval(ti, i, j);
			for (int x = ti - 20; x <= ti + 20; ++x) newdp[i] = min(newdp[i], getval(x, i, j));
		}
		swap(dp, newdp);
		for (int i = 0; i < MAXN; ++i) newdp[i] = INF;
	}
	return dp[n];
}
mt19937 rnd(time(0) + rand());
signed main()
{
	int cnt = 0;
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	vin(a);
	cout << smart(n, k, a);
	return 0;
	while (1)
	{
		++cnt;
		int n, k;
		n = rnd() % 200 + 1;
		k = rnd() % 3 + 1;
		vector<int> a(n);
		for (int i = 0; i < n; ++i) a[i] = rnd() % 100 + 1;
		ll fs = stupid(n, k, a);
		ll ss = smart(n, k, a);
		if (fs != ss)
		{
			cout << fs << ' ' << ss << endl;
			cout << n << ' ' << k << endl;
			for (int i : a) cout << i << ' ';
			cout << endl;
			sp;
		}
		cout << cnt << '\n';
	}
	sp;
}
