#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int,int> pi;
typedef pair<ll,ll> pl;
#define F first
#define S second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);
#define endl '\n'
#ifdef dremix
    #define p(x) cerr<<#x<<" = "<<x<<endl;
    #define p2(x,y) cerr<<"("<<#x<<","<<#y<<") = "<<x<<","<<y<<endl;
    #define pv(x) cerr<<#x<<" = {";for(auto v : x)cerr<<v<<", ";cerr<<"}"<<endl;
#else
    #define p(x)
    #define p2(x,y)
    #define pv(x)
#endif
const ll INF = 2e18;
const int MOD = 1e9+7;
const int N = 1001;

int pref[N][N];

void valid(int &x){
    x = max(x,1);
    x = min(x,1000);
}

int get(int x1, int y1, int x2, int y2){
    /// (x1,y1) upper left
    /// (x2,y2) lower right
    valid(x1);
    valid(x2);
    valid(y1);
    valid(y2);
    return pref[x2][y2] - pref[x1-1][y2] - pref[x2][y1-1] +
    pref[x1-1][y1-1];
}

int main (){
fastio

/// lemma : optimal rectangle always has a corner on a point
/// => 4N possible positions for rectangle
/// find way to count points in rectangle efficiently

int n,w,h;
cin>>n>>w>>h;

int i,j;
int arr[N][N];
memset(arr,0,sizeof arr);

pi p[n];

for(i=0;i<n;i++){
    int x,y;
    cin>>x>>y;
    p[i] = {x,y};
    arr[x][y]++;
}

for(i=1;i<N;i++){
    int sum = 0;
    for(j=1;j<N;j++){
        sum += arr[i][j];
        pref[i][j] = pref[i-1][j] + sum;
    }
}

int ans = 0;

for(i=0;i<n;i++){
    int x = p[i].F;
    int y = p[i].S;
    ans = max(ans,get(x-w,y,x,y+h));
    ans = max(ans,get(x,y,x+w,y+h));
    ans = max(ans,get(x,y-h,x+w,y));
    ans = max(ans,get(x-w,y-h,x,y));
}

cout<<ans;



}
