#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using ll = long long;

int const lgmax = 26;
std::vector<int> var[1 + lgmax];

short dp[(1 << lgmax)];
int quick[1 << lgmax];

int main() {
  std::string s;
  for(int i = 0; i < lgmax; i++) {
    std::cin >> s;
    for(int j = 0; j < s.size(); j++)
      var[i].push_back(s[j] - 'A');
    std::sort(var[i].begin(), var[i].end());
    var[i].erase(std::unique(var[i].begin(), var[i].end()), var[i].end());
    for(int j = 0; j < var[i].size(); j++)
      quick[i] |= (1 << var[i][j]);
  }

  dp[0] = 1;
  for(int mask = 0; mask < (1 << lgmax) - 1; mask++) {
    if(0 < dp[mask]) {
      int id = __builtin_popcount(mask);
      if((mask & quick[id]) == quick[id])
        continue;

      for(int i = 0; i < var[id].size(); i++) {
        if((mask & (1 << var[id][i])) == 0) {
          dp[mask | (1 << var[id][i])] += dp[mask];
        }
      }
    }
  }
  std::cout << dp[(1 << lgmax) - 1];
  return 0;
}
