#include <iostream>
#include <vector>
#include <cassert>

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 1000;
ll const inf = 1000000000000000000;

int v[1 + nmax];
ll sum[1 + nmax];
ll dp[1 + nmax][1 + nmax];
int sol[1 + nmax];

int main() {
  int n, k;
  std::cin >> n >> k;
  for(int i = 1;i <= n; i++) 
    std::cin >> v[i];
  for(int i = 1;i <= n; i++)
    sum[i] = sum[i - 1] + v[i];
  for(int i = 0; i <= n; i++)
    for(int j = 0; j <= n; j++)
      dp[i][j] = inf;
  dp[0][0] = 0;
  for(int i = 1; i <= k; i++) {
    for(int j = 1;j <= n; j++) {
      sol[j] = sol[j - 1];
      for(int j2 = sol[j]; j2 < j; j2++) {
        ll result = dp[i - 1][j2] + (sum[j] - sum[j2]) * (j - j2 - 1);
        if(result < dp[i][j]) {
          dp[i][j] = result;
          sol[j] = j2;
        }
      }
    }
  }
  std::cout << dp[k][n];
  return 0;
}
