#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define mp make_pair
#define pll pair<ll,ll>
#define pii pair<int,int>
#define fi first
#define se second
#define all(v) v.begin(),v.end()
#define ld long double

using namespace std;

const ll MOD=1e9+7;

ll n, k, m;
vector<pll> v;

struct node
{
    node *l, *r;
    ll mx=0, tt=0;
    node():l(0),r(0),mx(0),tt(0){};
};

struct segment_tree
{
    node *root;

    ll get(node *h)
    {
        if (h) return h->mx; else return 0;
    }

    void update(node *h,int l,int r,int x,int y,int k)
    {
        if (x>y) return;
        if (l==x && y==r)
        {
            h->tt+=k;
            h->mx+=k;
            return;
        }
        int w=(l+r)/2;
        if (!h->l && x<=w) h->l=new node();
        update(h->l,l,w,x,min(y,w),k);
        if (!h->r && y>=w) h->r=new node();
        update(h->r,w+1,r,max(x,w+1),y,k);
        h->mx=max(get(h->l),get(h->r))+h->tt;
    }
};


segment_tree g;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll w, h;
    g.root=new node();
    cin >> n >> w >> h;
    for (int i = 1; i <= n; i++)
    {
        ll x, y;
        cin >> x >> y;
        v.pb(mp(x, y));
    }
    sort(all(v));
    ll l=0, r=0, ans=0;
    while (r<v.size())
    {
        //cout << v[r].fi << " " << v[r].se << "\n";
        g.update(g.root, 0, 1e8, max(0ll, v[r].se-h), v[r].se, 1);
        while (v[l].fi+w<v[r].fi)
        {
            g.update(g.root, 0, 1e8, max(0ll, v[l].se-h), v[l].se, -1);
            l++;
        }
        //cout << " " << l << " " << g.get(g.root) << "\n";
        ans=max(ans, g.get(g.root));
        r++;
    }
    cout << ans << "\n";
    return 0;
}
/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2
*/
