#include <iostream>
#include <vector>
#include <list>
#define int long long
#define SUM(a,b) (part[b+1]-part[a])
using namespace std;

int32_t main() {
    ios_base::sync_with_stdio(false);
    int n,k;
    cin>>n>>k;
    vector<int> part(n+1);
    part[0]=0;
    for(int i=0; i<n; i++){
        cin>>part[i+1];
        part[i+1]+=part[i];
    }
    vector<vector<int>> dp(n,vector<int>(k,0));
    for(int i=1; i<n; i++){
        dp[i][0]=part[i+1]*i;
        for(int j=1; j<k; j++){
            for(int l=1; l<=i; l++) {
                dp[i][j] = dp[i - l][j - 1] + SUM(i - l + 1, i) * (l - 1);
            }
        }
    }

    cout<<dp[n-1][k-1];

    return 0;
}
