#include <iostream>
#include <bits/stdc++.h>
#define ii pair<int,int>
#define x first
#define y second
using namespace std;

struct st{
    int n;
    vector<int> lz;
    vector<int> v;
    st(int N){
        n=1;
        while(n<N){
            n*=2;
        }

        v.assign(2*n+1,0);
        lz.assign(2*n+1,0);
    }
    void push(int i, int l, int r){
        v[i]+=(r-l+1)*lz[i];
        if(l!=r) {
            lz[2 * i]+= lz[i];
            lz[2*i+1]+= lz[i];
        }
        lz[i]=0;
    }
    int get_rec(int a, int b, int l, int r, int i){
        if(b<l||r<a||r<l){
            return 0;
        }
        push(i,l,r);
        if(a<=l&&r<=b){
            return v[i];
        }
        int mid=(l+r)/2;
        return get_rec(a,b,l,mid,2*i)+get_rec(a,b,mid+1,r,2*i+1);
    }
    int get(int a,int b){
        return get_rec(a,b,1,n,1);
    }
    void update_rec(int a,int b, int l ,int r, int i, int vn){
        if(b<l||r<a||r<l){
            return;
        }
        push(i,l,r);
        if(a<=l&&r<=b){
            lz[i]=vn;
            push(i,l,r);
            return;
        }
        int mid=(l+r)/2;
        update_rec(a,b,l,mid,2*i,vn);
        update_rec(a,b,mid+1,r,2*i+1,vn);
        v[i]=v[2*i]+v[2*i+1];
    }
    void update(int a, int b, int s){
        update_rec(a,min(b,n),1,n,1,s);
    }
};
int main() {
    int n,w,h;
    cin>>n>>w>>h;

    vector<ii> pts(n);
    int maxy=0;
    for(int i=0; i<n; i++){
        cin>>pts[i].x>>pts[i].y;
        maxy=max(maxy,pts[i].y);
    }
    st tree(maxy);
//    cout<<tree.v.size()<<endl;
    sort(pts.begin(),pts.end());
    deque<ii> active;
    int m=0;
    for(auto p:pts){
        active.push_back(p);
        tree.update(p.y,p.y,1);
        while(p.x-active.front().x>w){
            tree.update(active.front().y,active.front().y,-1);
            active.pop_front();
        }

        m=max(m,tree.get(max(p.y-h,1),p.y));
    }
    cout<<m;
    return 0;
}
