#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <algorithm>
using namespace std;

#define pb push_back
#define vi vector<int>
#define vvi vector<vector<int>>

int calcStress(vector<int> exm, int start, int end) {
	int sum = 0;
	for (int i = start; i < end; i++) {
		sum += (end-start-1)*exm[i];
	}
	return sum;
}

int main()
{
	int N, K, A;
	cin >> N >> K;
	vi agro(N);
	vi aquarium;
	for (int i = 0; i < N; i++) {
		cin >> A;
		agro[i] = A;
	}
	if (K == 1) {
		cout << calcStress(agro, 0, agro.size()) << endl;
		return 0;
	}
	aquarium.pb(0);

	int sum = 0;
	for (int i = 0; i < aquarium.size() - 1; i++) {
		sum += calcStress(agro, aquarium[i], aquarium[i + 1]);
	}
}