#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <algorithm>
using namespace std;

#define pb push_back
#define vi vector<int>
#define vvi vector<vector<int>>

int calcFear(vector<int> exm, int start, int end) {
	int sum = 0;
	for (int i = start; i < end; i++) {
		sum += (end - start - 1)*exm[i];
	}
	return sum;
}

int main()
{
	int N, K, A;
	cin >> N >> K;
	vi agro(N);
	vi aquarium;
	for (int i = 0; i < N; i++) {
		cin >> A;
		agro[i] = A;
	}
	if (K == N) {
		cout << 0 << endl;
		return 0;
	}
	int counter = K - 1;
	int start = 0; //index of the first element in the aquarium
	int end = N; //index of the first element after the aquarium
	aquarium.pb(0);
	aquarium.pb(N);
	while (counter > 0) {
		int Max = 0;
		for (int i = 0; i < aquarium.size() - 1; i++) {
			int z = calcFear(agro, aquarium[i], aquarium[i + 1]);
			if (z > Max) {
				Max = z;
				start = aquarium[i];
				end = aquarium[i + 1];
			}
		}
		int sum = 0;
		for (int i = start; i < end; i++) {
			sum += agro[i];
		}
		int cursum = 0;
		for (int i = start; i < end; i++) {
			if (abs((sum - cursum) - cursum) < abs((sum - cursum) - (cursum + agro[i]))) {
				aquarium.pb(i);
				break;
			}
			cursum += agro[i];
		}
		sort(aquarium.begin(), aquarium.end());
		--counter;
	}
	//find aquarium with biggest sum of fear
	//sum the agros in the aquarium
	//find the most equal division (sum-wise)
	//aquarium.pb(most equal position)
	//calculate new fear values and repeat for k-1 times

	int sumOfFear = 0;
	for (int i = 0; i < aquarium.size() - 1; i++) {
		sumOfFear += calcFear(agro, aquarium[i], aquarium[i + 1]);
	}
	cout << sumOfFear << endl;
}