#include <bits/stdc++.h>

using namespace std;

const long long MAXN = 100005;
const long long INF = 1000000000000000000LL;

struct smn {
  long long c;
  long long k;
};

smn dp[MAXN];

long long a[MAXN];
long long sp[MAXN];

smn best(smn a, smn b) {
  if (a.c < b.c)
    return a;
  if (a.c > b.c)
    return b;
  if (a.k < b.k)
    return a;
  return b;
}

smn calc(int i, int j, long long cost) {
  smn aux = dp[j];
  aux.k++;
  aux.c += sp[j] * j + sp[j] - sp[i] * j - sp[j] * i + sp[i] * i - sp[i] + cost;
  return aux;
}

smn cauta(int l, int r, int i, long long cost) {
  while (r - l >= 3) {
    int m1 = l + (r - l) / 3;
    int m2 = r - (r - l) / 3;
    long long c1 = sp[m1] * m1 + sp[m1] - sp[i] * m1 - sp[m1] * i + sp[i] * i - sp[i] + cost;
    long long c2 = sp[m2] * m2 + sp[m2] - sp[i] * m2 - sp[m2] * i + sp[i] * i - sp[i] + cost;
    if (c1 < c2)
      r = m2;
    else
      l = m1;
  }
  smn bc = calc(i, 0, cost);
  for (int j = l; j <= r; ++j) {
    smn c = calc(i, j, cost);
    bc = best(bc, c);
  }
  return bc;
}

int w[MAXN];

long long baga(long long n, long long cost) {
  for (long long i = 1; i <= n; ++i) {
    dp[i] = {INF, 0};
    for (long long j = max(0LL, i - 500); j < i; ++j) {
      smn aux = dp[j];
      aux.k++;
      aux.c += sp[j] * j + sp[j] - sp[i] * j - sp[j] * i + sp[i] * i - sp[i] + cost;
      dp[i] = best(dp[i], aux);
      if (dp[i].c == aux.c && dp[i].k == aux.k)
        w[i] = j;
    }
    for (long long j = w[i - 1]; j < min(i, w[i - 1] + 500LL); ++j) {
      smn aux = dp[j];
      aux.k++;
      aux.c += sp[j] * j + sp[j] - sp[i] * j - sp[j] * i + sp[i] * i - sp[i] + cost;
      dp[i] = best(dp[i], aux);
      if (dp[i].c == aux.c && dp[i].k == aux.k)
        w[i] = j;
    }
    //dp[i] = cauta(0, i - 1, i, cost);
    /*smn aux = dp[j];
    aux.k++;
    aux.c += sp[j] * j + sp[j] - sp[i] * j - sp[j] * i + sp[i] * i - sp[i] + cost;
    dp[i] = aux;*/
  }
  return dp[n].k;
}

long long solve(long long n, long long k) {
  long long l = 0, r = 10000000000LL;
  long long last;
  while (l <= r) {
    long long mid = (l + r) / 2;
    if (baga(n, mid) <= k) {
      r = mid - 1;
      last = mid;
    } else {
      l = mid + 1;
    }
  }
  baga(n, last);
  return dp[n].c - 1LL * k * last;
}

int main() {
  //freopen("cancer.in", "r", stdin);
  //freopen("cancer.out", "w", stdout);

  long long n, k;
  scanf("%lld%lld", &n, &k);
  for (long long i = 1; i <= n; ++i) {
    scanf("%lld", &a[i]);
    sp[i] = sp[i - 1] + a[i];
  }

  printf("%lld\n", solve(n, k));

  return 0;
}
