#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/detail/standard_policies.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/rope>

using namespace std;
//using namespace __gnu_cxx;
//using namespace __gnu_pbds;
//
//template < typename T > using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define ld long double
#define pb push_back
#define F first
#define S second
#define endl '\n'
#define Endl '\n'
#define pii pair < int, int >
#define TIME clock() / (ld)CLOCKS_PER_SEC

int N, n, m;

const int M = 1000 + 10;

int a[M][M];

int pref[M][M];

int calc(int x1, int y1, int x2, int y2){
    int ans = pref[x1][y1];
    if (y2 - 1 >= 0)ans -= pref[x1][y2 - 1];
    if (x2 - 1 >= 0)ans -= pref[x2 - 1][y1];
    if (y2 - 1 >= 0 && x2 - 1 >= 0)ans += pref[x2 - 1][y2 - 1];
    return ans;
}
vector < pii > all;

const int LOL = 100000 + 10;

vector < vector < int > > t(4 * LOL);

void merg(vector < int >&ans, int v1, int v2){
    int pos_1 = 0;
    int pos_2 = 0;
    while(pos_1 != (int)t[v1].size() || pos_2 != (int)t[v2].size()){
        if (pos_1 == (int)t[v1].size()){
            ans.pb(t[v2][pos_2]);
            pos_2++;
            continue;
        }
        if (pos_2 == (int)t[v2].size()){
            ans.pb(t[v1][pos_1]);
            pos_1++;
            continue;
        }
        if (t[v1][pos_1] < t[v2][pos_2]){
            ans.pb(t[v1][pos_1]);
            pos_1++;
        }else{
            ans.pb(t[v2][pos_2]);
            pos_2++;
        }
    }
}

void build(int v, int vl, int vr){
    if (vl == vr){
        t[v].pb(all[vl].S);
        return;
    }
    int mid = (vl + vr) >> 1;
    build((v << 1), vl, mid);
    build((v << 1)|1, mid + 1, vr);
    merg(t[v], (v << 1), (v << 1)|1);
}

int go(int v, int vl, int vr, int l, int r, int val){
    if (vl >= l && vr <= r){
        int L = 0, R = (int)t[v].size() - 1;
        int ot = -1;
        while(L <= R){
            int mid = (L + R) >> 1;
            if (t[v][mid] <= val)L = mid + 1, ot = mid;
            else R = mid - 1;
        }
        return ot + 1;
    }
    if (vl > r || vr < l)return 0;
    int mid = (vl + vr) >> 1;
    return go((v << 1), vl, mid, l, r, val) + go((v << 1)|1, mid + 1, vr, l, r, val);
}

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL

    bool fl = 0;

    cin >> N >> n >> m;
    for (int i = 0;i < N; ++i){
        int x, y;
        cin >> x >> y;
        all.pb({x, y});
        if (x >= M || y >= M)fl = 1;
        else a[x][y]++;
    }
    if (!fl){
        for (int i = 0;i < M; ++i){
            if (!i)pref[0][i] = a[0][i];
            else pref[0][i] = pref[0][i - 1] + a[0][i];
        }
        for (int i = 0;i < M; ++i){
            if (!i)pref[i][0] = a[i][0];
            else pref[i][0] = pref[i - 1][0] + a[i][0];
        }
        for (int i = 1;i < M; ++i){
            for (int j = 1;j < M; ++j){
                pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];
            }
        }
        int ans = 0;
        for (int i = 0;i < M; ++i){
            for (int j = 0;j < M; ++j){
                if ((i - n) >= 0 && (j - m) >= 0){
                    ans = max(ans, calc(i, j, i - n, j - m));
                }
            }
        }
        cout << ans << endl;
        return 0;
    }
    sort(all.begin(), all.end());
    build(1, 0, N - 1);

    if (N > 1000){
        int ans = 0;
        for (int i = 0;i < N; ++i){

            int l = 0, r = i;
            int ot = i;
            while(l <= r){
                int mid = (l + r) >> 1;
                if (all[i].F - all[mid].F <= n)r = mid - 1, ot = mid;
                else l = mid + 1;
            }
            int max_left = all[i].S - m;
            int max_right = all[i].S;
            int tech = go(1, 0, N - 1, ot, i, max_right) - go(1, 0, N - 1, ot, i, max_left - 1);
            ans = max(ans, tech);
        }
        cout << ans << endl;
        return 0;
    }

    int ans = 0;
    for (int i = 0;i < N; ++i){
        int l = 0, r = i;
        int ot = i;
        while(l <= r){
            int mid = (l + r) >> 1;
            if (all[i].F - all[mid].F <= n)r = mid - 1, ot = mid;
            else l = mid + 1;
        }

        for (int j = ot;j <= i; ++j){
            if (j != ot && all[j].S == all[j - 1].S)continue;
            int max_left = all[j].S - m;
            int max_right = all[j].S;
            int tech = go(1, 0, N - 1, ot, i, max_right) - go(1, 0, N - 1, ot, i, max_left - 1);
            ans = max(ans, tech);
        }
    }
    cout << ans << endl;

    return 0;
}


