#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    vector<int> a(26);
    for(int i = 0; i < 26; i++) {
        string s;
        cin >> s;
        for(char c: s) {
            a[i] |= 1 << (c - 'A');
        }
    }

    vector< pair<int, long long> > curdp;
    curdp.emplace_back(0, 1LL);

    for(int i = 0; i < 26; i++) {
        vector<int> idxfree;
        for(int j = 0, sz = curdp.size(); j < sz; j++) {
            auto pp = curdp[j];
            auto mask = pp.first;
            auto cnt = pp.second;
            int x = a[i] & ~mask;
            idxfree.push_back(j);
            while(x) {
                int bit = x & ~(x - 1);
                if(idxfree.size()) {
                    curdp[idxfree.back()] = {mask | bit, cnt};
                    idxfree.pop_back();
                } else {
                    curdp.emplace_back(mask | bit, cnt);
                }
                x &= x - 1;
            }
        }
        for(int j: idxfree) {
            curdp[j] = {curdp[0].first, 0};
        }
        sort(curdp.begin(), curdp.end());
        pair<int, long long>* ptrto = curdp.data();
        for(auto& p: curdp) {
            auto mask = p.first;
            auto cnt = p.second;
            p.second = 0;
            if(ptrto != curdp.data() && (ptrto - 1)->first == mask) {
                (ptrto - 1)->second += cnt;
            } else {
                ptrto->first = mask;
                ptrto->second = cnt;
                ptrto++;
            }
        }
        curdp.resize(ptrto - curdp.data());
    }

    cout << (curdp.size() > 0 && curdp.back().first == ((1 << 26) - 1) ? curdp.back().second : 0) << endl;

    return 0;
}
