// #define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

// ABCDE BCDEF CDEFG DEFGH EFGHI FGHIJ GHIJK HIJKL IJKLM JKLMN KLMNO LMNOP MNOPQ NOPQR OPQRS PQRST QRSTU RSTUV STUVW TUVWX UVWXY VWXYZ WXYZA XYZAB YZABC ZABCD

#pragma pack(1)
struct small_pair {
    int first;
    long long second;
    small_pair(): first(0), second(0LL) {}
    small_pair(int first, long long second): first(first), second(second) {
    }
    bool operator<(const small_pair& other) const {
        return first < other.first;
    }
};

using namespace std;

long long solve(vector<int> a) {
    vector<small_pair> curdp;
    curdp.emplace_back(0, 1LL);

    for(int i = 0; i < 26; i++) {
        vector<int> idxfree;
        for(int j = 0, sz = curdp.size(); j < sz; j++) {
            auto pp = curdp[j];
            auto mask = pp.first;
            auto cnt = pp.second;
            int x = a[i] & ~mask;
            idxfree.push_back(j);
            while(x) {
                int bit = x & ~(x - 1);
                if(idxfree.size()) {
                    curdp[idxfree.back()] = {mask | bit, cnt};
                    idxfree.pop_back();
                } else {
                    curdp.emplace_back(mask | bit, cnt);
                }
                x &= x - 1;
            }
        }
        for(int j: idxfree) {
            curdp[j] = {0, 0};
        }
        cerr << curdp.capacity() * 8 * 2 / 1024 << endl;
        sort(curdp.begin(), curdp.end());
        small_pair* ptrto = curdp.data();
        for(auto& p: curdp) {
            auto mask = p.first;
            auto cnt = p.second;
            p.second = 0;
            if(cnt == 0) {
                continue;
            }
            if(ptrto != curdp.data() && (ptrto - 1)->first == mask) {
                (ptrto - 1)->second += cnt;
            } else {
                ptrto->first = mask;
                ptrto->second = cnt;
                ptrto++;
            }
        }
        curdp.resize(ptrto - curdp.data());
        curdp.shrink_to_fit();
    }

    return (curdp.size() > 0 && curdp.back().first == ((1 << 26) - 1) ? curdp.back().second : 0);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    vector<int> a(26);
    for(int i = 0; i < 26; i++) {
        string s;
        cin >> s;
        for(char c: s) {
            a[i] |= 1 << (c - 'A');
        }
    }

    cout << solve(a) << endl;

    return 0;
}
