#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

// ABCDE BCDEF CDEFG DEFGH EFGHI FGHIJ GHIJK HIJKL IJKLM JKLMN KLMNO LMNOP MNOPQ NOPQR OPQRS PQRST QRSTU RSTUV STUVW TUVWX UVWXY VWXYZ WXYZA XYZAB YZABC ZABCD

using namespace std;

#define NEXTMASK(x) ({ \
    int _mask = (x); \
    int _mask1 = (_mask | (_mask - 1)) + 1; \
    while(!(_mask & 1)) { \
        _mask >>= 1; \
    } \
    _mask >>= 1; \
    int _j = 0; \
    while((_mask >> _j) & 1) { \
        _j++; \
    } \
    _mask1 |= (1 << _j) - 1; \
    _mask1; \
})

int docount(int i) {
    long long x = 1;
    int k = min(i, 26 - i);
    for(int j = 26 - k + 1; j <= 26; j++) {
        x *= j;
    }
    for(int j = 1; j <= k; j++) {
        x /= j;
    }
    return x;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int a[26];
    for(int i = 0; i < 26; i++) {
        a[i] = 0;
        string s;
        cin >> s;
        for(char c: s) {
            a[i] |= 1 << (c - 'A');
        }
    }

    int start = clock();
    vector<long long> dp;
    dp.push_back(1);

    for(int i = 0; i < 26; i++) {
        cerr << i << endl;

        vector<long long> next_dp(docount(i + 1));

        int cnt = docount(i);

        int x = a[i];
        while(x) {
            int bit = x & ~(x - 1);

            int mask = (1 << i) - 1;
            int mask1 = (1 << (i + 1)) - 1;
            int k = 0;

            for(int j = 0; j < cnt; j++) {
                if(!(mask & bit)) {
                    while(mask1 != (mask | bit)) {
                        mask1 = NEXTMASK(mask1);
                        k++;
                    }
                    next_dp[k] += dp[j];
                }
                if(j != cnt - 1) {
                    mask = NEXTMASK(mask);
                }
            }
            x &= x - 1;
        }

        dp = next_dp;
    }

    cerr << (double)(clock() - start) / CLOCKS_PER_SEC << endl;
    cout << dp[0] << endl;

    return 0;
}
