#include <bits/stdc++.h>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<long long> pref(n);
    for(int i = 0; i < n; i++) {
        pref[i] = (i == 0 ? 0 : pref[i - 1]) + a[i];
    }

    if(k == 3) {
        long long ans = 1000000000000000000LL;
        for(int i = 0; i < n; i++) {
            int l = i + 1;
            int r = n - 1;
            while(r - l > 100) {
                int m1 = (2 * l + r) / 3;
                int m2 = (l + 2 * r) / 3;
                long long cur1 = (
                    (pref[m1] - pref[i]) * (m1 - i - 1) + (pref.back() - pref[m1]) * (n - 1 - m1 - 1)
                );
                long long cur2 = (
                    (pref[m2] - pref[i]) * (m2 - i - 1) + (pref.back() - pref[m2]) * (n - 1 - m2 - 1)
                );
                if(cur1 > cur2) {
                    l = m1;
                } else {
                    r = m2;
                }
            }
            long long tmp = 1000000000000000000LL;
            for(int j = l; j <= r; j++) {
                long long cur = (
                    (pref[j] - pref[i]) * (j - i - 1) + (pref.back() - pref[j]) * (n - 1 - j - 1)
                );
                tmp = min(tmp, cur);
            }
            ans = min(ans, pref[i] * i + tmp);
        }
        cout << ans << endl;
        return 0;
    }

    vector< vector<long long> > dp(n, vector<long long>(k + 1, 1000000000000000LL));
    vector<int> i1point(k + 1, -1);
    for(int i = 0; i < n; i++) {
        vector<int> nexti1point(k + 1, -1);
        for(int j = k; j >= 1; j--) {
            for(int i1 = (i == 0 ? -1 : i1point[j]); i1 <= (j == k ? i - 1 : nexti1point[j + 1]); i1++) {
                long long cur = (i1 == -1 ? 0 : dp[i1][j - 1] + pref[i1] * i1) - (i1 == -1 ? 0 : pref[i1]) * i - pref[i] * i1;
                if(cur < dp[i][j]) {
                    dp[i][j] = cur;
                    nexti1point[j] = i1;
                }
            }
            dp[i][j] += pref[i] * i;
        }
        i1point = nexti1point;
    }

    cout << dp[n - 1][k] - pref.back() << endl;
    return 0;
}

/*
10 5
48297 29989 7188 871 4296 8708 12788 62159 34365 83386
*/
