#include <bits/stdc++.h>

using namespace std;

class SegmentTree {
public:
    vector<int> a;
    vector<int> mod;
    int n;
};


int h;
multimap<int, int> length_by_y;

void add_point(int y) {
    auto it_end = length_by_y.upper_bound(y);
    for(auto it = length_by_y.lower_bound(y - h); it != it_end; ++it) {
        it->second++;
    }
    int cnt = distance(length_by_y.lower_bound(y), it_end) + 1;
    length_by_y.emplace(y, cnt);
}

void remove_point(int y) {
    auto it_end = length_by_y.upper_bound(y);
    for(auto it = length_by_y.lower_bound(y - h); it != it_end; ++it) {
        it->second--;
    }
    length_by_y.erase(length_by_y.find(y));
}

int get_value() {
    int ans = 0;
    for(auto p: length_by_y) {
        ans = max(ans, p.second);
    }
    /*
    for(int j1 = 0; j1 < yy.size(); j1++) {
        while(yy[j1] - yy[i1] > h) {
            i1++;
        }
        ans = max(ans, j1 - i1 + 1);
    }
    */
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    int w;
    cin >> w >> h;

    vector< pair<int, int> > points;
    for(int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        points.emplace_back(x, y);
    }
    sort(points.begin(), points.end());

    int i = 0;
    int ans = 0;
    for(int j = 0; j < points.size(); j++) {
        add_point(points[j].second);
        while(points[j].first - points[i].first > w) {
            remove_point(points[i].second);
            i++;
        }
        ans = max(ans, get_value());
    }
    cout << ans << endl;

    return 0;
}
