#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

const int maxN = 100005;
const int smallN = 6003;
int N, K;
int A[maxN];
ll S[maxN];
ll dp[2][smallN];

ll sg(int l, int r)
{
    return (S[r] - S[l - 1]) * (r - l);
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> N >> K;
    for (int i = 1; i <= N; ++i)
    {
        cin >> A[i];
        S[i] = A[i] + S[i - 1];
    }
    if (N <= 6000)
    {
        memset(dp, 0x20, sizeof dp);
        for (int i = 1; i <= N; ++i)
            dp[1][i] = S[i] * (ll)(i - 1);
        for (int k = 2; k <= K; ++k)
        {
            memset(dp[k & 1], 0x20, sizeof dp[k & 1]);
            int ptr = k - 1;
            for (int i = k; i <= N; ++i)
            {
                function< ll(int) > f = [&](int j) -> ll
                {
                    return dp[~k & 1][j] + (S[i] - S[j]) * (ll)(i - j - 1);
                };
                /*while (ptr + 1 < i && f(ptr + 1) < f(ptr))
                    ++ptr;
                dp[k & 1][i] = f(ptr);*/
                /*int vl = k - 2;
                int vr = i - 1;
                while (vr - vl > 1)
                {
                    int vm = (vl + vr) >> 1;
                    if (f(vm + 1) >= f(vm))
                        vr = vm;
                    else
                        vl = vm;
                }
                dp[k & 1][i] = f(vl + 1);*/
                for (int j = k - 1; j < i; ++j)
                    chkmin(dp[k & 1][i], f(j));
            }
            for (int i = k; i <= N; ++i)
            {
//                debug(k, i, dp[k & 1][i], dp[k & 1][i + 1] - dp[k & 1][i]);
            }
        }
        cout << dp[K & 1][N] << '\n';
        return 0;
    }
    if (K == 3)
    {
        ll ans = 1e18;
        for (int s = 2; s < N; ++s)
        {
            auto f = [&](int t) -> ll
            {
//                return sg(1, s - 1) + sg(s, t - 1) + sg(t, N);
                return S[s - 1] * (s - 2) + (S[t - 1] - S[s - 1]) * (t - s - 1) + (S[N] - S[t - 1]) * (N - t);
            };
            int vl = s + 1;
            int vr = N - 1;
            while (vr - vl > 1)
            {
                int vm = (vl + vr) >> 1;
                if (f(vm + 1) <= f(vm))
                    vl = vm;
                else
                    vr = vm;
            }
            chkmin(ans, f(vr));
        }
        cout << ans << '\n';
    }
    

    return 0;
}