#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

const int maxN = 100005;
int P[maxN][2];
int re[2][maxN], sz[2];
int Left[maxN];
map<int, int> co[2];

namespace sgt
{
    int mx[4 * maxN];
    int down[4 * maxN];

    inline void apply(int v, int d)
    {
        mx[v] += d;
        down[v] += d;
    }

    void push(int v, int vl, int vr)
    {
        if (vl == vr || !down[v]) return;
        apply(v << 1, down[v]);
        apply(v << 1 | 1, down[v]);
        down[v] = 0;
    }

    void upd(int v, int vl, int vr)
    {
        if (vl != vr)
        {
            mx[v] = max(mx[v << 1], mx[v << 1 | 1]);
        }
    }

    void mdf(int v, int vl, int vr, int l, int r, int d)
    {
        if (l > r || r < vl || vr < l) return;
        if (l <= vl && vr <= r)
        {
            apply(v, d);
            return;
        }
        int vm = (vl + vr) >> 1;
        push(v, vl, vr);
        mdf(v << 1, vl, vm, l, r, d);
        mdf(v << 1 | 1, vm + 1, vr, l, r, d);
        upd(v, vl, vr);
    }

    int gt()
    {
        return mx[1];
    }
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int N, W, H;
    cin >> N >> W >> H;
    for (int i = 0; i < N; ++i)
    {
        int x, y;
        cin >> x >> y;
        P[i][0] = x;
        P[i][1] = y;
        re[0][sz[0]++] = x;
        re[1][sz[1]++] = y;
    }
    for (int ax = 0; ax < 2; ++ax)
    {
        sort(re[ax], re[ax] + sz[ax]);
        sz[ax] = unique(re[ax], re[ax] + sz[ax]) - re[ax];
        for (int i = 0; i < sz[ax]; ++i)
            co[ax].insert(mp(re[ax][i], i));
    }
    {
        int ptr = 0;
        for (int y = 1; y < sz[1]; ++y)
        {
            while (re[1][y] - re[1][ptr] > H)
                ++ptr;
            Left[y] = ptr;
        }
    }
    vector<int> ord(N);
    iota(all(ord), 0);
    sort(all(ord), [&](int i, int j) -> bool { return P[i][0] < P[j][0]; });
    int ptr = 0;
    int ans = 0;
    for (int i = 0; i < N; )
    {
        while (ptr < N && P[ord[ptr]][0] - P[ord[i]][0] <= W)
        {
            int k = ord[ptr++];
            int cy = co[1][P[k][1]];
            sgt::mdf(1, 0, sz[1] - 1, Left[cy], cy, 1);
        }

        chkmax(ans, sgt::gt());
        
        int j = i;
        while (j < N && P[ord[j]][0] == P[ord[i]][0])
            ++j;
        for (int u = i; u < j; ++u)
        {
            int k = ord[u];
            int cy = co[1][P[k][1]];
            sgt::mdf(1, 0, sz[1] - 1, Left[cy], cy, -1);
        }
        i = j;
    }
    cout << ans << '\n';

    return 0;
}