#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <queue>

#define ll long long
#define vll vector<ll>
#define vvll vector<vll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define big (ll)1000000000000000
#define mod (ll)1000000007

using namespace std;

ll n, w, h;
vpll arr;
ll ans;
void print_vll(vll& arr, const string name)
{
	cout << name << ": " << endl;
	for (ll i = 0; i < arr.size(); i++)
	{
		cout << arr[i] << " ";
	}
	cout << endl;
}


void solve()
{
	ll xmax = 0, ymax = 0;
	for (ll i = 0; i < n; i++)
	{
		xmax = max(xmax, arr[i].first);
		ymax = max(ymax, arr[i].second);
	}
	//xmax++; ymax++;
	vvll board(xmax+h+1, vll(ymax+w+1, 0));
	for (ll i = 0; i < n; i++)
	{
		board[arr[i].first][arr[i].second]++;
	}
	for (ll x = 0; x <= xmax; x++)
	{
		for (ll y = 0; y <= ymax; y++)
		{
			ll curans = 0;
			for (ll row = x; row <= x + h; row++)
			{
				for (ll k = y; k <= y + w; k++)
				{
					curans += board[row][k];
				}
			}
			ans = max(ans, curans);
		}
	}
	cout << ans << endl;
}
int main()
{
	cin >> n >> w >> h;
	arr.resize(n);
	for (ll i = 0; i < n; i++)
	{
		cin >> arr[i].first >> arr[i].second;
		arr[i].first--; arr[i].second--;
	}

	ans = 0;
	solve();
}