#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <queue>

#define ll long long
#define vll vector<ll>
#define vvll vector<vll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define big (ll)1000000000000000
#define mod (ll)1000000007

using namespace std;

ll n, w, h;
vpll arr;
ll ans;
void print_vll(vll& arr, const string name)
{
	cout << name << ": " << endl;
	for (ll i = 0; i < arr.size(); i++)
	{
		cout << arr[i] << " ";
	}
	cout << endl;
}


void solve()
{
	ll xmax = 0, ymax = 0;
	for (ll i = 0; i < n; i++)
	{
		xmax = max(xmax, arr[i].first);
		ymax = max(ymax, arr[i].second);
	}
	//xmax++; ymax++;
	vvll board(xmax+h+1, vll(ymax+w+1, 0));
	for (ll i = 0; i < n; i++)
	{
		board[arr[i].first][arr[i].second]++;
	}
	for (ll x = 0; x <= xmax; x++)
	{
		for (ll y = 0; y <= ymax; y++)
		{
			//cout << "x: " << x << " y: " << y << endl;
			ll curans = 0;
			for (ll row = x; row <= x + h; row++)
			{
				for (ll col = y; col <= y + w; col++)
				{
					if (row < 0 || col < 0) continue;
					curans += board[row][col];
				}
			}
			//cout << "curans: " << curans << endl;
			ans = max(ans, curans);
		}
	}
	cout << ans << endl;
}


void solve2()
{
	ll MX = 100;
	for (ll x = 0; x < MX; x++)
	{
		for (ll y = 0; y < MX; y++)
		{
			ll curans = 0;
			for (ll i = 0; i < n; i++)
			{
				if (arr[i].first < x || arr[i].first > x + w) continue;
				if (arr[i].second < y || arr[i].second > y + h) continue;
				curans++;
			}
			ans = max(ans, curans);
		}
	}
	//cout << "ans: " << endl;
	cout << ans << endl;
}

void solve4()
{
	ll tans = 0;
	ll mx = 1020;
	vvll mp(mx, vll(mx, 0));
	for (ll i = 0; i < n; i++)
	{
		ll curx = arr[i].first;
		ll cury = arr[i].second;
		mp[curx][cury]++;
	}
	vvll bsum(mx, vll(mx, 0));
	for (ll i = 0; i < mx; i++)
	{
		for (ll j = 0; j < mx; j++)
		{
			//cout << "i: " << i << " j: " << j << endl;
			ll thisplace = mp[i][j];
			//cout << "thisplace: " << thisplace << endl;
			if (i == 0 && j == 0)
			{
				bsum[i][j] = thisplace;
			}
			else if (i == 0)
			{
				bsum[i][j] = thisplace + bsum[i][j - 1];
			}
			else if (j == 0)
			{
				bsum[i][j] = thisplace + bsum[i - 1][j];
			}
			else
			{
				bsum[i][j] = thisplace + bsum[i - 1][j] + bsum[i][j - 1] - bsum[i - 1][j - 1];
			}
			//cout << "cur bsum: " << bsum[i][j] << endl;
		}
	}
	/*
	for (ll i = 0; i < mx; i++)
	{
		for (ll j = 0; j < mx; j++)
		{
			cout << "i: " << i << " j: " << j << endl;
			cout << bsum[i][j] << endl;
		}
	}
	*/

	for (ll i = 0; i < n; i++)
	{
		ll curx = arr[i].first;
		ll cury = arr[i].second;
		ll x = max(curx - w, (ll)1);
		ll y = max(cury - h, (ll)1);
		//cout << "curx: " << curx << " cury: " << cury << endl;
		//cout << "x: " << x << " y: " << y << endl;
		ll curans = bsum[curx][cury] - bsum[curx][y-1] - bsum[x-1][cury] + bsum[x-1][y-1];
		//cout << "curans: " << curans << endl;
		tans = max(tans, curans);
	}
	cout << tans << endl;

}
int main()
{
	
	cin >> n >> w >> h;
	arr.resize(n);
	for (ll i = 0; i < n; i++)
	{
		cin >> arr[i].first >> arr[i].second;
		//arr[i].first += 1001; arr[i].second += 1001;
	}

	ans = 0;
	solve4();
	


	/*
	cout << "hi" << endl;
	ll x = 0;
	for (ll i = 0; i < 1000000000; i++)
	{
		x++;
	}
	cout << "hi" << endl;
	*/
}


/*

8 2 3
1 1
1 1
3 1
2 2
3 3
5 3
3 5
10 10



2 1 1
1 1
1 2



*/