﻿//#pragma GCC optimize("Ofast,unroll-loops")

/*
#ifdef LOCAL
#include "headers.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#endif
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>
#include <map>

using namespace std;
 
//#define int ll
 
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
#define sz(x) int((x).size())


/*
template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
*/
 
const int N = 1e5 + 10;
//const ll MOD = 998244353;
const ll MOD = 1e9 + 7;
const ld eps = 5e-8;
const pii dir[] = { { 0, 1 }, { 0, -1 }, { 1, 0 }, { -1, 0 } };

vector <int> a[26];
int cur;
unsigned short s[1 << 26];
char used[26];
ll ans;

void solve1(int i) {
    if (i == 13) {
        s[cur]++;
    }
    else {
        for (int x : a[i]) {
            if (!used[x]) {
                used[x] = 1;
                cur ^= (1 << x);

                solve1(i + 1);

                cur ^= (1 << x);
                used[x] = 0;
            }
        }
    }
}

void solve2(int i) {
    if (i == 26) {
        ans += s[((1 << 26) - 1) ^ cur];
    }
    else {
        for (int x : a[i]) {
            if (!used[x]) {
                used[x] = 1;
                cur ^= (1 << x);

                solve2(i + 1);

                cur ^= (1 << x);
                used[x] = 0;
            }
        }
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    for (int i = 0; i < 26; i++) {
        string s;
        cin >> s;

        sort(s.begin(), s.end());
        s.erase(unique(s.begin(), s.end()), s.end());

        for (char c : s) {
            a[i].push_back(c - 'A');
        }
    }

    solve1(0);

    memset(used, 0, sizeof used);
    cur = 0;

    solve2(13);

    cout << ans << endl;

    return 0;
}
