﻿//#pragma GCC optimize("Ofast,unroll-loops")

#ifdef LOCAL
#include "headers.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#endif
 
using namespace std;
 
#define int ll
 
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
#define sz(x) int((x).size())

template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef ONLINE_JUDGE
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(1000 - 7);
#endif
 
const int N = 3e2 + 10;
//const ll MOD = 998244353;
const ll MOD = 1e9 + 7;
const ld eps = 5e-8;
const pii dir[] = { { 0, 1 }, { 0, -1 }, { 1, 0 }, { -1, 0 } };

int n, k, a[N], p[N], dp[N][N], opt[N][N];

inline int cost(int l, int r) {
    return (r - l) * (p[r + 1] - p[l]);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    } 

    for (int i = 0; i < n; i++) {
        p[i + 1] = p[i] + a[i];
    }

    fill(&dp[0][0], &dp[N - 1][N - 1] + 1, 1e18);
    fill(&opt[0][0], &opt[N - 1][N - 1] + 1, n + 1);
    dp[0][0] = 0;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= k; j++) {
            for (int k = 0; k < i; k++) {
                if (dp[i][j] > dp[k][j - 1] + cost(k, i - 1)) {
                    dp[i][j] = dp[k][j - 1] + cost(k, i - 1);
                    opt[i][j] = k;
                }
            }
        }
    }

    /*
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= k; j++) {
            cout << opt[i][j] << " ";
        }
        cout << endl;
    }
    */

    cout << dp[n][k] << endl;

    return 0;
}
