#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e5) + 5;
const ll inf = ll(1e17) + 123;

ll n, k;
vector<ll> a;

void solve() {
    cin >> n >> k;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        a.pb(cur);
    }

    ll dp[n + 1][k + 1];
    for(ll i = 0; i < n + 1; i++) {
        for(ll j = 0; j < k + 1; j++) {
            dp[i][j] = inf;
        }
    }
    dp[0][0] = 0;

    for(ll i = 0; i < n; i++) {
        for(ll j = 0; j < k; j++) {
            ll mus = 0;
            for(ll c = i; c < n; c++) {
                mus += a[c];
                dp[c + 1][j + 1] = min(dp[c + 1][j + 1], dp[i][j] + mus * (c - i));
            }
        }
    }
    cout << dp[n][k] << endl;
}


int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
