#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e5) + 5;
const ll inf = ll(1e17) + 123;

ll n, k;
vector<ll> a;
vector<ll> pref(1, 0);

void solve() {
    cin >> n >> k;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        a.pb(cur);
    }
    for(ll i = 0; i < n; i++) {
        pref.pb(pref.back() + a[i]);
    }

    if(k == 3) {
        ll ans = inf;
        for(ll i = 0; i < n - 2; i++) {
            ll cur = pref[i + 1] * i;
            ll l = i + 1, r = n - 2;
            while(r - l > 1) {
                ll mid = (l + r) / 2;
                ll val1 = (pref[mid + 1] - pref[i + 1]) * (mid - i - 1);
                ll val2 = (pref[n] - pref[mid + 1]) * (n - mid - 2);
                if(val1 < val2) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            cur += min((pref[r + 1] - pref[i + 1]) * (r - i - 1) + (pref[n] - pref[r + 1]) * (n - r - 2),
                       (pref[l + 1] - pref[i + 1]) * (l - i - 1) + (pref[n] - pref[l + 1]) * (n - l - 2));

            ans = min(ans, cur);
        }
        cout << ans;
        return;
    }

    ll dp[n + 1][k + 1];
    for(ll i = 0; i < n + 1; i++) {
        for(ll j = 0; j < k + 1; j++) {
            dp[i][j] = inf;
        }
    }
    dp[0][0] = 0;

    for(ll i = 0; i < n; i++) {
        for(ll j = 0; j < k; j++) {
            ll mus = 0;
            for(ll c = i; c < n; c++) {
                mus += a[c];
                dp[c + 1][j + 1] = min(dp[c + 1][j + 1], dp[i][j] + mus * (c - i));
            }
        }
    }
    cout << dp[n][k] << endl;
}


int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
