#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e5) + 5;
const ll inf = ll(1e17) + 123;

ll n, k;
vector<ll> a;
vector<ll> pref(1, 0);

ll get_3_ans(ll i, ll pos) {
    return (pref[pos + 1] - pref[i + 1]) * (pos - i - 1) + (pref[n] - pref[pos + 1]) * (n - pos - 2);
}

void solve() {
    cin >> n >> k;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        a.pb(cur);
    }
    for(ll i = 0; i < n; i++) {
        pref.pb(pref.back() + a[i]);
    }

    if(k == 3) {
        ll ans = inf;
        for(ll i = 0; i < n - 2; i++) {
            ll cur = pref[i + 1] * i;
            ll l = i + 1, r = n - 2;
            while(r - l > 2) {
                ll part = (r - l) / 3;
                ll uk1 = l + part;
                ll uk2 = r - part;
                ll first = get_3_ans(i, uk1);
                ll sec = get_3_ans(i, uk2);
                if(first > sec) {
                    l = uk1;
                } else {
                    r = uk2;
                }
            }
            ll tmp = inf;
            for(ll j = l; j <= r; j++) {
                tmp = min(tmp, get_3_ans(i, j));
            }
            cur += tmp;

            ans = min(ans, cur);
        }
        cout << ans;
        return;
    }

    ll dp[n + 1][k + 1];
    for(ll i = 0; i < n + 1; i++) {
        for(ll j = 0; j < k + 1; j++) {
            dp[i][j] = inf;
        }
    }
    dp[0][0] = 0;

    for(ll i = 0; i < n; i++) {
        for(ll j = 0; j < k; j++) {
            ll mus = 0;
            for(ll c = i; c < n; c++) {
                mus += a[c];
                dp[c + 1][j + 1] = min(dp[c + 1][j + 1], dp[i][j] + mus * (c - i));
            }
        }
    }
    cout << dp[n][k] << endl;
}


int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
