#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e3) + 2;
const ll inf = ll(1e17) + 123;

ll n, w, h;
vector<pll> ps;

void solve() {
    cin >> n >> w >> h;
    for(ll i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        ps.pb({x, y});
    }

    ll ans = 0;

    if(n > ll(1e3)) {
        ll pref[maxn][maxn];
        for(ll i = 0; i < maxn; i++) {
            for(ll j = 0; j < maxn; j++) {
                pref[i][j] = 0;
            }
        }
        for(ll i = 0; i < n; i++) {
            pref[ps[i].first][ps[i].second]++;
        }
        for(ll i = 1; i < maxn; i++) {
            for(ll j = 1; j < maxn; j++) {
                pref[i][j] = (pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1]) + pref[i][j];
            }
        }

        for(ll i = w + 1; i < maxn; i++) {
            for(ll j = h + 1; j < maxn; j++) {
                ll cur = pref[i][j] - pref[i - w - 1][j] - pref[i][j - h - 1] + pref[i - w - 1][j - h - 1];
                ans = max(ans, cur);
            }
        }
        cout << ans;
        return;
    }

    sort(ps.begin(), ps.end());

    for(ll i = 0; i < n; i++) {
        vector<pll> cur;
        for(ll j = i; j < n; j++) {
            if(ps[j].first - ps[i].first > w) {
                break;
            }
            cur.pb({ps[j].second, ps[j].first});
        }
        sort(cur.begin(), cur.end());

        ll l = 0, r = 0;
        while(l < cur.size()) {
            while(r < cur.size() && cur[r].first - cur[l].first <= h) {
                r++;
            }
            ans = max(ans, r - l);
            l++;
        }
    }
    cout << ans;
}


int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
