#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second
#define all(x) (x).begin() , (x).end()
#define rall(x) (x).rbegin() , (x).rend()
#define pb push_back
#define len(x) (int)(x).size()
#define mkp make_pair
#define fast_io ios_base::sync_with_stdio(0) , cin.tie(0) , cout.tie(0)

using namespace __gnu_pbds;
using namespace std;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef double ld;

int w , h;

const int N = 3e5 + 10;
struct node{
    int push;
    int mx;
    node(){push = 0 ; mx = 0;}
};
node seg[4*N];
void push(int v){
    if(seg[v].push != 0){
        int v1 = v << 1;
        for(auto u : {v1 , v1|1})
            seg[u].push += seg[v].push , seg[u].mx += seg[v].push;
        seg[v].push = 0;
    }
}
void pull(int v){
    int v1 = v << 1;
    seg[v].mx = max(seg[v1].mx , seg[v1|1].mx);
}
void add_on_line(int v , int tl , int tr , int l , int r , int val){
    if(tl ==  l  && tr == r){
        seg[v].mx += val;
        seg[v].push += val;
        return;
    }
    push(v);
    int v1 = v << 1 , mid = (tl + tr) >> 1;
    if(l <= mid)
        add_on_line(v1 , tl  ,mid , l , min(r , mid) , val);
    if(r > mid)
        add_on_line(v1|1 , mid + 1 , tr , max(l , mid+1) , r , val);
    pull(v);
}
vector < int > zipka;
void add_dot(int y , int val){
    /// leftmost is [y-h , y]

    int l = y - h , r = y;
    l = lower_bound(all(zipka) , l) - zipka.begin()+1;
    r = lower_bound(all(zipka) , r) - zipka.begin()+1;


    add_on_line(1 , 1 , N , l , r, val);
}

signed main()
{
    int n;
    cin >> n >> w >> h;
    vector < pair < int , int > > dots(n);
    for(auto &i : dots)
        cin >> i.fi >> i.se , zipka.pb(i.se) , zipka.pb(i.se - h);
    sort(all(zipka));
    sort(all(dots));
    vector < int > x;
    for(auto &i : dots)
        x.pb(i.fi);
    x.erase(unique(all(x)) , x.end());
    add_dot(dots[0].se , +1);
//
//    cout << "woo\n";
//    return 0;
    int l = 0 , r = 0;
    int answer = 0;
    for(auto X : x){
        while(l < len(dots) && dots[l].fi < X)
            add_dot(dots[l].se , -1) , ++l;
        while(r+1 < len(dots) && dots[r+1].fi <= X + w)
            add_dot(dots[r+1].se , +1) , ++r;

//        cout << X << ' ' << seg[1].mx << endl;
        answer = max(answer , seg[1].mx);
    }
    cout << answer;
    return 0;
}
