#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>

#define ll long long

using namespace std;

vector<set<char>> names;
unordered_map<int,ll> dp;

ll calc(int k, int i)
{
    // if(dp.find(k) != dp.end())
    //     return dp[k];   
    if(k == 0)
        return 1;
    
    ll res = 0;
    for(char c:names[i])
        if((1<<(c-'A'))&k)
        {
            res += calc(k^(1<<(c-'A')), i+1);
        }
    
    // dp[k] = res;
    return res;
}

int main()
{
    names = vector<set<char>>(26);
    for(int i=0; i<26; i++)
    {
        string str;
        cin>>str;
        for(char c:str)
            names[i].insert(c);
    }
    cout<<calc((1<<26) - 1, 0)<<endl;
}