#include <algorithm>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <vector>
using namespace std;
#define all(x) begin(x), end(x)
#define allr(x) rbegin(x), rend(x)
typedef long long ll;

static constexpr ll mod = 1'000'000'007ll;
static constexpr int INF = 1'000'000'000ll;

int main() {
  int n, w, h;
  cin >> n >> w >> h;
  map<int, vector<int>> mx;
  int minx = INF, maxx = 0, miny = INF, maxy = 0;
  for (int ni = 0; ni < n; ni++) {
    int x, y;
    cin >> x >> y;
    mx[x].push_back(y);
    minx = min(x, minx);
    miny = min(y, miny);
    maxx = max(maxx, x);
    maxy = max(y, maxy);
  }
  for (auto& p : mx) sort(all(p.second));

  int ans = 0;
  for (int x = minx; x <= maxx; x++) {
    auto it1 = mx.lower_bound(x);
    if (it1 == mx.end()) continue;
    auto it2 = mx.lower_bound(x + w);
    if (it2 != mx.end() && it2->first > (x + w)) {
      advance(it2, -1);
    }

    for (int y = miny; y <= maxy; y++) {
      int lol = 0;
      auto it = it1;
      do {
        if (it == end(mx)) break;

        auto it3 = lower_bound(all(it->second), y);
        if (it3 == end(it->second)) continue;

        auto it4 = lower_bound(all(it->second), y + h);
        if (it4 == end(it->second)) {
          lol += distance(it3, it4);
        } else {
          if (*it4 > y + h) {
            lol += distance(it3, it4);
          } else
            lol += distance(it3, it4) + 1;
        }

      } while (it++ != it2);
      ans = max(ans, lol);
    }
  }
  cout << ans << endl;

  return 0;
}
