#include <bits/stdc++.h>

#define int long long
#define vec vector
#define pb push_back
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sq(x) (x)*(x)
#define fast_io ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

using namespace std;
typedef pair<int,int> PII;
typedef long double ld;
const int R = 1e8+1;
struct ver{
    int sum = 0;
    ver *l = nullptr;
    ver *r = nullptr;
};
bool per(int l, int r, int tl, int tr){
    if((l <= tl && tl <= r) || (l <= tr && tr <= r) || (tl <= l && r <= tr)) return true;
    return false;
}
int get(ver* v, int tl, int tr, int l, int r){
    if(v == nullptr) return 0;
    if(l <= tl && tr <= r) return v->sum;
    int t = (tl+tr)/2;
    int one = 0;
    int two = 0;
    if(per(l, r, tl, t)) one = get(v->l, tl, t, l, r);
    if(per(l, r, t+1, tr)) two = get(v->r, t+1, tr, l, r);
    return one+two;
}
//int zap(ver* v){
//    if(v == nullptr) return 0;
//    cout << "pl";
//    return v->sum;
//}
void add(ver* &v, int tl, int tr, int in){
    if(v == nullptr) v = new ver;
    if(tl == tr){
        v->sum++;
        return;
    }
    int t = (tl+tr)/2;
    if(in <= t) add(v->l, tl, t, in);
    else add(v->r, t+1, tr, in);
    v->sum++;
}
void del(ver* &v, int tl, int tr, int in){
    if(v == nullptr) v = new ver;
    if(tl == tr){
        v->sum--;
//        cout << tl << " " << tr << " " << v->sum << "(sum)\n";
        return;
    }
    int t = (tl+tr)/2;
    if(in <= t) del(v->l, tl, t, in);
    else del(v->r, t+1, tr, in);
    v->sum--;
}
ver* root;
signed main()
{
//    fast_io;
    root = new ver;
    int n, w, h;
    cin >> n >> w >> h;
    vec < PII > q(n);
    map < int, set < int > > used;
    for(auto &i: q) cin >> i.fi >> i.se, used[i.fi].insert(i.se);
    sort(all(q));
    int last = 0;
    int in = 0;
    int ans = 0;
    for(auto &i: used){
        while(last < n && q[last].fi <= i.fi+w)
            add(root, 0, R, q[last].se), last++;
        for(auto &j: i.se){
            ans = max(ans, get(root, 0, R, j, j+h));
        }
        while(in < n && q[in].fi == i.fi){
            del(root, 0, R, q[in].se);
            in++;
        }
    }
    swap(w, h);
    in = 0;
    last = 0;
    for(auto &i: used){
        while(last < n && q[last].fi <= i.fi+w)
            add(root, 0, R, q[last].se), last++;
        for(auto &j: i.se){
            ans = max(ans, get(root, 0, R, j, j+h));
        }
        while(in < n && q[in].fi == i.fi){
            del(root, 0, R, q[in].se);
            in++;
        }
    }
    cout << ans;
    return 0;
}
