#include <bits/stdc++.h>

#define vec vector
#define pb push_back
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sq(x) (x)*(x)
#define fast_io ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

using namespace std;
typedef pair<int,int> PII;
typedef long double ld;
const int R = 1e8;
struct ver{
    int mx = 0;
    int ph = 0;
    ver *l = nullptr;
    ver *r = nullptr;
    int fantom = 0;
};
bool per(int l, int r, int tl, int tr){
    if((l <= tl && tl <= r) || (l <= tr && tr <= r) || (tl <= l && r <= tr)) return true;
    return false;
}
void build(ver* & v, int tl, int tr, int x){
    if(tl == tr) return;
    if(v == nullptr) v = new ver;
    int t = (tl+tr)/2;
    if(x <= t) build(v->l, tl, t, x);
    else build(v->r, t+1, tr, x);
}
void push(ver* &v){
    if(v->ph == 0) return;
    if(v->l != nullptr){
        v->l->mx += v->ph;
        v->l->ph += v->ph;
    }
    if(v->r != nullptr){
        v->r->mx += v->ph;
        v->r->ph += v->ph;
    }
    v->ph = 0;
}
int zap(ver* v){
    if(v == nullptr) return 0;
    return v->mx;
}
void add(ver* &v, int tl, int tr, int l, int r){
    if(l <= tl && tr <= r){
        v->mx++;
        v->ph++;
        return;
    }
    push(v);
    int t = (tl+tr)/2;
    if(per(l, r, tl, t)){
        if(v->l == nullptr){
            v->fantom++, v->mx = max(v->mx, v->fantom);
            return;
        }else add(v->l, tl, t, l, r);
    }
    if(per(l, r, t+1, tr)){
        if(v->r == nullptr){
            v->fantom++, v->mx = max(v->mx, v->fantom);
            return;
        }else add(v->r, t+1, tr, l, r);
    }
    v->mx = max(zap(v->l), zap(v->r));
}
void del(ver* &v, int tl, int tr, int l, int r){
    if(v->l == nullptr){
        v->mx--;
        return;
    }
    if(l <= tl && tr <= r){
        v->mx--;
        v->ph--;
        return;
    }
    push(v);
    int t = (tl+tr)/2;
    if(per(l, r, tl, t)){
        if(v->l == nullptr){
            v->fantom--, v->mx = max(v->mx, v->fantom);
            return;
        }else del(v->l, tl, t, l, r);
    }
    if(per(l, r, t+1, tr)){
        if(v->r == nullptr){
            v->fantom--, v->mx = max(v->mx, v->fantom);
            return;
        }else del(v->r, t+1, tr, l, r);
    }
    v->mx = max(zap(v->l), zap(v->r));
}
ver* root;
signed main()
{
    fast_io;
    root = new ver;
    int n, w, h;
    cin >> n >> w >> h;
    vec < PII > q(n);
    map < int, int > used;
    for(auto &i: q){
        cin >> i.fi >> i.se, used[i.fi]++;
        build(root, 0, R, i.se);
        build(root, 0, R, i.se+h);
    }
    vec < int > dd;
    for(auto &i: used) dd.pb(i.fi);
    sort(all(q));
    int last = 0;
    int in = 0;
    int ans = 0;
    for(auto &i: dd){
        while(last < n && q[last].fi <= i+w){
            add(root, 0, R, q[last].se, q[last].se+h);
            last++;
        }
        ans = max(ans, root->mx);
        while(in < n && q[in].fi == i){
            del(root, 0, R, q[in].se, q[in].se+h);
            in++;
        }
    }
    cout << ans;
    return 0;
}
