#include <bits/stdc++.h>

#define int long long
#define vec vector
#define pb push_back
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sq(x) (x)*(x)
#define fast_io ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

using namespace std;
typedef pair<int,int> PII;
typedef long double ld;
const int R = 2e8+3;
struct ver{
    int mx = 0;
    int ph = 0;
    ver *l = nullptr;
    ver *r = nullptr;
};
bool per(int l, int r, int tl, int tr){
    if((l <= tl && tl <= r) || (l <= tr && tr <= r) || (tl <= l && r <= tr)) return true;
    return false;
}
void push(ver* &v){
    if(v->ph == 0) return;
    if(v->l == nullptr)
        v->l = new ver;
    if(v->r == nullptr)
        v->r = new ver;
    v->l->mx += v->ph;
    v->r->mx += v->ph;
    v->l->ph += v->ph;
    v->r->ph += v->ph;
    v->ph = 0;
}
int get(ver* v, int tl, int tr, int l, int r){
    if(v == nullptr) return 0;
    if(l <= tl && tr <= r) return v->mx;
    push(v);
    int t = (tl+tr)/2;
    int one = 0;
    int two = 0;
    if(per(l, r, tl, t)) one = get(v->l, tl, t, l, r);
    if(per(l, r, t+1, tr)) two = get(v->r, t+1, tr, l, r);
    return max(one,two);
}
int zap(ver* v){
    if(v == nullptr) return 0;
    return v->mx;
}
void add(ver* &v, int tl, int tr, int l, int r){
    if(v == nullptr) v = new ver;
    if(l <= tl && tr <= r){
        v->mx++;
        v->ph++;
        return;
    }
    push(v);
    int t = (tl+tr)/2;
    if(per(l, r, tl, t)) add(v->l, tl, t, l, r);
    if(per(l, r, t+1, tr)) add(v->r, t+1, tr, l, r);
    v->mx = max(zap(v->l), zap(v->r));
}
void del(ver* &v, int tl, int tr, int l, int r){
    if(v == nullptr) v = new ver;
    if(l <= tl && tr <= r){
        v->mx--;
        v->ph--;
        return;
    }
    push(v);
    int t = (tl+tr)/2;
    if(per(l, r, tl, t)) del(v->l, tl, t, l, r);
    if(per(l, r, t+1, tr)) del(v->r, t+1, tr, l, r);
    v->mx = max(zap(v->l), zap(v->r));
}
ver* root;
signed main()
{
    fast_io;
    root = new ver;
    int n, w, h;
    cin >> n >> w >> h;
    vec < int > to(1000, 0);
    vec < PII > q(n);
    map < int, set < int > > used;
    for(auto &i: q) cin >> i.fi >> i.se, used[i.fi].insert(i.se);
    vec < int > dd;
    for(auto &i: used) dd.pb(i.fi);
    sort(all(q));
    int last = 0;
    int in = 0;
    int ans = 0;
    map < int, int > f;
    for(auto &i: q){
        f[i.se]++;
        f[i.se+h]++;
    }
    int tt = 0;
    for(auto &i: f) i.se = tt, tt++;
    for(auto &i: dd){
        while(last < n && q[last].fi <= i+w){
            add(root, 0, R, f[q[last].se], f[q[last].se+h]);
            last++;
        }
        ans = max(ans, root->mx);
        while(in < n && q[in].fi == i){
            del(root, 0, R, f[q[in].se], f[q[in].se+h]);
            in++;
        }

    }
    cout << ans;
    return 0;
}
