#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e18 + 10;
const int MOD = (int)1e9 + 7;

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<int> p(n + 1);
	for (int i = 0; i < n; ++i)
		p[i + 1] = p[i] + a[i];
	vvi dp(k + 1, vi(n + 1, INF));
	dp[0][0] = 0;
	for (int i = 1; i <= k; ++i) {
		for (int j = 0; j <= n; ++j) {
			dp[i][j] = dp[i - 1][j];
			for (int x = 0; x < j; ++x)
				dp[i][j] = min(dp[i][j], dp[i - 1][x] + (p[j] - p[x]) * (j - x - 1));
		}
	}
	cout << dp[k][n];

	return 0;
}