#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e18 + 10;
const int MOD = (int)1e9 + 7;

map<pii, int> dp;

int rec(int n, int k, vi& a, vi& p) {
	if (n == 0)
		return 0;
	if (k == 0)
		return INF;
	if (dp.find({ n, k }) != dp.end())
		return dp[{n, k}];
	int ans = INF;
	for (int i = n - 1; i >= 0; --i)
		ans = min(ans, rec(i, k - 1, a, p) + (p[n] - p[i]) * (n - i - 1));
	dp[{n, k}] = ans;
	return ans;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<int> p(n + 1);
	for (int i = 0; i < n; ++i)
		p[i + 1] = p[i] + a[i];
	cout << rec(n, k, a, p);

	return 0;
}