#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, w, h;
	cin >> n >> w >> h;
	vector<pii> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].first >> a[i].second;
	if (n <= 1000) {
		vi x(n), y(n);
		for (int i = 0; i < n; ++i) {
			x[i] = a[i].first;
			y[i] = a[i].second;
		}
		sort(x.begin(), x.end());
		sort(y.begin(), y.end());
		x.erase(unique(x.begin(), x.end()), x.end());
		y.erase(unique(y.begin(), y.end()), y.end());
		vvi s(x.size() + 1, vi(y.size() + 1));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < x.size(); ++j) {
				if (x[j] == a[i].first) {
					a[i].first = j;
					break;
				}
			}
			for (int j = 0; j < y.size(); ++j) {
				if (y[j] == a[i].second) {
					a[i].second = j;
					break;
				}
			}
		}
		vvi fie(x.size(), vi(y.size()));
		for (int i = 0; i < n; ++i)
			fie[a[i].first][a[i].second] += 1;
		for (int i = 0; i < x.size(); ++i) {
			for (int j = 0; j < y.size(); ++j) {
				s[i + 1][j + 1] = s[i + 1][j] + s[i][j + 1] - s[i][j] + fie[i][j];
			}
		}
		int ans = 0;
		for (int r = 0; r < x.size(); ++r) {
			int l = 0;
			while (x[r] - x[l] > w)
				++l;
			for (int u = 0; u < y.size(); ++u) {
				int d = 0;
				while (y[u] - y[d] > h)
					++d;
				ans = max(ans, s[r + 1][u + 1] - s[r + 1][d] - s[l][u + 1] + s[l][d]);
			}
		}
		cout << ans;
	}

	return 0;
}