#include <bits/stdc++.h>

#define int long long
using namespace std;
const int inf = 1e15;
const int maxn = 1e5;
int a[maxn];

pair<int, int> calc(int n, int x) {
    pair<int, int> dp[n + 1];
    for (int j = 0; j < n + 1; ++j) {
        dp[j] = {inf, 0};
    }
    dp[0] = {0, 0};
    for (int l = 1; l < n + 1; ++l) {
        int sum = 0;
        for (int j = l - 1; j >= 0; --j) {
            sum += a[j];
            if (dp[l].first > dp[j].first + sum * (l - j - 1) + x) {
                dp[l].first = dp[j].first + sum * (l - j - 1) + x;
                dp[l].second = dp[j].second + 1;
            }
        }
    }
    return dp[n];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int l = 0;
    int r = inf;
    while (l + 1 != r) {
        int m = (l + r) / 2;
        pair<int, int> o = calc(n, m);
        if (o.second >= k) {
            l = m;
        } else {
            r = m;
        }
    }
    cout << calc(n, l).first - k * l;
}