#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("Ofast")

struct node{
    int ma = 0, p = 0;
    node *left, *right;
    node(){
        right = left = nullptr;
        ma = p = 0;
    }
};

int getm(node *x){
    if(x == nullptr)
        return 0;
    return x->ma;
}

void push(node *x){
    if(x->p == 0) return;
    if(x->left == nullptr) x->left = new node();
    if(x->right == nullptr) x->right = new node();
    x->left->ma += x->p;
    x->left->p += x->p;
    x->right->ma += x->p;
    x->right->p += x->p;
    x->p = 0;
}

node* update(node* t, int tl, int tr, int l, int r, int z){
    if(l > r) return t;
    if(t == nullptr) t = new node();
    if(tl == l && tr == r){
        t->ma += z;
        t->p += z;
        return t;
    }
    push(t);
    int mid = (tl+tr)/2;
    t->left = update(t->left, tl, mid, l, min(r, mid), z);
    t->right = update(t->right, mid+1, tr, max(l, mid+1), r, z);
    t->ma = max(getm(t->left), getm(t->right));
    return t;
}

int get(node *t, int tl, int tr, int l, int r){
    if(l > r) return 0;
    if(t == nullptr) return 0;
    if(tl == l && tr == r){
        return t->ma;
    }
    push(t);
    int mid = (tl+tr)/2;
    return max(get(t->left, tl, mid, l, min(r, mid)),get(t->right, mid+1, tr, max(l, mid+1), r));
}

node *t = new node();
int ma = 200000;
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, h, w;
    cin >> n >> w >> h;
    vector<pair<int, int> > c(n);
    for(int i = 0; i < n; i++){
        cin >> c[i].second >> c[i].first;
    }

    sort(c.begin(), c.end());

    int ans = 0;

    queue<pair<int, int> > q;
    for(int i = 0; i < n; i++){
        if(!q.empty()){
            pair<int, int> z = q.front();
            while(!q.empty() && q.front().first == z.first){
                pair<int, int> y = q.front(); q.pop();
                update(t, 0, ma, max(0, y.second - w), y.second, -1);
            }
        }
        if(q.empty()){
            q.push(c[i]);
            update(t, 0, ma, max(0, c[i].second - w), c[i].second, 1);
        }
        pair<int, int> z = q.front();
        while(i+1 < n && c[i+1].first <= z.first + h){
            i++;
            q.push(c[i]);
            update(t, 0, ma, max(0, c[i].second - w), c[i].second, 1);
        }

       // cout << q.size() << '\n';

        ans = max(ans, get(t, 0, ma, 0, ma));

    }

    cout << ans;

}
