#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


class P {
public:
    int x, y;
    P(int x, int y)
    {
        this->x = x;
        this->y = y;
    }
};


int n, w, h;
vector<P> points;



int main()
{
    cin >> n >> w >> h;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        points.push_back(P(a, b));
    }
    int maxp = 0;
    for (int i = 0; i < n; i++) {
        for (int k = points[i].x - w; k <= points[i].x + w; k++) {
            int count1 = 0;
            int count2 = 0;
            int count3 = 0;
            int count4 = 0;
            for (int j = 0; j < n; j++) {
                count1 += (points[j].x >= k && points[j].x <= k + w &&
                    points[j].y <= points[i].y && points[j].y >= points[i].y - h);
                count2 += (points[j].x >= k && points[j].x <= k + w &&
                    points[j].y >= points[i].y && points[j].y <= points[i].y + h);
                count3 += (points[j].x <= k && points[j].x >= k - w &&
                    points[j].y <= points[i].y && points[j].y >= points[i].y - h);
                count4 += (points[j].x <= k && points[j].x >= k - w &&
                    points[j].y >= points[i].y && points[j].y <= points[i].y + h);

            }
            maxp = max(maxp, max(count1, max(count2, max(count3, count4))));
        }
    }
    cout << maxp <<endl;
    return 0;
}
