/*
																							  
																							  
										..........             ...........  ..  ..          
	 ..--.............  ...................----......... ...........--......------.         
	  ..::----------------::---.-:*:::::*:*******:::***:-:::::----............-**..         
	  ..-:::-................:::****:--..-:--:::-..:**-::-..................:**:-.          
	   ...-::::..........-*:--.-::-:-.....-:.-..-::-..--.....--..........-::::--..          
	  ...-..-*::::-....:*--...----:--......-:.--..-::...--....-----...-:::::-..-..          
		.-...-*::--:**:.-...-:..-:--.......-:-..-...::-...-.....-:--:::::::-....            
		....-...-::::......--...-.*-........::-.--...-:-...-.-...----:::...-..-.            
		..---...-:*.......--...---*-........-:-..-....-::...---...--:-::-...-.-.            
		  .--..-::..-....--...-:.::-........-::..--....-*:..-.:-...--:-:::-.--..            
		  .--.:*-..-....-:....--.::-........-:*-..:--...:*-..--*-...--::**:-.-..            
		  ...:+-..-.....:....-:.-::-....-...-:*:..:-.-..-:*..-.*:....--:****:-..            
		  ..-+-..-...-..:...--:.:::-....--...::*..-:-.--.:::.--*::...---::-:*...            
		  ..*....-..-..--...-::.::*-.....-.-.*:*-.-:---:-::*--::.::...---:--::.             
		  .--.-.-..--..--..--::.*:*--....:.:-*:::.-::---*-::*-*..:::..----:--+..            
		  .-.:..-..--..--..-:::-*:::-....:.-*::.*.---:--:*::-*-..-:::..---:--*-.            
		..--:-.-...--..--..-::::*::*:-...:--*:-.:.--.-:--*:::*....::::.-------*.            
		..:-*..-..-::..:----:--:*-:*::...---*:-.:-::..-:::*::*-...-::::.------:.            
		.--:*.-..--::..:---::..::--:*:-..---**-.----...-:::::::...-::-::------:.            
		.--:*.-..--::..:--::-..-:-.-*:------:*-.--:.....::::--:-..-::--:*------.            
	   ..--:*.-..--:*..:--::-...::..-:------::..--:...--::-::-:...-::---:*:---:-.           
	   .--.:*--.---::-.:--::-..--:-..-:----:-:..-::-+%####%@@**-..-::---.*::----..          
	   .--.:::-.---:::.:--::+=%%%=*--.-:---:.-..-:**%#####@-::*+-.-::--:.::::----.          
	  ..--.::*-.:--:::--:*%##@@@#+**-...-:--....:--*@#@#@#%=:+::-.-::--:.::::::--..         
	  ..--.-::-.---::*:-*::#####@=+%:-...--.....-...=+++**=*+*--..-::--:--*:---*---...      
	   ..-.-::-.---::::::-:+=++=++*++...............-=:::::*+.:...-::--*:-*::-.---....      
		...--::.----::*::--.+****::+:.................-:--:---:.-.-::--**.**:-..--....      
		...---:-.:--:-:*:::-.-**:::--...................---------.-::..+*.**:-..--.         
		  .---::.---::::*::-------......................-----:-:..:::..++.::*:...--.        
		  .---::--:-::-::*::-----........................---:-:*..**:.-=+.::**-..--..       
		  .:-.::*.:--:-:::=+:--...........................-:--=*.-**-.-==-::***-..--..      
		  .:..--:*.:-*::::*=*::-.........................-.-*+=*.***--:=+-:::**:-...-.      
		  .-..-::*+-*:*:-::==*-.---..........:-..........:=***=*:**:.-*=*.*:::**:..--..     
		..-...-::++*:**:-::+=**++:....................:=++=***=***:-.:+=:.+*:::*:*----..    
		.-....-:***+:*:*:::+=+*+++*+=*-............:*:=**+=***=***:.::++:.++:-:-:::-.--...  
	   ..-....-*+**+*:**:::*=+*+++**+=+=:*::...-:*::::=***+=**:--::=*:-+++:::-:*-----..  
	  ..-....--+***+=:::**::++*+++**+%+==*::::::**+=%%%+**=+*+=*:-:::++*.*+*+*::---*..:---..
	 ..-....--+****==+-::*::*=+++=***=+=########@@%%%%@%+*++*++*::-:*=+:-=+**+*::---:..-:--.
	..-...--.*****+=++:------:+++=%@@@##%@####@@%%%%=+:%@%%@#@*:::::=++.*+***++:::----..-:--
   ..--..-:.**:*:..........-=@@%@@@%%@*:::---*:--:------*%%%@+:::-:=#+.***+***++::---:-..-:*
  ...-..-:-:+::-........-*@@@@=+*%##@%+:----**:---------*%%@=*::-:++:**:::::***++::---:...:-
  ..-..::--=::-.......-:@@%%=:*+%*:-%%=:..--**:**-:-....=@@=%@##@%%=::-......-*+++::---:..-:
...-..:::-*+::.......-=%%%%:+*%*:--..:%:.....-:*:-....--**%@+*+%%%%%@=::-.......-++::--:-..:
..-..::---=*:-......-=%%%%*+=%::-..-...=.............-....--:%***%%%@##**:........:*:---:..:
.-..-----*+::-.....--#@%%=+*@::--....:*@%=+***+*****:..-...---:%*++%%%%@+*........--*-----.:
-..----:-++*:-------*####%@@%:-..--..=#%@%%%%%@==%%%..-...--.---+=**%%%%@+..........::---:.:
..-.----:=***:::::::*####%%#+::-...:@@@%%@@%%%:%=-%%@-:..--..----+%*+@%%@+...........*---:-:
.-.-----*=*-*::::::::####%%#:--.-++*=%%@%%#@%%@**%%%@@#*-:..-:.---=%=@##@*---.......-:----::
-..---:-+=*.-=:::::::@##@@%##@+***::=@%%%%%#=+%:*%+=@@%=****-.*%####%%#%+*--------.---:---*-
...:--::*=*.-********:::::*+++:::*::+%==%%@%@@:-:+%@@%=+*:::**++*=%%+=+-..:*******---:*---*-
 .----:**=*..:*:---------:**:*:-:*::+@@%%%===%#@@@@=*+:+*::::+:-----*+:-...........--:::--*-
..----:**=*..::*---------:+*::*-:*::+::*=@@#@%%@##%@##@%*:-::+:-----:**--.........-:::.:-:::
..----:+*=*..::::--------:=:-**-:*:*+-----:+=@@@@@@%=*--*::::*:----:-:*-----...--:::....:*:-
*/

// #pragma GCC target ("avx,avx2,fma")
// #pragma GCC optimize("Ofast,unroll-loops")
  
#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>


// #pragma GCC optimize("Stack:\")
// using namespace __gnu_pbds;
 // #pragma GCC optimization("O2")
// #pragma GCC optimization
// #pragma GCC optimization("avx")
// #pragma GCC optimization("avx2")

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2")

// 8x = Ofast, avx, avx2, fma

// #pragma GCC optimize ("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;
mt19937 rnd(time(0));
typedef long long ll;
typedef long double ld;

// #define _GLIBCXX_DEBUG
// #define int ll
#define f first
#define s second
#define pb push_back
#define int ll
#define pii pair<int, int> 
#define vi vector<int>

const int mod = 1e9 + 7;
const int maxn = 1e5 + 1;
int pref[maxn];
int n;
int sum (int l, int r) {
	return pref[r] - (l > 0 ? pref[l - 1] : 0);
};

pii comp(pii a, pii b) {
	if (a.f < b.f)
		return a;
	if (b.f < a.f)
		return b;
	if (a.s > b.s)
		return a;
	return b;
}
pii get(int kek, int deb = 0) {
	pii dp[n + 1];
	for (auto &i : dp)
		i = {1e18, 0};
	dp[0] = {0, 0};
	for (int i = 1; i <= n; ++i) {
		int l = 0, r = i - 1;
		while (r - l > 2) {
			int mid1 = l + (r - l) / 3;
			int mid2 = r - (r - l) / 3;
			auto get1 = make_pair(dp[mid1].f + sum(mid1, i - 1) * (i - mid1 - 1) + kek, dp[mid1].s + 1);
			auto get2 = make_pair(dp[mid2].f + sum(mid2, i - 1) * (i - mid2 - 1) + kek, dp[mid2].s + 1);
			if (comp(get1, get2) == get1) {
				r = mid2;
			} else {
				l = mid1;
			}
		}
		if (deb) {
			cout << i << ' ' << l << ' ' << r << endl;
		}
		// cout << 
		// cout << l << ' ' << r << endl;
		for (int j = l; j <= r; ++j) {
			// cout << i << ' ' << l << ' ' << r << endl;
			// cout << j << endl;
			auto x = make_pair(dp[j].f + sum(j, i - 1) * (i - j - 1) + kek, dp[j].s + 1);
			// cout << x.f << ' ' << x.s << endl;
			dp[i] = comp(dp[i], x);
		}
	}
	if (deb) {
		for (auto &i : dp)
			cout << i.f - kek * i.s << ":" << i.s << " - ";
		cout << endl;
	}
	return dp[n];
}
vector<vi> dp;


void rec(int l, int r, int optl, int optr, int k) {
	if (l > r)
		return;
	int mid = (l + r) / 2;
	int opt = 0;
	for (int j = optl; j <= min(mid - 1, optr); ++j) {
		// cout << k << ' ' << mid << ' ' << dp[mid][k] << endl;
		// cout << j << ' ' << dp[j][k - 1] + sum(j, mid - 1) * (mid - j - 1) << endl;
		// cout << (dp[j][k - 1] + sum(j, mid - 1) * (mid - j - 1) < dp[mid][k]) << endl;
		if (dp[j][k - 1] + sum(j, mid - 1) * (mid - j - 1) < dp[mid][k]) {
			dp[mid][k] = dp[j][k - 1] + sum(j, mid - 1) * (mid - j - 1);
			opt = j;
		}
	}
	// cout << opt << endl;
	rec(l, mid - 1, optl, opt, k);
	rec(mid + 1, r, opt, optr, k);
}

void solve() {
	int k;
	cin >> n >> k;
	int a[n];
	for (auto &i : a)
		cin >> i;
	for (int i = 0; i < n; ++i) {
		pref[i] = a[i];
		if (i)
			pref[i] += pref[i - 1];
	}
	if (k <= 10 || n <= 1000) {
	dp.resize(n + 1, vi(k + 1, int(1e18)));
		dp[0][0] = 0;
		for (int j = 1; j <= k; ++j) {
			rec(1, n, 0, n, j);	
		}
		cout << dp[n][k] << endl;
		exit(0);
	}
	int l = -1e13, r = 1e13;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		if (get(mid).s >= k) {
			l = mid;
		} else {
			r = mid;
		}
	}
	// cout << l << endl;
	cout << get(l, 0).f - l * k << endl;
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	while(t--){
		solve();
	}

	return 0;
}