#include <random>

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cstring>
#include <string>
#include <unordered_map>

using namespace std;
#define int long long
vector<int> arr[26];

unordered_map<int, int> dp[26];

int calc_dp(int cnt, int mask) {
    if (dp[cnt].count({mask})) {
        return dp[cnt][mask];
    }
    if (cnt == 0) {
        if (__builtin_popcount(mask) == 26) {
            return 1;
        }
        return 0;
    }
    int ans = 0;
    for (auto i:arr[cnt - 1]) {
        if ((mask | (1LL << i)) != mask) {
            mask ^= (1LL << i);
            ans += calc_dp(cnt - 1, mask);
            mask ^= (1LL << i);
        }
    }
    return ans;

}

bool comp(vector<int> &a, vector<int> &b) {
    return a.size() > b.size();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    for (int i = 0; i < 26; ++i) {
        string s;
        cin >> s;
        sort(s.begin(), s.end());
        s.erase(unique(s.begin(), s.end()), s.end());
        for (char c:s) {
            int ind = c - 'A';
            arr[ind].push_back(i);
        }
    }
    sort(arr, arr + 26, comp);
    cout << calc_dp(26, 0);
    return 0;
}