#include <random>

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cstring>
#include <string>

using namespace std;

#define MAXN 1000000
#define MAXN 1000000

vector<string> str;

int n, k;
vector<int> a;
vector<int> pref;

int gett(int l, int r) {
    return (pref[r] - pref[l]) * (r - l - 1);

}

#define INF 1000000000

void solve_dp() {
    int dp[n + 1][k + 1];
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= k; ++j) {
            dp[i][j] = INF;
        }
    }
    dp[0][0] = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= k; ++j) {
            for (int l = 0; l < i; ++l) {
                dp[i][j] = min(dp[i][j], dp[l][j - 1] + gett(l, i));
            }
            //cout << dp[i][j] << " ";
        }
        //cout << "\n";
    }
    cout << dp[n][k];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //int n, k;
    cin >> n >> k;
    a.resize(n);
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    solve_dp();
    return 0;
}