#include <random>

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cstring>
#include <string>

using namespace std;
#define int long long
#define MAXN 1000000
#define MAXN 1000000

vector<string> str;

int n, k;
vector<int> a;
vector<int> pref;

int gett(int l, int r) {
    return (pref[r] - pref[l]) * (r - l - 1);

}

#define INF 1000000000000000000

int getcreep(pair<int, int> p) {
    return p.first * (p.second - 1);
}

void solve_dp() {
    vector<pair<int, int>> vp;
    for (int i = 0; i < n; ++i) {
        vp.push_back({a[i], 1});
    }
    while (vp.size() > k) {
        int aind = -1;
        int aans = INF;
        for (int i = 0; i < vp.size() - 1; ++i) {
            int cur = getcreep(vp[i]) + getcreep(vp[i + 1]);
            int nw = getcreep({vp[i].first + vp[i + 1].first, vp[i].second + vp[i + 1].second});
            if (nw - cur < aans) {
                aans = nw - cur;
                aind = i;
            }
        }
        vp[aind].first += vp[aind + 1].first;
        vp[aind].second += vp[aind + 1].second;
        vp.erase(vp.begin() + aind + 1);
    }
    int ans = 0;
    for (int i = 0; i < k; ++i) {
        ans += getcreep(vp[i]);
    }
    cout << ans;
}


void solve_tern() {
    int ans = INF;
    for (int i = 1; i < n; ++i) {
        int l = i;
        int r = n - 1;
        while (r - l >= 3) {
            int m1 = (r - l) / 3 + l;
            int m2 = r - (r - l) / 3;
            int a1 = gett(i, m1) + gett(m1, n);
            int a2 = gett(i, m2) + gett(m2, n);
            if (a1 < a2) {
                r = m2;
            } else {
                l = m1;
            }
        }
        int ac = INF;
        for (int j = l; j <= r; j++) {
            ac = min(ac, gett(i, j) + gett(j, n));
        }
        ac += gett(0, i);
        ans = min(ans, ac);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //int n, k;
    cin >> n >> k;
    a.resize(n);
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    if (k == 3) {
        solve_tern();
    } else {
        solve_dp();
    }
    return 0;
}