#include <random>

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cstring>
#include <string>

using namespace std;
#define int long long
#define MAXN 1000000
#define MAXN 1000000

vector<string> str;

int n, k;
vector<int> a;
vector<int> pref;

int gett(int l, int r) {
    return (pref[r] - pref[l]) * (r - l - 1);

}

#define INF 1000000000000000000


int solve_tern(int K, int tl, int tr) {

    int len = tr - tl;
    if (len < K) {
        return INF;
    }
    if (len == K) {
        return 0;
    }
    if (K == 1) {
        return gett(tl, tr);
    }

    int kl = K / 2;
    int kr = K - kl;
    int l = tl;
    int r = tr - 1;
    while (r - l >= 3) {
        int m1 = (r - l) / 3 + l;
        int m2 = r - (r - l) / 3;
        int a1 = solve_tern(kl, tl, m1) + solve_tern(kr, m1, tr);
        int a2 = solve_tern(kl, tl, m2) + solve_tern(kr, m2, tr);
        if (a1 < a2) {
            r = m2;
        } else {
            l = m1;
        }
    }
    int ac = INF;
    for (int j = l; j <= r; j++) {
        ac = min(ac, solve_tern(kl, tl, j) + solve_tern(kr, j, tr));
    }
    return ac;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //int n, k;
    cin >> n >> k;
    a.resize(n);
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    cout << solve_tern(k,0,n);
    return 0;
}