#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
typedef long long ll;
typedef long double ld;

const int N = 1e5 + 10, C = 1 << 20, TREE = 1 << 21;

pair<int, int> a[N];

int tree[TREE];

template<int x>
void add(int i) {
	i += C;
	while (i) {
		tree[i] += x;
		i /= 2;
	}
}

int get(int l, int r) {
	l += C;
	r += C;
	int ans = 0;
	while (l < r) {
		if (l & 1)	ans += tree[l];
		if (!(r & 1))	ans += tree[r];
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return ans;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, w, h;
	cin >> n >> w >> h;
	for (int i = 0; i < n; ++i)
		cin >> a[i].x >> a[i].y;
	sort(a, a + n);
	int j = 0;
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		if (i)
			add<-1>(a[i - 1].y);
		while (j < n && (a[j].x - a[i].x < w || (a[j].x - a[i].x == w && a[j].y - a[i].y == h))) {
			// cout << "at" << i << " " << j << "\n"; 
			add<1>(a[j].x), ++j;
		}
		ans = max(ans, get(a[i].y, a[i].y + h));
	}
	cout << ans << "\n";
	return 0;
}