#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
typedef long long ll;
typedef long double ld;

const int N = 1e5 + 10, C = 1 << 20, TREE = 1 << 21;

pair<int, int> a[N];

int tree[TREE];

template<int x>
void add(int l, int r) {
	for (int i = l; i <= r; ++i)
		tree[i] += x;
}

int get() {
	int res = 0;
	for (int i = 0; i < 1000; ++i) {
		res = max(res, tree[i]);
	}
	return res;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, w, h;
	cin >> n >> w >> h;
	for (int i = 0; i < n; ++i)
		cin >> a[i].x >> a[i].y;
	sort(a, a + n);
	int ans = 0;

	int j = 0;
	for (int i = 0; i < n; ++i) {
		if (i) {
			// remove point a[i - 1]
			add<-1>(max(0, a[i - 1].y - h), a[i - 1].y);
		}
		if (!i || a[i].x != a[i - 1].x) {
			while (j < n && a[j].x <= a[i].x + w) {
				// add point a[j].x
				add<1>(max(0, a[j].y - h), a[j].y);
				++j;
			}
			ans = max(ans, get());
			// cout << "at layer " << a[i].x << ": ";
			// for (int h = 0; h < 20; ++h) {
			// 	cout << tree[h] << " ";
			// }
			// cout << "\n";
		}
	}
	cout << ans << "\n";
	return 0;
}