#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef pair<ll, ll> pl;
typedef vector<pl> vpl;
typedef vector<ll> vl;
typedef vector<vl> vvl;
typedef vector<vpl> vvpl;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vpi> vvpi;

#define fi first
#define se second
#define pb push_back
#define eb emplace_back
#define rep(i, n) for(int i = 0; i < n; ++i)
#define repl(i, n) for(ll i = 0; i < n; ++i)
#define all(c) (c.begin()), (c.end())

//#define BRUH_WHY_TESTCASES
const int mod = 1e9 + 7;

ll bexp(ll b, ll p) {
    ll curr = b;
    ll res = 1;
    while(p) {
        if(p % 2)
        {
            res *= curr;
            res %= mod;
        }
        curr *= curr;
        curr %= mod;
        p /= 2;
    }
    return res;

}













struct Segtree  // TODO: range add, max query
{
    int mx; int lazy; Segtree* l; Segtree* r;
    int tl; int tr; int tm;
    Segtree(int _tl, int _tr)
    {
        tl=_tl; tr=_tr; tm=tl+(tr-tl)/2; mx=lazy=0; l=r=0;
    }
    void push()  {
        if(!l) {
            l = new Segtree(tl, tm);
        }
        if(!r) {
            r = new Segtree(tm+1, tr);
        }
        if(lazy)
        {
            l->mx += lazy;
            r->mx += lazy;
            l->lazy += lazy;
            r->lazy += lazy;
            lazy = 0;
        }
    }
    void pull()
    {
        mx = max(l->mx, r->mx);
        if(l->mx == 0) {delete l; l = 0;}
        if(r->mx == 0) {delete r;  r = 0;}
    }
    void add(int ql, int qr, int off) {
        if(ql > qr || qr < tl || ql > tr) return;
        if(tl == ql && tr == qr)
        {
            mx += off; lazy += off;
        }
        else {
            push();
            l->add(ql, min(tm, qr), off); r->add(max(tm+1, ql), qr, off);
            pull();
        }
    }
};



const int INFI = 1e9 + 5;

const int maxn = 1e5 + 5;
const int maxc = 2e8+ 5;
int n;
int w, h;



struct event
{
    int x; int y; int type;
};
vector<event> ev;


void solve()
{
    cin >> n >> w >> h;

    int mny = INFI;
    int mxy = 0;
    rep(i, n)
    {
        int x, y; cin >> x >> y;
        mny = min(mny, y);
        mxy = max(mxy, y);
        ev.pb(event{x, y, 1});
        ev.pb(event{x+w+1, y, -1});
    }
    sort(all(ev), [&](const event& a, const event& b){

        if(a.x != b.x) return a.x < b.x;
        return a.type < b.type;
    });
    Segtree st(mny, mxy-h);
    int res = 0;
    for(auto e : ev) {
        //cout << e.x << ' ' << e.y << ' '<< e.type << '\n';
        if(e.type ==1) {
            // add to the segment tree, update result
            st.add(max(mny, e.y-h), min(mxy-h, e.y), 1);
            res = max(st.mx, res);
        }
        else
        {
            st.add(max(mny, e.y-h), min(mxy-h, e.y), -1);
        }
        
    }
    cout << res << '\n';


}

































int main()
{
    ios::sync_with_stdio(false); cin.tie(nullptr);
    int t = 1;
    #ifdef BRUH_WHY_TESTCASES
        cin >> t;
    #endif
    rep(_t, t)
    {
        solve();
    }
}