#include <bits/stdc++.h>
using namespace std;
#define int long long
#define app push_back
#define f first
#define s second
#define ii pair <int, int>
#define Time (double)clock()/CLOCKS_PER_SEC

const int INF = 1e13, N = 1e5+7, T = 1e18;
int n, k, a[N], pref[N];

ii dp[N];

int SH;

void solve1(int l, int r, int tl, int tr) {
    if (r < l)
        return;
    if (tr < tl)
        return;
    int m = (l + r) >> 1;    
    ii best = {T, T};
    int opt = tl;
    for (int i = tl; i <= tr && i < m; ++i) {
        int sum = pref[m] - pref[i];
        auto t = dp[i];
        t.f += sum * (m - i - 1) + SH;
        t.s++;
        if (t < best) {
            best = t;
            opt = i;
        }   
    }   
    dp[m] = min(dp[m], best);
    solve1(l, m - 1, tl, opt);
    solve1(m + 1, r, opt, tr);    
}

void solve(int l, int r, int tl, int tr) {
    //cout << "solve " << l << ' ' << r << endl;
    if (r < l)
        return;
    if (tr < tl)
        return;
    int m = (l + r) >> 1;    
    ii best = {T, T};
    int opt = tl;
    for (int i = tl; i <= tr && i < l; ++i) {
        int sum = pref[m] - pref[i];
        auto t = dp[i];
        t.f += sum * (m - i - 1) + SH;
        t.s++;
        if (t < best) {
            best = t;
            opt = i;
        }   
    }   
    dp[m] = min(dp[m], best);
    solve1(l, m - 1, tl, opt);
    solve1(m + 1, r, opt, min(tr, l - 1));    

    {
    ii best = {T, T};
    int opt = tl;
    for (int i = max(l, tl); i <= tr && i < m; ++i) {
        int sum = pref[m] - pref[i];
        auto t = dp[i];
        t.f += sum * (m - i - 1) + SH;
        t.s++;
        if (t < best) {
            best = t;
            opt = i;
        }   
    }   
    dp[m] = min(dp[m], best);
    solve(l, m - 1, max(l, tl), opt); //?
    solve(m + 1, r, opt, tr); //?            
    }
}   

ii solve(int sh) {
    SH = sh;
    dp[0] = {0, 0};
    for (int i = 1; i <= n; ++i)
        dp[i] = {T, T};
    solve(1, n, 0, n - 1);
    return dp[n];
}   

signed main() {
    #ifdef HOME
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #endif
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }   
    int l = -INF, r = INF;
    while (l < r - 1) {
        int m = (l + r) >> 1;
        auto t = solve(m); // (cost, k)
        if (t.s <= k)
            r = m;
        else
            l = m;
    }   
    cout << solve(r).f - r * k << endl;
    #ifdef HOME
    cout << Time << endl;
    #endif
}