#include <bits/stdc++.h>
using namespace std;
#define int long long
#define app push_back
#define f first
#define s second
#define ii pair <int, int>
#define Time (double)clock()/CLOCKS_PER_SEC

const int INF = 1e13, N = 1e5+7, T = 1e18;
int n, k, a[N], pref[N];

ii dp[N];
ii solve(int sh) {
    dp[0] = {0, 0};
    for (int i = 1; i <= n; ++i)
        dp[i] = {T, T};
    for (int i = 0; i < n; ++i) {
        for (int len = 1; i + len <= n; ++len) {
            int sum = pref[i + len] - pref[i];
            auto t = dp[i];
            t.f += sum * (len - 1) + sh;
            t.s++;
            dp[i + len] = min(dp[i + len], t);            
        }   
    }   
    return dp[n];
}   

signed main() {
    #ifdef HOME
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #endif
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }   

        int l = -INF, r = INF;
        while (l < r - 1) {
            int m = (l + r) >> 1;
            auto t = solve(m); // (cost, k)
            if (t.s <= k)
                r = m;
            else
                l = m;
        }   
        cout << solve(r).f - r * k << endl;

    #ifdef HOME
    cout << Time << endl;
    #endif
}