#include <bits/stdc++.h>
using namespace std;
#define int long long
#define app push_back
#define f first
#define s second
#define ii pair <int, int>
#define Time (double)clock()/CLOCKS_PER_SEC

const int INF = 1e13, N = 1e5+7, T = 1e18;
int n, k, a[N], pref[N];

ii dp1[N], dp2[N];

int get_opt(int m, int tl, int tr) {
    ii best = {T, T};
    int opt = tl;
    for (int i = tl; i <= tr && i < m; ++i) {
        int sum = pref[m] - pref[i];
        auto t = dp1[i];
        t.f += sum * (m - i - 1);
        t.s++;
        if (t < best) {
            best = t;
            opt = i;
        }   
    }   
    dp2[m] = min(dp2[m], best);
    return opt;
}   

void solve(int l, int r, int tl, int tr) {
    if (r < l)
        return;
    if (tr < tl)
        return;
    int m = (l + r) >> 1;    
    int opt = get_opt(m, tl, tr);
    solve(l, m - 1, tl, opt);
    solve(m + 1, r, opt, tr);    
}

void shift() {
    for (int i = 0; i <= n; ++i)
        dp2[i] = {T, T};
    solve(1, n, 0, n - 1);
    for (int i = 0; i <= n; ++i)
        dp1[i] = dp2[i];
}   

ii dp[N];
ii solve(int sh) {
    dp[0] = {0, 0};
    for (int i = 1; i <= n; ++i)
        dp[i] = {T, T};
    for (int i = 0; i < n; ++i) {
        for (int len = 1; i + len <= n/k+100; ++len) {
            int sum = pref[i + len] - pref[i];
            auto t = dp[i];
            t.f += sum * (len - 1) + sh;
            t.s++;
            dp[i + len] = min(dp[i + len], t);            
        }   
    }   
    return dp[n];
}   

signed main() {
    #ifdef HOME
    freopen("input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #endif
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }   

    if (k < 50) {
        dp1[0] = {0, 0};
        for (int i = 1; i <= n; ++i)
            dp1[i] = {T, T};
        for (int i = 0; i < k; ++i) {
            shift();
        }   
        cout << dp1[n].f << endl;
    }
    else {
        int l = -INF, r = INF;
        while (l < r - 1) {
            int m = (l + r) >> 1;
            auto t = solve(m); // (cost, k)
            if (t.s <= k)
                r = m;
            else
                l = m;
        }   
        cout << solve(r).f - r * k << endl;
    }   

    #ifdef HOME
    cout << Time << endl;
    #endif
}