#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = unsigned;
#define int ll
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int n = 26;
const int k = 20000000;
vector<int> a[n];
bitset<(1 << n)> good;
int zip[k], dp[k], len = 0;

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (char c : s) {
			a[i].push_back(c - 'A');
		}
		sort(all(a[i]));
		a[i].erase(unique(all(a[i])), a[i].end());
	}
	int full = (1 << n) - 1;
	good.set(0);
	for (int i = 0; i < full; ++i) {
		if (!good.test(i)) {
			continue;
		}
		assert(len < k);
		zip[len++] = i;
		auto &vec = a[__builtin_popcountll(i)];
		for (int j : vec) {
			if ((i >> j) & 1) {
				continue;
			}
			good.set(i | (1 << j));
		}
	}
	zip[len++] = full;

	dp[0] = 1;
	for (int ind = 0; ind < len; ++ind) {
		int i = zip[ind];
		int v = dp[ind];
		if (!v) {
			continue;
		}
		auto &vec = a[__builtin_popcountll(i)];
		for (int j : vec) {
			if ((i >> j) & 1) {
				continue;
			}
			int pos = (int)(lower_bound(zip, zip + len, (i | (1 << j))) - zip);
			assert(good.test(i | (1 << j)));
			assert(pos < len);
			assert(zip[pos] == (i | (1 << j)));
			dp[pos] += v;
		}
	}
	cout << dp[len - 1] << "\n";
#ifdef LC
	cout << "Time: " << 1000 * clock() / CLOCKS_PER_SEC <<  "ms" << endl;
	cout << "States: " << len << " " << 100.0 * len / (1 << n) << "%" << endl;
#endif
	return 0;
}