#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = unsigned;
#define int ll
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

void time_assert(bool c) {
	if (c) {
		return;
	}
	while (clock() < 100 * CLOCKS_PER_SEC) {}
}

void wa_assert(bool c) {
	if (c) {
		return;
	}
	cout << "-1\n";
	exit(0);
}

const int n = 26;
const int k = 11e6;
const int x = 1 << 13;

vector<int> a[n];
int czip[k];
int cval[k];
int clen;
int nzip[k];
int nval[k];
int nlen;
int pop[x];

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (char c : s) {
			a[i].push_back(c - 'A');
		}
		sort(all(a[i]));
		a[i].erase(unique(all(a[i])), a[i].end());
	}
	for (int i = 0; i < x; ++i) {
		pop[i] = __builtin_popcount(i);
	}
	int full = (1 << n) - 1;
	clen = 0;
	czip[clen] = 0;
	cval[clen] = 1;
	++clen;
	for (int cnt = 0; cnt < n; ++cnt) {
		nlen = 0;
		for (int i = 0; i < (1 << n); ++i) {
			if (pop[i >> 13] + pop[i & (x - 1)] == cnt + 1) {
				nzip[nlen]   = i;
				nval[nlen++] = 0;
			}
		}
		for (int ind = 0; ind < clen; ++ind) {
			int i = czip[ind];
			int v = cval[ind];
			if (!v) {
				continue;
			}
			auto &vec = a[cnt];
			for (int j : vec) {
				if ((i >> j) & 1) {
					continue;
				}
				int pos = (int)(lower_bound(nzip, nzip + nlen, (i | (1 << j))) - nzip);
				nval[pos] += v;
			}
		}
		clen = nlen;
		copy_n(nzip, clen, czip);
		copy_n(nval, clen, cval);
	}
	assert(clen == 1);
	assert(czip[0] == full);
	cout << cval[0] << "\n";
#ifdef LC
	cout << "Time: " << 1000 * clock() / CLOCKS_PER_SEC <<  "ms" << endl;
#endif
	return 0;
}