#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
using ll = unsigned;
#define int ll
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

void time_assert(bool c) {
	if (c) {
		return;
	}
	while (clock() < 100 * CLOCKS_PER_SEC) {}
}

void wa_assert(bool c) {
	if (c) {
		return;
	}
	cout << "-1\n";
	exit(0);
}

const int n = 26;

vector<int> a[n];

int dfs(int m) {
	if (m == (1 << n) - 1) {
		return 1;
	}
	int s = 0;
	auto &vec = a[__builtin_popcount(m)];
	for (int i : vec) {
		if ((m >> i) & 1) {
			continue;
		}
		s += dfs(m ^ (1 << i));
	}
	return s;
}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (char c : s) {
			a[i].push_back(c - 'A');
		}
		sort(all(a[i]));
		a[i].erase(unique(all(a[i])), a[i].end());
	}
	cout << dfs(0) << "\n";
#ifdef LC
	cout << "Time: " << 1000 * clock() / CLOCKS_PER_SEC <<  "ms" << endl;
#endif
	return 0;
}