#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")
#include <bits/stdc++.h>
using namespace std;
using ll = unsigned;
#define int ll
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

void time_assert(bool c) {
	if (c) {
		return;
	}
	while (clock() < 100 * CLOCKS_PER_SEC) {}
}

void wa_assert(bool c) {
	if (c) {
		return;
	}
	cout << "-1\n";
	exit(0);
}

const int n 	= 26;
const int k 	= 11;
const int z     = (int)((1 << n) * 0.16);

vector<int> a[n];
int zip[z];
int val[z];
int len = 0;

int full;
int ans = 0;

void fi(int i, int m) {
	if (i == k) {
		int pos = (int)(lower_bound(zip, zip + len, m) - zip);
		assert(pos < len && zip[pos] == m);
		++val[pos];
		return;
	}
	for (int j : a[i]) {
		if ((m >> j) & 1) {
			continue;
		}
		fi(i + 1, m ^ (1 << j));
	}
}

void se(int i, int m) {
	if (i == n) {
		int need = full ^ m;
		int pos = (int)(lower_bound(zip, zip + len, need) - zip);
		assert(pos < len && zip[pos] == need);
		ans += val[pos];
		return;
	}
	for (int j : a[i]) {
		if ((m >> j) & 1) {
			continue;
		}
		se(i + 1, m ^ (1 << j));
	}
}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (char c : s) {
			a[i].push_back(c - 'A');
		}
		sort(all(a[i]));
		a[i].erase(unique(all(a[i])), a[i].end());
	}
	full = (1 << n) - 1;
	for (int i = 0; i <= full; ++i) {
		if (__builtin_popcount(i) == k) {
			zip[len] = i;
			val[len] = 0;
			++len;
		}
	}
	fi(0, 0);
	se(k, 0);
	cout << ans << "\n";
#ifdef LC
	cout << "Time:\t" << 1000 * clock() / CLOCKS_PER_SEC <<  "ms" << endl;
	cout << "|Q|:\t" << len << endl;
#endif
	return 0;
}