#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
using namespace std;
using ll = unsigned;
#define int ll
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int INF = 1e9;

void time_assert(bool c) {
	if (c) {
		return;
	}
	while (clock() < 100 * CLOCKS_PER_SEC) {}
}

void wa_assert(bool c) {
	if (c) {
		return;
	}
	cout << "-1\n";
	exit(0);
}

const int n = 26;
const int full = (1 << n) - 1;
const int maxs = 10400600;

int cnk[n + 1][n + 1];

int getmask(int k, int i) {
	assert(i < cnk[n][k]);
	int res = 0;
	for (int b = n; b--; ) {
		if (i >= cnk[b][k]) {
			i -= cnk[b][k];
			res |= 1 << b;
			--k;
		}
	}
	return res;
}
int getind(int k, int res) {
	int i = 0;
	for (int b = n; b--; ) {
		if ((res >> b) & 1) {
			i += cnk[b][k--];
		}
	}
	return i;
}

vector<int> a[n];
int mem[2 * maxs], sav[maxs], *cur, *nxt;

const int k = 1e5;
bitset<(1 << n)> good;
int *zip;
uint64_t *dp;
int len = 0;

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	for (int i = 0; i <= n; ++i) {
		cnk[i][0] = cnk[i][i] = 1;
		for (int j = 1; j < i; ++j) {
			cnk[i][j] = min(INF, cnk[i - 1][j] + cnk[i - 1][j - 1]);
		}
	}
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (char c : s) {
			a[c - 'A'].push_back(i);
		}
	}
	for (int i = 0; i < n; ++i) {
		sort(all(a[i]));
		a[i].erase(unique(all(a[i])), a[i].end());
	}
	good.set(0);
	int good_cnt = 0;
	for (int i = 0; i < full; ++i) {
		if (!good.test(i)) {
			continue;
		}
		if (++good_cnt >= k) {
			break;
		}
		auto &vec = a[__builtin_popcountll(i)];
		for (int j : vec) {
			if ((i >> j) & 1) {
				continue;
			}
			good.set(i | (1 << j));
		}
	}
	good.set(full);
	if (good_cnt < k) {
		zip = new int[k];
		dp = new uint64_t[k]();
		for (int i = 0; i <= full; ++i) {
			if (good.test(i)) {
				zip[len++] = i;
			}
		}
		dp[0] = 1;
		for (int ind = 0; ind < len; ++ind) {
			int i = zip[ind];
			uint64_t v = dp[ind];
			if (!v) {
				continue;
			}
			auto &vec = a[__builtin_popcountll(i)];
			for (int j : vec) {
				if ((i >> j) & 1) {
					continue;
				}
				int pos = (int)(lower_bound(zip, zip + len, (i | (1 << j))) - zip);
				dp[pos] += v;
			}
		}
		cout << dp[len - 1] << "\n";
	} else {
		cur = mem;
		nxt = mem + maxs;
		cur[0] = 1;
		for (int cnt = 0; cnt < n / 2; ++cnt) {
			fill_n(nxt, cnk[n][cnt + 1], 0);
			for (int ind = 0; ind < cnk[n][cnt]; ++ind) {
				if (!cur[ind]) {
					continue;
				}
				int i = getmask(cnt, ind);
				int v = cur[ind];
				for (int j : a[cnt]) {
					if ((i >> j) & 1) {
						continue;
					}
					nxt[getind(cnt + 1, i | (1 << j))] += v;
				}
			}
			swap(cur, nxt);
		}
		copy_n(cur, maxs, sav);
		reverse(a, a + n);
		fill_n(cur, maxs, 0);
		cur[0] = 1;
		for (int cnt = 0; cnt < n / 2; ++cnt) {
			fill_n(nxt, cnk[n][cnt + 1], 0);
			for (int ind = 0; ind < cnk[n][cnt]; ++ind) {
				if (!cur[ind]) {
					continue;
				}
				int i = getmask(cnt, ind);
				int v = cur[ind];
				for (int j : a[cnt]) {
					if ((i >> j) & 1) {
						continue;
					}
					nxt[getind(cnt + 1, i | (1 << j))] += v;
				}
			}
			swap(cur, nxt);
		}
		int ans = 0;
		for (int i = 0; i < maxs; ++i) {
			ans += sav[i] * cur[maxs - 1 - i];
		}
		cout << ans << "\n";
	}
#ifdef LC
	cout << "Time: " << 1000 * clock() / CLOCKS_PER_SEC <<  "ms" << endl;
	// cout << "States: " << len << " " << 100.0 * len / (1 << n) << "%" << endl;
#endif
	return 0;
}