#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define int ll
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int N = 1 << 17;
int tmax[2 * N];
int tadd[2 * N];

int ls(int v) {
	return 2 * v + 1;
}
int rs(int v) {
	return 2 * v + 2;
}
void push(int v) {
	tmax[ls(v)] += tadd[v];
	tadd[ls(v)] += tadd[v];
	tmax[rs(v)] += tadd[v];
	tadd[rs(v)] += tadd[v];
	tadd[v] = 0;
}
void upd(int v, int vl, int vr, int ql, int qr, int d) {
	if (ql <= vl && vr <= qr) {
		tmax[v] += d;
		tadd[v] += d;
		return;
	}
	if (qr <= vl || vr <= ql) {
		return;
	}
	int vm = (vl + vr) / 2;
	push(v);
	upd(ls(v), vl, vm, ql, qr, d);
	upd(rs(v), vm, vr, ql, qr, d);
	tmax[v] = max(tmax[ls(v)], tmax[rs(v)]);
}
void update(int l, int r, int d) {
	// cout << "update " << l << " " << r << " " << d << endl;
	upd(0, 0, N, l, r, d);
}
int query() {
	// cout << "query " << tmax[0] << endl;
	return tmax[0];
}

int n, w, h;
vector<tuple<int, int, int, int>> scanline;
// {x, -1 if CLOSE else +1, y_lef, y_rig}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> w >> h;
	++w, ++h;
	for (int x, y; n--; ) {
		cin >> x >> y;
		assert(x < N && y < N && w < N && h < N);
		scanline.emplace_back(x, +1, y, y + h);
		scanline.emplace_back(min(N - 1, x + w), -1, y, y + h);
	}
	sort(all(scanline));
	int answer = 0;
	for (auto e : scanline) {
		int x, d, l, r;
		tie(x, d, l, r) = e;
		update(l, r, d);
		answer = max(answer, query());
	}
	cout << answer << "\n";
	return 0;
}