#include <bits/stdc++.h>
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define all(x) begin(x), end(x)
#define OK cout << "OK" << endl
//#define int ll
//#define endl '\n'

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n, w, h, ans;
vector<pii> hor, ver;

void solve()
{
    sort(all(hor));
    sort(all(ver));

    for(int i = 0; i < n; i++)
    {
        int x0 = hor[i].first;
        int x1 = hor[i].first + w;
        int y0 = hor[i].second - h;
        int y1 = hor[i].second + h;

        pii tmp = {hor[i].second, -1};
        int pos = lb(all(ver), tmp) - ver.begin();
        deque<pii> points;
        for(int j = pos; j < n; j++)
        {
            if (ver[j].first > y1) break;
            if (x0 <= ver[j].second && ver[j].second <= x1)
            {
                if (points.size() && points.back().second == ver[j].first)
                {
                    points.back().first++;
                }
                else
                {
                    points.pb({1, ver[j].first});
                }
            }
        }
        for(int j = pos - 1; j >= 0; j--)
        {
            if (ver[j].first < y0) break;
            if (x0 <= ver[j].second && ver[j].second <= x1)
            {
                if (points.size() && points.front().second == ver[j].first)
                {
                    points.front().first++;
                }
                else
                {
                    points.push_front({1, ver[j].first});
                }
            }
        }
        int tmp_ans = 0;
        for(int i = 0, j = 0; i < points.size(); i++)
        {
            if (points[i].second - points[j].second > h)
            {
                tmp_ans -= points[j].first;
                j++, i--;
                continue;
            }
            tmp_ans += points[i].first;
            ans = max(ans, tmp_ans);
        }
    }
}

int grid[1007][1007];
int dp[1007][1007];

void solve2()
{
    for(int i = 0; i <= 1000; i++)
    {
        for(int j = 0; j <= 1000; j++)
        {
            dp[i][j] = dp[i - 1][j] + dp[i][j - 1] - dp[i - 1][j - 1] + grid[i][j];
        }
    }

    for(int i = 0; i < ver.size(); i++)
    {
        int y = ver[i].first;
        int x = ver[i].second;
        if (y - w - 1 < 0 || x - h - 1 < 0) continue;
        int tmp = dp[y][x] - dp[y - w - 1][x] - dp[y][x - h - 1] + dp[y - w - 1][x - h - 1];
        ans = max(ans, tmp);
    }
}

main()
{
    cin >> n >> w >> h;
    bool flag = 0;
    for(int i = 0, x, y; i < n; i++)
    {
        cin >> x >> y;
        hor.pb({x, y});
        ver.pb({y, x});
        if (x <= 1000 && y <= 1000) grid[y][x] = 1;
        else flag = 1;
    }

    if (flag) solve();
    else solve2();

    cout << ans << endl;
}

/*
6 4 4
1 1
2 3
4 3
5 2
5 5
4 6
*/
