#include<bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define se second
#define fi first
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ld long double
#define pb push_back

vector<int> t, d;

void push(int v, int l, int r) {
    t[v] += d[v];
    if (l + 1 != r) {
        d[v * 2 + 1] += d[v];
        d[v * 2 + 2] += d[v];
    }
    d[v] = 0;
}

void update(int v, int l, int r, int l1, int r1, int x) {
    push(v, l, r);
    if (l >= r1 || l1 >= r) return;
    if (l1 <= l && r <= r1) {
        d[v] += x;
        push(v, l, r);
        return;
    }
    int m = (l + r) / 2;
    update(v * 2 + 1, l, m, l1, r1, x);
    update(v * 2 + 2, m, r, l1, r1, x);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int v, int l, int r, int l1, int r1) {
    push(v, l, r);
    if (l1 >= r || l >= r1) return 0;
    if (l1 <= l && r <= r1) return t[v];
    int m = (l + r) / 2;
    return max(get(v * 2 + 1, l, m, l1, r1), get(v * 2 + 2, m, r, l1, r1));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    w++, h++;
    int MX = 1e5 + 1;
    t.resize(4 * MX, 0);
    d.resize(4 * MX, 0);
    vector<int> b[MX];
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        b[x].pb(y);
    }
    int ans = 0;
    for (int i = 0; i < w; i++) {
        for (auto y : b[i]) {
            update(0, 0, MX, y - h + 1, y + 1, 1);
        }
    }
    ans = t[0];
    for (int i = w; i < MX; i++) {
        for (auto y : b[i]) {
            update(0, 0, MX, y - h + 1, y + 1, 1);
        }
        for (auto y : b[i - w]) {
            update(0, 0, MX, y - h + 1, y + 1, -1);
        }
        ans = max(ans, t[0]);
    }
    cout << ans;
}
