#include "bits/stdc++.h"


#define int long long

#define all(v) v.begin(), v.end()


using namespace std;


const int maxn = 1000 + 10;
const int inf = 1e14;

int a[maxn];
int dp[maxn][maxn];
//
//
//int calc(int n, int lambda) {
//    dp[0] = {0, 0};
//    for (int i = 1; i <= n; ++i) {
//        int sum = 0;
//        int now = 0;
//        dp[i] = {inf, inf};
//        for (int j = i - 1; j >= 0; --j) {
//            int len = (i - j);
//            now += sum + a[j] * (len - 1);
//            sum += a[j];
//            if (dp[j].second + now + lambda <= dp[i].second) {
//                if (dp[j].first + 1 < dp[i].first && dp[j].second + now + lambda == dp[i].second) {
//                    dp[i] = {dp[j].first + 1, dp[j].second + now + lambda};
//                }
//                if (dp[j].second + now + lambda < dp[i].second) {
//                    dp[i] = {dp[j].first + 1, dp[j].second + now + lambda};
//                }
//            }
//        }
//    }
//    return dp[n].first;
//}

//int bin_search(int k, int n) {
//    int l = -1, r = 1e12;
//    while (l + 1 < r) {
//        int m = (l + r) / 2;
//        int cnt = calc(n, m);
//        if (cnt >= k) {
//            l = m;
//        } else {
//            r = m;
//        }
//    }
//    return l;
//}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
//    int lambda = bin_search(k, n);
    dp[0][0] = 0;
    for (int i = 1; i <= n; ++i) {
        dp[i][0] = inf;
        for (int s = 1; s <= min(k, i); ++s) {
            int sum = 0;
            int now = 0;
            dp[i][s] = inf;
            for (int j = i - 1; j >= 0; --j) {
                int len = (i - j);
                now += sum + a[j] * (len - 1);
                sum += a[j];
                dp[i][s] = min(dp[i][s], dp[j][s - 1] + now);
            }
        }
    }
    cout << dp[n][k];
}