#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define X first
#define Y second

const int N = 1<<20;

int dp[N];

struct vertex {
    int cnt = 0;
    int to[2];
    vertex() {
        cnt = 0;
        to[0] = to[1] = -1;
    }
    vertex(int a, int b, int c) {
        this-> cnt = a;
        to[0] = b;
        to[1] = c;
    }
};

vector <vertex> bor;


int go(int v, int t) {
    if (bor[v].to[t] == -1) {
        bor[v].to[t] = bor.size();
        bor.push_back(vertex());
    }
    return bor[v].to[t];
}

void add_mask(int mask) {
    if (mask < N) {
        dp[mask]++;
        return;
    }
    int v = 0;
    for (int i = 0; i < 26; i++) {
        v = go(v, mask&1);
        mask /= 2;
    }
    bor[v].cnt++;
}

int get_mask(int mask) {
    if (mask < N) {
        return dp[mask];
    }
    int v = 0;
    for (int i = 0; i < 26; i++) {
        if (bor[v].to[mask&1] == -1) {
            return 0;
        }
        v = go(v, mask&1);
        mask /= 2;
    }
    return bor[v].cnt;
}

string v[26];
inline bool bit(int x, int n) {
    return (x&(1<<n));
}
void calc1(int pos, int mask) {
    if (pos == 13) {
        add_mask(mask);
        return;
    }
    for (int i = 0; i < v[pos].size(); i++) {
        if (!bit(mask, v[pos][i] - 'A')) {
            calc1(pos + 1, (mask|(1<<(v[pos][i] - 'A'))));
        }
    }
}
long long ans = 0;
int fmask;
void calc2(int pos, int mask) {
    if (pos == 26) {
        ans += get_mask(fmask^mask);
        return;
    }
    for (int i = 0; i < v[pos].size(); i++) {
        if (!bit(mask, v[pos][i] - 'A')) {
            calc2(pos + 1, (mask|(1<<(v[pos][i] - 'A'))));
        }
    }
}
signed main () {
    bor.push_back(vertex());
    for (int i = 0; i < 26; i++) cin >> v[i];
    fmask = (1<<26) - 1;
    for (int i = 0; i < 26; i++) {
        set <char> st;
        for (auto it : v[i]) st.insert(it);
        v[i].clear();
        for (auto it : st) v[i].push_back(it);
    }
    calc1(0, 0);
    calc2(13, 0);
    cout << ans << '\n';
    return 0;
}
