#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

int mp[5001 * 5001];
mt19937 rng(time(nullptr));

int mx_n, mx_y;
long long f(long long x, long long y) {
    return x * mx_y + y;
}


int get(int x, int y) {
    int ans = 0;
    for (int i = x; i >= 0; i = (i&(i + 1)) - 1) {
        for (int j = y; j >= 0; j = (j&(j + 1)) - 1) {
            ans += mp[f(i, j)];
        }
    }
    return ans;
}

int get(int x, int y, int xx, int yy) {
    return get(x, y) + get(xx, yy) - get(x, yy) - get(xx, y);
}

void update(int x, int y, int add) {
    for (int i = x; i <= mx_n; i |= i + 1) {
        for (int j = y; j <= mx_y; j |= j + 1) {
            mp[f(i, j)] += add;
        }
    }
}

int n, w, h;

int check2(int x, int y) {
    return get(max<int>(0, x - w - 1), max<int>(0, y - h - 1), x, y);
}

int check(int x, int y) {
    return max(get(x - 1, y - 1, x + w, y + h), check2(x, y));
}

signed main () {
    cin >> n >> w >> h;
    vector <pair <int, int> > p;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        mx_n = max(mx_n, x);
        mx_y = max(mx_y, y);
        p.push_back({x, y});
    }
    mx_n += w;
    mx_y += h;
    for (auto it : p) {
        update(it.first, it.second, 1);
    }
    int ans = 0;
    if (n <= 1000) {
        vector <int> x, y;
        for (int i = 0; i < n; i++) {
            x.push_back(p[i].first);
            y.push_back(p[i].second);
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                ans = max(ans, check(x[i], y[j]));
            }
        }
    }
    else {
        for (auto it : p) {
            ans = max(ans, check(it.first, it.second));
        }
        for (int i = 0; i <= 10000; i++) {
            ans = max(ans, check(p[rng() % n].first, p[rng() % n].second));
        }
    }
    cout << ans << '\n';
    return 0;
}












