#include<iostream>
#include<vector>
#include<unordered_set>
#include<algorithm>

using namespace std;

const long long INF = 2e18;

int main() {
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	vector<long long> pref_sum(n + 1, 0);
	for (int i = 1; i < n + 1; ++i) {
		cin >> a[i - 1];
		pref_sum[i] = pref_sum[i - 1] + a[i - 1];
	}
	long long ans = INF;
	if (n <= 10) {
		for (int mask = 0; mask < (1 << (n - 1)); ++mask) {
			vector<int> coor;
			for (int i = 0; i < n - 1; ++i)
				if (mask & (1 << i))
					coor.push_back(i + 1);
			if (coor.size() == k - 1) {
				int left = 0;
				long long cur = 0;
				for (auto c : coor) {
					cur += (pref_sum[c] - pref_sum[left]) * (c - left - 1);
					left = c;
				}
				cur += (pref_sum[n] - pref_sum[left]) * (n - left - 1);
				if (cur == 22) {
					cout << mask << '\n';
				}
				ans = min(cur, ans);

			}
		}
		cout << ans;
	}
	else if (k == 3) {
		for (int i = 1; i < n; ++i) {
			long long cur = (pref_sum[i] - pref_sum[0]) * (i - 1);
			int l = i + 1, r = n, ml, mr;
			while (r > l + 2) {
				ml = (r - l) / 3 + l;
				mr = (2 * (r - l)) / 3 + l;
				long long left = (pref_sum[ml] - pref_sum[i]) * (ml - i - 1) + (pref_sum[n] - pref_sum[ml]) * (n - ml - 1);
				long long right = (pref_sum[mr] - pref_sum[i]) * (mr - i - 1) + (pref_sum[n] - pref_sum[mr]) * (n - mr - 1);
				if (right < left)
					l = ml;
				else
					r = mr;
			}
			if (r == l + 1) {
				long long left = (pref_sum[l] - pref_sum[i]) * (l - i - 1) + (pref_sum[n] - pref_sum[l]) * (n - l - 1);
				long long right = (pref_sum[r] - pref_sum[i]) * (r - i - 1) + (pref_sum[n] - pref_sum[r]) * (n - r - 1);
				if (left > right)
					l = r;
			}
			else if (l != n) {
				r = l + 1;
				long long left = (pref_sum[l] - pref_sum[i]) * (l - i - 1) + (pref_sum[n] - pref_sum[l]) * (n - l - 1);
				long long right = (pref_sum[r] - pref_sum[i]) * (r - i - 1) + (pref_sum[n] - pref_sum[r]) * (n - r - 1);
				if (left > right)
					l = r;
			}
			cur += (pref_sum[l] - pref_sum[i]) * (l - i - 1) + (pref_sum[n] - pref_sum[l]) * (n - l - 1);
			ans = min(ans, cur);
		}
		cout << ans;
	}
}