#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
struct Event{
    ll t,l,r,type;
    Event(ll x,ll a,ll b,ll c)
    {
        t=x;
        l=a;
        r=b;
        type=c;
    }
};
operator<(const Event a,const Event b)
{
    if(a.t==b.t)
        return a.type>b.type;
    return a.t<b.t;
}
vector<Event> sl;
struct Node{
    ll l,r,l_son,r_son,mx,to_add;
    Node(ll a,ll b)
    {
        to_add=0;
        l=a;
        r=b;
        l_son=-1;
        r_son=-1;
        mx=0;
    }
};
vector<Node> stree;
void push(ll ind)
{
    ll mid=(stree[ind].l+stree[ind].r)/2;
    if(stree[ind].l_son==-1)
    {
        stree[ind].l_son=stree.size();
        stree.push_back({stree[ind].l,mid});
    }
    if(stree[ind].r_son==-1)
    {
        stree[ind].r_son=stree.size();
        stree.push_back({mid,stree[ind].r});
    }
    stree[stree[ind].l_son].to_add+=stree[ind].to_add;
    stree[stree[ind].r_son].to_add+=stree[ind].to_add;
    stree[ind].to_add=0;
    return;
}
void to_good(ll ind)
{
    stree[ind].mx=max(stree[stree[ind].l_son].mx+stree[stree[ind].l_son].to_add,stree[stree[ind].r_son].mx+stree[stree[ind].r_son].to_add);
    //cout<<stree[ind].mx<<' '<<stree[stree[ind].l_son].mx<<'\n';
    return;
}
void upd(ll x,ll y,ll cnt,ll ind=0)
{
    if(stree[ind].l>=y||stree[ind].r<=x)
        return;
    if(stree[ind].l>=x&&stree[ind].r<=y)
    {
        stree[ind].to_add+=cnt;
        return;
    }
    push(ind);
    upd(x,y,cnt,stree[ind].l_son);
    upd(x,y,cnt,stree[ind].r_son);
    to_good(ind);
    //cout<<stree[ind].l<<' '<<stree[ind].r<<' '<<stree[ind].mx<<' '<<stree[ind].to_add<<'\n';
}
int main(){
    stree.push_back(Node({-100000001,100000001}));
    ll n,w,h;
    cin>>n>>w>>h;
    for(int i=0;i<n;i++)
    {
        ll x,y;
        cin>>x>>y;
        ll t1=x-w;
        sl.push_back({t1,y-h,y,1});
        sl.push_back({x,y-h,y,-1});
    }
    sort(sl.begin(),sl.end());
    ll ans=0;
    for(auto x:sl)
    {
        //ll a;
        //cin>>a;
        //ll tm=x.t;
        ll l=x.l;
        ll r=x.r;
        ll tp=x.type;
        upd(l,r+1,tp);
        ans=max(ans,stree[0].mx+stree[0].to_add);
    }
    cout<<ans;
}
