#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define F first
#define S second
#define pb push_back
#define endl '\n'

using namespace std;
using namespace __gnu_pbds;


template <typename T> using ordered_set = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

vector<pair<int,int> > a;


int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt","r",stdin);
        freopen("output.txt","w",stdout);
    #else
        //freopen("input.txt","r",stdin);
        //freopen("output.txt","w",stdout);
    #endif

    int n,w,h;

    cin>>n>>w>>h;

    a.resize(n);

    for(int i=0;i<n;i++){
        cin>>a[i].F>>a[i].S;
    }

    //return 0;

    if(n<=1001){
        sort(a.begin(),a.end());

        int ans=1;
        for(int i=0;i<n;i++){
            int y=a[i].S;
            int yvx=y+h;
            int l=0,r=0;
            while(a[l].F<(a[i].F-w)){
                l++;r++;
            }
            int cur=0;
            if(a[l].S>=y && a[l].S<=yvx){
                cur=1;
            }
            while(l<=i){
                while(r+1<n && a[r+1].F<=a[l].F+w){
                    r++;
                    if(a[r].S>=y && a[r].S<=yvx){
                        cur++;
                        ans=max(ans,cur);
                    }
                }

                if(a[l].S>=y && a[l].S<=yvx){
                        cur--;
                }
                l++;
            }
        }
        cout<<ans<<endl;
    }
    else{
        int kol[1001][1001];
        map<pair<int,int>,int> mp;
        for(int i=0;i<n;i++){
            mp[{a[i].F,a[i].S}]++;
        }
        for(int i=0;i<1001;i++){
            for(int j=0;j<1001;j++){
                if(i>0 && j>0)
                kol[i][j]=kol[i][j-1]+kol[i-1][j]-kol[i-1][j-1];
                else
                if(i==0){
                    kol[i][j]=kol[i][j-1];
                }
                else
                if(j==0){
                    kol[i][j]=kol[i-1][j];
                }
                if(mp.count({i,j})>0){
                    kol[i][j]+=mp[{i,j}];
                }
            }
        }

        int ans=0;

        for(int i=0;i<n;i++){
            int cur=kol[a[i].F][a[i].S];
            if(a[i].F-w-1>=0){
                cur-=kol[a[i].F-w-1][a[i].S];
            }
            if(a[i].S-h-1>=0){
                cur-=kol[a[i].F][a[i].S-h-1];
            }
            if(a[i].S-h-1>=0 && a[i].F-w-1>=0){
                cur+=kol[a[i].F-w-1][a[i].S-h-1];
            }
            ans=max(ans,cur);
        }
        cout<<ans<<endl;
    }


}
