#include <bits/stdc++.h>
#define in(x) freopen(x, "r", stdin)
#define out(x) freopen(x, "w", stdout)
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#define FBO find_by_order
//#define OOK order_of_key
using namespace std;
//using namespace __gnu_pbds;

//typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = (int)(1e5 + 500);

int n, w, h, W, H;
int x[N], y[N];
int pf[(int)(1e3 + 100)][(int)(1e3 + 100)];

int solve(int x1, int y1, int x2, int y2) {
    int ret = 0;
    for (int i = 0; i < n; ++i) {
        ret += (x[i] >= x1) && (x[i] <= x2) && (y[i] >= y1) && (y[i] <= y2);
    }
    return ret;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

//    in("input.txt");

    cin >> n >> w >> h;
    W = w;
    H = h;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        W = max(W, x[i]);
        H = max(H, y[i]);
    }

    if (max(W, H) <= 1e4) {
        for (int i = 0; i < n; ++i) {
            ++pf[x[i]][y[i]];
        }

        for (int i = 0; i <= W; ++i) {
            for (int j = 0; j <= H; ++j) {
                if (i - 1 >= 0) {
                    pf[i][j] += pf[i - 1][j];
                }
                if (j - 1 >= 0) {
                    pf[i][j] += pf[i][j - 1];
                }
                if (i - 1 >= 0 && j - 1 >= 0) {
                    pf[i][j] -= pf[i - 1][j - 1];
                }
            }
        }

        int ans = 0;
        for (int i = 0; i <= W; ++i) {
            for (int j = 0; j <= H; ++j) {
                int cur = pf[i][j];
                if (i - w - 1 >= 0) {
                    cur -= pf[i - w - 1][j];
                }
                if (j - h - 1 >= 0) {
                    cur -= pf[i][j - h - 1];
                }
                if (i - w - 1 >= 0 && j - h - 1 >= 0) {
                    cur += pf[i - w - 1][j - h - 1];
                }
                ans = max(ans, cur);
            }
        }

        cout << ans << "\n";
    } else {
        int ans = 0;

        for (int i = 0; i < n; ++i) {
            ans = max(ans, solve(x[i] - w, y[i] - h, x[i], y[i]));
            ans = max(ans, solve(x[i] - w, y[i], x[i], y[i] + h));
            ans = max(ans, solve(x[i], y[i] - h, x[i] + w, y[i]));
            ans = max(ans, solve(x[i], y[i], x[i] + w, y[i] + h));
        }

        cout << ans << "\n";
    }
}
