#include <bits/stdc++.h>
#define in(x) freopen(x, "r", stdin)
#define out(x) freopen(x, "w", stdout)
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#define FBO find_by_order
//#define OOK order_of_key
using namespace std;
//using namespace __gnu_pbds;

//typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = (int)(1e5 + 500);

int n, w, h, W, H, ans = 0;
int x[N], y[N], fen[N];
int pf[(int)(1e3 + 100)][(int)(1e3 + 100)];
vector <int> X, Y;
vector <pair <int, int> > all;

bool cmp(pair <int, int> a, pair <int, int> b) {
    return (a.second == b.second) ? a.first < b.first : a.second < b.second;
}

void upd(int _x, int val) {
    while (_x <= (int)(1e5)) {
        fen[_x] += val;
        _x += (_x & -_x);
    }
}

int get(int _x) {
    int ret = 0;
    while (_x > 0) {
        ret += fen[_x];
        _x -= (_x & -_x);
    }
    return ret;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

//    in("input.txt");

    cin >> n >> w >> h;
    W = w;
    H = h;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        W = max(W, x[i]);
        H = max(H, y[i]);
    }

    if (max(W, H) <= 1e4) {
        for (int i = 0; i < n; ++i) {
            ++pf[x[i]][y[i]];
        }

        for (int i = 0; i <= W; ++i) {
            for (int j = 0; j <= H; ++j) {
                if (i - 1 >= 0) {
                    pf[i][j] += pf[i - 1][j];
                }
                if (j - 1 >= 0) {
                    pf[i][j] += pf[i][j - 1];
                }
                if (i - 1 >= 0 && j - 1 >= 0) {
                    pf[i][j] -= pf[i - 1][j - 1];
                }
            }
        }

        for (int i = 0; i <= W; ++i) {
            for (int j = 0; j <= H; ++j) {
                int cur = pf[i][j];
                if (i - w - 1 >= 0) {
                    cur -= pf[i - w - 1][j];
                }
                if (j - h - 1 >= 0) {
                    cur -= pf[i][j - h - 1];
                }
                if (i - w - 1 >= 0 && j - h - 1 >= 0) {
                    cur += pf[i - w - 1][j - h - 1];
                }
                ans = max(ans, cur);
            }
        }
    } else {
        vector <int> X, Y;
        X.clear();
        Y.clear();
        for (int i = 0; i < n; ++i) {
            X.push_back(x[i]);
            Y.push_back(y[i]);
        }

        sort(X.begin(), X.end());
        sort(Y.begin(), Y.end());
        X.resize(unique(X.begin(), X.end()) - X.begin());
        Y.resize(unique(Y.begin(), Y.end()) - Y.begin());

        for (int i = 0; i < n; ++i) {
            int _x = lower_bound(X.begin(), X.end(), x[i]) - X.begin();
            int _y = lower_bound(Y.begin(), Y.end(), y[i]) - Y.begin();
            ++pf[_x][_y];
        }

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i - 1 >= 0) {
                    pf[i][j] += pf[i - 1][j];
                }
                if (j - 1 >= 0) {
                    pf[i][j] += pf[i][j - 1];
                }
                if ((i - 1 >= 0) && (j - 1 >= 0)) {
                    pf[i][j] -= pf[i - 1][j - 1];
                }
            }
        }

        for (int i = 0; i < (int)(X.size()); ++i) {
            for (int j = 0; j < (int)(Y.size()); ++j) {
                int cx = X[i], cy = Y[j];
                int nx = lower_bound(X.begin(), X.end(), cx - w) - X.begin();
                int ny = lower_bound(Y.begin(), Y.end(), cy - h) - Y.begin();

                int cur = pf[i][j];
                if (nx - 1 >= 0) {
                    cur -= pf[nx - 1][j];
                }
                if (ny - 1 >= 0) {
                    cur -= pf[i][ny - 1];
                }
                if ((nx - 1 >= 0) && (ny - 1 >= 0)) {
                    cur += pf[nx - 1][ny - 1];
                }

                ans = max(ans, cur);
            }
        }
    }

    all.clear();
    for (int i = 0; i < n; ++i) {
        all.push_back(make_pair(x[i], y[i]));
    }

    sort(all.begin(), all.end(), cmp);

    int l = 0;
    for (int i = 0; i < n; ++i) {
        int _x = all[i].first, _y = all[i].second;
        while (all[l].second < _y - h) {
            upd(all[l].first, -1);
            ++l;
        }
        upd(_x, +1);
        int vl1 = get(_x);
        int vl2 = get(_x - w - 1);
        ans = max(ans, vl1 - vl2);
    }

    cout << ans << "\n";
}
