#include <bits/stdc++.h>

using namespace std;

unordered_map<int, int> norm_x;
vector<int> list_x;

unordered_map<int, int> norm_y;
vector<int> list_y;

vector<pair<int, int>> points;

const int offset = (1<<17);

struct node
{
    int lazy = 0;
    int maxim = 0;
} aint[2 * offset + 7];

void lazy_push(int nod)
{
    if(nod >= offset)
    {
        aint[nod].maxim += aint[nod].lazy;
        aint[nod].lazy = 0;
    }
    else
    {
        aint[nod].maxim += aint[nod].lazy;
        aint[2*nod].lazy += aint[nod].lazy;
        aint[2*nod + 1].lazy += aint[nod].lazy;
        aint[nod].lazy = 0;
    }
}

void update(int nod, int l, int r, int gl, int gr, int to_add)
{
    lazy_push(nod);

    if(l <= gl && gr <= r) {
        aint[nod].lazy += to_add;
        lazy_push(nod);
        return;
    }
    if(r < gl || l > gr) return;

    int mid = (gl + gr) / 2;

    update(2 * nod, l, r, gl, mid, to_add);
    update(2*nod + 1, l, r, mid+1, gr, to_add);

    aint[nod].maxim = max(aint[2*nod].maxim, aint[2*nod + 1].maxim);
}

vector<int> lines[offset];

int main()
{
    int n, w, h; cin >> n >> w >> h;
    for(int i = 0; i < n; i++)
    {
        int x, y; cin >> x >> y;
        points.push_back(make_pair(x, y));
        if(norm_x[x] == 0)
        {
            norm_x[x] = 1;
            list_x.push_back(x);
        }
        if(norm_y[y] == 0)
        {
            norm_y[y] = 1;
            list_y.push_back(y);
        }
    }

    sort(list_x.begin(), list_x.end());

    for(int i = 0; i < list_x.size(); i++) {
        norm_x[list_x[i]] = i;
    }

    for(auto pct : points)
    {
        lines[norm_x[pct.first]].push_back(pct.second);
    }

    sort(list_y.begin(), list_y.end());
    for(int i = 0; i < list_y.size(); i++) {
        norm_y[list_y[i]] = i;
    }

    int ptr1 = 0;
    int ptr2 = 0;

    int maxim = 0;

    while(ptr1 < list_x.size())
    {
        while(ptr2 < list_x.size() && list_x[ptr2] - list_x[ptr1] <= w)
        {
            for(auto pct : lines[ptr2])
                update(1, pct - h, pct, 0, offset-1, 1);
            ptr2++;
        }

        //cout << aint[1].maxim << endl;
        maxim = max(aint[1].maxim, maxim);

        for(auto pct : lines[ptr1])
            update(1, pct - h, pct, 0, offset-1, -1);
        ptr1++;
    }

    cout << maxim;
}
