#include <bits/stdc++.h>

const int SIGMA = 26;

std::string str[SIGMA];

std::unordered_map<int, int> cnt_mask1, cnt_mask2;

void meet_in_the_middle(int N, std::string* str, std::unordered_map<int, int> &mp) {
	int lim = 1;
	for(int i = 0; i < N; ++i)
		lim = lim * str[i].size();
	
	for(int mask = 0; mask < lim; ++mask) {
		int i = 0, letters = 0, maskc = mask;
		bool ok = true;
		for(int i = 0; i < N; ++i) {
			int j = maskc % str[i].size();
			if(j >= str[i].size())
				ok = false;
			else if((1 << (str[i][j] - 'A')) & letters)
				ok = false;
			letters |= (1 << (str[i][j] - 'A'));
			maskc /= str[i].size();
		}

		if(ok)
			mp[letters]++;
	}
}

int main() {
	for(int i = 0; i < SIGMA; ++i) {
		std::cin >> str[i];
		
		std::sort(str[i].begin(), str[i].end());
		str[i].resize(std::unique(str[i].begin(), str[i].end()) - str[i].begin());
	}

	//fprintf(stderr, "Curated:\n");
	//for(int i = 0; i < SIGMA; ++i)
	//	fprintf(stderr, "%s\n", str[i].c_str());

	meet_in_the_middle(13, str, cnt_mask1);
	meet_in_the_middle(13, str + 13, cnt_mask2);

	long long res = 0LL;
	for(auto it: cnt_mask1) {
		res += (long long)cnt_mask2[((1 << SIGMA) - 1) ^ it.first] * it.second;
	}
	printf("%lld", res);
	return 0;
}
