#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second
#define re return
#define pb push_back
#define endl "\n"

#define fr(i, a, b) for(int i = (a); i <= (b); i++)
#define rf(i, a, b) for(int i = (a); i >= (b); i--)
#define fe(x, y) for(auto& x : y)
#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

deque<pii> d;
ordered_set<pii> st;

int main(){
#ifdef LOCAL

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

#endif

    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int n, w, h, ans = 0;
    cin >> n >> w >> h;

    vector<pii> a(n);
    fe(x, a)cin >> x.fi >> x.se;

    sort(all(a));

    if(n <= 1e3){
        int j = 0;
        fr(i, 0, n - 1){

            while(j < n && abs(a[i].fi - a[j].fi) <= w)d.pb(a[j++]);

            vector<pii> v;
            fe(x, d)v.pb({x.se, x.fi});

            sort(all(v));

            int j2 = 0;
            fr(i2, 0, v.size() - 1){
                while(j2 < v.size() && abs(v[i2].fi - v[j2].fi) <= h)j2++;
                ans = max(j2 - i2, ans);
            }

            d.pop_front();
        }

        cout << ans << endl;
    }
    else {

        int j = 0;
        fr(i, 0, n - 1){
            st.insert({a[i].se, i});

            while(j < n && abs(a[j].fi - a[i].fi) > w){
                st.erase({a[j].se, j});
                j++;
            }

            int x = st.order_of_key({a[i].se, 1e9});
            int y = st.order_of_key({a[i].se - h, -1});

            ans = max(ans, x - y);
        }

        cout << ans << endl;

    }

re 0;}
