#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long

using namespace std;

using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;

const int N = 3e5 + 23;
const int M = 1e9 + 7;

int n, w, h;

pair < int, int > a[N];

unordered_map < int, int > what;

vector < int > d, lazy;

void push(int v) {
    if (lazy[v]) {
        d[v * 2] += lazy[v];
        d[v * 2 + 1] += lazy[v];
        lazy[v * 2] += lazy[v];
        lazy[v * 2 + 1] += lazy[v];
        lazy[v] = 0;
    }
}

void add(int v, int l, int r, int cl, int cr, int x) {
    if (cl >= r || cr <= l) {
        return;
    }
    if (cl >= l && cr <= r) {
        d[v] += x;
        lazy[v] += x;
        return;
    }
    push(v);
    int mid = (cl + cr) / 2;
    add(v * 2, l, r, cl, mid, x);
    add(v * 2 + 1, l, r, mid, cr, x);
    d[v] = max(d[v * 2], d[v * 2 + 1]);
}

int get(int v, int l, int r, int cl, int cr) {
    if (cl >= r || cr <= l) {
        return 0;
    }
    if (cl >= l && cr <= r) {
        return d[v];
    }
    push(v);
    int mid = (cl + cr) / 2;
    return max(get(v * 2, l, r, cl, mid), get(v * 2 + 1, l, r, mid, cr));
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> w >> h;
    vector < int > all;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].F >> a[i].S;
        all.pb(a[i].S);
        all.pb(a[i].S + h);
    }
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());
    int sz = (int)(all.size());
    for (int i = 0; i < sz; ++i) {
        what[all[i]] = i;
    }
    int st = 0;
    while ((1 << st) < sz) {
        ++st;
    }
    d.resize(1 << (st + 1));
    lazy.resize(1 << (st + 1));
    sort(a, a + n);
    int ans = 0;
    queue < pair < int, int > > del;
    for (int i = 0; i < n; ++i) {
        while (!del.empty() && (del.front()).F <= a[i].F) {
            add(1, what[(del.front()).S], what[(del.front()).S + h] + 1, 0, 1 << st, -1);
            del.pop();
        }
        add(1, what[a[i].S], what[a[i].S + h] + 1, 0, 1 << st, 1);
        del.push({a[i].F + w + 1, a[i].S});
        ans = max(ans, d[1]);
    }
    cout << ans;
    return 0;
}
