#include <bits/stdc++.h>
#include <immintrin.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define rsz resize
#define mp make_pair

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;

template<class T> bool ckmin(T& a, T b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, T b) { return a < b ? a = b, true : false; }

const int INF = 1e9;
const ll LINF = 1e18;

mt19937 rng(1337228);

const int A = 26;
const int C = 1 << A;

vi x[A], mods;

int popcnt(int x) {
    return x ? x%2 + popcnt(x/2) : 0;
}

bool is_prime(int x) {
    if (x % 2 == 0) return false;
    for (int i = 3; i*i <= x; i += 2)
        if (x % i == 0) return false;
    return true;
}

ll rev(ll a, ll m) {
    return a == 1 ? 1 : m - m*rev(m%a,a)/a;
}

ll solve(ll a, ll b, ll n, ll m) {
    ll k = (b - a) % m; if (k < 0) k += m;
    ll x = k * rev(n, m) % m;
    ll res = n * x + a;
    assert(res % n == a);
    assert(res % m == b);
    // cout << a << ' ' << b << ' ' << n << ' ' << m << " -> " << res << endl;
    return res;
}

ll solve(vector<pair<ll, ll>> diof) {
    while(diof.size() > 1) {
        ll a, b, n, m;
        tie(a, n) = diof.back(); diof.pop_back();
        tie(b, m) = diof.back(); diof.pop_back();
        diof.eb(solve(a, b, n, m), n*m);
    }
    return diof[0].F;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    ll res = 1;

    int i = 1 << 15;
    while (mods.size() < 4) {
        while (!is_prime(i)) --i;
        mods.pb(i--);
    }

    // cout << sizeof(cnt) / (int)1e6 << "MB" << endl;

    for (int i = 0; i < 26; ++i) {
        string name; cin >> name;
        sort(all(name)); name.erase(unique(all(name)), name.end());
        for(char c : name) x[i].pb(c - 'A');
    }


    uint16_t* cnt = new uint16_t[C];
    vector<pair<ll, ll>> diof;
    for (int m : mods) {
        cnt[0] = 1;
        for (int mask = 1; mask < C; ++mask) cnt[mask] = 0;
        for (int mask = 0; mask < C; ++mask) {
            int i = popcnt(mask); //_mm_popcnt_u32
            for (int j : x[i]) {
                const int nmask = mask | (1 << j);
                if (nmask != mask) {
                    cnt[nmask] += cnt[mask];
                    if (cnt[nmask] >= m) cnt[nmask] -= m;
                }
            }
        }
        diof.eb(cnt[C-1], m);
        // cout << "Count " << m << " -> " << cnt[C-1] << endl;
    }

    cout << solve(diof) << endl;
}

/*
ELLY KRISS STAN WU ALEX ZOE POOH KATE VILI MAXIM QT G ZAEK BOBI TEO YOYO DEQN FIL CECO DAWG JORO MONI SASHO DUDA VESKO POOH
*/