#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt")

#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
#include <random>
#include <immintrin.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define rsz resize
#define mp make_pair

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;

template<class T> bool ckmin(T& a, T b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, T b) { return a < b ? a = b, true : false; }

const int INF = 1e9;
const ll LINF = 1e18;

const int A = 26, M = 10;
const int C = 1 << A;

uint16_t cnt[C];
vi x[A], mods;

mt19937 rng(1337228);

bool is_prime(int x) {
    if (x % 2 == 0) return false;
    for (int i = 3; i*i <= x; i += 2)
        if (x % i == 0) return false;
    return true;
}

ll rev(ll a, ll m) {
    return a == 1 ? 1 : m - m*rev(m%a,a)/a;
}

ll solve(ll a, ll b, ll n, ll m) {
    ll k = (b - a) % m; if (k < 0) k += m;
    ll x = k * rev(n, m) % m;
    ll res = n * x + a;
    return res;
}

ll solve(vector<pair<ll, ll>> diof) {
    while(diof.size() > 1) {
        ll a = diof.back().F, n = diof.back().S; diof.pop_back();
        ll b = diof.back().F, m = diof.back().S; diof.pop_back();
        diof.eb(solve(a, b, n, m), n*m);
    }
    return diof[0].F;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int i = 1 << 15;
    while (mods.size() < 4) {
        while (!is_prime(i)) --i;
        mods.pb(i--);
    }

    for (int i = 0; i < 26; ++i) {
        string name; cin >> name;
        sort(all(name)); name.erase(unique(all(name)), name.end());
        for(char c : name) x[i].pb(1 << c - 'A');
    }
    shuffle(x, x+26, rng);

    vector<pair<ll, ll>> diof;
    for (int m : mods) {
        cnt[0] = 1;
        for (int mask = 1; mask < C; ++mask) cnt[mask] = 0;
        for (int mask = 0; mask < C; ++mask) {
            if (!cnt[mask]) continue;
            int i = __builtin_popcount((uint32_t)mask); //_mm_popcnt_u32
            for (int j : x[i]) {
                const int nmask = mask | j;
                if (nmask != mask) {
                    cnt[nmask] += cnt[mask];
                    if (cnt[nmask] >= m) cnt[nmask] -= m;
                }
            }
        }
        diof.eb(cnt[C-1], m);
    }

    cout << solve(diof) << endl;
}

/*
ELLY KRISS STAN WU ALEX ZOE POOH KATE VILI MAXIM QT G ZAEK BOBI TEO YOYO DEQN FIL CECO DAWG JORO MONI SASHO DUDA VESKO POOH
*/