#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define rsz resize
#define mp make_pair

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;
using vpi = vector<pi>;

template<class T> bool ckmin(T& a, T b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, T b) { return a < b ? a = b, true : false; }

const int INF = 1e9;
const ll LINF = 1e18;

mt19937 rng(1337228);

const int N = 1e5+7;
const int LG = 30;  // 30
const int C = 1 << LG;

struct Node {
    int a, x; // a - max, x - add
    int l, r;

    Node(int a = 0, int x = 0, int l = 0, int r = 0) : a(a), x(x), l(l), r(r) { }
} nd[2*N*LG];
int __nd_i = 1;

int new_node(int l, int r, int x) {
    nd[__nd_i].l = l;
    nd[__nd_i].r = r;
    nd[__nd_i].x = x;
    nd[__nd_i].a = max(nd[l].a + nd[l].x, nd[r].a + nd[r].x);
    return __nd_i++;
}

int add(int v, int vl, int vr, int l, int r, int x) {
    if (l <= vl && vr <= r) return new_node(nd[v].l, nd[v].r, nd[v].x + x);
    if (r <= vl || vr <= l) return v;

    // cout << "add v=" << v << ", vl=" << vl << ", vr=" << vr << endl;

    int vm = (vl + vr) / 2;
    return new_node(add(nd[v].l, vl, vm, l, r, x),
                    add(nd[v].r, vm, vr, l, r, x), nd[v].x);
}

int add_point(int t, int x, int w, int d) {
    // cout << (d > 0 ? "add" : "del") << " point " << x << " at [" << x << "; " << x+w+1 << ")" << endl;
    return add(t, 0, C, x, x+w+1, d);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n, w, h; cin >> n >> w >> h;
    vpi v(n); for(pi& x : v) cin >> x.F >> x.S;
    sort(all(v));

    int t = 0, ans = 0;
    for (int i = 0, j = 0; i < n; ++i) {
        t = add_point(t, v[i].S, w, +1);
        while (j < i && v[j].F < v[i].F - w) 
            t = add_point(t, v[j++].S, h, -1);

        // cout << nd[t].a + nd[t].x << endl;
        ckmax(ans, nd[t].a + nd[t].x);       
    }

    cout << ans << endl;
}

/*
10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2
*/