#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define rsz resize
#define mp make_pair

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;
using vpi = vector<pi>;

template<class T> bool ckmin(T& a, T b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, T b) { return a < b ? a = b, true : false; }

const int INF = 1e9;
const ll LINF = 1e18;

mt19937 rng(1337228);

const int N = 1e5+7;
const int LG = 18;  // 30
const int C = 1 << LG;

int tmax[2*C], tadd[2*C];

void add(int v, int vl, int vr, int l, int r, int x) {
    if (l <= vl && vr <= r) {
        tadd[v] += x;
    } else if (r > vl && vr > l) {
        int vm = (vl + vr) / 2;
        add(2*v, vl, vm, l, r, x);
        add(2*v+1, vm, vr, l, r, x);
        tmax[v] = max(tmax[2*v] + tadd[2*v], tmax[2*v+1] + tadd[2*v+1]);
    }
}

void add_point(int x, int w, int d, const vi& vx) {
    const int l = lower_bound(all(vx), x)     - vx.begin();
    const int r = lower_bound(all(vx), x+w+1) - vx.begin();
    add(1, 0, C, l, r, d);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n, w, h; cin >> n >> w >> h;

    vi vx;
    vpi v(n); for(pi& x : v) cin >> x.F >> x.S, vx.push_back(x.S);
    sort(all(v));
    sort(all(vx)); vx.erase(unique(all(vx)), vx.end());

    int ans = 0;
    for (int i = 0, j = 0; i < n; ++i) {
        add_point(v[i].S, h, +1, vx);
        while (v[j].F < v[i].F - w) 
            add_point(v[j++].S, h, -1, vx);
        ckmax(ans, tmax[1] + tadd[1]);       
    }

    cout << ans << endl;
}

/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
*/