#include <iostream>
#include <cstring>
#include <algorithm>

using namespace std;

using ll = long long;

const int NMAX = 27, SIGMAX = (int)('Z' - 'A' + 1);
const int MMAX = 6;

bool fr[NMAX][SIGMAX];
int List[NMAX][MMAX];

char S[MMAX];

int ans = 0;

int p[NMAX];

static inline void Load ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    for(int i = 1; i <= 26; ++i)
    {
        cin >> (S + 1);

        int M = (int)strlen(S + 1);

        for(int j = 1; j <= M; ++j)
            fr[i][(int)(S[j] - 'A')] = 1;

        for(int j = 0; j <= (int)('Z' - 'A'); ++j)
            if(fr[i][j])
                List[i][++List[i][0]] = j;
    }

    return;
}

bool Sel[SIGMAX];

static inline void Back (int Level)
{
    if(Level == 27)
    {
        ++ans;

        return;
    }

    int Id = p[Level];

    for(int i = 1; i <= List[Id][0]; ++i)
        if(!Sel[List[Id][i]])
            Sel[List[Id][i]] = 1, Back(Level + 1), Sel[List[Id][i]] = 0;

    return;
}

int main()
{
    Load();

    for(int i = 1; i <= 26; ++i)
        p[i] = i;

    random_shuffle(p + 1, p + 26 + 1);

    Back(1);

    cout << ans << '\n';

    return 0;
}
