#include <iostream>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 1e3 + 5;

int N, W, H;

PII A[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> W >> H;

    for(int i = 1; i <= N; ++i)
        cin >> A[i].first >> A[i].second;

    return;
}

static inline int Go (int X1, int Y1, int X2, int Y2)
{
    int ans = 0;

    for(int i = 1; i <= N; ++i)
        if(A[i].first >= X1 && A[i].first <= X2)
            if(A[i].second >= Y1 && A[i].second <= Y2)
                ++ans;

    return ans;
}

static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

static inline void Task_1 ()
{
    int ans = 0;

    for(int i = 1; i <= N; ++i)
    {
        ans = my_max(ans, Go(A[i].first, A[i].second, A[i].first + W, A[i].second + H));
        ans = my_max(ans, Go(A[i].first - W, A[i].second, A[i].first, A[i].second + H));
        ans = my_max(ans, Go(A[i].first - W, A[i].second - H, A[i].first, A[i].second));
        ans = my_max(ans, Go(A[i].first, A[i].second - H, A[i].first + W, A[i].second));

        ans = my_max(ans, Go(A[i].first - W / 2, A[i].first + W / 2, A[i].second - W / 2, A[i].second + W / 2));
    }

    cout << ans << '\n';

    return;
}

static inline void Solve ()
{
    if(N <= 1e3)
        Task_1();

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
