#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;


#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
 
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")



mt19937 gen(time(0));

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const int n = 26;

vector<pair<int, ll>>	get(vector<vector<int>> a) {
	vector<pair<int, ll>> dp;
	for(int x : a[0]) {
		dp.emplace_back(1 << x, 1);
	}
	for(int i = 1; i < 13; i++) {
		vector<pair<int, ll>> nxt;
		while (!dp.empty()) {
			auto v = dp.back();
			dp.pop_back();
			if (size(nxt) >= 1e7 && fl) {
				fl = 0;
				vector<pair<int, ll>> norm;
				sort(all(nxt));
				for(int i = 0; i < size(nxt); ) {
					norm.emplace_back(nxt[i].first, 0);
					int de = i;
					while (i < size(nxt) && nxt[i].first == nxt[de].first) {
						norm.back().second += nxt[i++].second;
					}
				}
				swap(norm, nxt);
			}
			for(int z : a[i]) {
				if ((v.first & (1 << z)) == 0) {
					nxt.emplace_back(v.first ^ (1 << z), v.second);
				}
			}
		}
		sort(all(nxt));
		for(int i = 0; i < size(nxt); ) {
			dp.emplace_back(nxt[i].first, 0);
			int de = i;
			while (i < size(nxt) && nxt[i].first == nxt[de].first) {
				dp.back().second += nxt[i++].second;
			}
		}
	}
	return dp;
}

void run() {
	vector<vector<int>> a(n);
	for(int i = 0; i < n; i++) {
		string s;
		cin >> s;
		sort(all(s));
		s.resize(unique(all(s)) - s.begin());
		for(char c : s)
		 a[i].push_back(c - 'A');
	}
	//shuffle(all(a), gen);
	vector<vector<int>> l, r;
	for(int i = 0; i < n; i++) {
		if (i < n / 2) {
			l.push_back(a[i]);
		} else {
			r.push_back(a[i]);
		}
	}
	auto a1 = get(l);
	auto a2 = get(r);

	ll ans = 0;
	ll pt = size(a2) - 1;
	int mask = (1 << n) - 1;
	for(int i = 0; i < size(a1); i++) {
		while (pt >= 0 && (a1[i].first ^ mask) < a2[pt].first) {
			pt--;
		}
		if ((a1[i].first ^ a2[pt].first) == mask) {
			ans += a1[i].second * a2[pt].second;
		}
	}
	cout << ans;
}

signed main() {
#ifdef LOCAL
	freopen("input", "r", stdin);
	freopen("output", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	run();
	
}	