#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;


#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
 
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")



mt19937 gen(time(0));

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const int n = 26;

vector<pair<int, ll>>	get(vector<vector<int>> a) {
	vector<pair<int, ll>> dp;
	for(int x : a[0]) {
		dp.emplace_back(1 << x, 1);
	}
	for(int i = 1; i < size(a); i++) {
		vector<pair<int, ll>> nxt;
		bool fl = 1;
		while (!dp.empty()) {
			auto v = dp.back();
			dp.pop_back();
			
			if (size(nxt) >= 1e7 && fl) {
				fl = 0;
				vector<pair<int, ll>> norm;
				sort(all(nxt));
				for(int i = 0; i < size(nxt); ) {
					norm.emplace_back(nxt[i].first, 0);
					int de = i;
					while (i < size(nxt) && nxt[i].first == nxt[de].first) {
						norm.back().second += nxt[i++].second;
					}
				}
				swap(norm, nxt);
			}
			
			for(int z : a[i]) {
				if ((v.first & (1 << z)) == 0) {
					nxt.emplace_back(v.first ^ (1 << z), v.second);
				}
			}
		}
		sort(all(nxt));
		for(int i = 0; i < size(nxt); ) {
			dp.emplace_back(nxt[i].first, 0);
			int de = i;
			while (i < size(nxt) && nxt[i].first == nxt[de].first) {
				dp.back().second += nxt[i++].second;
			}
		}
	}
	return dp;
}

void run() {
	vector<vector<int>> a(n);
	for(int i = 0; i < n; i++) {
		string s;
		cin >> s;
		sort(all(s));
		s.resize(unique(all(s)) - s.begin());
		for(char c : s)
		 a[i].push_back(c - 'A');
	}
	shuffle(all(a), gen);
	vector<vector<int>> l, r, m;
	for(int i = 0; i < n; i++) {
		if (i < 13) {
			l.push_back(a[i]);
		} else if (i < 19) {
			r.push_back(a[i]);
		} else {
			m.push_back(a[i]);
		}
	}
	auto a1 = get(r);
	auto a2 = get(l);
	auto a3 = get(m);
	if (size(a2) < size(a3)) swap(a2, a3);
	if (size(a1) < size(a2)) swap(a1, a2);
	reverse(all(a1));
	ll ans = 0;
	swap(a1, a3);
	int mask = (1 << n) - 1;
	for(auto v1 : a3) {
		int pt = 0;
		for(auto v2 : a2) {
			if ((v1.first & v2.first) != 0) {
				continue;
			}
			while (pt + 1 < size(a1) && (a1[pt].first > (mask ^ v1.first ^ v2.first))) {
				pt++;
			}
			if ((v1.first ^ v2.first ^ a1[pt].first) == mask) {
				ans += v1.second * v2.second * a1[pt].second;
			}
		}
	}
	cout << ans;
}

signed main() {
#ifdef LOCAL
	freopen("input", "r", stdin);
	freopen("output", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	run();
	
}	