#include <iostream>
#include <set>
#include <map>

#pragma stack("100000000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optmize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef FREOPEN
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif

    map <long long,long long> dpp,dpc;
    int all = 1<<26;
    dpp[0] = 1;
    set <int> st;
    string s;
    for (int step = 0; step < 26; ++step) {
        cin >> s;
        st.clear();
        for (auto &i: s)
            st.insert(i-'A');
        for (auto &i: st) {
            for (auto &j: dpp) {
                if ((j.first>>i)&1)
                    continue;
                dpc[j.first|(1<<i)]+=j.second;
            }
        }
        dpp.clear();
        for (auto &i: dpc) {
            dpp[i.first] = i.second;
        }
        dpc.clear();
    }

    cout << dpp[all-1];
    return 0;
}