#include <bits/stdc++.h>

using namespace std;

const long long INFLL = 1e18;

int main()
{
    int n, k;
    cin >> n >> k;
    vector<long long> a(n + 1);
    for (int i = 1; i < n + 1; i++)
    {
        cin >> a[i];
    }

    vector<long long> p = a;
    for (int i = 1; i < n + 1; i++)
        p[i] += p[i - 1];
    if (k == 3)
    {
        long long ans = INFLL;
        for (int i = 1; i <= n; i++)
        {
            int L = 1, R = i;
            long long cur = min(L * p[L] + (i - L) * (p[i] - p[L]), R * p[R] + (i - R) * (p[i] - p[R]));
            while (L + 2 < R)
            {
                int M1 = (2 * L + R) / 3;
                int M2 = (L + R * 2) / 3;
                long long g1 = M1 * p[M1] + (i - M1) * (p[i] - p[M1]);
                long long g2 = M2 * p[M2] + (i - M2) * (p[i] - p[M2]);
                cur = min(cur, min(g1, g2));
                if (g1 < g2)
                    R = M2;
                else
                    L = M1;
            }
            for (int j = L + 1; j < R; j++)
                cur = min(cur, j * p[j] + (i - j) * (p[i] - p[j]));
            ans = min(ans, cur + (n - i) * (p[n] - p[i]));
            //cout << cur << endl;
            /*for (int j = 1; j <= i; j++)
            {
                //1..j, j+1..i
                long long res = j * p[j] + (i - j) * (p[i] - p[j]);
                cout << res << " ";
            }
            cout << endl;*/
        }
        cout << ans - accumulate(a.begin(), a.end(), 0ll);
        return 0;
    }
    vector<vector<long long> > dp(2, vector<long long>(n + 1, INFLL));
    dp[0][0] = 0;
    vector<int> ji(n + 1);
    for (int i = 1; i <= n; i++)
        ji[i] = max(0, i - 2200);
    for (int g = 1; g <= k; g++)
    {
        for (int i = max(1, g * n / k - 1100); i <= n && i <= 1ll * g * n / k + 1100; i++)
        {
            dp[g & 1][i] = INFLL;
            for (int j = ji[i]; j < i; j++)
            {
                if (dp[(g - 1) & 1][j] + 1ll * (i - j) * (p[i] - p[j]) < dp[g & 1][i])
                    ji[i] = j;
                dp[g & 1][i] = min(dp[g & 1][i], dp[(g - 1) & 1][j] + 1ll * (i - j) * (p[i] - p[j]));
            }
        }
    }
    cout << dp[k & 1][n] - accumulate(a.begin(), a.end(), 0ll);
}
