#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif 
  const int K = 26;
  vector <int> who(K);

  for (int i = 0; i < 26; ++i) {
    string s;
    cin >> s;
    sort(s.begin(), s.end());
    s.resize(unique(s.begin(), s.end()) - s.begin());
    int mask = 0;
    for (char c : s) {
      who[i] |= (1 << (c - 'A'));
    }
  }
  vector <int> gs;
  int best = K;
  vector <int> best_gs;
  function <void(int, int)> rec = [&] (int id, int mask) {
    if (gs.size() == 5) {
      if (__builtin_popcount(mask) < best) {
        best = __builtin_popcount(mask);
        best_gs = gs;
      }
    } else if (id < K) {
      rec(id + 1, mask);
      gs.push_back(id);
      rec(id + 1, mask | who[id]);
      gs.pop_back();
    }
  };
  rec(0, 0);
  vector <int> ord;
  vector <int> used(K);
  for (int x : gs) {
    ord.push_back(x);
    used[x] = 1;
  }
  for (int i = 0; i < K; ++i) {
    if (!used[i]) {
      ord.push_back(i);
    }
  }
  
  vector <pair <int, ll>> cur;
  vector <pair <int, ll>> ncur;

  cur.push_back({0, 1});
  for (int i : ord) {
    vector <int> mem;
    for (int j = 0; j < 26; ++j) {
      if (who[i] & (1 << j)) {
        mem.push_back(j);
      }
    }
    for (int id : mem) {
      for (auto p : cur) {
        if (!(p.first & (1 << id))) {
          ncur.push_back({p.first | (1 << id), p.second});
        }
      }
    }
    sort(ncur.begin(), ncur.end());
    cur.clear();
    for (auto p : ncur) {
      if (cur.empty() || cur.back().first != p.first) {
        cur.push_back(p);
      } else {
        cur.back().second += p.second;
      }
    }
    ncur.clear();
  } 

  ll ans = 0;
  for (auto p : cur) ans += p.second;
  cout << ans << '\n';
}
