#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define sz(x) (long long)((x).size())
#define f first
#define s second

const ll mod197 = 1e9 + 7;

void initial(){
#ifdef PC
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}
bool pr(ll x, ll y, ll x1, ll x2, ll y1, ll y2)
{
    return (x >= min(x1, x2) && x <= max(x2, x1)) && (y >= min(y1, y2) && y <= max(y2, y1));
}
const ll maxn = 1e3 + 1;
ll tr[maxn][maxn];
void add(ll x, ll y)
{
    for (int i = x; i < 1e5; i = (i | (i + 1)))
        for (int j = y; j < 1e5; j = (j | (j + 1)))
            tr[i][j]++;
}
ll sum(ll x, ll y)
{
    ll ret = 0;
    for (int i = x; i >= 0; i = (i & (i + 1)) - 1)
        for (int j = y; j >= 0; j = (j & (j + 1)) - 1)
            ret += tr[i][j];
    return ret;
}
signed main(){
    initial();
    ll n, w, h;
    cin >> n >> w >> h;
    pair <ll, ll> per[8] = {
            {w, h},
            {w, -h},
            {-w, h},
            {-w, -h},
    };
    vector <pair <ll, ll> > mas(n);
    for (int i = 0; i < n; i++)
    {
        cin >> mas[i].f >> mas[i].s;
    }
    ll ans = 1;
    if (n <= 100)
    {
        for (int i = 0; i < n; i++)
        {
            for (int t = 0; t < n; t++)
            {
                ll x1 = mas[i].f, y1 = mas[t].s;
                for (auto [x, y] : per)
                {
                    ll cnt = 0;
                    for (int j = 0; j < n; j++)
                    {
                        if (pr(mas[j].f, mas[j].s, x1, x1 + x, y1, y1 + y))
                            cnt++;
                    }
                    ans = max(ans, cnt);
                }
            }
        }
        cout << ans;
        return 0;
    }
    else if (n <= 1e3)
    {
        for (int i = 0; i < n; i++)
            add(mas[i].f, mas[i].s);
        for (int i = 0; i < n; i++)
        {
            for (int t = 0; t < n; t++)
            {
                ll x1 = mas[i].f, y1 = mas[t].s;
                for (auto [x, y] : per)
                {
                    ll x2 = (x1 + x);
                    ll y2 = (y1 + y);
                    ll cnt = sum(max(x1, x2), max(y1, y2));
                    cnt -= sum(min(x1, x2) - 1, max(y1, y2));
                    cnt -= sum(max(x1, x2), min(x1, x2) - 1);
                    cnt -= sum(min(x1, x2) - 1, min(y1, y2) - 1);
                    ans = max(ans, cnt);
                }
            }
        }
    }
}