﻿#include <iostream>
#include <set>
#include <vector>
#include <string>
#include <map>

using namespace std;

vector <set <int>> names(26);

vector <vector <long long>> dp(2, vector <long long> (10400600, 0));

vector <map <int, int>> where(30);

vector <vector <int>> must_to_see(30);

bool get(int mask, int index) {
	return (mask >> index) % 2 == 1;
}

int sum_of_cifr(int mask) {
	int count = 0;
	while (mask > 0) {
		count += mask % 2;
		mask /= 2;
	}
	return count;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	string str;
	for (int i = 0; i < 26; ++i) {
		cin >> str;
		for (auto ch : str)
			names[i].insert(int(ch - 'A'));
	}
	for (auto el : names[0])
		dp[0][where[0][1 << el]] = 1;
	int sum_;
	for (int mask = 0; mask < (1 << 26); ++mask) {
		sum_ = sum_of_cifr(mask);
		must_to_see[sum_].push_back(mask);
		where[sum_][mask] = where[sum_].size();
	}
	for (int i = 1; i < 26; ++i) {
		for (auto el : names[i]) {
			for (auto mask : where[i - 1]) {
				if (!get(mask.first, el)) {
					dp[i % 2][where[i][mask.first + (1 << el)]] += dp[(i + 1) % 2][where[i - 1][mask.first]];
				}
			}
		}
		for (auto mask : where[i - 1])
			dp[(i + 1) % 2][where[i - 1][mask.first]] = 0;
	}
	cout << dp[1][0];
}