#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;
vector <vector<ll>> dp;
ll pref[100005], a[100005];
const ll inf = 1'000'000'000'000'000'000;
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, K;
	cin >> n >> K;
	dp.resize(n + 1);
	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
		pref[i] = pref[i - 1] + a[i];
		dp[i].resize(min(n, K) + 1, inf);
	}
	if (K >= n)
	{
		cout << 0;
		return 0;
	}
	for (int i = 1; i <= n; i++)
		dp[i][1] = pref[i] * (i * 1LL - 1LL);
	for (int i = 2; i <= n; i++)
		for (int k = 2; k <= min(i, K); k++)
			for (int j = max(k - 1, i - K); j < i; j++)
				if (dp[j][k - 1] != inf)
				{
						dp[i][k] = min(dp[i][k], dp[j][k - 1] + (i * 1LL - j * 1LL - 1LL) * (pref[i] - pref[j]));
				}
	cout << dp[n][K];
	return 0;
}