#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second
#ifndef MY
    #define endl '\n'
#endif // MY
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define int long long

typedef long long ll;

const int N = 305 + 5;
const int M = 1e5 + 5;
int lst[M];
int dp[N][N];
int prf[M];
const int inf = 1e18;

int sum(int l, int r) {
    return prf[r] - prf[l - 1];
}

int f(int l, int r) {
    return sum(l, r) * (r - l + 1);
}

void solve(int n, int k, int s) {
    int ans = inf;
    for (int i = 1; i <= n; i++) {
        int res = f(i + 1, n);
        int l = 0, r = i;
        while (l + 2 < r) {
            int ml = l + (r - l) / 3;
            int mr = l + 2 * (r - l) / 3;
            int x = f(1, ml) + f(ml + 1, i);
            int y = f(1, mr) + f(mr + 1, i);
            if (x > y) {
                l = ml;
            } else {
                r = mr;
            }
        }
        int add = inf;
        for (int j = max(1ll, l - 2); j < min(i, r + 2); j++) {
            add = min(add, f(1, j) + f(j + 1, i));
        }
        ans = min(ans, add + res);
    }
    cout << ans - s;
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    int s = 0;
    for (int i = 1; i <= n; i++) {
        cin >> lst[i];
        s += lst[i];
        prf[i] = s;
    }
    if (k == 3) {
        solve(n, k, s);
        return 0;
    }
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= k; j++) {
            dp[i][j] = inf;
        }
    }
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= min(i, k); j++) {
            for (int t = i - 1; t >= 0; t--) {
                dp[i][j] = min(dp[i][j], dp[t][j - 1] + sum(t + 1, i) * (i - t));
            }
        }
    }
    cout << dp[n][k] - s;
    return 0;
}
