#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second
#ifndef MY
    #define endl '\n'
#endif // MY
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
//#define int long long

typedef long long ll;
typedef pair < int, int > pii;
const int N = 1e5 + 5;
const int deg = (1 << 17);
pii lst[N];
vector < int > coor;
int n, w, h;
int tree[deg * 2];
int psh[deg * 2];

int find(int a) {
    int res = a;
    for (int i = a; i < sz(coor); i++) {
        if (coor[a] + w < coor[i]) {
            break;
        }
        res = i;
    }
    return res;
}

void push(int v) {
    tree[v] += psh[v];
    if (v < deg) {
        psh[v * 2] += psh[v];
        psh[v * 2 + 1] += psh[v];
    }
    psh[v] = 0;
}

void update(int ql, int qr, int a, int v = 1, int l = 0, int r = deg) {
    for (int i = ql; i < qr; i++) {
        tree[i] += a;
    }
    return;
    push(v);
    if (qr <= l || r <= ql) {
        return;
    }
    if (ql <= l && r <= qr) {
        psh[v] = a;
        push(v);
        return;
    }
    int m = (l + r) / 2;
    update(ql, qr, a, v * 2, l, m);
    update(ql, qr, a, v * 2 + 1, m, r);
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

void add(int a) {
    int b = find(a);
    update(a, b + 1, 1);
    update(b + 1, sz(coor), -1);
}

void del(int a) {
    int b = find(a);
    update(a, b + 1, -1);
    update(b + 1, sz(coor), 1);
}

int get_max() {
    int res = 0;
    for (int i = 0; i < sz(coor); i++) {
        res = max(res, tree[i]);
    }
    return res;
    return tree[1];
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> w >> h;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        lst[i] = {x, y};
        coor.pb(x);
    }
    coor.pb(0);
    sort(all(coor));
    coor.resize(unique(all(coor)) - coor.begin());
    for (int i = 0; i < n; i++) {
        lst[i].F = lower_bound(all(coor), lst[i].F) - coor.begin();
    }
    sort(lst, lst + n, [](pii a, pii b) {return a.S < b.S;});
    int l = 0, r = 0;
    int ans = 0;
    while (l != n) {
        while (r < n && lst[l].S + h >= lst[r].S) {
            add(lst[r].F);
            r++;
        }
        ans = max(ans, get_max());
        int cur = lst[l].S;
        while (l < n && lst[l].S == cur) {
            del(lst[l].F);
            l++;
        }
    }
    cout << ans;
    return 0;
}
