#include<bits/stdc++.h>
#define ll long long
#define ff first
#define ss second
#define pb push_back
using namespace std;

const int N = 1e5+5;
const int K = 1e8;

int n,h,w,answer;
vector<pair<int,int>>P;

struct tree{
    int val = 0;
    tree* left = NULL;
    tree* right = NULL;
};

void upd(tree* &node,int tl,int tr,int x,int val){
    if(node == NULL) node = new tree();
    if(tl == tr){
        node->val += val;
        return ;
    }
    int mid = tl+tr; mid >>= 1;
    if(x <= mid){
        upd(node->left,tl,mid,x,val);
    } else {
        upd(node->right,mid+1,tr,x,val);
    }

    node->val = ((node->left) ? node->left->val : 0) + ((node->right) ? node->right->val : 0);
    //cout << node-> val << " " << tl << " " << tr << endl;
    //cout << ((node->left) ? node->left->val : 0) << " " << ((node->right) ? node->right->val : 0) << endl;
}

int get(tree* &node,int tl,int tr,int val){
    if(node == NULL || tl > val) return 0;
    if(tr <= val){
        return node->val;
    }
    int mid = tl+tr; mid >>= 1;
    int x = get(node->left,tl,mid,x);
    int y = get(node->right,mid+1,tr,x);
    return x + y;
}

int main(){
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> w >> h;


    for(int i = 0; i < n; i ++ ){
        int x,y;
        cin >> x >> y;
        P.pb({x,y});
        P[i].ff = P[i].ff;
        P[i].ss = P[i].ss;
    }

    sort(P.begin(),P.end());

    int l = 0, r = 0;
    tree* root = new tree();

    while(l < n){
        while(P[r].ff - P[l].ff <= w && r < n){
            upd(root,1,K,P[r].ss,1);
            r++;
        }

        int y = P[l].ss;
        int res1 = get(root,1,K,y+h);
        int res2 = get(root,1,K,y-1);
        answer = max(answer, res1 - res2);

        upd(root,1,K,P[l].ss,-1);
        l++;
    }

    cout << answer << endl;
}

