#include<bits/stdc++.h>
#define ll long long
#define ff first
#define ss second
#define pb push_back
using namespace std;

const int N = 1e5+5;
const int K = 1e8;

int n,h,w,answer;
vector<pair<int,int>>P;

struct tree{
    int val = 0;
    tree* left = NULL;
    tree* right = NULL;
};

void upd(tree* &node,int tl,int tr,int x,int val){
    if(tl == tr){
        node->val += val;
        return ;
    }
    int mid = tl+tr; mid >>= 1;
    if(x <= mid){
        if(node->left == NULL) node->left = new tree();
        upd(node->left,tl,mid,x,val);
    } else {
        if(node->right == NULL) node->right = new tree();
        upd(node->right,mid+1,tr,x,val);
    }

    int a = 0, b = 0;
    if(node->left != NULL) a = node->left->val;
    if(node->right != NULL) b = node->right->val;
    node->val = a+b;
}

int get(tree* &node,int tl,int tr,int val){
    if(node == NULL || tl > val) return 0;
    if(tr <= val){
        return node->val;
    }
    int mid = tl+tr; mid >>= 1;
    int x = get(node->left,tl,mid,val);
    int y = get(node->right,mid+1,tr,val);
    return x + y;
}

int main(){
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> w >> h;


    for(int i = 0; i < n; i ++ ){
        int x,y;
        cin >> x >> y;
        P.pb({x,y});
        //P[i].ff = 1e8 - P[i].ff;
        //P[i].ss = 1e8 - P[i].ss;
    }

    sort(P.begin(),P.end());

    int l = n-1, r = n-1;
    tree* root = new tree();

    while(l >= 0){
        while(P[l].ff - P[r].ff <= w && r >= 0){
            upd(root,1,K,P[r].ss,1);
            r--;
        }
        //cout << r << endl;
        int y = P[l].ss;
        int res1 = get(root,1,K,y);
        int res2;
        if(y-h-1 <= 0) res2 = 0; else res2 = get(root,1,K,y-h-1);
        //cout << res1 << " " << res2 << " " << y << " "<<  y-h-1<< endl;
        answer = max(answer, res1 - res2);

        upd(root,1,K,P[l].ss,-1);
        l--;
    }

    cout << answer << endl;
}

