#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
using namespace std;

const long long inf = 1000000000000000018;

long long dp[1005][1005], cur[1005][1005];

int32_t main () {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	long long n;
	int k;
	cin >> n >> k;
	long long a[n + 5];
	long long pref[n + 5];
	memset(a, 0, sizeof(a));
	memset(pref, 0, sizeof(pref));
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		pref[i] = a[i] + pref[i - 1];
	}
	if (n <= 1000 && k != 3) {
		memset(dp, 0, sizeof(dp));
		for (int j = 0; j <= n; ++j) {
			for (int w = 0; w <= k; ++w)
				cur[j][w] = inf;
		}
		for (long long i = 2; i <= n; ++i) {
			for (int opened_since = 1; opened_since < i; ++opened_since) {
				for (int borders = 1; borders <= min(opened_since, k); ++borders) {
					cur[opened_since][borders] = min(cur[opened_since][borders], dp[opened_since][borders] + (pref[i] - pref[opened_since - 1]) + a[i] * (i - 1 - opened_since));
					cur[i][borders + 1] = min(cur[i][borders + 1], dp[opened_since][borders]);
				}
			}
			swap(dp, cur);
			for (int j = 0; j <= n; ++j) {
				for (int w = 0; w <= k; ++w)
					cur[j][w] = inf;
			}
		}
		long long ans = inf;
		for (int j = 1; j <= n; ++j) {
			for (int w = 1; w <= k; ++w)
				ans = min(dp[j][w], ans);
		}
		cout << ans << '\n';
	}
	else if (k == 3) {
		long long ans = inf;
		for (long long lb = 2; lb < n; ++lb) { // left border;;;
			long long here = pref[lb - 1] * (lb - 2);
			long long lrb = lb, rrb = n - 1;
			while (rrb - lrb > 6) { // i hate ternary search
				long long m1 = (lrb + (rrb - lrb) / 3), m2 = (lrb + 2 * (rrb - lrb) / 3);
				if ((pref[m1] - pref[lb - 1]) * (m1 - lb) + (pref[n] - pref[m1]) * (n - m1 - 1) > (pref[m2] - pref[lb - 1]) * (m2 - lb) + (pref[n] - pref[m2]) * (n - m2 - 1))
					lrb = m1;
				else
					rrb = m2;
			}
			long long best = inf;
			for (long long i = lrb; i <= rrb; ++i)
				best = min(best, (pref[i] - pref[lb - 1]) * (i - lb) + (pref[n] - pref[i]) * (n - i - 1));
			ans = min(here + best, ans);
		}
		cout << ans << '\n';
	}
	else 
		cout << "kalllket_doorak\n";
}
