#pragma GCC optimize("Ofast,unroll-loops")

#include <bits/stdc++.h> 
using namespace std;

const int maxn = 300005;

int sz;
int add[4 * maxn], mx[4 * maxn];

void push (int v) {
	mx[v] += add[v];
	if (2 * v + 1 < 4 * maxn) {
		add[2 * v] = add[v];
		add[2 * v + 1] = add[v];
	}
	add[v] = 0;
}

void pull (int v) {
	if (2 * v + 1 < 4 * maxn) 
		mx[v] = max(mx[2 * v], mx[2 * v + 1]);
}

int get_mx (int v = 1) {
	return mx[v];
}

void add_seg (int d, int lq, int rq, int l = 0, int r = sz - 1, int v = 1) {
	push(v);
	if (max(l, lq) > min(rq, r))
		return;
	else if (lq <= l && r <= rq) {
		add[v] += d;
		push(v);
	}
	else {
		add_seg(d, lq, rq, l, (l + r) / 2, 2 * v);
		add_seg(d, lq, rq, (l + r) / 2 + 1, r, 2 * v + 1);
		pull(v);
	}
}

int32_t main () {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	int n, w, h;
	cin >> n >> w >> h;
	vector <pair <int, int> > points(n);
	vector <int> vals;
	for (int i = 0; i < n; ++i) {
		cin >> points[i].first >> points[i].second;
		vals.push_back(points[i].second - h);
		vals.push_back(points[i].second);
		vals.push_back(points[i].second + h);
	}
	sort(vals.begin(), vals.end());
	vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
	sz = vals.size();
	map <int, int> coords;
	for (int i = 0; i < sz; ++i)
		coords[vals[i]] = i;
	sort(points.begin(), points.end());
	int r = 0, ans = 0;
	for (int l = 0; l < n; ++l) {
		while (r < n && points[r].first <= points[l].first + w) {
			add_seg(1, coords[points[r].second - h], coords[points[r].second + h]);
			++r;
		}
		ans = max(ans, get_mx());
		add_seg(-1, coords[points[l].second - h], coords[points[l].second + h]);
	}
	cout << ans << '\n';
}
