#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <map>
#include <set>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <random>
//#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
//using namespace __gnu_pbds;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define rall(c) (c).rbegin(), (c).rend()
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;


string s[26];
int cnt[26];
vector<int> where[26];
bool used[26];
bool used1[26];
ll ans = 0;
vector<pair<int, int> > st;
int who[26];
int dp[(1 << 24)];
int curmask = 0;
vector<int> fk;


void go(int i, int j) {
	if (i == j) {
		dp[curmask]++;
		return;
	}
	for (int t = 0; t < sz(s[fk[i]]); t++) {
		int val = s[fk[i]][t] - 'A';
		if (used1[val]) {
			continue;
		} 
		int c = who[val];
		curmask ^= (1 << c);
		used1[val] = true;
		go(i + 1, j);
		used1[val] = false;
		curmask ^= (1 << c);
	}
}


void go1(int i, int j) {
	if (i == j) {
		ans += dp[(1 << 24) - 1 - curmask];
		return;
	}
	for (int t = 0; t < sz(s[fk[i]]); t++) {
		int val = s[fk[i]][t] - 'A';
		if (used1[val]) {
			continue;
		} 
		int c = who[val];
		curmask ^= (1 << c);
		used1[val] = true;
		go1(i + 1, j);
		used1[val] = false;
		curmask ^= (1 << c);
	}
}


void gen(int ii) {
	if (ii == 2) {
		int it = 0;
		for (int i = 0; i < 26; i++) {
			if (used1[i]) {
				continue;
			}
			who[i] = it;
			it++;
		}	
		memset(dp, 0, sizeof(dp));
		fk.clear();
		for (int i = 0; i < 26; i++) {
			if (used[i]) {
				continue;
			}
			fk.pb(i);
		}
		go(0, 12);
		go1(12, 24);
		return;
	}
	for (int j = 0; j < sz(where[st[ii].second]); j++) {
		int pos = where[st[ii].second][j];
		if (!used[pos]) {
			used[pos] = true;
			used1[st[ii].second] = true;
			gen(ii + 1);
			used1[st[ii].second] = false;
			used[pos] = false;
		}
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	freopen("input.in", "r", stdin);
	for (int i = 0; i < 26; i++) {
		cin >> s[i];
	}
	for (int i = 0; i < 26; i++) {
		sort(all(s[i]));
		s[i].resize(distance(s[i].begin(), unique(all(s[i]))));
	}
	for (int i = 0; i < 26; i++) {
		for (auto x: s[i]) {
			where[x - 'A'].pb(i);
			cnt[x - 'A']++;
		}
	}
	for (int t = 0; t < 26; t++) {
		st.pb(mp(cnt[t], t));
	}
	sort(all(st));
	if (st[0].first == 0) {
		cout << 0 << '\n';
		return 0;
	}
	gen(0);
	cout << ans << '\n';
}