#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = (int) 1e5 + 7;
const ll INF = (ll) 1e18;
int n;
int k;
int a[N];
ll s[N];

struct T {
  ll first;
  ll second;
};

bool operator < (T a, T b) {
  if (a.first != b.first) {
    return a.first < b.first;
  } else {
    return a.second < b.second;
  }
}

T dp[N];

T get(ll coef) {
  for (int i = 1; i <= n; i++) {
    dp[i] = {INF, INF};
    for (int j = 1; j <= i; j++) {
      T value = {coef + dp[j - 1].first + (s[i] - s[j - 1]) * (i - j + 1), dp[j - 1].second + 1};
      if (value < dp[i]) {
        dp[i] = value;
      }
    }
  }
  return dp[n];
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);


  cin >> n >> k;
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
    s[i] = s[i - 1] + a[i];
  }

  int l = -(int) 1e9, r = -l, last;
  while (l <= r) {
    int m = (l + r) / 2;
    if (get(m).second <= k) {
      last = m;
      r = m - 1;
    } else {
      l = m + 1;
    }
  }
  T it = get(last);
  cout << it.first - k * last - s[n] << "\n";

}
