#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int) 1e5 + 7;
const ll INF = (ll) 1e18;
int n;
int k;
int a[N];
ll s[N];

struct T {
  ld first;
  int second;
};

bool operator < (T a, T b) {
  if (a.first != b.first) {
    return a.first < b.first;
  } else {
    return a.second < b.second;
  }
}

T dp[N];

T get(ld coef) {
  for (int i = 1; i <= n; i++) {
    dp[i] = {INF, INF};
    for (int j = 1; j <= i; j++) {
      T value = {coef + dp[j - 1].first + (s[i] - s[j - 1]) * (i - j + 1), dp[j - 1].second + 1};
      if (value < dp[i]) {
        dp[i] = value;
      }
    }
  }
  return dp[n];
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);


  cin >> n >> k;
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
    s[i] = s[i - 1] + a[i];
  }

  ld l = -(int) 1e9, r = -l;
  for (int i = 1; i <= 200; i++) {
    ld m = (l + r) * 0.5;
    if (get(m).second <= k) {
      r = m;
    } else {
      l = m;
    }
  }
  T it = get(l);
  ld sol = it.first - k * l - s[n];
  ll x = sol;
  ll y = x - 1;
  ll z = x + 1;
  ld dx = fabs(sol - x);
  ld dy = fabs(sol - y);
  ld dz = fabs(sol - z);
  if (dx < dy && dx < dz) {
    cout << x << "\n";
    return 0;
  }
  if (dy < dx && dy < dz) {
    cout << y << "\n";
    return 0;
  }
  if (dz < dx && dz < dy) {
    cout << z << "\n";
    return 0;
  }

}
