#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int) 1e5 + 7;
int n;
int k;
int pos[N];
int a[N];
ll s[N];
ll DP[N];
ll DP2[N];

struct T {
  ld first;
  int second;
};

bool operator < (T a, T b) {
  if (a.first != b.first) {
    return a.first < b.first;
  } else {
    return a.second < b.second;
  }
}

T dp[N];

T eval(ld coef, int i, int j) {
  return {coef + dp[j - 1].first + (s[i] - s[j - 1]) * (i - j + 1), dp[j - 1].second + 1};
}

const int C = 20;

void dv(int l, int r, int lo, int hi) {
  if (l > r) {
    return;
  }
  int i = (l + r) / 2, opt;
  for (int j = lo; j <= min(hi, i); j++) {
    if (DP[j - 1] + (s[i] - s[j - 1]) * (i - j + 1) < DP2[i]) {
      DP2[i] = DP[j - 1] + (s[i] - s[j - 1]) * (i - j + 1);
      opt = j;
    }
  }
  dv(l, i - 1, lo, opt);
  dv(i + 1, r, opt, hi);
}

T get(ld coef) {
  int opt = 1;
  for (int i = 1; i <= n; i++) {
    dp[i] = {(ld) 1e18, (int) 1e9};
    for (int j = max(1, i - C); j <= i; j++) {
      T value = eval(coef, i, j);
      if (value < dp[i]) {
        dp[i] = value;
        pos[i] = j;
      }
    }
    for (int j = max(1, pos[i - 1] - C); j <= min(i, pos[i - 1] + C); j++) {
      T value = eval(coef, i, j);
      if (value < dp[i]) {
        dp[i] = value;
        pos[i] = j;
      }
    }
  }
  return dp[n];
}



int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);


  cin >> n >> k;
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
    s[i] = s[i - 1] + a[i];
  }
  if (n <= 6000 || n * k <= (int) 1e5) {
    for (int i = 0; i < N; i++) {
      DP[i] = DP2[i] = (ll) 1e18;
    }
    DP[0] = 0;
    for (int step = 1; step <= k; step++) {
      dv(1, n, 1, n);
      for (int i = 1; i <= n; i++) {
        DP[i] = DP2[i];
        DP2[i] = (ll) 1e18;
      }
    }
    cout << DP[n] - s[n] << "\n";
    return 0;
  }

  ld l = -(ld) 1e9, r = (ld) 1e9;
  for (int i = 1; i <= 100; i++) {
    ld m = (l + r) * 0.5;
    if (get(m).second <= k) {
      r = m;
    } else {
      l = m;
    }
  }
  T it = get(l);
  ld sol = it.first - k * l - s[n];
  ll x = sol;
  ll y = x - 1;
  ll z = x + 1;
  ld dx = fabs(sol - x);
  ld dy = fabs(sol - y);
  ld dz = fabs(sol - z);
  if (dx < dy && dx < dz) {
    cout << x << "\n";
    return 0;
  }
  if (dy < dx && dy < dz) {
    cout << y << "\n";
    return 0;
  }
  if (dz < dx && dz < dy) {
    cout << z << "\n";
    return 0;
  }

}
