#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = (int) 1e5 + 7;
int n;
int l1;
int l2;
int x[N];
int y[N];
int s[1000 + 7][1000 + 7];

int down(int r, int c) {
  if (r <= 0 || c <= 0) {
    return 0;
  } else {
    return s[r][c];
  }
}

int sum(int r1, int c1, int r2, int c2) {
  return down(r2, c2) - down(r1 - 1, c2) - down(r2, c1 - 1) + down(r1 - 1, c1 - 1);
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

 /// freopen ("input", "r", stdin);

  cin >> n >> l1 >> l2;
  for (int i = 1; i <= n; i++) {
    cin >> x[i] >> y[i];
    assert(x[i] <= 1000 && y[i] <= 1000);
    s[x[i]][y[i]]++;
  }
  for (int i = 1; i <= 1000; i++) {
    int partial = 0;
    for (int j = 1; j <= 1000; j++) {
      partial += s[i][j];
      s[i][j] = s[i - 1][j] + partial;
    }
  }
  int sol = 0;
  for (int i = 1; i <= 1000; i++) {
    for (int j = 1; j <= 1000; j++) {
      sol = max(sol, sum(i - l1, j - l2, i, j));
    }
  }
  cout << sol << "\n";
}
