#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = (int) 1e5 + 7;
int n;
int l1;
int l2;
int x[N];
int y[N];
int s[1000 + 7][1000 + 7];

int down(int r, int c) {
  if (r <= 0 || c <= 0) {
    return 0;
  } else {
    return s[r][c];
  }
}

int sum(int r1, int c1, int r2, int c2) {
  return down(r2, c2) - down(r1 - 1, c2) - down(r2, c1 - 1) + down(r1 - 1, c1 - 1);
}

int aib[100000 + 7];

void add(int i, int x) {
  while (i <= 100000) {
    aib[i] += x;
    i += i & (-i);
  }
}

int get(int i) {
  if (i <= 0) {
    return 0;
  }
  int sol = 0;
  while (i) {
    sol += aib[i];
    i -= i & (-i);
  }
  return sol;
}

int subtask4() {
  int sol = 0;
  vector<pair<int, int>> v;
  for (int i = 1; i <= n; i++) {
    v.push_back({x[i], y[i]});
  }
  sort(v.begin(), v.end());
  int j = 0;
  for (int i = 0; i < n; i++) {
    add(v[i].second, +1);
    while (v[i].first - v[j].first > l1) {
      add(v[j].second, -1);
      j++;
    }

    sol = max(sol, get(v[i].second) - get(v[i].second - l2 - 1));
  }
  return sol;
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);


  bool smallxy = 1;

  cin >> n >> l1 >> l2;
  for (int i = 1; i <= n; i++) {
    cin >> x[i] >> y[i];
    smallxy &= (x[i] <= 1000 && y[i] <= 1000);
  }
  if (smallxy) {
    for (int i = 1; i <= n; i++) {
      s[x[i]][y[i]]++;
    }
    for (int i = 1; i <= 1000; i++) {
      int partial = 0;
      for (int j = 1; j <= 1000; j++) {
        partial += s[i][j];
        s[i][j] = s[i - 1][j] + partial;
      }
    }
    int sol = 0;
    for (int i = 1; i <= 1000; i++) {
      for (int j = 1; j <= 1000; j++) {
        sol = max(sol, sum(i - l1, j - l2, i, j));
      }
    }
    cout << sol << "\n";
    return 0;
  }
  int sol = subtask4();
  cout << sol << "\n";
}
