#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = (int) 1e5 + 7;
int n;
int l1;
int l2;
int x[N];
int y[N];
int s[1000 + 7][1000 + 7];

int sub(int r, int c) {
  if (r <= 0 || c <= 0) {
    return 0;
  } else {
    return s[r][c];
  }
}

int sum(int r1, int c1, int r2, int c2) {
  return sub(r2, c2) - sub(r1 - 1, c2) - sub(r2, c1 - 1) + sub(r1 - 1, c1 - 1);
}

int aib[100000 + 7];

void add(int i, int x) {
  while (i <= 100000) {
    aib[i] += x;
    i += i & (-i);
  }
}

int get(int i) {
  if (i <= 0) {
    return 0;
  }
  int sol = 0;
  while (i) {
    sol += aib[i];
    i -= i & (-i);
  }
  return sol;
}

int subtask5() {
  int sol = 0;
  vector<pair<int, int>> v;
  for (int i = 1; i <= n; i++) {
    v.push_back({x[i], y[i]});
  }
  sort(v.begin(), v.end());
  int j = 0;
  for (int i = 0; i < n; i++) {
    add(v[i].second, +1);
    while (v[i].first - v[j].first > l1) {
      add(v[j].second, -1);
      j++;
    }

    sol = max(sol, get(v[i].second) - get(v[i].second - l2 - 1));
  }
  return sol;
}

struct T {
  int x;
  int y;
  int my;
};

bool operator < (T a, T b) {
  if (a.x != b.x) {
    return a.x < b.x;
  } else {
    return a.y < b.y;
  }
}


vector<int> doary;
int down[N];

int subtask3() {
  map<int, int> memo;
  for (int i = 1; i <= n; i++) {
    memo[y[i]] = 0;
  }
  int sz = 0;
  doary.push_back(-(int) 1e9);
  for (auto &it : memo) {
    doary.push_back(it.first);
    it.second = ++sz;
  }
  vector<T> v;
  for (int val = 1; val <= sz; val++) {
    int l = 0, r = val;
    down[val] = val;
    while (l <= r) {
      int m = (l + r) / 2;
      if (doary[val] - doary[m] > l2) {
        down[val] = m;
        l = m + 1;
      } else {
        r = m - 1;
      }
    }
  }
  for (int i = 1; i <= n; i++) {
    int val = memo[y[i]];
    v.push_back({x[i], y[i], val});
  }
  sort(v.begin(), v.end());
  int sol = 0;
  int j = 0;
  for (int i = 0; i < n; i++) {
    add(v[i].my, +1);
    while (v[i].x - v[j].x > l1) {
      add(v[j].my, -1);
      j++;
    }
    for (int k = 1; k <= sz; k++) {
      sol = max(sol, get(k) - get(down[k]));
    }
    ///sol = max(sol, get(v[i].second) - get(v[i].second - l2 - 1));
  }
  return sol;
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

 /// freopen ("input", "r", stdin);


  bool smallxy = 1;

  cin >> n >> l1 >> l2;
  for (int i = 1; i <= n; i++) {
    cin >> x[i] >> y[i];
    smallxy &= (x[i] <= 1000 && y[i] <= 1000);
  }
  if (n <= 1000) {
    cout << subtask3() << "\n";
    return 0;
  }
  if (smallxy) {
    for (int i = 1; i <= n; i++) {
      s[x[i]][y[i]]++;
    }
    for (int i = 1; i <= 1000; i++) {
      int partial = 0;
      for (int j = 1; j <= 1000; j++) {
        partial += s[i][j];
        s[i][j] = s[i - 1][j] + partial;
      }
    }
    int sol = 0;
    for (int i = 1; i <= 1000; i++) {
      for (int j = 1; j <= 1000; j++) {
        sol = max(sol, sum(i - l1, j - l2, i, j));
      }
    }
    cout << sol << "\n";
    return 0;
  }
  int sol = subtask5();
  cout << sol << "\n";
}
