#define fast ios::sync_with_stdio(false); cin.tie(0);
#define foru(i, k, n) for (int i = k; i < n; i++)
#define ford(i, k, n) for (int i = k; i >= n; i--)
#define pb push_back

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const ll inf = 1e17;
const int sz = 1e5;
int n, k;
int a[sz];
ll p[sz];
inline ll query(int i, int j) { return (j >= i ? p[j] - (i ? p[i - 1] : 0) : 0); }
ll prv[sz], dp[sz];
int winind[sz];

int main() {
	fast;
	cin >> n >> k;
	foru(i, 0, n) {
		cin >> a[i]; p[i] = (i ? p[i - 1] : 0) + a[i];
	}
	for (int i = 0; i < n; i++) {
		prv[i] = query(0, i)*i; dp[i] = inf;
	}
	for (int pk = 2; pk <= k; pk++) {
		for (int i = pk - 1; i < n; i++) {
			dp[i] = inf;
			winind[i] = -1;
			if (i == pk - 1) {
				winind[i] = i;
				dp[i]=0;
			}
			else {
				int ind = winind[i - 1];
				while (ind < i - 1) {
					ll a = query(ind + 1, i)*(i - ind - 1) + prv[ind], 
						b = query(ind + 2, i)*(i - ind - 2) + prv[ind + 1];
					if (b < a)ind++;
					else break;
				}
				winind[i] = ind;
				dp[i] = query(ind + 1, i)*(i - ind - 1) + prv[ind];
			}
		}
		for (int j = 0; j < n; j++)prv[j] = dp[j];
	}
	cout << prv[n - 1];
	return 0;
}