#include <bits/stdc++.h>

#ifndef _LOCAL
    #pragma GCC optimize("unroll-loops")
    #pragma GCC optimize("-O3")
    #pragma GCC optimize("Ofast")
#endif // _LOCAL

#define i2 array<int,2>
#define PB push_back
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
using namespace std;
typedef long long ll;
typedef long double ld;
const int oo = 2e9;
const ll OO = 1e18;
const int N = 100100;
const int MX = int(1e8) + 10;
const int BIG = int(7e6);
//const int K = 6010;
vector<i2> events;
vector<int> cords;
int n, w, h, ans = 0, x[N], y[N], LF[N], RT[N];

int vl[BIG], psh[BIG], L[BIG], R[BIG], CNT;

void update(int v, int tl, int tr, int ql, int qr, int ad){
    if (ql > qr) return;

    if (tl == ql && tr == qr) {
        psh[v] += ad;
        if (L[v] == 0 && R[v] == 0)
            vl[v] = psh[v];
        else if (L[v] == 0)
            vl[v] = psh[v] + vl[R[v]];
        else if (R[v] == 0)
            vl[v] = psh[v] + vl[L[v]];
        else vl[v] = psh[v] + max(vl[L[v]], vl[R[v]]);
        return;
    }

    int md = (tl + tr) >> 1;

    if (L[v] == 0) {
        L[v] = ++CNT;
        R[L[v]] = L[L[v]] = psh[L[v]] = vl[L[v]] = 0;
    }

    if (R[v] == 0) {
        R[v] = ++CNT;
        R[R[v]] = L[R[v]] = psh[R[v]] = vl[R[v]] = 0;
    }

    update(L[v], tl, md, ql, min(qr, md), ad);
    update(R[v], md + 1, tr, max(md + 1, ql), qr, ad);

    vl[v] = max(vl[L[v]], vl[R[v]]) + psh[v];
}

void se_solve(){
    events.clear();
    cords.clear();

    int mn = oo, mx = oo;

    for (int i = 1; i <= n; i++){
        events.PB({x[i] - w, +i});
        events.PB({x[i] + 1, -i});

        mn = min(mn, y[i]);
        mx = max(mx, y[i]);

        cords.PB(y[i]);
        cords.PB(y[i] + h);
    }

    sort(all(cords));
    cords.resize(unique(all(cords)) - cords.begin());

    for (int i = 0; i < n; i++){
        LF[i] = lower_bound(all(cords), y[i]) - cords.begin();
        RT[i] = lower_bound(all(cords), y[i] + h) - cords.begin();
    }

    sort(all(events));

    CNT = 1;
    vl[1] = psh[1] = 0;
    L[1] = R[1] = 0;

    for (int it = 0; it < sz(events); ){
        int jt = it;

        while (jt < sz(events) && events[jt][0] == events[it][0]){
            i2 now = events[jt++];
            int id = abs(now[1]);

            if (now[1] < 0) {
                update(1, 0, sz(cords) - 1, LF[id], RT[id], -1);
            } else {
                update(1, 0, sz(cords) - 1, LF[id], RT[id], +1);
            }
        }

        ans = max(ans, vl[1]);

        it = jt;
    }
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef _LOCAL
    freopen("in.txt","r",stdin);
#endif // _LOCAL

    cin >> n >> w >> h;

    for (int i = 1; i <= n; i++)
        cin >> x[i] >> y[i];

    se_solve();

    swap(w, h);

    for (int i = 1; i <= n; i++)
        swap(x[i], y[i]);

    se_solve();

    cout << ans;

    return 0;
}
