#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back
#define TIME 1.0 * clock() / CLOCKS_PER_SEC

const int N = 1e5 + 10;
const int INF = 1e9;
const int MOD = 1e9 + 7;
const int rx[4] = {-1, 0, 1, 0};
const int ry[4] = {0, 1, 0, -1};


mt19937 gen(time(0));

ll ans = 0;
bool used[N];
bool ok = true;
vector <int> str_[26];

void dfs(int kol) {
    if (!ok) return;
    if (kol == 26) {
        ans ++;
        return;
    }
    if (TIME > 1.50) {
        ok = false;
        return;
    }
    for (auto to : str_[kol]) {
        if (!used[to]) {
            used[to] = true;
            dfs(kol + 1);
            used[to] = false;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string str[26];
    for (int i = 0; i < 26; i++) {
        cin >> str[i];
        set <char> st;
        for (auto it : str[i]) st.insert(it);
        for (auto it : st) {
            str_[int(it - 'A')].pb(i);
        }
    }
    dfs(0);
    if (ok) {
        cout << ans << endl;
        return 0;
    }
    unordered_map <int, ll> dp[14];
    dp[0][0] = 1;
    for (int i = 0; i < 13; i++) {
        set <int> st;
        for (auto it : str[i]) st.insert(int(it - 'A'));
        for (auto it : dp[i]) {
            for (auto it2 : st) {
                if ((((it.F >> it2) & 1) == 0)) {
                    dp[i + 1][(it.F | (1 << it2))] += it.S;
//                    cerr << it.S << endl;
                }
            }
        }
    }
    unordered_map <int, ll> dp2[14];
    dp2[0][0] = 1;
    for (int i = 13; i < 26; i++) {
        set <int> st;
        for (auto it : str[i]) st.insert(int(it - 'A'));
        for (auto it : dp2[i - 13]) {
            for (auto it2 : st) {
                if ((((it.F >> it2) & 1) == 0)) {
                    dp2[i + 1 - 13][(it.F | (1 << it2))] += it.S;
                }
            }
        }
    }
    ll res = 0;
    for (auto it : dp[13]) {
        res += it.S * (dp2[13][(1 << 26) - 1 - it.F]);
    }
    cout << res << endl;
    return 0;
}
