#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back

const int N = 1e5 + 10;
const int INF = 1e9;
const int MOD = 1e9 + 7;
const int rx[4] = {-1, 0, 1, 0};
const int ry[4] = {0, 1, 0, -1};


mt19937 gen(time(0));

struct segtree {
    vector <int> t, lazy;
    int nw;

    segtree (int n) {
        nw = (1 << (32 - __builtin_clz(n) - (__builtin_popcount(n) == 1)));
        t.resize(nw << 1);
        lazy.resize(nw << 1);
    }

    void push(int v) {
        t[v * 2] += lazy[v];
        t[v * 2 + 1] += lazy[v];
        lazy[v * 2] += lazy[v];
        lazy[v * 2 + 1] += lazy[v];
        lazy[v] = 0;
    }

    void upd(int v, int cl, int cr, int l, int r, int val) {
        if (cl >= l && cr <= r) {
            t[v] += val;
            lazy[v] += val;
            return;
        }
        if (cl >= r || cr <= l) return;
        push(v);
        int mid = (cl + cr) / 2;
        upd(v * 2, cl, mid, l, r, val);
        upd(v * 2 + 1, mid, cr, l, r, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void upd(int l, int r, int val) {
        l = max(1, l);
        upd(1, 1, nw + 1, l, r + 1, val);
    }
};

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    int mx = max(w, h);
    pair <int, int> cs[n];
    for (int i = 0; i < n; i++) {
        cin >> cs[i].F >> cs[i].S;
        mx = max(mx, cs[i].F);
        mx = max(mx, cs[i].S);
    }
    sort(cs, cs + n);
//    if (mx > 100000 || n <= 1000) {
//        multiset <int> st;
//        int l = 0, ans = 0;
//        for (int i = 0; i < n; i++) {
//            st.insert(cs[i].S);
//            while (cs[i].F - cs[l].F > w) {
//                st.erase(st.find(cs[l].S));
//                l ++;
//            }
//            int l2 = 0;
//            vector <int> v;
//            for (auto it : st) v.pb(it);
//            for (int j = 0; j < v.size(); j++) {
//                while (v[j] - v[l2] > h) l2 ++;
//                ans = max(ans, j - l2 + 1);
//            }
//        }
//        cout << ans << endl;
//        return 0;
//    }
    int l = 0;
    segtree sgt(200100);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        while (cs[i].F - cs[l].F > w) {
            sgt.upd(cs[l].S - h / 2, cs[l].S + h / 2, -1);
            l ++;
        }
        sgt.upd(cs[i].S - h / 2, cs[i].S + h / 2, 1);
        ans = max(ans, sgt.t[1]);
    }
    cout << ans << endl;
    return 0;
}
