#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>

using namespace std;

template<typename T> void uin(T &a, T b) {
    if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
    if (b > a) a = b;
}

#define left left228
#define right right228
#define double long double

vector<int> let[26];

int ans = 0;

bool busy[26];

void gen(int n) {
    if (n == 26) {
        ++ans;
    } else {
        for (int i : let[n]) {
            if (!busy[i]) {
                busy[i] = 1;
                gen(n + 1);
                busy[i] = 0;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    for (int i = 0; i < 26; ++i) {
        string s;
        cin >> s;
        set<char> S;
        for (char c : s) {
            S.insert(c);
        }
        for (char c : S){
            let[i].emplace_back(c - 'A');
        }
    }
    gen(0);
    cout << ans << endl;
    return 0;
}

/*

8 4
8 1 2 3 9 1 9 1

32

---------------------

6 3
10 3 8 5 4 7

37


*/