#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228

const int N = 1005;
const long long INF = 1e18 + 228;

int n, k;
int a[N];
long long dp[N][N];
long long pref[N];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		pref[i] = pref[i - 1] + a[i];
	}
	if (k == 3)  {
		int tr = n / 3;
		int ttr = 2 * n / 3;
		long long ans = INF;
		for (int p1 = max(1, tr - 5); p1 < min(n, tr + 5); ++p1) {
			for (int p2 = max(p1 + 1, ttr - 5); p2 < min(n, ttr + 5); ++p2) {
				long long cur = pref[p1] * (p1 - 1);
				cur += (pref[p2] - pref[p1]) * (p2 - p1 - 1);
				cur += (pref[n] - pref[p2]) * (n - p2 - 1);
				uin(ans, cur);
			}
		}
		cout << ans << '\n';
	} else {
		for (int i = 1; i <= n; ++i) {
			dp[i][1] = pref[i] * (i - 1);
			for (int j = 2; j <= min(i, k); ++j) {
				dp[i][j] = INF;
				for (int t = i; t >= j; --t) {
					uin(dp[i][j], (pref[i] - pref[t - 1]) * (i - t) + dp[t - 1][j - 1]);
				}
			}
		}
		cout << dp[n][k] << '\n';
	}
	return 0;
}

/*

8 4
8 1 2 3 9 1 9 1

32

---------------------

6 3
10 3 8 5 4 7

37


*/