#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228

const int N = 1005;
const long long INF = 1e18 + 228;

int n, k;
int a[N];
long long pref[N];

long long cost(int l, int r) {
	return (pref[r] - pref[l - 1]) * (r - l);
}

long long dp[N];
int opt[N];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		pref[i] = pref[i - 1] + a[i];
	}
	opt[2] = 1;
	for (int i = 3; i <= n; ++i) {
		opt[i] = opt[i - 1];
		while (opt[i] + 1 < i && cost(1, opt[i]) + cost(opt[i] + 1, i) >= cost(1, opt[i] + 1) + cost(opt[i] + 2, i)) {
			++opt[i];
		}
		dp[i] = cost(1, opt[i]) + cost(opt[i] + 1, i);
	}
	long long ans = INF;
	for (int r = n; r > 1; --r) {
		uin(ans, dp[r - 1] + cost(r, n));
	}
	cout << ans << '\n';
	return 0;
}

/*

8 4
8 1 2 3 9 1 9 1

32

---------------------

6 3
10 3 8 5 4 7

37


*/