#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228

const int N = 100 * 1005;
const long long INF = 1e18 + 228;

int n, k;
int a[N];
long long pref[N];

long long cost(int l, int r) {
	return (pref[r] - pref[l - 1]) * (long long)(r - l);
}

long long pd[N];
int opt[6006][6006];
long long dp[6006][6006];

long long f(int m, int i) {
	return cost(1, m) + cost(m + 1, i);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		pref[i] = pref[i - 1] + a[i];
	}
	if (k == 3) {
		pd[2] = cost(1, 1) + cost(2, 2);
		for (int i = 3; i <= n; ++i) {
			pd[i] = INF;
		}
		for (int i = 3; i <= n; ++i) {
			// vector< pair<int, int> > v;
			// vector<int> li;
			// int k = max(1, i / 50);
			// for (int j = 1; j <= i; j += k) {
			// 	li.emplace_back(j);
			// }
			// if (li.back() != i) {
			// 	li.emplace_back(i);
			// }
			// for (int jj = 0; jj < (int)li.size() - 1; ++jj) {
			// 	int l = li[jj];
			// 	int r = li[jj + 1];

			// 	if (r != i) {
			// 		uin(pd[i], f(r, i));
			// 	}
			// 	if (l != i) {
			// 		uin(pd[i], f(l, i));
			// 	}

			// 	while (r - l > 3) {
			// 		int m1 = l + (r - l) / 3;
			// 		int m2 = r - (r - l) / 3;
			// 		if (f(m1, i) < f(m2, i)) {
			// 			r = m2;
			// 		} else {
			// 			l = m1;
			// 		}
			// 	}
			// 	for (int j = max(1, l - 20); j <= min(i - 1, l + 20); ++j) {
			// 		uin(pd[i], cost(1, j) + cost(j + 1, i));
			// 	}

			// 	l = li[jj];
			// 	r = li[jj + 1];
			// 	while (r - l > 3) {
			// 		int m1 = l + (r - l) / 3;
			// 		int m2 = r - (r - l) / 3;
			// 		if (f(m1, i) < f(m2, i)) {
			// 			l = m1;
			// 		} else {
			// 			r = m2;
			// 		}
			// 	}
			// 	for (int j = max(1, l - 20); j <= min(i - 1, l + 20); ++j) {
			// 		uin(pd[i], cost(1, j) + cost(j + 1, i));
			// 	}

			// }
			int l = 1;
			int r = i;

			if (r != i) {
				uin(pd[i], f(r, i));
			}
			if (l != i) {
				uin(pd[i], f(l, i));
			}

			while (r - l > 3) {
				int m1 = l + (r - l) / 3;
				int m2 = r - (r - l) / 3;
				if (f(m1, i) < f(m2, i)) {
					r = m2;
				} else {
					l = m1;
				}
			}
			for (int j = max(1, l - 200); j <= min(i - 1, l + 200); ++j) {
				uin(pd[i], cost(1, j) + cost(j + 1, i));
			}

			l = 1;
			r = i;
			while (r - l > 3) {
				int m1 = l + (r - l) / 3;
				int m2 = r - (r - l) / 3;
				if (f(m1, i) < f(m2, i)) {
					l = m1;
				} else {
					r = m2;
				}
			}
			for (int j = max(1, l - 200); j <= min(i - 1, l + 200); ++j) {
				uin(pd[i], cost(1, j) + cost(j + 1, i));
			}
		}
		long long ans = INF;
		for (int r = n; r > 2; --r) {
			uin(ans, pd[r - 1] + cost(r, n));
		}
		cout << ans << '\n';
	} else {
		for (int i = 1; i <= n; ++i) {
			dp[i][1] = pref[i] * (i - 1);
			for (int j = 2; j <= min(i, k); ++j) {
				dp[i][j] = INF;
				int t = max(1, opt[i - 1][j]);
				while (t + 1 <= i && dp[t - 1][j - 1] + (pref[i] - pref[t - 1]) * (i - t) > dp[t + 1 - 1][j - 1] + (pref[i] - pref[t + 1 - 1]) * (i - (t + 1))) {
					++t;
				}
				opt[i][j] = t;

				dp[i][j] = (pref[i] - pref[t - 1]) * (i - t) + dp[t - 1][j - 1];
			}
		}
		cout << dp[n][k] << '\n';
	}
	return 0;
}

/*
8 4
8 1 2 3 9 1 9 1

A


*/



































