#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 6000 + 3;
int n, k, a[N];
const ll big = 1000000000000000000LL;
ll ldp[N], ndp[N], sum[N];

ll get_sum(int l, int r){
    if (!l) return sum[r];
    return sum[r] - sum[l - 1];
}

void solve(int l, int r, int optl, int optr){
    int mid = (l + r) / 2;
    pair <ll, int> opt = {big, -1};
    for (int i = min(optr, mid); i >= optl; i--)
        opt = min(opt, {ldp[i - 1] + get_sum(i, mid) * (mid - i), i});
    ndp[mid] = opt.first;
    if (l == r) return;
    solve(l, mid, optl, opt.ss);
    solve(mid + 1, r, opt.ss, optr);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        sum[i] = a[i];
        if (i) sum[i] += sum[i - 1];
    }
    for (int j = 0; j < n; j++)
        ldp[j] = get_sum(0, j) * 1LL * j;
    for (int i = 1; i < k; i++){
        solve(0, n - 1, 1, n - 1);
        for (int j = 0; j < n; j++)
            ldp[j] = ndp[j];
    }
    cout << ldp[n - 1];
    return 0;
}
