#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 100000 + 3;
int t[N * 4], mod[N * 8];

void push(int v, int tl, int tr){
    if (mod[v]){
        mod[v * 2] += mod[v];
        mod[v * 2 + 1] += mod[v];
        t[v * 2] += mod[v];
        t[v * 2 + 1] += mod[v];
        mod[v] = 0;
    }
}

void up(int v, int tl, int tr, int l, int r, int val){
    if (l > r) return;
    if (tl == l && tr == r){
        mod[v] += val;
        t[v] += val;
        return;
    }
    int tm = (tl + tr) / 2;
    push(v, tl, tr);
    up(v * 2, tl, tm, l, min(r, tm), val);
    up(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int get_max(int v, int tl, int tr, int l, int r){
    if (l > r) return 0;
    if (tl == l && tr == r) return t[v];
    int tm = (tl + tr) / 2;
    return max(get_max(v * 2, tl, tm, l, min(tm, r)),
               get_max(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

int n, w, h;
vector <int> events[N];

vector <int> X, Y;
vector <pii> q;

void solve68(){
    ++w; ++h;
    int ans = 0;
    for (int i = 0; i < upper_bound(all(Y), Y[0] + h - 1) - Y.begin(); i++){
        for (auto u: events[i]){
            int lotr = lower_bound(all(X), u - w + 1) - X.begin(), rotr = upper_bound(all(X), u) - X.begin() - 1;
            up(1, 0, N - 1, lotr, rotr, 1);
        }
    }
//    cout << t[1] << "\n";
    ans = t[1];
    int j = 0;
    for (int i = upper_bound(all(Y), Y[0] + h - 1) - Y.begin(); i < Y.size(); i++){
        for (auto u: events[i]){
            int lotr = lower_bound(all(X), u - w + 1) - X.begin(), rotr = upper_bound(all(X), u) - X.begin() - 1;
            up(1, 0, N - 1, lotr, rotr, 1);
        }
        for (;j < upper_bound(all(Y), Y[i] - h) - Y.begin(); j++)
        for (auto u: events[j]){
            int lotr = lower_bound(all(X), u - w + 1) - X.begin(), rotr = upper_bound(all(X), u) - X.begin() - 1;
            up(1, 0, N - 1, lotr, rotr, -1);
        }
        ans = max(ans, t[1]);
    }
    cout << ans;
}

    //const int M = 1000 + 3;
    //int fenw[M][M];
    //
    //void add(int x, int y){
    //    for (int i = x; i < M; i |= (i + 1)){
    //        for (int j = y; j < M; j |= (j + 1)){
    //            fenw[i][j]++;
    //        }
    //    }
    //}
    //
    //int get(int x, int y){
    //    int ans = 0;
    //    for (int i = x; i >= 0; i = (i & (i + 1)) - 1)
    //        for (int j = y; j >= 0; j = (j & (j + 1)) - 1)
    //            ans += fenw[i][j];
    //    return ans;
    //}
    //
    //int get_sum(int x1, int y1, int x2, int y2){
    //    int ans = 0;
    //    ans += get(x2, y2);
    //    if (x1) ans -= get(x1 - 1, y2);
    //    if (y1) ans -= get(x2, y1 - 1);
    //    if (x1 && y1) ans += get(x1 - 1, y1 - 1);
    //    return ans;
    //}
    //
    //void solve23(){
    //    h++; w++;
    //
    //    for (auto u: q){
    //        add(lower_bound(all(X), u.ff) - X.begin(), lower_bound(all(Y), u.ss) - Y.begin());
    //    }
    //    int ans = 0;
    //    for (int i = 0; i < X.size(); i++){
    //        for (int j = 0; j < Y.size(); j++){
    //            int i1 = upper_bound(all(X), X[i] - w) - X.begin();
    //            int j1 = upper_bound(all(Y), Y[j] - h) - Y.begin();
    //            ans = max(ans, get_sum(i1, j1, i, j));
    //        }
    //    }
    //    cout << ans;
    //}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> w >> h;
    int is_68 = 1;
    for (int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        X.pb(x);
        Y.pb(y);
        q.pb({x, y});
    }

    sort(all(X)); X.resize(unique(all(X)) - X.begin());
    sort(all(Y)); Y.resize(unique(all(Y)) - Y.begin());

    for (auto u: q){
//        u.ff = lower_bound(all(X), u.ff)-X.begin();
        u.ss = lower_bound(all(Y), u.ss)-Y.begin();
        events[u.ss].pb(u.ff);
    }
    for (int i = 0; i < X.size(); i++)
        sort(all(events[i]));
//    for (auto u: Y) cout << u << " "; cout << "\n";
//    cout << lower_bound(all(Y), 2) - Y.begin() << "!!!\n";
//    if (is_68)
        solve68();
//    else
//        solve23();
    return 0;
}
