
/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

//#define int ll

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

string s[26];
map<int, ll> mp[27], mp1[27];

void f1(int l, int r) {
    mp[0][0] = 1;
    for (int i = l; i < r; i++) {
        if (i - l)
            mp[i - l - 1].clear();
        for (auto u : mp[i - l]) {
            for (auto v : s[i]) {
                int val = int(v - 'A');
                if (!((1 << val) & u.f)) {
                    mp[i - l + 1][(1 << val) | u.f] += u.s;
                }
            }
        }
    }
}

void f2(int l, int r) {
    mp1[0][0] = 1;
    for (int i = l; i < r; i++) {
        if (i - l)
            mp1[i - l - 1].clear();
        for (auto u : mp1[i - l]) {
            for (auto v : s[i]) {
                int val = int(v - 'A');
                if (!((1 << val) & u.f)) {
                    mp1[i - l + 1][(1 << val) | u.f] += u.s;
                }
            }
        }
    }
}

void print(int mask) {
    for (int i = 0; i < 26; i++) {
        if ((1 << i) & mask)
            cout << 1;
        else
            cout << 0;
    }
    cout << endl;
}

void solve() {
    int a[26][26];
    for (int i = 0; i < 26; i++) {
        for (int j = 0; j < 26; j++)
            a[i][j] = 0;
    }
    for (int i = 0; i < 26; i++) {
        cin >> s[i];
        string nw = "";
        for (auto u : s[i]) {
            a[i][int(u - 'A')] = 1;
        }
        for (int j = 0; j < 26; j++) {
            if (a[i][j])
                nw.pb(char(j + 'A'));
        }
        s[i] = nw;
    }
    int mid = 20;
    f1(0, mid);
    f2(mid, 26);
    int ans = 0;
    const int A = (1 << 26) - 1;
    for (auto u : mp[mid]) {
        ans += u.s * mp1[26 - mid][A ^ u.f];
    }
    cout << ans << endl;
}

signed main() {
    ios;
//    open("anime.in", "anime.out");
    int attempts = 1;
//    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}