
/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

#define int ll

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

const int N = 1e5 + 10;
const int MXN = 1e3 + 10;
int n, k, a[N];

void generate() {
    n = rnd() % N + 1;
    k = rnd() % n + 1;
    for (int i = 0; i < n; i++)
        a[i] = rnd() % MXN + 1;
}

void input() {
    cin >> n >> k;
    for (int i = 0; i < n; i++)
        cin >> a[i];
}

int fst() {
    int dp[n + 1][k + 1];
    const int inf = 1e18 + 7;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= k; j++)
            dp[i][j] = inf;
    }
    dp[0][0] = 0;
    int sum[n][n], sum1[n][n];
    for (int i = 0; i < n; i++) {
        sum[i][i] = 0;
        sum1[i][i] = a[i];
    }
    for (int l = 0; l < n; l++) {
        for (int r = l + 1; r < n; r++) {
            sum1[l][r] = sum1[l][r - 1] + a[r];
            sum[l][r] = sum[l][r - 1] + sum1[l][r - 1] + a[r] * (r - l);
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= k; j++) {
            for (int i1 = i; i1 >= 1; i1--) {
                dp[i][j] = min(dp[i][j], dp[i1 - 1][j - 1] + sum[i1 - 1][i - 1]);
//                cout << min(inf, dp[i1 - 1][j - 1] + sum[i1 - 1][i - 1]) << ' ';
            }
//            cout << endl;
//            cout << endl;
//            cout << endl;
        }
    }
    return dp[n][k];
}

int snd() {
    int dp[n + 1][k + 1];
    const int inf = 1e18 + 7;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= k; j++)
            dp[i][j] = inf;
    }
    dp[0][0] = 0;
    int sum[n][n], sum1[n][n];
    for (int i = 0; i < n; i++) {
        sum[i][i] = 0;
        sum1[i][i] = a[i];
    }
    for (int l = 0; l < n; l++) {
        for (int r = l + 1; r < n; r++) {
            sum1[l][r] = sum1[l][r - 1] + a[r];
            sum[l][r] = sum[l][r - 1] + sum1[l][r - 1] + a[r] * (r - l);
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= k; j++) {
            int l = 1, r = i;
            while (r > l + 10) {
                int fst = l + (r - l) / 3;
                int snd = r - (r - l) / 3;
                int fst_val = min(inf, sum[fst - 1][i - 1] + dp[fst - 1][j - 1]);
                int snd_val = min(inf, sum[snd - 1][i - 1] + dp[snd - 1][j - 1]);
                if (fst_val == snd_val && fst_val == inf) {
                    if (min(inf, sum[i - 1][i - 1] + dp[i - 1][j - 1]) == inf)
                        r = snd;
                    else
                        l = snd;
                    continue;
                }
                if (fst_val < snd_val)
                    r = snd;
                else
                    l = fst;
            }
            for (int i1 = l; i1 <= r; i1++) {
                dp[i][j] = min(dp[i][j], dp[i1 - 1][j - 1] + sum[i1 - 1][i - 1]);
            }
            dp[i][j] = min(dp[i][j], dp[1 - 1][j - 1] + sum[1 - 1][i - 1]);
            dp[i][j] = min(dp[i][j], dp[i - 1][j - 1] + sum[i - 1][i - 1]);
        }
    }
    return dp[n][k];
}

void solve() {
    input();
//    cout << fst() << endl;
    cout << snd() << endl;
//    while (true) {
//        generate();
//        if (fst() != snd()) {
//            cout << fst() << ' ' << snd() << endl;
//            cout << n << ' ' << k << endl;
//            for (int i = 0; i < n; i++)
//                cout << a[i] << ' ';
//            cout << endl;
//            return;
//        }
//    }
}

signed main() {
    ios;
//    open("anime.in", "anime.out");
    int attempts = 1;
//    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}