
/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

#define int ll

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

const int N = 1e5 + 10, inf = 1e18 + 7;
int n, k, a[N];

void generate() {
    const int N1 = 5;
    const int MXN = 1e3 + 10 + 10;
    n = rnd() % N1 + 4;
//    k = rnd() % n + 1;
    k = 3;
    for (int i = 0; i < n; i++)
        a[i] = rnd() % MXN + 1;
}

void input() {
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
}

int solve_1_2_3() {
    int dp[n + 1][k + 1];
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= k; j++)
            dp[i][j] = inf;
    }
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= k; j++) {
            int sum = 0, kolvo = 0, sum1 = 0;
            for (int i1 = i; i1 >= 1; i1--) {
                sum += a[i1 - 1] * kolvo + sum1;
                sum1 += a[i1 - 1];
                kolvo++;
                dp[i][j] = min(dp[i][j], dp[i1 - 1][j - 1] + sum);
            }
        }
    }
    return dp[n][k];
}

int solve_5() {
    int pref[n + 1], suff[n + 1];
    pref[0] = suff[0] = 0;
    for (int i = 1; i <= n; i++)
        pref[i] = pref[i - 1] + a[i - 1];
    for (int i = 1; i <= n; i++)
        suff[i] = suff[i - 1] + a[n - i];
    int kolvo = 1;
    int ans = inf;
    for (int i = 1; i < n; i++) {
        while (pref[kolvo] * (kolvo - 1) + (pref[i + 1] - pref[kolvo]) * (i - kolvo) >
               pref[kolvo + 1] * kolvo + (pref[i + 1] - pref[kolvo + 1]) * (i - kolvo - 1))
            kolvo++;
        ans = min(ans, suff[n - i - 1] * (n - i - 2) + pref[kolvo] * (kolvo - 1) +
                       (pref[i + 1] - pref[kolvo]) * (i - kolvo));
    }
    kolvo = 1;
    for (int i = 1; i < n; i++) {
        while (suff[kolvo] * (kolvo - 1) + (suff[i + 1] - suff[kolvo]) * (i - kolvo) >
               suff[kolvo + 1] * kolvo + (suff[i + 1] - suff[kolvo + 1]) * (i - kolvo - 1))
            kolvo++;
        ans = min(ans, pref[n - i - 1] * (n - i - 2) + suff[kolvo] * (kolvo - 1) +
                       (suff[i + 1] - suff[kolvo]) * (i - kolvo));
    }
    return ans;
}

pair<int, int> lm(int s) {
    int ans = 0, k = 0, sum = 0;
    int kolvo = 1;
    for (int i = 0; i < n; i++) {
        if (sum + k * a[i] < s) {
            ans += sum + k * a[i];
            sum += a[i];
            k++;
        } else {
            ans += s;
            sum = a[i];
            k = 1;
            kolvo++;
        }
//        cout << ans << endl;
    }
    return {ans, kolvo};
}

int solve_all() {
    int ans = inf;
    int l = -1, r = inf;
    while (l + 1 < r) {
        int mid = (r + l) / 2;
        if (lm(mid).s <= k - 1)
            r = mid;
        else
            l = mid;
    }
    int l1 = r;
    l = 0, r = inf + 1;
    while (l + 1 < r) {
        int mid = (r + l) / 2;
        if (lm(mid).s >= k - 1)
            l = mid;
        else
            r = mid;
    }
    int r1 = l;
    l = l1;
    r = r1;
    while (l + 10 < r) {
        int fst = l + (r - l) / 3;
        int snd = r - (r - l) / 3;
        int val1 = lm(fst).f - (k - 1) * fst;
        int val2 = lm(snd).f - (k - 1) * snd;
        if (val1 < val2)
            r = snd;
        else
            l = fst;
    }
    for (int i = l; i <= r; i++) {
        pair<int, int> b = lm(i);
        ans = min(ans, b.f - i * b.s);
    }
    return ans;
}

void solve() {
    input();
    if (k != 3 || n <= 1000) {
        cout << solve_1_2_3() << endl;
    } else {
        cout << solve_all() << endl;
    }
//    while (true) {
//        generate();
//        if (solve_1_2_3() != solve_5()){
//            cout << solve_1_2_3() << ' ' << solve_5() << endl;
//            cout << n << ' ' << k << endl;
//            for (int i = 0; i < n; i++)
//                cout << a[i] << ' ';
//            cout << endl;
//            return;
//        }
//    }
}

signed main() {
    ios;
//    open("anime.in", "anime.out");
    int attempts = 1;
//    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}