
/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

//#define int ll

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

const int MXN = 2e8 + 10;
const int N = 5e6 + 10;
//int t[4 * N], add[4 * N];
int val[N], add[N], l[N], r[N], tl[N], tr[N];

//struct node {
//    node *tl, *tr;
//    int val, add;
//    int l, r;
//
//    node(int l, int r) {
//        this->l = l;
//        this->r = r;
//        val = add = 0;
//        tl = tr = nullptr;
//    }
//};

//node *root = new node(0, MXN);

int it = 0;

void sozd(int v, int l1, int r1) {
    val[it] = 0;
    add[it] = 0;
    l[it] = l1;
    r[it] = r1;
    tl[it] = -1;
    tr[it] = -1;
    it++;
}

void build(int v) {
    int mid = (l[v] + r[v]) / 2;
    if (tl[v] == -1) {
        tl[v] = it;
        sozd(it, l[v], mid);
    }
    if (tr[v] == -1) {
        tr[v] = it;
        sozd(it, mid, r[v]);
    }
}

void push(int v) {
    val[v] += add[v];
    if (l[v] != r[v] - 1) {
        build(v);
        add[tl[v]] += add[v];
        add[tr[v]] += add[v];
    }
    add[v] = 0;
}

//void push(int v, int l, int r) {
//    t[v] += add[v];
//    if (l != r - 1) {
//        add[2 * v + 1] += add[v];
//        add[2 * v + 2] += add[v];
//    }
//    add[v] = 0;
//}

void update(int v, int tl1, int tr1, int val1) {
    push(v);
    if (tl1 <= l[v] && r[v] <= tr1) {
        add[v] += val1;
        push(v);
        return;
    }
    if (l[v] >= tr1 || r[v] <= tl1)
        return;
    build(v);
    update(tl[v], tl1, tr1, val1);
    update(tr[v], tl1, tr1, val1);
    val[v] = max(val[tl[v]], val[tr[v]]);
}

//void update(int v, int l, int r, int tl, int tr, int val) {
//    push(v, l, r);
//    if (tl <= l && r <= tr) {
//        add[v] += val;
//        push(v, l, r);
//        return;
//    }
//    if (l >= tr || r <= tl)
//        return;
//    int mid = (r + l) / 2;
//    update(2 * v + 1, l, mid, tl, tr, val);
//    update(2 * v + 2, mid, r, tl, tr, val);
//    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
//}

int get(int v, int tl1, int tr1) {
    push(v);
    if (tl1 <= l[v] && tr1 >= r[v]) {
        return val[v];
    }
    if (l[v] >= tr1 || r[v] <= tl1)
        return 0;
    build(v);
    return max(get(tl[v], tl1, tr1), get(tr[v], tl1, tr1));
}

//int get(int v, int l, int r, int tl, int tr) {
//    push(v, l, r);
//    if (tl <= l && tr >= r) {
//        return t[v];
//    }
//    if (l >= tr || r <= tl)
//        return 0;
//    int mid = (r + l) / 2;
//    return max(get(2 * v + 1, l, mid, tl, tr), get(2 * v + 2, mid, r, tl, tr));
//}

void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    pair<int, int> coord[n];
    for (int i = 0; i < n; i++)
        cin >> coord[i].f >> coord[i].s;
    sort(coord, coord + n);
    vector<int> reb;
    for (int i = 0; i < n; i++) {
        reb.pb(coord[i].f);
        reb.pb(max(0, coord[i].f - w));
    }
    sort(reb.begin(), reb.end());
    sozd(0, 0, MXN);
    int l1 = 0, r1 = 0, mx = 0;
    for (auto u : reb) {
        while (r1 != n && coord[r1].f <= u + w) {
            update(0, coord[r1].s, coord[r1].s + h + 1, 1);
            r1++;
        }
        while (l1 != n && coord[l1].f < u) {
            update(0, coord[l1].s, coord[l1].s + h + 1, -1);
            l1++;
        }
        mx = max(mx, get(0, 0, MXN));
    }
    cout << mx << endl;
}

signed main() {
    ios;
//    open("anime.in", "anime.out");
    int attempts = 1;
//    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}