
/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
//mt19937_64 rnd(time(nullptr));

//#define int ll

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

const int MXN = 2e8 + 10;
const int N = 1e7 + 10;
int val[N], add[N], l[N], r[N], tl[N], tr[N];

int it = 0;

inline void sozd(int v, int l1, int r1) {
    val[it] = 0;
    add[it] = 0;
    l[it] = l1;
    r[it] = r1;
    tl[it] = -1;
    tr[it] = -1;
    it++;
}

inline void build(int v) {
    int mid = (l[v] + r[v]) / 2;
    if (tl[v] == -1) {
        tl[v] = it;
        sozd(it, l[v], mid);
    }
    if (tr[v] == -1) {
        tr[v] = it;
        sozd(it, mid, r[v]);
    }
}

inline void push(int v) {
    if (!add[v])
        return;
    val[v] += add[v];
    if (l[v] != r[v] - 1) {
        build(v);
        add[tl[v]] += add[v];
        add[tr[v]] += add[v];
    }
    add[v] = 0;
}

void update(int v, int tl1, int tr1, int val1) {
    push(v);
    if (l[v] >= tr1 || r[v] <= tl1)
        return;
    if (tl1 <= l[v] && r[v] <= tr1) {
        add[v] += val1;
        push(v);
        return;
    }
    build(v);
    update(tl[v], tl1, tr1, val1);
    update(tr[v], tl1, tr1, val1);
    val[v] = max(val[tl[v]], val[tr[v]]);
}

int get(int v, int tl1, int tr1) {
    push(v);
    if (l[v] >= tr1 || r[v] <= tl1)
        return 0;
    if (tl1 <= l[v] && tr1 >= r[v]) {
        return val[v];
    }
    build(v);
    int fst = get(tl[v], tl1, tr1);
    int snd = 0;
    if (val[v] - fst >= fst)
        snd = get(tr[v], tl1, tr1);
    return max(fst, snd);
}

void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    pair<int, int> coord[n];
    for (int i = 0; i < n; i++)
        cin >> coord[i].f >> coord[i].s;
    sort(coord, coord + n);
    vector<int> reb;
    for (int i = 0; i < n; i++) {
        reb.pb(coord[i].f);
    }
    sozd(0, 0, MXN);
    int l1 = 0, r1 = 0, mx = 0;
    int cnt = 0;
    for (auto u : reb) {
        while (r1 != n && coord[r1].f <= u + w) {
            update(0, coord[r1].s, coord[r1].s + h + 1, 1);
            r1++;
        }
        while (l1 != n && coord[l1].f < u) {
            update(0, coord[l1].s, coord[l1].s + h + 1, -1);
            l1++;
        }
        mx = max(mx, get(0, 0, MXN));
        cnt++;
        if (mx > n - cnt) {
            break;
        }
    }
    cout << mx << '\n';
}

signed main() {
    ios;
//    open("anime.in", "anime.out");
    int attempts = 1;
//    cin >> attempts;
//    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}