#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

#define int long long

const int INF = 1e14 + 228;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, K;
    cin >> n >> K;
    vector<int> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + arr[i];
    }
    auto calc = [&](int l, int r) {
        return (pref[r] - pref[l]) * (r - l - 1);
    };
    
    vector<vector<int>> dp(2, vector<int> (n + 1, INF));
    vector<vector<int>> p(2, vector<int> (n + 1, -1));

    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        dp[1][i + 1] = calc(0, i + 1);
        p[1][i + 1] = 0;
    }
    for (int j = 2; j <= K; j++) {
        vector<int>().swap(dp[j - 2]);
        vector<int>().swap(p[j - 2]);
        dp.push_back(vector<int> (n + 1, INF));
        p.push_back(vector<int> (n + 1, -1));
        for (int i = n; i >= 1; i--) {
            int right = n;
            if (i != n) {
                right = p[j][i + 1];
            }
            right = min(right, i - 1);
            for (int k = p[j - 1][i]; k <= right; k++) {
                int x = dp[j - 1][k] + calc(k, i);
                if (x < dp[j][i]) {
                    dp[j][i] = x;
                    p[j][i] = k;
                }
            }
        }
    }
    cout << dp.back().back() << endl;
}

