#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include <queue>
#include <deque>

#define peredayu_privet_andreyu_ivanovu ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define cod(x) static_cast<int>(x)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

using ll = long long;
using vl = vector<ll>;
using vvl = vector<vl>;
using ld = long double;
using vd = vector<ld>;
using vvd = vector<vd>;
const ll INF = 1e18 + 1e17;
const ll MOD = 1e9 + 7;
const ld delta = 1 / 1e8;

// global variables;

ll n, k;
vl a;

//

int main() {
	peredayu_privet_andreyu_ivanovu;
	cin >> n >> k;
	a.resize(n);
	ll sum_a = 0;
	rep(i, n) {
		cin >> a[i];
		sum_a += a[i];
	}
	vl pref(n + 1);
	pref[0] = 0;
	for (int i = 1; i <= n; ++i) {
		pref[i] = pref[i - 1] + a[i - 1];
	}
	if (k == 3) {
		ll min_ans = INF;
		for (int x = 1; x < n - 2; ++x) {
			ll cur_sum = pref[x] * x;
			ll left = x, right = n - 2;
			while (left + 2 < right) {
				ll mid1 = (left * 2 + right) / 3;
				ll mid2 = (left + right * 2) / 3;
				ll sum1 = (pref[mid1] - pref[x]) * (mid1 - x) + (pref[n-2] - pref[mid1]) * (n-2 - mid1);
				ll sum2 = (pref[mid2] - pref[x]) * (mid2 - x) + (pref[n-2] - pref[mid2]) * (n-2 - mid2);
				if (sum1 < sum2) {
					right = mid2;
				}
				else if (sum1 == sum2) {
					left = mid1;
					right = mid2;
				}
				else if (sum1 > sum2) {
					left = mid1;
				}
			}
			if (left + 1 == right) {
				ll sum1 = (pref[left] - pref[x]) * (left - x) + (pref[n - 2] - pref[left]) * (n - 2 - left);
				ll sum2 = (pref[right] - pref[x]) * (right - x) + (pref[n - 2] - pref[right]) * (n - 2 - right);
				cur_sum += min(sum1, sum2);
				min_ans = min(min_ans, cur_sum);
			}
			else {
				ll sum1 = (pref[left] - pref[x]) * (left - x) + (pref[n - 2] - pref[left]) * (n - 2 - left);
				ll sum2 = (pref[right] - pref[x]) * (right - x) + (pref[n - 2] - pref[right]) * (n - 2 - right);
				left = (left + right) / 2;
				ll sum3 = (pref[left] - pref[x]) * (left - x) + (pref[n - 2] - pref[left]) * (n - 2 - left);
				cur_sum += min(sum3, min(sum1, sum2));
				min_ans = min(min_ans, cur_sum);
			}
		}
		cout << min_ans;
		return 0;
	}
	vvl dp(n + 1);
	rep(i, n + 1) {
		dp[i].resize(min((ll)i + 1, k + 1));
	}
	dp[0][0] = 0;
	for (int m = 1; m <= n; ++m) {
		dp[m][0] = INF;
		for (int k0 = 1; k0 < dp[m].size(); ++k0) {
			ll cur_min = INF;
			ll cur_sum = 0;
			for (int i = m - 1; i >= k0 - 1; --i) {
				cur_sum = cur_sum + (pref[m] - pref[i]) + a[i] * (m - 1 - i);
				cur_min = min(cur_min, dp[i][k0 - 1] + cur_sum);
			}
			dp[m][k0] = cur_min;
		}
	}
	//rep(i, dp.size()) {
	//	rep(j, dp[i].size()) {
	//		cout << dp[i][j] << " ";
	//	}
	//	cout << "\n";
	//}
	cout << dp[n][k] - sum_a;
	return 0;
}