#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 2e5, INF = 1e17;
int arr[MAXN], pref[MAXN];
int n, k;

array<int, 2> get(int x) {
    vector<int> dp(n + 1, 0);
    vector<int> pr(n + 1, -1);
    for (int i = 1; i <= n; ++i) {
        dp[i] = INF;
        for (int j = 0; j < i; ++j) {
            int nw = (pref[i] - pref[j]) * (i - j) + dp[j] + x;
            if (nw <= dp[i]) {
                dp[i] = nw;
                pr[i] = j;
            }
        }
    }
    int cnt = 0;
    int cur = n;
    while (cur != 0) {
        cnt++;
        cur = pr[cur];
    }
    return {dp[n], cnt};
}

main() {
    cin >> n >> k;
    int sm = 0;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        sm += arr[i];
    }
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + arr[i];
    }
    int l = 0, r = INF;
    while (r - l > 1) {
        int m = (l + r) / 2;
        auto res = get(m);
        if (res[1] < k) {
            r = m;
        } else {
            l = m;
        }
    }
    auto res = get(l);
    cout << res[0] - res[1] * l - sm;
    return 0;
}
