#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <utility>
#include <random>
#include <chrono>
//#define int long long
#define pii pair<int, int>
#define x first
#define y second
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC target("avx,avx2")
#define endl "\n"

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1e5 + 10;
const int MXCORD = 1e5 + 10;
const int inf = 1e18 + 10;

int n;
int w, h;
pii a[N];
unordered_map<int, int> mp[MXCORD];

void add(int x, int y)
{
	for (int i = x; i < MXCORD; i += (i & -i))
		for (int j = y; j < MXCORD; j += (j & -j))
			++mp[i][j];
}

int sum(int x, int y)
{
	if (min(x, y) == 0)
		return 0;

	int res = 0;

	for (int i = x; i > 0; i -= (i & -i))
		for (int j = y; j > 0; j -= (j & -j))
			res += mp[i][j];

	return res;
}

int sum(int x1, int y1, int x2, int y2)
{
	return sum(x2, y2) - sum(x1 - 1, y2) - sum(x2, y1 - 1) + sum(x1 - 1, y1 - 1);
}

void group2()
{
	for(int i = 0; i < n; ++i)
		add(a[i].x, a[i].y);

	int ans = 0;

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			ans = max(ans, sum(a[i].x, a[j].y, max(1, a[i].x + w), max(1, a[j].y + h)));

	cout << ans << endl;
}

void group45()
{
	for (int i = 0; i < n; ++i)
		add(a[i].x, a[i].y);

	int ans = 0;

	for (int i = 0; i < n; ++i)
		ans = max(ans, sum(max(1, a[i].x - w), max(1, a[i].y - h), a[i].x, a[i].y));

	cout << ans << endl;
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> w >> h;

	for (int i = 0; i < n; ++i)
		cin >> a[i].x >> a[i].y;

	if (n <= 110)
		group2();
	else
		group45();
}
