#include<iostream>
#include<cmath>
#include<vector>
#include<algorithm>
#include<set>
#include<map>

#define vec vector
#define f first
#define s second
#define FOR(i, n) for(int (i) = 0; (i) < (n); (i)++)
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define pb push_back

using namespace std;

void solve1(int n, int w, int h, vec<pii> a)
{
    int mx = 0;
    int cnt = 0;
    pii point;
    FOR(i, 3e2)
    {
        FOR(j, 3e2)
        {
            int i1 = i + w;
            int j1 = j + h;

            for(auto k : a)
            {
                if(i <= k.f and k.f <= i1 and j <= k.s and k.s <= j1)
                {
                    cnt++;
                }
            }
            if(mx < cnt)
            {
                mx = cnt;
                point = {i, j};
            }
            cnt = 0;
        }
    }

    cout << point.f << ' ' << point.s << endl;

    cout << mx;
}

void solve2(int n, int w, int h, vec<pii> a)
{
    const int maxn = 1e3 + 2;

    vec<vec<int>> pref(maxn, vec<int> (maxn));
    vec<vec<int>> A(maxn, vec<int> (maxn));

    FOR(i, maxn)
    {
        FOR(j, maxn)
        {
            A[i][j] = 0;
            pref[i][j] = 0;
        }
    }

    for(auto i : a)
    {
        A[i.f][i.s]++;
    }

    for(int i = 1; i < maxn; i++)
    {
        for(int j = 1; j < maxn; j++)
        {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] + A[i][j] - pref[i - 1][j - 1];
        }
    }

    int mx = pref[w][h];

    // pref[x1][y1] - pref[x2][y1] - pref[x1][y2] + pref[x2][y2];

    for(auto i : a)
    {
        int x1 = i.f, y1 = i.s;
        int x2 = max(0, i.f - w - 1), y2 = max(0, i.s - h - 1);

        mx = max(mx, pref[x1][y1] - pref[x2][y1] - pref[x1][y2] + pref[x2][y2]);
    }

    cout << mx;
}

int main()
{
    int n, w, h;
    cin >> n >> w >> h;

    vec<pii> a (n);

    FOR(i, n)
    {
        cin >> a[i].f >> a[i].s;
    }

    sort(all(a));

    if(n <= 3e2 and h <= 3e2 and w <= 3e2)
    {
        solve1(n, w, h, a)
    }
    else
        solve2(n, w, h, a);
}

