#include <bits/stdc++.h>
#define pii pair <int, int>
#define x first
#define y second
#define ll long long
#define ld long double

using namespace std;

const int M = (1 << 26) - 1;

vector <string> s;
string t;
unordered_map <int, int> dp1, dp2, dp3, tmp;
ll ans;

void get(int l, int r, unordered_map <int, int> &dp) {
  dp[0] = 1;
  for(int i = l; i <= r; i++) {
    tmp.clear();
    for(int j = 0; j < s[i].size(); j++) {
      int x = s[i][j] - 'A';
      for(auto &it : dp) {
        int mask = it.first;
        if((mask >> x) & 1)
          continue;
        tmp[mask ^ (1 << x)] += dp[mask];
      }
    }
    dp = tmp;
  }
}

bool comp(string a, string b) {
  return a.size() < b.size();
}

int main() {
  s.resize(27);
  for(int i = 1; i <= 26; i++) {
    cin >> t;
    sort(t.begin(), t.end());
    s[i] += t[0];
    for(int j = 1; j < t.size(); j++) {
      if(t[j] != t[j - 1])
        s[i] += t[j];
    }
  }
  sort(s.begin(), s.end(), comp);
  int CT = 10;
  get(1, CT, dp1);
  get(CT + 1, 2 * CT, dp2);
  get(2 * CT + 1, 26, dp3);
  for(auto &i : dp1) {
    int m1 = i.first;
    for(auto &j : dp3) {
      int m2 = j.first;
      if(m2 & m1)
        continue;
      if(dp2.find(M ^ m2 ^ m1) != dp2.end())
        ans += 1LL * i.second * j.second * dp2[M ^ m2 ^ m1];
    }
  }
  cout << ans;
  return 0;
}
