#include <iostream>
#include<bits/stdc++.h>
using namespace std;
const int XMAX = INT_MAX;
struct anode{
	int val;
	int lazy;
	int l,r;
	anode *ls, *rs;
	anode(int _l,int _r){
		val = 0;
		l = _l;
		r = _r;
		lazy = 0;
		ls = rs = NULL;
	}
};
anode *root = new anode(0, XMAX);
void makesons(anode *node){
	int mid = (node->l + node->r) / 2;
	if(node->ls == NULL)
		node->ls = new anode(node->l, mid);
	if(node->rs == NULL)
		node->rs = new anode(mid+1, node->r);
}
void propag(anode *node){
	node->val += node->lazy;
	if(node->l!= node->r){
		makesons(node);
		node->ls->lazy+=node->lazy;
		node->rs->lazy+=node->lazy;
	}
	node->lazy = 0;
}
void update(anode *node,int ul,int ur,int val){
	propag(node);
	int l = node->l, r = node->r;
	if(l > ur || r < ul)
		return;
	if(ul<=l && r<=ur){
		node->lazy+=val;
		propag(node);
		return;
	}
	makesons(node);
	update(node->ls, ul, ur, val);
	update(node->rs, ul, ur, val);
	node->val = max(node->ls->val, node->rs->val);
}

struct events{
	int x,y;
	int val;
};
bool cmpev(events a, events b){
	if(a.y==b.y){
		return a.val >b.val;
	}
	return a.y<b.y;
}
vector<events> ev;

int main()
{
		//freopen(".in", "r", stdin);
		int n, w, h;
		int ans = 0;
		cin>>n>>w>>h;
		for(int i=1;i<=n;i++){
			int x, y;
			cin>>x>>y;
			ev.push_back({x, y, 1});
			ev.push_back({x, y+h, -1});
		}
		sort(ev.begin(), ev.end(), cmpev);
    for(auto e:ev){
			update(root, max(e.x - w, 0), e.x, e.val);
			ans = max(ans, root->val);
    }
    cout<<ans;
    return 0;
}
