#include <bits/stdc++.h>

using namespace std;
const int SIG = 26;
using ll = long long;
const int M = 12345;
struct Hash {
    vector <vector <pair <int, int>>> v;
    void start () {
        v.resize (M);
    }
    void add (int key, int value) {
        int t = key % M;
        bool found = false;
        for (auto &x : v[t])
            if (x.first == key) {
                x.second += value;
                found = true;
            }
        if (not found)
            v[t].emplace_back (key, value);
    }
    vector <pair <int, int>> all () {
        vector <pair <int, int>> ans;
        for (int i = 0; i < M; i++)
            for (auto x : v[i])
                ans.emplace_back (x);
        return ans;
    }
    void curata () {
        for (int i = 0; i < M; i++)
            v[i].clear ();
    }
};

Hash dp[2];
string str[1 + SIG];
bool cmp (string a, string b) {
    set <int> sa, sb;
    for (char ch : a)
        sa.insert (ch - 'a');
    for (char ch : b)
        sb.insert (ch - 'a');
    return sa.size () < sb.size ();
}
int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie (0);
    dp[0].start ();
    dp[1].start ();
    dp[0].add (0, 1);
    for (int i = 1; i <= SIG; i++) {
        cin >> str[i];
    }
    sort (str + 1, str + SIG, cmp);
    for (int i = 1; i <= SIG; i++) {
        int cur = i & 1;
        dp[cur].curata ();
        set <int> s;
        for (char ch : str[i])
            s.insert (ch - 'a');
        for (auto it : dp[not cur].all ())
            for (int bit : s) {
                if (((1 << bit) & it.first) == 0)
                    dp[cur].add (it.first + (1 << bit), it.second);
            }
    }
    ll ans = 0;
    for (auto it : dp[SIG & 1].all ())
        ans += it.second;

    cout << ans << "\n";
    return 0;
}
