#include <bits/stdc++.h>

using namespace std;
const int SIG = 26;
using ll = long long;
const int M = 9875;
#define pb push_back
struct Hash {
    vector <vector <pair <int, ll>>> v;
    void start () {
        v.resize (M);
    }
    void add (int key, ll value) {
        int t = key % M;
        bool found = false;
        for (auto &x : v[t])
            if (x.first == key) {
                x.second += value;
                found = true;
            }
        if (not found)
            v[t].emplace_back (key, value);
    }
    vector <pair <int, ll>> all () {
        vector <pair <int, ll>> ans;
        for (int i = 0; i < M; i++)
            for (auto x : v[i])
                ans.emplace_back (x);
        return ans;
    }
    void curata () {
        for (int i = 0; i < M; i++)
            v[i].clear ();
    }
};

Hash dp[2];
string str[1 + SIG];
vector <string> l[10];
int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie (0);
    dp[0].start ();
    dp[1].start ();
    dp[0].add (0, 1);
    for (int i = 1; i <= SIG; i++) {
        string s;
        cin >> s;
        l[s.size ()].pb (s);
    }
    int nr = 0;
    for (int i = 1; i <= 5; i++) {
        for (int steps = 0; steps < 123; steps++)
            random_shuffle (l[i].begin (), l[i].end ());
        for (string s : l[i])
            str[++nr] = s;
    }
    for (int i = 1; i <= SIG; i++) {
        int cur = i & 1;
        dp[cur].curata ();
        set <int> s;
        for (char ch : str[i])
            s.insert (ch - 'a');
        for (auto it : dp[not cur].all ())
            for (int bit : s) {
                if (((1 << bit) & it.first) == 0)
                    dp[cur].add (it.first + (1 << bit), it.second);
            }
    }
    ll ans = 0;
    for (auto it : dp[SIG & 1].all ())
        ans += it.second;

    cout << ans << "\n";
    return 0;
}
