#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <map>
#include <unordered_map>
#include <deque>

#pragma GCC optimize("Ofast")

using namespace std;

const int MAX_N = 26;
string s[MAX_N];

unordered_map<int, long long> cnt;
int e[MAX_N];

int main() {
//    freopen("input.txt", "r", stdin);

    int n = 0;
    while (n < 26)
        cin >> s[n++];

    for (int i = 0; i < n; i++) {
        for (char ch : s[i])
            e[i] |= (1 << (ch - 'A'));
//            e[i] |= (1 << (rand() % 26));
    }

    long long non_zero = 0;
    cnt[0] = 1;
    int i = -1, next = 0;
    deque<int> q(1, 0);
    while (q.size()) {
        int mask = q.front();
        q.pop_front();

        if (mask == next) {
            i++;
            next = -1;
        }

        long long c = cnt[mask];
        if (mask != (1 << n) - 1)
            cnt.erase(mask);

        for (int x = (mask ^ ((1 << n) - 1)) & e[i]; x; x &= x - 1) {
            int b = (x & -x);

            long long aux = (cnt[mask ^ b] += c);
            if (aux == c) {
                q.push_back(mask ^ b);
                if (next == -1)
                    next = mask ^ b;
            }
        }
    }

    cout << cnt[(1 << n) - 1] << endl;

    return 0;
}
