#include <iostream>
#include <map>
#include <algorithm>
using namespace std;

string s[26];
long long ans = 0;

map<int, long long> pp;


bool comp(string x, string y)
{
    return x.size() < y.size();
}

void Rec1(int mask = 0, int idx = 0)
{
    if (idx == 13)
    {
        pp[mask]++;
        return;
    }

    for (int i = idx; i < 13; ++ i)
    {
        bool can = false;
        for (int j = 0; j < s[i].size(); ++ j)
        {
            int let = s[i][j] - 'a';
            if ((mask & (1 << let)) == 0)
            {
                can = true;
                break;
            }
        }
        if (can == false) return;
    }

    for (int i = 0; i < s[idx].size(); ++ i)
    {
        if (s[idx][i] == 0) continue;
        int let = s[idx][i] - 'A';
        if ((mask & (1 << let)) == 0)
        {
            mask ^= (1 << let);
            Rec1(mask, idx + 1);
            mask ^= (1 << let);
        }
    }
}

void Rec2(int mask = 0, int idx = 13)
{
    if (idx == 26)
    {
        int oppmask = mask ^ ((1 << 26) - 1);
        ans += pp[oppmask];
        return;
    }

    for (int i = idx; i < 26; ++ i)
    {
        bool can = false;
        for (int j = 0; j < s[i].size(); ++ j)
        {
            int let = s[i][j] - 'a';
            if ((mask & (1 << let)) == 0)
            {
                can = true;
                break;
            }
        }
        if (can == false) return;
    }

    for (int i = 0; i < s[idx].size(); ++ i)
    {
        if (s[idx][i] == 0) continue;
        int let = s[idx][i] - 'A';
        if ((mask & (1 << let)) == 0)
        {
            mask ^= (1 << let);
            Rec2(mask, idx + 1);
            mask ^= (1 << let);
        }
    }
}

int main()
{
    for (int i = 0; i < 26; ++ i)
    {
        cin >> s[i];
        sort(s[i].begin(), s[i].end());
        char let = 0;
        for (int j = 0; j < s[i].size(); ++ j)
        {
            if (s[i][j] == let) s[i][j] = 0;
            else let = s[i][j];
        }
    }

    sort(s, s + 26, comp);

    Rec1();
    Rec2();

    //cout << sss.size() << endl;

    cout << ans << endl;
    return 0;
}
