#include <iostream>
using namespace std;

long long const MAXN=1000001;
long long n, k;
long long a[MAXN];
long long t[MAXN];
long long used[MAXN], p[MAXN];
long long minsum=1e18;

void read()
{
    cin>>n>>k;
    k--;
    p[0]=0;
    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
        t[i]=t[i-1]+a[i];
    }
    n--;
    p[0]=0;
}

int MAX()
{
    int sum=0;
    for(int i=1;i<=k;i++)
    {
        sum+=(t[p[i]]-t[p[i-1]])*(p[i]-p[i-1]-1);
    }
    sum+=(t[n+1]-t[p[k]])*(n-p[k]);
    return sum;
}

void perm(int pos)
{
    if(pos>k)
    {
        int ma=MAX();
        if(ma<minsum) minsum=ma;
    }
    else
    {
        for(int i=p[pos-1]+1;i<=n-k+pos;i++)
        {
            if(!used[i])
            {
                used[i]=1;
                p[pos]=i;
                perm(pos+1);
                used[i]=0;
            }
        }
    }
}

int main()
{
    read();
    perm(1);
    if(n==k) cout<<0<<endl;
    else cout<<minsum<<endl;
    return 0;
}
