#include<bits/stdc++.h>
using namespace std;

const int maxN = 1e5 + 1;
const int maxW = 1e8 + 1;
int n, w, h;

struct pt
{
    int x, y;
};

pt pts[maxN];
int x_diff[maxN], y_diff[maxN];
int from_begining_x[maxN], from_begining_y[maxN];

bool cmp(pt a, pt b)
{
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >>n >>w >>h;
    for(int i = 0; i < n; i++)
    {
        cin >>pts[i].x >>pts[i].y;
    }

    sort(pts, pts + n, &cmp);

    int min_x = INT_MAX;
    int min_y = INT_MAX;
    for(int i = 0; i < n - 1; i++)
    {
        x_diff[i] = pts[i + 1].x - pts[i].x;
        y_diff[i] = pts[i + 1].y - pts[i].y;
        if(x_diff[i] < min_x)
        {
            min_x = x_diff[i];
        }
        if(y_diff[i] < min_y)
        {
            min_y = y_diff[i];
        }
    }

    /*from_begining_x[0] = from_begining_y[0] = 0;
    for(int i = 0; i < n - 1; i++)
    {
        from_begining_x[i + 1] = from_begining_x[i + 1] + x_diff[i];
        from_begining_y[i + 1] = from_begining_y[i + 1] + y_diff[i];
    }

    for(int i = 0; i < n; i++)
    {
        for(int j = i; j < n; j++)
        {
           if(from_begining_x[j] - from_begining_x[i] < w)
           {

           }
        }
    }*/

    if(min_x > w && min_y > h)
    {
        cout <<1 <<endl;
        return 0;
    }

    int cnt = 0;
    for(int i = 0; i < n; i++)
    {
        int t = i, t_old = t;
        int temp_x = 0;
        while(temp_x <= w && t < n)
        {
            temp_x += x_diff[t];
            t++;
        }
        for(int j = t_old; j < t; j++)
        {
            int d = j, d_old = d;
            int temp_y = 0;
            while(temp_y <= h && d < t)
            {
                temp_y += y_diff[d];
                d++;
            }
            cnt = max(cnt, d - d_old + 1);
        }
    }

    cout <<cnt - 1 <<endl;
    /*for(int i = 0; i < n; i++)
    {
        cout <<pts[i].x <<" " <<pts[i].y <<endl;
    }*/
    return 0;
}
