#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42;

int n,k,inp[nmax];
long long pref[nmax];

pair<long long,int> dp[nmax];

long long mem_penalty;

pair<long long,int> score(int prv,int pos)
{
    pair<long long,int> cur={dp[prv-1].first+1LL*(pref[pos]-pref[prv-1])*(pos-prv)+mem_penalty,dp[prv-1].second+1};

    return cur;
}

const int C=5;

int IN=0;

void dc_merge(int l_prv,int r_prv,int l_pos,int r_pos)
{
    if(l_pos>r_pos)return;

    //cout<<l_prv<<" "<<r_prv<<" "<<l_pos<<" "<<r_pos<<endl;

    if(r_prv-l_prv<=C||r_pos-l_pos<=C)
    {
        for(int pos=l_pos;pos<=r_pos;pos++)
            for(int prv=l_prv;prv<=r_prv;prv++)
                dp[pos]=min(dp[pos],score(prv,pos));

        return;
    }
    int pos=(l_pos+r_pos)/2;

    int opt=l_prv;

    pair<long long,int> cur_mini={1LL<<62,0};

    for(int prv=l_prv;prv<=r_prv;prv++)
    {
        IN++;

        pair<long long,int> cur=score(prv,pos);

        dp[pos]=min(dp[pos],cur);

        if(cur_mini>cur)
        {
            cur_mini=cur;
            opt=prv;
        }
    }

    dc_merge(l_prv,opt,l_pos,pos-1);
    dc_merge(opt,r_prv,pos+1,r_pos);
}
void dc(int l,int r)
{
    if(r-l<=5)
    {
        for(int pos=l;pos<=r;pos++)
            for(int prv=l;prv<=pos;prv++)
                dp[pos]=min(dp[pos],score(prv,pos));
        return;
    }
    if(l==r)
    {
        dp[l]=min(dp[l],score(l,l));
        return;
    }

    int av=(l+r)/2;

    dc(l,av);

    /*
    for(int pos=av+1;pos<=r;pos++)
        for(int prv=av;prv>=l;prv--)
            dp[pos]=min(dp[pos],score(prv,pos));
    */

    dc_merge(l,av,av+1,r);

    dc(av+1,r);
}
void eval(long long penalty)
{
    mem_penalty=penalty;

    dp[0]={0,0};

    for(int pos=1;pos<=n;pos++)
        dp[pos]={1LL<<62,0};

    //cout<<"go "<<1<<" "<<n<<" "<<penalty<<endl;

    dc(1,n);
    /*
    for(int i=1;i<=n;i++)
        assert(dp[i-1].second<=dp[i].second);
    */

    /*
    cout<<"penalty: "<<penalty<<endl;
    for(int i=1;i<=n;i++)cout<<dp[i].first<<" "<<dp[i].second<<endl;
    cout<<"---"<<endl;
    */
    /*
    cout<<"IN= "<<IN<<endl;
    IN=0;

    cout<<"penalty "<<dp[n].first<<" "<<dp[n].second<<endl;
    */
}

mt19937 rng(42);

void gen()
{
    n=1e5;
    k=rng()%100;

    for(int i=1;i<=n;i++)inp[i]=rng()%100000;
}

int main()
{
    //gen();

    scanf("%i%i",&n,&k);
    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    for(int i=1;i<=n;i++)pref[i]=pref[i-1]+inp[i];

    if(k==1)
    {
        unsigned long long outp=pref[n];
        outp=outp*(n-1);

        cout<<outp<<endl;
        return 0;
    }

    long long ok=1LL<<62,not_ok=0;//f(ok)=1 group, f(not_ok)=n groups

    while(ok-not_ok>1)
    {
        long long av=(ok+not_ok)/2;

        eval(av);

        if(dp[n].second==k)
        {
            long long outp=dp[n].first-1LL*av*k;

            //outp=outp-1LL*not_ok*(k-dp[n].second);

            printf("%lld\n",outp);

            exit(0);
        }

        if(dp[n].second<=k)ok=av;
        else not_ok=av;
    }

    eval(ok);

    long long outp=dp[n].first-1LL*ok*k;

    //outp=outp-1LL*not_ok*(k-dp[n].second);

    printf("%lld\n",outp);
    return 0;
}
/*
4 3
1 1 1 1
*/