#include<bits/stdc++.h>
#define pb push_back
#define pii pair<int,int>
#define ll long long
#define ull unsigned long long
#define INF 1000000007
#define mod 1000000007
#define null NULL
using namespace std;

struct Point
{
    int x,y,br;
};

bool cmp(pii a, pii b){return a.first<b.first;}

int n,w,h;
vector<Point> pts;
vector<pii > v;

struct Node2
{
    int data;
    int l,r;
    Node2 *lptr, *rptr, *par;
    Node2()
    {
        lptr = rptr = par = null;
        l=0; r=INF; data=0;
    }
};

struct Node1
{
    Node2 *data;
    int l,r;
    Node1 *lptr, *rptr, *par;
    Node1()
    {
        lptr = rptr = par = null;
        l=0; r=INF; data=new Node2();
    }
};

Node1 *tree_root;

Node1* getleaf1(int x,Node1 *root)
{
    while(root->l < root->r)
    {
        int mid = (root->l+root->r)>>1;
        if(x>mid)
        {
            if(root->rptr == null)
            {
                root->rptr = new Node1();
                root->rptr->par = root;
                root->rptr->l=mid+1; root->rptr->r=root->r;
            }
            root = root->rptr;
        }
        else
        {
            if(root->lptr == null)
            {
                root->lptr = new Node1();
                root->lptr->par = root;
                root->lptr->l=root->l; root->lptr->r=mid;
            }
            root = root->lptr;
        }
    }
    return root;
}

Node2* getleaf2(int x,Node2 *root)
{
    while(root->l < root->r)
    {
        int mid = (root->l+root->r)>>1;
        if(x>mid)
        {
            if(root->rptr == null)
            {
                root->rptr = new Node2();
                root->rptr->par = root;
                root->rptr->l=mid+1; root->rptr->r=root->r;
            }
            root = root->rptr;
        }
        else
        {
            if(root->lptr == null)
            {
                root->lptr = new Node2();
                root->lptr->par = root;
                root->lptr->l=root->l; root->lptr->r=mid;
            }
            root = root->lptr;
        }
    }
    return root;
}

void upd2(int x,int d,Node2 *root)
{
    root = getleaf2(x, root);
    while(root->par != null)
    {
        root->data += d;
        root=root->par;
    }
}

void upd(int x,int y,int d)
{
    Node1 *root = getleaf1(x,tree_root);
    while(root->par != null)
    {
        upd2(y,d,root->data);
        root=root->par;
    }
}

int query2(int l,int r,Node2 *root)
{
    Node2 *lef = getleaf2(l,root), *rig = getleaf2(r,root);
    if(lef == rig) return lef->data;
    int ans = lef->data + rig->data;
    while(lef->par != null && rig->par != null)
    {
        if(lef->par != rig->par)
        {
            if(lef->par->lptr != null && lef->par->rptr != null && lef == lef->par->lptr) ans += lef->par->rptr->data;
            if(rig->par->rptr != null && rig->par->lptr != null && rig == rig->par->rptr) ans += rig->par->lptr->data;
        }
        lef = lef->par;
        rig = rig->par;
    }
    return ans;
}

int query(int l1,int r1,int l2,int r2)
{
    Node1 *lef = getleaf1(l1,tree_root), *rig = getleaf1(r1,tree_root);
    if(lef == rig) return query2(l2,r2,lef->data);
    int ans = query2(l2,r2,lef->data) + query2(l2,r2,rig->data);
    while(lef->par != null && rig->par != 0)
    {
        if(lef->par != rig->par)
        {
            if(lef->par->lptr != null && lef->par->rptr != null && lef == lef->par->lptr) ans += query2(l2,r2,lef->par->rptr->data);
            if(rig->par->rptr != null && rig->par->lptr != null && rig == rig->par->rptr) ans += query2(l2,r2,rig->par->lptr->data);
        }
        lef = lef->par;
        rig = rig->par;
    }
    return ans;
}

void naive()
{
    sort(v.begin(),v.end(),cmp);
    pts.pb({v[0].first,v[0].second,1}); int sz=1;
    for(int i=1;i<n;i++)
    {
        if(v[i].first==v[i-1].first&&v[i].second==v[i-1].second)
        {
            pts[sz-1].br++;
        }
        else{pts.pb({v[i].first,v[i].second,1}); sz++;}
    }
    n=sz;
    int ans=0;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            int x=pts[i].x, y=pts[j].y, br=0;
            for(int k=0;k<n;k++)
            {
                if((pts[k].x>=x&&pts[k].x<=x+w)&&(pts[k].y>=y&&pts[k].y<=y+h)) br+=pts[k].br;
            }
            ans=max(ans,br);
        }
    }
    cout<<ans<<endl;
}

void solve1()
{
    for(int i=0;i<n;i++)
    {
        upd(v[i].first,v[i].second,1);
    }
    int ans=0;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            int x=v[i].first, y=v[j].second;
            ans=max(ans,query(x,x+w,y,y+h));
        }
    }
    cout<<ans<<endl;
}

void solve2()
{
    for(int i=0;i<n;i++)
    {
        upd(v[i].first,v[i].second,1);
    }
    int ans=0;
    for(int i=0;i<n;i++)
    {
        int x1,x2=v[i].first,y1,y2=v[i].second;
        x1=x2-w; y1=y2-h;
        if(x1>=0&&y1>=0) ans=max(ans,query(x1,x2,y1,y2));
    }
    cout<<ans<<endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    tree_root = new Node1();
    cin>>n>>w>>h;
    for(int i=0;i<n;i++)
    {
        int x,y;
        cin>>x>>y;
        v.pb({x,y});
    }
    if(n<=100) naive();
    //else if(n<=1000) solve1();
    else
        solve2();
    return 0;
}
/**

6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2

*/
