#include<bits/stdc++.h>
#define eb push_back
#define pb push_back
#define f first
#define s second

using namespace std;

const int MAXN = 1e5;
const int MAXNB = 6000;
int n, k;
int a[MAXN];
struct group {
    long long sum;
    int cnt;
};

long long  ans = 1e18;

void input() {
    cin>>n>>k;
    for (int i=0; i<n; i++) {
        cin>>a[i];
    }
}

void output() {
    cout<<ans<<endl;
}

long long sum(group &t) {
    return (t.cnt-1) * t.sum;
}

void solveK3() {
    int p1 = 0, p2 = n - 2;
    group g1, g2 = {0, 0}, g3;
    g1.sum = a[0];
    g1.cnt = 1;
    for (int i=1; i<n-1; i++) {
        g2.sum += a[i];
        g2.cnt++;
    }
    g3.sum = a[n-1];
    g3.cnt = 1;

    bool moved = 1;
    while (moved) {
        moved = 0;
        group temp1 = g1, temp2 = g2;
        temp1.sum += a[p1+1];
        temp1.cnt++;
        temp2.sum -= a[p1+1];
        temp2.cnt--;
        //cerr<<sum(temp1)<<' '<<sum(temp2)<<" <> "<<sum(g1)<<' '<<sum(g2)<<endl;
        if (sum(temp1) + sum(temp2) < sum(g1) + sum(g2)) {
            swap(temp1, g1);
            swap(temp2, g2);
            moved = 1;
        }

        temp1 = g3, temp2 = g2;
        temp1.sum += a[p2];
        temp1.cnt++;
        temp2.sum -= a[p2];
        temp2.cnt--;
        if (sum(temp1) + sum(temp2) < sum(g3) + sum(g2)) {
            swap(temp1, g3);
            swap(temp2, g2);
            moved = 1;
        }
    }

    ans = sum(g1) + sum(g2) + sum(g3);
}

void rekursiq(int i, int lk, long long sum, long long csum, int cnt) {
    //cerr<<i<<' '<<lk<<' '<<sum<<' '<<csum<<' '<<cnt<<endl;
    if (i == n) {
        ans = min(ans, sum + csum*(cnt-1));
        return;
    }

    if (lk) {
        rekursiq(i+1, lk-1, sum + csum*(cnt-1), a[i], 1);
    }
    rekursiq(i+1, lk, sum, csum+a[i], cnt+1);
}

void solve() {
    rekursiq(0, k-1, 0, 0, 0);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    if (k == 3){
        solveK3();
    } else {
        solve();
    }
    output();
    return 0;
}

