#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1003
using namespace std;
int k, w, h;
int row[MAXN][MAXN];
int col[MAXN][MAXN];
int cnt[MAXN][MAXN];
int tab[MAXN][MAXN];
int n, m;
bool toPrint = false;

struct point
{
    int x, y;
    point () {}
    point (int _x, int _y)
    {
        x = _x;
        y = _y;
    }
};

point points[MAXN];

void input()
{
    n = 0;
    m = 0;
    cin >> k >> w >> h;
    for (int i = 0; i < k; ++i)
    {
        cin >> points[i].x >> points[i].y;
        n = max(n, points[i].y);
        m = max(m, points[i].x);
    }
}

void init()
{
    /// initializing grid
    for (int i = 0; i < k; ++i)
    {
        point pt = points[i];
        ++tab[pt.y][pt.x];
    }

    /// initializing columns
    for (int i = 0; i <= m; ++i)
    {
        col[i][0] = tab[0][i];
        for (int j = 1; j <= n; ++j)
        {
            col[i][j] = col[i][j-1];
            col[i][j] += tab[j][i];
            /*if (tab[j][i])
                ++col[i][j];*/
        }
    }

    /// initializing rows
    for (int i = 0; i <= n; ++i)
    {
        row[i][0] = tab[i][0];
        for (int j = 1; j <= m; ++j)
        {
            row[i][j] = row[i][j-1];
            row[i][j] += tab[i][j];
            /*if (tab[i][j])
                ++row[i][j];*/
        }
    }

    /// initializing
    cnt[0][0] = tab[0][0];
    for (int j = 1; j <= n; ++j)
    {
        cnt[0][j] = cnt[0][j-1];
        cnt[0][j] += tab[j][0];
        /*if (tab[j][0])
            ++cnt[0][j];*/
    }
    for (int i = 1; i <= m; ++i)
    {
        cnt[i][0] = col[0][i];
        for (int j = 1; j <= n; ++j)
        {
            cnt[i][j] = cnt[i][j-1];
            cnt[i][j] += row[j][i];
        }
    }
}

int get(int x, int y)
{
    int ret = cnt[x][y];

    if (x - w - 1 >= 0)
        ret -= cnt[x-w-1][y];

    if (y - h - 1 >= 0)
        ret -= cnt[x][y-h-1];

    if (x - w - 1 >= 0 && y - h - 1 >= 0)
        ret += cnt[x-w-1][y-h-1];

    return ret;
}

void solve()
{
    int best = 0;

    for (int i = h; i <= n; ++i)
    {
        for (int j = w; j <= m; ++j)
        {
            best = max(best, get(j, i));
        }
    }

    cout << best << endl;
}

void print()
{
    if (!toPrint)
        return;
    cout << "rows" << endl;
    for (int i = 0; i <= n; ++i)
    {
        cout << i << "-th: ";
        for (int j = 0; j <= m; ++j)
            cout << row[i][j] << " ";
        cout << endl;
    }

    cout << "columns" << endl;
    for (int i = 0; i <= n; ++i)
    {
        cout << i << "-th: ";
        for (int j = 0; j <= m; ++j)
            cout << col[i][j] << " ";
        cout << endl;
    }

    cout << "counter" << endl;
    for (int i = 0; i <= n; ++i)
    {
        for (int j = 0; j <= m; ++j)
        {
            cout << cnt[i][j] << " ";
        }
        cout << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    init();
    print();
    solve();


    return 0;
}
