#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 100003
using namespace std;
int k, w, h;
map <int, vector<int>> row;
map <int, vector<int>> col;
int n, m;
bool toPrint = false;

struct point
{
    int x, y;
    point () {}
    point (int _x, int _y)
    {
        x = _x;
        y = _y;
    }
    bool operator < (const point &p) const
    {
        if (y < p.y)
            return true;
        if (y > p.y)
            return true;
        return x < p.x;
    }
};

point points[MAXN];

void input()
{
    n = 0;
    m = 0;
    cin >> k >> w >> h;
    for (int i = 0; i < k; ++i)
    {
        cin >> points[i].x >> points[i].y;
        n = max(n, points[i].y);
        m = max(m, points[i].x);
    }

    n = max(n, m);
    m = max(n, m);
}

void init()
{
    sort(points, points + k);
    for (int i = 0; i < k; ++i)
    {

        point p = points[i];
        //cout << p.x << " - " << p.y << endl;
        row[p.y].push_back(p.x);
        col[p.x].push_back(p.y);
    }
}

int get(int x, int y)
{
    int cnt = 0;
    for (auto curr: row)
    {

        if (curr.first < y - h)
            continue;
        if (curr.first > y)
            break;
        if (!(row.count(curr.first) > 0))
            continue;
        auto tmp = curr.second;
        int sz = tmp.size();

        for (auto d: tmp)
        {
            if (d < (x - w))
                continue;
            if (d > x)
                break;
            ++cnt;
        }
    }
    return cnt;
}

void print()
{
    for (int i = 0; i <= n; ++i)
    {
        cout << i << ": " << endl;
        if (!row[i].size())
            continue;

        auto tmp = row[i];

        for (auto pt: tmp)
            cout << pt << " ";
        cout <<endl;

    }
}

void solve()
{
    int best = 0;

    for (int i = h; i <= n; ++i)
    {
        for (int j = w; j <= m; ++j)
        {
            best = max(best, get(j, i));
        }
    }

    cout << best << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    init();
    //print();
    solve();


    return 0;
}
