#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define endl "\n";
#define out(x) << "{" << (#x) << ": " << x << "} "
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {out << x.first << " " << x.second; return out;}
template<class T, class T2> inline istream &operator >>(istream &in, pair<T, T2> &x) {in >> x.first >> x.second; return in;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}
const ll mod = 1e9 + 7;

const int MAX_N = 26, HALF = 13;
string in[MAX_N];

ll dp[2][1 << MAX_N];
vector<int> height[MAX_N + 1];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    for(int i = 0; i < (1 << MAX_N); i ++) {
        if(__builtin_popcount(i) <= 13) {
            height[__builtin_popcount(i)].push_back(i);
        }
    }
    for(int i = 0; i < MAX_N; i ++) {
        cin >> in[i];
        sort(in[i].begin(), in[i].end());
        in[i].resize(unique(in[i].begin(), in[i].end()) - in[i].begin());
    }
    for(int part = 0; part < 2; part ++) {
        dp[part][0] = 1;
        for(int i = 0; i < HALF; i ++) {
            for(auto c : in[i + HALF * part]) {
                int mask = 1 << (c - 'A');
                for(auto it : height[i]) {
                    dp[part][it ^ mask] += dp[part][it];
                }
            }
        }
    }
    ll ret = 0;
    for(auto it : height[HALF]) {
        ret += dp[0][it] * dp[1][((1 << MAX_N) - 1) ^ it];
    }
    cout << ret << endl;
}

