#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
#define endl "\n";
#define out(x) << "{" << (#x) << ": " << x << "} "
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {out << x.first << " " << x.second; return out;}
template<class T, class T2> inline istream &operator >>(istream &in, pair<T, T2> &x) {in >> x.first >> x.second; return in;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}
const ll mod = 1e9 + 7;

const int MAX_N = 26;
string in[MAX_N];

vector<pair<int, ll> > divcon(int l, int r) {
    if(l == r) {
        vector<pair<int, ll> > ret;
        for(auto it : in[l]) {
            ret.push_back({1 << (it - 'A'), 1});
        }
        return ret;
    }
    int m = (l + r) / 2ll;
    vector<pair<int, ll> > lft = divcon(l, m), rght = divcon(m + 1, r);
    auto beg = clock();
    if(r - l > 7) {
        unordered_map<int, ll> ret;
        for(auto it : lft) {
            for(auto it2 : rght) {
                ret[it.first ^ it2.first] += it.second * it2.second;
            }
        }
        vector<pair<int, ll> > realRet;
        for(auto it : ret) {
            if(__builtin_popcount(it.first) != (r - l + 1)) {continue;}
            realRet.push_back(it);
        }
        return realRet;
    } else {
        vector<pair<int, ll> > ret;
        for(auto it : lft) {
            for(auto it2 : rght) {
                ret.push_back({it.first ^ it2.first, it.second * it2.second});
            }
        }
        sort(ret.begin(), ret.end());
        vector<pair<int, ll> > realRet;
        for(int i = 0; i < ret.size(); i ++) {
            if(__builtin_popcount(ret[i].first) != (r - l + 1)) {continue;}
            if(i == 0 || ret[i].first != ret[i - 1].first) {
                realRet.push_back(ret[i]);
            } else {
                realRet[realRet.size() - 1].second += ret[i].second;
            }
        }
        return realRet;
    }
}

unordered_map<int, ll> mp;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    for(int i = 0; i < MAX_N; i ++) {
        cin >> in[i];
        sort(in[i].begin(), in[i].end());
        in[i].resize(unique(in[i].begin(), in[i].end()) - in[i].begin());
    }
    auto ff = divcon(0, 12), ss = divcon(13, 25);
    for(auto it : ff) {
        mp[it.first] = it.second;
    }
    ll ret = 0;
    for(auto it : ss) {
        ret += mp[it.first ^ ((1 << MAX_N) - 1)] * it.second;
    }
    cout << ret << endl;
}

