#include<iostream>
#include<cstdio>
#include<algorithm>
#include<vector>
#include<climits>

using namespace std;

int ans = INT_MAX;
int n, k;
vector<int> scared;

void rec(int left, int last, int curScore)
{
    int roundScore = 0;

    if (left == 0)
    {
        for (int i = last - 1; i < n; i++)
            roundScore += scared[i];

        roundScore*=n-last;
        curScore += roundScore;
        ans = min(ans, curScore);
        return;
    }

    for (int i=last; i<n; i++)
    {
        roundScore += scared[i-1];
        rec(left-1, i+1, curScore + roundScore*(i-last) );
    }
}

int main ()
{
    scanf("%d%d", &n, &k);
    for (int i=0; i<n; i++)
    {
        int a;
        scanf("%d", &a);
        scared.push_back(a);
    }
    rec(k-1, 1, 0);
    cout<<ans<<endl;
    return 0;
}
