#include<iostream>
#include<cstdio>
#include<vector>
#include<set>

using namespace std;

int n, w, h;

vector<pair<int, int> > input;
set<pair<int, int> > candidates;

int main ()
{
    scanf("%d%d%d", &n, &w, &h);

    for (int i=0; i<n; i++)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        input.emplace_back(x, y);
        candidates.emplace(x, y);
    }
    for (int i=0; i<n; i++)
    {
        for (int j=i+1; j<n; j++)
        {
            if ((input[i].first - input[j].first)*(input[i].second - input[j].second) >= 0) continue;
            if (abs(input[i].first - input[j].first) > w || abs(input[i].second - input[j].second) > h) continue;
            candidates.emplace(min(input[i].first, input[j].first), min(input[i].second, input[j].second));
        }
    }
    int ans = 0;
    for (auto x : candidates)
    {
        int curans = 0;
        for (int i=0; i<input.size(); i++)
        {
            if (0 <= input[i].first - x.first && input[i].first - x.first <= w && 0 <= input[i].second - x.second && input[i].second - x.second <= h) curans++;
        }
        ans = max(ans, curans);
    }
    cout<<ans<<endl;
    return 0;

}
