#include<iostream>
#include<cstdio>
#include<vector>
#include<set>
#include<algorithm>

using namespace std;

int n, w, h;

vector<pair<int, int> > input;
set<pair<int, int> > candidates;

bool inverseSort(pair<int, int> a, pair<int, int> b)
{
    if (a.second > b.second) return true;
    else if (a.second < b.second) return false;
    return a.first > b.first;
}

int main ()
{
    scanf("%d%d%d", &n, &w, &h);

    for (int i=0; i<n; i++)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        input.emplace_back(x, y);
        candidates.emplace(x, y);
    }

    sort(input.begin(), input.end(), inverseSort);
    //for (auto x : input) cout<<x.first<<" "<<x.second<<endl;

    if (n <= 1000)
    for (int i=0; i<n; i++)
    {
        for (int j=i+1; j<n; j++)
        {
            if ((input[i].first - input[j].first)*(input[i].second - input[j].second) >= 0) continue;
            if (abs(input[i].first - input[j].first) > w || abs(input[i].second - input[j].second) > h) continue;
            candidates.emplace(max(input[i].first, input[j].first), max(input[i].second, input[j].second));
        }
    }

    int ans = 0;
    for (auto x : candidates)
    {
        int curans = 0;
        for (int i=0; i<input.size(); i++)
        {
            if (x.second - input[i].second > h) break;
            if (0 <= x.first - input[i].first && x.first - input[i].first <= w && 0 <= x.second - input[i].second && x.second - input[i].second <= h) curans++;
        }
        ans = max(ans, curans);
    }
    cout<<ans<<endl;
    return 0;

}
