#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = 1e5 + 3;
const ll INF = 2e18;
const ll MAX = 1e13;

int n, k;
ll a[N], prefix[N];
ll dp[N], cnt[N];

void solve(ll cost){
    dp[n + 1] = 0;
    cnt[n + 1] = 0;

    for(int i = n; i >= 1; --i){
        dp[i] = INF;
        for(int j = i; j <= n; ++j){
            ll curr = (prefix[j] - prefix[i - 1]) * (ll)(j - i) + dp[j + 1] + cost;
            //cout << curr << " " << i << " " << j << endl;
            if(curr < dp[i]){
                dp[i] = curr;
                cnt[i] = cnt[j + 1] + 1;
            }
            else if(curr == dp[i]){
                if(cnt[j + 1] + 1 < cnt[i]){
                    cnt[i] = cnt[j + 1] + 1;
                }
            }
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 1; i <= n; ++i)
        cin >> a[i];

    for(int i = 1; i <= n; ++i)
        prefix[i] = prefix[i - 1] + a[i];

    ll l = -MAX, r = MAX;
    while(l != r){
        ll mid = (l + r) >> 1;
        solve(mid);

        if(cnt[1] <= k)
            r = mid;
        else
            l = mid + 1;
    }

    solve(l);
    //cout << l << " " << dp[1] << " " << cnt[1] << endl;
    cout << dp[1] - cnt[1] * l << "\n";
}
