#include <iostream>
#include <cstring>
#include <set>

using namespace std;

int dp[2][(1<<23)+5];

int pascal[30][30];

void init()
{
    pascal[0][0] = 1;
    for(int i = 1;i<=26;i++)
    {
        pascal[i][0] = 1;
        for(int j = 1;j<=i;j++) pascal[i][j] = pascal[i-1][j] + pascal[i-1][j-1];
    }
}

int _encode(int x, int oneCnt, int digInd)
{
    if(oneCnt==digInd+1) return 0;
    if(digInd==0) return 0;
    if(oneCnt==0) return 0;

    if(((x>>digInd)&1)==0)
    {
        return _encode(x, oneCnt, digInd-1);
    }
    else
    {
        //cout << pascal[26-digInd][oneCnt-1] << " " << 26-digInd << " " << oneCnt-1 << '\n';
        return pascal[digInd][oneCnt] + _encode(x, oneCnt-1, digInd-1);
    }
}

int encode(int x)
{
    return _encode(x, __builtin_popcount(x), 25);
}

int seen = 0;
bool inWord[30], letterSeen[30];

void fillDp(int wordInd, string &word, int digInd, int num, int oneCnt, bool valid = false)
{
    if(26-digInd<oneCnt) return;
    if(valid==false && oneCnt==0) return;
    if(digInd>word[word.size()-1]-'A' && valid==false) return;

    if(digInd==26)
    {
        int code = encode(num);

        dp[wordInd&1][code] = 0;
        for(char c: word)
        {
            if(((num>>(c-'A'))&1)==1)
                dp[wordInd&1][code] += dp[(wordInd-1)&1][encode(num^(1<<(c-'A')))];
        }

        //if(dp[wordInd&1][code]==0) cout << "FASADAS" << '\n';
        return;
    }

    if(26-digInd>oneCnt) fillDp(wordInd, word, digInd+1, num, oneCnt, valid);
    if(oneCnt!=0 && letterSeen[digInd]==true) fillDp(wordInd, word, digInd+1, num+(1<<digInd), oneCnt-1, (valid|inWord[digInd]));
}

int main()
{
    init();

    string word = "";
    //fillDp(0, word, 0, 0, 2);

    dp[0][0] = 1;
    for(int i = 1;i<=26;i++)
    {
        seen = 0;
        cin >> word;

        set <char> letters;
        memset(inWord, false, sizeof(inWord));
        for(char c: word) letters.insert(c);

        word = "";
        for(char c: letters) word += c, inWord[c-'A'] = true, letterSeen[c-'A'] = true;

        memset(dp[i&1], 0, sizeof(dp[i&1]));
        fillDp(i, word, 0, 0, i);
    }

    cout << dp[26&1][encode((1<<26)-1)] << '\n';
}
