#include <iostream>

using namespace std;

const int MAXN = 1005;
const long long inf = 1e17 + 5;

int n, k;
int a[MAXN];

long long pref[MAXN];
long long dp[MAXN][5];

long long getSum(int l, int r)
{
    if(l==0) return pref[r];
    return pref[r] - pref[l-1];
}

int A[MAXN][5];
void init()
{
    pref[0] = a[0];
    for(int i = 0;i<n;i++) pref[i] = pref[i-1] + a[i], A[i][0] = i + 1;

    for(int i = 0;i<n;i++) dp[i][0] = pref[i]*i;
}

long long getFear(int l, int r)
{
    return getSum(l, r)*(r-l);
}


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0;i<n;i++) cin >> a[i];
    init();

    for(int i = 0;i<n;i++)
    {
        for(int groupCnt = 1;groupCnt<k;groupCnt++)
        {
            int opt = -1;
            long long ans = inf;

            for(int p = max(groupCnt, A[i][(groupCnt-1)%5]-55);p<=min(((groupCnt==k-1)?i:A[i-1][(groupCnt+1)%5]+55), i);p++)
            {
                long long val = dp[p-1][(groupCnt-1)%5]+getFear(p, i);

                if(val<=ans)
                {
                    ans = val;
                    opt = p;
                }
            }

            A[i][groupCnt%5] = opt;
            dp[i][groupCnt%5] = ans;
        }
    }

    for(int i = 0;i<n;i++)
    {
        //for(int j = 0;j<k;j++)
        //    cout << A[i][j] << " ";
        //cout << '\n';
    }

    cout << dp[n-1][(k-1)%5] << '\n';
}
