#include <iostream>
#include <cstdio>
using namespace std;

    void func (int N, int K, int arr []);

int main () {

    int N, K;

    cin >> N >> K;
    int arr [N];

    for (int i = 0; i < N; i ++) {

        scanf("%d", &arr [i]);
    }
    func (N, K, arr);

return 0;
}

void func (int N, int K, int arr []) {

    unsigned long long dynArr [K][N];
    unsigned long long runningSum = arr [0];
    unsigned long long subsetSums [N][N];

    for (int i = 0; i < N; i ++) {
        subsetSums [i][i] = 0;
    }
    int cSum = 0;
    for (int i = 0; i < N - 1; i ++) {
        cSum = arr [i];
        for (int j = i + 1; j < N; j ++) {
            subsetSums [i][j] = subsetSums [i][j - 1] + arr [j] * (j - i) + cSum;
            cSum += arr [j];
        }
    }
    for (int i = 0; i < K; i ++) {
        for (int j = 0; j < N; j ++) {
            dynArr [i][j] = 0;
        }
    }

    for (int i = 1; i < N - K + 1; i ++) {
        dynArr [0][i] += runningSum;
        dynArr [0][i] +=  dynArr [0][i - 1];
        dynArr [0][i] += arr [i] * i;
        runningSum += arr[i];
    }

    int currStart = 0;

    for (int i = 1; i < K; i ++) {
        runningSum = arr [i];

        currStart = i;

        for (int j = i + 1; j < N - (K - i) + 1; j ++) {
            unsigned long long minn = 9000000000000000000;
            for (int k = i; k < j + 1; k ++) {

                minn = min(minn, dynArr [i - 1][k - 1] + subsetSums [k][j]);

            }
            dynArr [i][j] = minn;
        }
    }
        for (int i = 0; i < K; i ++) {
            for (int j = 0; j < N; j ++) {
                cout << dynArr [i][j] << " ";
            }
            cout << endl;
        }

}
