#include<bits/stdc++.h>
using namespace std;
int n,w,h;
int lili(vector<pair<int,int>> points) {
    set<int> xes, yes;
    for (auto point : points) {
        xes.insert(point.first);
        yes.insert(point.second);
    }
    int res = 0;
    for (int px : xes) {
        for(int py : yes) {
            int partialRes = 0;
            for(auto point : points) {
                if(point.first >= px && point.first <= (px + w) &&
                   point.second >= py && point.second<= (py + h)) {
                    partialRes++;
                }
            }
            res = max(partialRes,res);
        }
    }
    return res;
}

int main() {
    vector<pair<int,int>> points;
    map<pair<int,int>,vector<pair<int,int>>> buckets;
    set<pair<int,int>> activeBuckets;
    cin>>n>>w>>h;
    int u,v;
    set<int> xes, yes;
    for (int i = 0; i < n; i++) {
        cin>>u>>v;
        /// C
        buckets[{u / w, v / h}].push_back({u,v});
        activeBuckets.insert({u / w, v / h});
        /// N
        buckets[{u / w, v / h + 1}].push_back({u,v});
        activeBuckets.insert({u / w, v / h + 1});
        /// S
        buckets[{u / w, v / h - 1}].push_back({u,v});
        activeBuckets.insert({u / w, v / h - 1});
        /// E
        buckets[{u / w + 1, v / h}].push_back({u,v});
        activeBuckets.insert({u / w + 1, v / h});
        /// W
        buckets[{u / w - 1, v / h}].push_back({u,v});
        activeBuckets.insert({u / w - 1, v / h});
        /// NE
        buckets[{u / w + 1, v / h + 1}].push_back({u,v});
        activeBuckets.insert({u / w + 1, v / h + 1});
        points.push_back({u,v});
        /// NW
        buckets[{u / w - 1, v / h + 1}].push_back({u,v});
        activeBuckets.insert({u / w - 1, v / h + 1});
        /// SE
        buckets[{u / w + 1, v / h - 1}].push_back({u,v});
        activeBuckets.insert({u / w + 1, v / h - 1});
        /// SW
        buckets[{u / w - 1, v / h - 1}].push_back({u,v});
        activeBuckets.insert({u / w - 1, v / h - 1});
        points.push_back({u,v});
    }
    int res = 0;
    for (auto bucket : activeBuckets) {
        res = max(res, lili(buckets[bucket]));
    }
    cout<<res;
    return 0;
}
